import { d as defineComponent, b as inject, i as injectWithCheck, ag as logInjectionKey, r as ref, L as watch, J as onMounted, K as onUnmounted, o as openBlock, h as createBlock, w as withCtx, g as createBaseVNode, f as createTextVNode, q as toDisplayString, c as createElementBlock, e as createVNode, W as _sfc_main$1, u as unref, n as normalizeClass, F as Fragment, m as renderList, j as createCommentVNode, y as withModifiers } from "./index.464d1201.js";
import { _ as _sfc_main$2 } from "./Modal.vue_vue_type_script_setup_true_lang.9365df46.js";
import { u as ue } from "./switch.85ed3546.js";
const _hoisted_1 = { class: "text-lg font-semibold text-default mb-4" };
const _hoisted_2 = { class: "italic" };
const _hoisted_3 = {
  key: 0,
  class: "flex items-center justify-center"
};
const _hoisted_4 = { key: 1 };
const _hoisted_5 = { key: 0 };
const _hoisted_6 = { class: "max-w-5xl mx-auto p-4 bg-accent text-default shadow-md rounded-lg" };
const _hoisted_7 = { class: "grid grid-cols-2 gap-2" };
const _hoisted_8 = { class: "col-span-1 mb-4" };
const _hoisted_9 = { class: "text-sm font-medium" };
const _hoisted_10 = { class: "text-sm font-medium" };
const _hoisted_11 = { class: "text-sm font-medium" };
const _hoisted_12 = { class: "col-span-1 w-fit flex flex-row gap-2 mb-4" };
const _hoisted_13 = /* @__PURE__ */ createBaseVNode("label", { class: "mt-1 block text-sm font-medium leading-6 text-default" }, "Show All Logs", -1);
const _hoisted_14 = /* @__PURE__ */ createBaseVNode("span", { class: "sr-only" }, "Use setting", -1);
const _hoisted_15 = /* @__PURE__ */ createBaseVNode("svg", {
  class: "h-3 w-3 text-muted",
  fill: "none",
  viewBox: "0 0 12 12"
}, [
  /* @__PURE__ */ createBaseVNode("path", {
    d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
    stroke: "currentColor",
    "stroke-width": "2",
    "stroke-linecap": "round",
    "stroke-linejoin": "round"
  })
], -1);
const _hoisted_16 = [
  _hoisted_15
];
const _hoisted_17 = /* @__PURE__ */ createBaseVNode("svg", {
  class: "h-3 w-3 text-primary",
  fill: "currentColor",
  viewBox: "0 0 12 12"
}, [
  /* @__PURE__ */ createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
], -1);
const _hoisted_18 = [
  _hoisted_17
];
const _hoisted_19 = { class: "bg-plugin-header p-4 rounded-lg" };
const _hoisted_20 = {
  role: "list",
  class: "divide-y divide-default h-96 overflow-y-scroll"
};
const _hoisted_21 = {
  key: 0,
  class: "m-1 block text-sm leading-6 text-default bold italic text-center bg-default"
};
const _hoisted_22 = {
  key: 2,
  class: "flex items-center justify-center"
};
const _hoisted_23 = { class: "w-full" };
const _hoisted_24 = { class: "button-group-row w-full justify-between" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "LogView",
  props: {
    idKey: {},
    task: {}
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const showLogView = inject("show-log-view");
    const myTaskLog = injectWithCheck(logInjectionKey, "log not provided!");
    const loadingLogs = ref(false);
    const loadingMoreLogs = ref(false);
    const taskInstance = ref(props.task);
    const thisLogEntry = ref();
    const viewMoreLogs = ref(false);
    const allLogsForThisTask = ref("");
    const pollInterval = ref();
    const closeModal = () => {
      showLogView.value = false;
      emit("close");
    };
    function logColor(line) {
      if (line.includes("systemd")) {
        if (line.includes("Failed") || line.includes("FAILURE") || line.includes("Stopped") || line.includes("error") || line.includes("Error") || line.includes("ERROR") || line.includes("Exception")) {
          return "text-danger";
        } else if (line.includes("Succeeded") || line.includes("Starting") || line.includes("Started")) {
          return "text-success";
        } else if (line.includes("restart") || line.includes("too quickly")) {
          return "text-warning";
        }
      } else if (line.includes("python")) {
        return "text-default";
      } else {
        return "text-muted";
      }
    }
    watch(viewMoreLogs, async (newVal, oldVal) => {
      if (viewMoreLogs.value) {
        fetchAllLogs();
      }
    });
    const fetchLatestLog = async () => {
      loadingLogs.value = true;
      try {
        const latestLog = await myTaskLog.getLatestEntryFor(taskInstance.value);
        if (latestLog) {
          thisLogEntry.value = latestLog;
        }
      } catch (error) {
        console.error("Failed to fetch logs:", error);
      } finally {
        loadingLogs.value = false;
      }
    };
    const fetchAllLogs = async () => {
      var _a;
      loadingMoreLogs.value = true;
      try {
        const logs = await myTaskLog.getEntriesFor(taskInstance.value, (_a = thisLogEntry.value) == null ? void 0 : _a.startDate);
        allLogsForThisTask.value = logs;
      } catch (error) {
        console.error("Failed to fetch logs:", error);
      } finally {
        loadingMoreLogs.value = false;
      }
    };
    const startPolling = () => {
      pollInterval.value = setInterval(() => {
        fetchLatestLog();
        if (viewMoreLogs.value) {
          fetchAllLogs();
        }
      }, 3e4);
    };
    const stopPolling = () => {
      if (pollInterval.value) {
        clearInterval(pollInterval.value);
        pollInterval.value = null;
      }
    };
    watch(showLogView, (newVal) => {
      if (newVal) {
        startPolling();
      } else {
        stopPolling();
      }
    });
    onMounted(() => {
      fetchLatestLog();
      startPolling();
    });
    onUnmounted(() => {
      stopPolling();
    });
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$2, {
        onClose: closeModal,
        isOpen: unref(showLogView),
        "margin-top": "mt-10",
        width: "w-3/5",
        "min-width": "min-w-3/5",
        height: "h-min",
        "min-height": "min-h-min",
        "close-on-background-click": true
      }, {
        title: withCtx(() => [
          createBaseVNode("div", _hoisted_1, [
            createBaseVNode("h3", null, [
              createTextVNode("Latest Task Exection Result for "),
              createBaseVNode("span", _hoisted_2, toDisplayString(props.task.name), 1)
            ])
          ])
        ]),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            loadingLogs.value ? (openBlock(), createElementBlock("div", _hoisted_3, [
              createVNode(_sfc_main$1, {
                width: "w-20",
                height: "h-20",
                baseColor: "text-gray-200",
                fillColor: "fill-gray-500"
              })
            ])) : (openBlock(), createElementBlock("div", _hoisted_4, [
              thisLogEntry.value !== void 0 ? (openBlock(), createElementBlock("div", _hoisted_5, [
                createBaseVNode("div", _hoisted_6, [
                  createBaseVNode("div", _hoisted_7, [
                    createBaseVNode("div", _hoisted_8, [
                      createBaseVNode("p", _hoisted_9, "Last Executed at " + toDisplayString(thisLogEntry.value.startDate), 1),
                      createBaseVNode("p", _hoisted_10, "Finished at " + toDisplayString(thisLogEntry.value.finishDate), 1),
                      createBaseVNode("p", _hoisted_11, "Exit Code: " + toDisplayString(thisLogEntry.value.exitCode), 1)
                    ]),
                    createBaseVNode("div", _hoisted_12, [
                      _hoisted_13,
                      createVNode(unref(ue), {
                        modelValue: viewMoreLogs.value,
                        "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => viewMoreLogs.value = $event),
                        class: normalizeClass([viewMoreLogs.value ? "bg-secondary" : "bg-default", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                      }, {
                        default: withCtx(() => [
                          _hoisted_14,
                          createBaseVNode("span", {
                            class: normalizeClass([viewMoreLogs.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                          }, [
                            createBaseVNode("span", {
                              class: normalizeClass([viewMoreLogs.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                              "aria-hidden": "true"
                            }, _hoisted_16, 2),
                            createBaseVNode("span", {
                              class: normalizeClass([viewMoreLogs.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                              "aria-hidden": "true"
                            }, _hoisted_18, 2)
                          ], 2)
                        ]),
                        _: 1
                      }, 8, ["modelValue", "class"])
                    ])
                  ]),
                  createBaseVNode("div", _hoisted_19, [
                    createBaseVNode("ul", _hoisted_20, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(thisLogEntry.value.output.split("\n"), (line, idx) => {
                        return openBlock(), createElementBlock("li", {
                          key: idx,
                          class: normalizeClass(["m-1 block text-sm leading-6 text-default", logColor(line)])
                        }, toDisplayString(line), 3);
                      }), 128)),
                      viewMoreLogs.value && !loadingMoreLogs.value ? (openBlock(), createElementBlock("li", _hoisted_21, " Previous Logs")) : createCommentVNode("", true),
                      viewMoreLogs.value && !loadingMoreLogs.value ? (openBlock(true), createElementBlock(Fragment, { key: 1 }, renderList(allLogsForThisTask.value.split("\n"), (line, idx) => {
                        return openBlock(), createElementBlock("li", {
                          key: idx,
                          class: normalizeClass(["m-1 block text-sm leading-6 text-default", logColor(line)])
                        }, toDisplayString(line), 3);
                      }), 128)) : createCommentVNode("", true),
                      loadingMoreLogs.value ? (openBlock(), createElementBlock("li", _hoisted_22, [
                        createVNode(_sfc_main$1, {
                          width: "w-20",
                          height: "h-20",
                          baseColor: "text-gray-200",
                          fillColor: "fill-gray-500"
                        })
                      ])) : createCommentVNode("", true)
                    ])
                  ])
                ])
              ])) : createCommentVNode("", true)
            ]))
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_23, [
            createBaseVNode("div", _hoisted_24, [
              createBaseVNode("button", {
                onClick: withModifiers(closeModal, ["stop"]),
                id: "close-view-logs-btn",
                name: "close-view-logs-btn",
                class: "btn btn-danger h-fit w-full"
              }, "Close")
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
