var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
(function polyfill() {
  const relList = document.createElement("link").relList;
  if (relList && relList.supports && relList.supports("modulepreload")) {
    return;
  }
  for (const link of document.querySelectorAll('link[rel="modulepreload"]')) {
    processPreload(link);
  }
  new MutationObserver((mutations) => {
    for (const mutation of mutations) {
      if (mutation.type !== "childList") {
        continue;
      }
      for (const node of mutation.addedNodes) {
        if (node.tagName === "LINK" && node.rel === "modulepreload")
          processPreload(node);
      }
    }
  }).observe(document, { childList: true, subtree: true });
  function getFetchOpts(script) {
    const fetchOpts = {};
    if (script.integrity)
      fetchOpts.integrity = script.integrity;
    if (script.referrerpolicy)
      fetchOpts.referrerPolicy = script.referrerpolicy;
    if (script.crossorigin === "use-credentials")
      fetchOpts.credentials = "include";
    else if (script.crossorigin === "anonymous")
      fetchOpts.credentials = "omit";
    else
      fetchOpts.credentials = "same-origin";
    return fetchOpts;
  }
  function processPreload(link) {
    if (link.ep)
      return;
    link.ep = true;
    const fetchOpts = getFetchOpts(link);
    fetch(link.href, fetchOpts);
  }
})();
/**
* @vue/shared v3.4.27
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
/*! #__NO_SIDE_EFFECTS__ */
function makeMap(str, expectsLowerCase) {
  const set2 = new Set(str.split(","));
  return expectsLowerCase ? (val) => set2.has(val.toLowerCase()) : (val) => set2.has(val);
}
const EMPTY_OBJ = {};
const EMPTY_ARR = [];
const NOOP = () => {
};
const NO = () => false;
const isOn = (key) => key.charCodeAt(0) === 111 && key.charCodeAt(1) === 110 && (key.charCodeAt(2) > 122 || key.charCodeAt(2) < 97);
const isModelListener = (key) => key.startsWith("onUpdate:");
const extend = Object.assign;
const remove = (arr, el) => {
  const i = arr.indexOf(el);
  if (i > -1) {
    arr.splice(i, 1);
  }
};
const hasOwnProperty$2 = Object.prototype.hasOwnProperty;
const hasOwn$3 = (val, key) => hasOwnProperty$2.call(val, key);
const isArray = Array.isArray;
const isMap = (val) => toTypeString(val) === "[object Map]";
const isSet = (val) => toTypeString(val) === "[object Set]";
const isDate = (val) => toTypeString(val) === "[object Date]";
const isRegExp$1 = (val) => toTypeString(val) === "[object RegExp]";
const isFunction$1 = (val) => typeof val === "function";
const isString = (val) => typeof val === "string";
const isSymbol = (val) => typeof val === "symbol";
const isObject = (val) => val !== null && typeof val === "object";
const isPromise = (val) => {
  return (isObject(val) || isFunction$1(val)) && isFunction$1(val.then) && isFunction$1(val.catch);
};
const objectToString$1 = Object.prototype.toString;
const toTypeString = (value) => objectToString$1.call(value);
const toRawType = (value) => {
  return toTypeString(value).slice(8, -1);
};
const isPlainObject = (val) => toTypeString(val) === "[object Object]";
const isIntegerKey = (key) => isString(key) && key !== "NaN" && key[0] !== "-" && "" + parseInt(key, 10) === key;
const isReservedProp = /* @__PURE__ */ makeMap(
  ",key,ref,ref_for,ref_key,onVnodeBeforeMount,onVnodeMounted,onVnodeBeforeUpdate,onVnodeUpdated,onVnodeBeforeUnmount,onVnodeUnmounted"
);
const cacheStringFunction = (fn) => {
  const cache = /* @__PURE__ */ Object.create(null);
  return (str) => {
    const hit = cache[str];
    return hit || (cache[str] = fn(str));
  };
};
const camelizeRE = /-(\w)/g;
const camelize = cacheStringFunction((str) => {
  return str.replace(camelizeRE, (_, c) => c ? c.toUpperCase() : "");
});
const hyphenateRE = /\B([A-Z])/g;
const hyphenate = cacheStringFunction(
  (str) => str.replace(hyphenateRE, "-$1").toLowerCase()
);
const capitalize = cacheStringFunction((str) => {
  return str.charAt(0).toUpperCase() + str.slice(1);
});
const toHandlerKey = cacheStringFunction((str) => {
  const s = str ? `on${capitalize(str)}` : ``;
  return s;
});
const hasChanged = (value, oldValue) => !Object.is(value, oldValue);
const invokeArrayFns = (fns, arg) => {
  for (let i = 0; i < fns.length; i++) {
    fns[i](arg);
  }
};
const def = (obj, key, value, writable = false) => {
  Object.defineProperty(obj, key, {
    configurable: true,
    enumerable: false,
    writable,
    value
  });
};
const looseToNumber = (val) => {
  const n = parseFloat(val);
  return isNaN(n) ? val : n;
};
const toNumber = (val) => {
  const n = isString(val) ? Number(val) : NaN;
  return isNaN(n) ? val : n;
};
let _globalThis;
const getGlobalThis = () => {
  return _globalThis || (_globalThis = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {});
};
function normalizeStyle(value) {
  if (isArray(value)) {
    const res = {};
    for (let i = 0; i < value.length; i++) {
      const item = value[i];
      const normalized = isString(item) ? parseStringStyle(item) : normalizeStyle(item);
      if (normalized) {
        for (const key in normalized) {
          res[key] = normalized[key];
        }
      }
    }
    return res;
  } else if (isString(value) || isObject(value)) {
    return value;
  }
}
const listDelimiterRE = /;(?![^(]*\))/g;
const propertyDelimiterRE = /:([^]+)/;
const styleCommentRE = /\/\*[^]*?\*\//g;
function parseStringStyle(cssText) {
  const ret = {};
  cssText.replace(styleCommentRE, "").split(listDelimiterRE).forEach((item) => {
    if (item) {
      const tmp = item.split(propertyDelimiterRE);
      tmp.length > 1 && (ret[tmp[0].trim()] = tmp[1].trim());
    }
  });
  return ret;
}
function normalizeClass(value) {
  let res = "";
  if (isString(value)) {
    res = value;
  } else if (isArray(value)) {
    for (let i = 0; i < value.length; i++) {
      const normalized = normalizeClass(value[i]);
      if (normalized) {
        res += normalized + " ";
      }
    }
  } else if (isObject(value)) {
    for (const name in value) {
      if (value[name]) {
        res += name + " ";
      }
    }
  }
  return res.trim();
}
const specialBooleanAttrs = `itemscope,allowfullscreen,formnovalidate,ismap,nomodule,novalidate,readonly`;
const isSpecialBooleanAttr = /* @__PURE__ */ makeMap(specialBooleanAttrs);
function includeBooleanAttr(value) {
  return !!value || value === "";
}
function looseCompareArrays(a, b) {
  if (a.length !== b.length)
    return false;
  let equal = true;
  for (let i = 0; equal && i < a.length; i++) {
    equal = looseEqual(a[i], b[i]);
  }
  return equal;
}
function looseEqual(a, b) {
  if (a === b)
    return true;
  let aValidType = isDate(a);
  let bValidType = isDate(b);
  if (aValidType || bValidType) {
    return aValidType && bValidType ? a.getTime() === b.getTime() : false;
  }
  aValidType = isSymbol(a);
  bValidType = isSymbol(b);
  if (aValidType || bValidType) {
    return a === b;
  }
  aValidType = isArray(a);
  bValidType = isArray(b);
  if (aValidType || bValidType) {
    return aValidType && bValidType ? looseCompareArrays(a, b) : false;
  }
  aValidType = isObject(a);
  bValidType = isObject(b);
  if (aValidType || bValidType) {
    if (!aValidType || !bValidType) {
      return false;
    }
    const aKeysCount = Object.keys(a).length;
    const bKeysCount = Object.keys(b).length;
    if (aKeysCount !== bKeysCount) {
      return false;
    }
    for (const key in a) {
      const aHasKey = a.hasOwnProperty(key);
      const bHasKey = b.hasOwnProperty(key);
      if (aHasKey && !bHasKey || !aHasKey && bHasKey || !looseEqual(a[key], b[key])) {
        return false;
      }
    }
  }
  return String(a) === String(b);
}
function looseIndexOf(arr, val) {
  return arr.findIndex((item) => looseEqual(item, val));
}
const toDisplayString = (val) => {
  return isString(val) ? val : val == null ? "" : isArray(val) || isObject(val) && (val.toString === objectToString$1 || !isFunction$1(val.toString)) ? JSON.stringify(val, replacer, 2) : String(val);
};
const replacer = (_key, val) => {
  if (val && val.__v_isRef) {
    return replacer(_key, val.value);
  } else if (isMap(val)) {
    return {
      [`Map(${val.size})`]: [...val.entries()].reduce(
        (entries, [key, val2], i) => {
          entries[stringifySymbol(key, i) + " =>"] = val2;
          return entries;
        },
        {}
      )
    };
  } else if (isSet(val)) {
    return {
      [`Set(${val.size})`]: [...val.values()].map((v) => stringifySymbol(v))
    };
  } else if (isSymbol(val)) {
    return stringifySymbol(val);
  } else if (isObject(val) && !isArray(val) && !isPlainObject(val)) {
    return String(val);
  }
  return val;
};
const stringifySymbol = (v, i = "") => {
  var _a;
  return isSymbol(v) ? `Symbol(${(_a = v.description) != null ? _a : i})` : v;
};
/**
* @vue/reactivity v3.4.27
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
let activeEffectScope;
class EffectScope {
  constructor(detached = false) {
    this.detached = detached;
    this._active = true;
    this.effects = [];
    this.cleanups = [];
    this.parent = activeEffectScope;
    if (!detached && activeEffectScope) {
      this.index = (activeEffectScope.scopes || (activeEffectScope.scopes = [])).push(
        this
      ) - 1;
    }
  }
  get active() {
    return this._active;
  }
  run(fn) {
    if (this._active) {
      const currentEffectScope = activeEffectScope;
      try {
        activeEffectScope = this;
        return fn();
      } finally {
        activeEffectScope = currentEffectScope;
      }
    }
  }
  on() {
    activeEffectScope = this;
  }
  off() {
    activeEffectScope = this.parent;
  }
  stop(fromParent) {
    if (this._active) {
      let i, l;
      for (i = 0, l = this.effects.length; i < l; i++) {
        this.effects[i].stop();
      }
      for (i = 0, l = this.cleanups.length; i < l; i++) {
        this.cleanups[i]();
      }
      if (this.scopes) {
        for (i = 0, l = this.scopes.length; i < l; i++) {
          this.scopes[i].stop(true);
        }
      }
      if (!this.detached && this.parent && !fromParent) {
        const last = this.parent.scopes.pop();
        if (last && last !== this) {
          this.parent.scopes[this.index] = last;
          last.index = this.index;
        }
      }
      this.parent = void 0;
      this._active = false;
    }
  }
}
function recordEffectScope(effect, scope = activeEffectScope) {
  if (scope && scope.active) {
    scope.effects.push(effect);
  }
}
function getCurrentScope() {
  return activeEffectScope;
}
let activeEffect;
class ReactiveEffect {
  constructor(fn, trigger2, scheduler2, scope) {
    this.fn = fn;
    this.trigger = trigger2;
    this.scheduler = scheduler2;
    this.active = true;
    this.deps = [];
    this._dirtyLevel = 4;
    this._trackId = 0;
    this._runnings = 0;
    this._shouldSchedule = false;
    this._depsLength = 0;
    recordEffectScope(this, scope);
  }
  get dirty() {
    if (this._dirtyLevel === 2 || this._dirtyLevel === 3) {
      this._dirtyLevel = 1;
      pauseTracking();
      for (let i = 0; i < this._depsLength; i++) {
        const dep = this.deps[i];
        if (dep.computed) {
          triggerComputed(dep.computed);
          if (this._dirtyLevel >= 4) {
            break;
          }
        }
      }
      if (this._dirtyLevel === 1) {
        this._dirtyLevel = 0;
      }
      resetTracking();
    }
    return this._dirtyLevel >= 4;
  }
  set dirty(v) {
    this._dirtyLevel = v ? 4 : 0;
  }
  run() {
    this._dirtyLevel = 0;
    if (!this.active) {
      return this.fn();
    }
    let lastShouldTrack = shouldTrack;
    let lastEffect = activeEffect;
    try {
      shouldTrack = true;
      activeEffect = this;
      this._runnings++;
      preCleanupEffect(this);
      return this.fn();
    } finally {
      postCleanupEffect(this);
      this._runnings--;
      activeEffect = lastEffect;
      shouldTrack = lastShouldTrack;
    }
  }
  stop() {
    if (this.active) {
      preCleanupEffect(this);
      postCleanupEffect(this);
      this.onStop && this.onStop();
      this.active = false;
    }
  }
}
function triggerComputed(computed2) {
  return computed2.value;
}
function preCleanupEffect(effect2) {
  effect2._trackId++;
  effect2._depsLength = 0;
}
function postCleanupEffect(effect2) {
  if (effect2.deps.length > effect2._depsLength) {
    for (let i = effect2._depsLength; i < effect2.deps.length; i++) {
      cleanupDepEffect(effect2.deps[i], effect2);
    }
    effect2.deps.length = effect2._depsLength;
  }
}
function cleanupDepEffect(dep, effect2) {
  const trackId = dep.get(effect2);
  if (trackId !== void 0 && effect2._trackId !== trackId) {
    dep.delete(effect2);
    if (dep.size === 0) {
      dep.cleanup();
    }
  }
}
let shouldTrack = true;
let pauseScheduleStack = 0;
const trackStack = [];
function pauseTracking() {
  trackStack.push(shouldTrack);
  shouldTrack = false;
}
function resetTracking() {
  const last = trackStack.pop();
  shouldTrack = last === void 0 ? true : last;
}
function pauseScheduling() {
  pauseScheduleStack++;
}
function resetScheduling() {
  pauseScheduleStack--;
  while (!pauseScheduleStack && queueEffectSchedulers.length) {
    queueEffectSchedulers.shift()();
  }
}
function trackEffect(effect2, dep, debuggerEventExtraInfo) {
  if (dep.get(effect2) !== effect2._trackId) {
    dep.set(effect2, effect2._trackId);
    const oldDep = effect2.deps[effect2._depsLength];
    if (oldDep !== dep) {
      if (oldDep) {
        cleanupDepEffect(oldDep, effect2);
      }
      effect2.deps[effect2._depsLength++] = dep;
    } else {
      effect2._depsLength++;
    }
  }
}
const queueEffectSchedulers = [];
function triggerEffects(dep, dirtyLevel, debuggerEventExtraInfo) {
  pauseScheduling();
  for (const effect2 of dep.keys()) {
    let tracking;
    if (effect2._dirtyLevel < dirtyLevel && (tracking != null ? tracking : tracking = dep.get(effect2) === effect2._trackId)) {
      effect2._shouldSchedule || (effect2._shouldSchedule = effect2._dirtyLevel === 0);
      effect2._dirtyLevel = dirtyLevel;
    }
    if (effect2._shouldSchedule && (tracking != null ? tracking : tracking = dep.get(effect2) === effect2._trackId)) {
      effect2.trigger();
      if ((!effect2._runnings || effect2.allowRecurse) && effect2._dirtyLevel !== 2) {
        effect2._shouldSchedule = false;
        if (effect2.scheduler) {
          queueEffectSchedulers.push(effect2.scheduler);
        }
      }
    }
  }
  resetScheduling();
}
const createDep = (cleanup, computed2) => {
  const dep = /* @__PURE__ */ new Map();
  dep.cleanup = cleanup;
  dep.computed = computed2;
  return dep;
};
const targetMap = /* @__PURE__ */ new WeakMap();
const ITERATE_KEY = Symbol("");
const MAP_KEY_ITERATE_KEY = Symbol("");
function track(target, type2, key) {
  if (shouldTrack && activeEffect) {
    let depsMap = targetMap.get(target);
    if (!depsMap) {
      targetMap.set(target, depsMap = /* @__PURE__ */ new Map());
    }
    let dep = depsMap.get(key);
    if (!dep) {
      depsMap.set(key, dep = createDep(() => depsMap.delete(key)));
    }
    trackEffect(
      activeEffect,
      dep
    );
  }
}
function trigger(target, type2, key, newValue, oldValue, oldTarget) {
  const depsMap = targetMap.get(target);
  if (!depsMap) {
    return;
  }
  let deps = [];
  if (type2 === "clear") {
    deps = [...depsMap.values()];
  } else if (key === "length" && isArray(target)) {
    const newLength = Number(newValue);
    depsMap.forEach((dep, key2) => {
      if (key2 === "length" || !isSymbol(key2) && key2 >= newLength) {
        deps.push(dep);
      }
    });
  } else {
    if (key !== void 0) {
      deps.push(depsMap.get(key));
    }
    switch (type2) {
      case "add":
        if (!isArray(target)) {
          deps.push(depsMap.get(ITERATE_KEY));
          if (isMap(target)) {
            deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
          }
        } else if (isIntegerKey(key)) {
          deps.push(depsMap.get("length"));
        }
        break;
      case "delete":
        if (!isArray(target)) {
          deps.push(depsMap.get(ITERATE_KEY));
          if (isMap(target)) {
            deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
          }
        }
        break;
      case "set":
        if (isMap(target)) {
          deps.push(depsMap.get(ITERATE_KEY));
        }
        break;
    }
  }
  pauseScheduling();
  for (const dep of deps) {
    if (dep) {
      triggerEffects(
        dep,
        4
      );
    }
  }
  resetScheduling();
}
const isNonTrackableKeys = /* @__PURE__ */ makeMap(`__proto__,__v_isRef,__isVue`);
const builtInSymbols = new Set(
  /* @__PURE__ */ Object.getOwnPropertyNames(Symbol).filter((key) => key !== "arguments" && key !== "caller").map((key) => Symbol[key]).filter(isSymbol)
);
const arrayInstrumentations = /* @__PURE__ */ createArrayInstrumentations();
function createArrayInstrumentations() {
  const instrumentations = {};
  ["includes", "indexOf", "lastIndexOf"].forEach((key) => {
    instrumentations[key] = function(...args) {
      const arr = toRaw(this);
      for (let i = 0, l = this.length; i < l; i++) {
        track(arr, "get", i + "");
      }
      const res = arr[key](...args);
      if (res === -1 || res === false) {
        return arr[key](...args.map(toRaw));
      } else {
        return res;
      }
    };
  });
  ["push", "pop", "shift", "unshift", "splice"].forEach((key) => {
    instrumentations[key] = function(...args) {
      pauseTracking();
      pauseScheduling();
      const res = toRaw(this)[key].apply(this, args);
      resetScheduling();
      resetTracking();
      return res;
    };
  });
  return instrumentations;
}
function hasOwnProperty$1(key) {
  if (!isSymbol(key))
    key = String(key);
  const obj = toRaw(this);
  track(obj, "has", key);
  return obj.hasOwnProperty(key);
}
class BaseReactiveHandler {
  constructor(_isReadonly = false, _isShallow = false) {
    this._isReadonly = _isReadonly;
    this._isShallow = _isShallow;
  }
  get(target, key, receiver) {
    const isReadonly2 = this._isReadonly, isShallow2 = this._isShallow;
    if (key === "__v_isReactive") {
      return !isReadonly2;
    } else if (key === "__v_isReadonly") {
      return isReadonly2;
    } else if (key === "__v_isShallow") {
      return isShallow2;
    } else if (key === "__v_raw") {
      if (receiver === (isReadonly2 ? isShallow2 ? shallowReadonlyMap : readonlyMap : isShallow2 ? shallowReactiveMap : reactiveMap).get(target) || Object.getPrototypeOf(target) === Object.getPrototypeOf(receiver)) {
        return target;
      }
      return;
    }
    const targetIsArray = isArray(target);
    if (!isReadonly2) {
      if (targetIsArray && hasOwn$3(arrayInstrumentations, key)) {
        return Reflect.get(arrayInstrumentations, key, receiver);
      }
      if (key === "hasOwnProperty") {
        return hasOwnProperty$1;
      }
    }
    const res = Reflect.get(target, key, receiver);
    if (isSymbol(key) ? builtInSymbols.has(key) : isNonTrackableKeys(key)) {
      return res;
    }
    if (!isReadonly2) {
      track(target, "get", key);
    }
    if (isShallow2) {
      return res;
    }
    if (isRef(res)) {
      return targetIsArray && isIntegerKey(key) ? res : res.value;
    }
    if (isObject(res)) {
      return isReadonly2 ? readonly(res) : reactive(res);
    }
    return res;
  }
}
class MutableReactiveHandler extends BaseReactiveHandler {
  constructor(isShallow2 = false) {
    super(false, isShallow2);
  }
  set(target, key, value, receiver) {
    let oldValue = target[key];
    if (!this._isShallow) {
      const isOldValueReadonly = isReadonly(oldValue);
      if (!isShallow(value) && !isReadonly(value)) {
        oldValue = toRaw(oldValue);
        value = toRaw(value);
      }
      if (!isArray(target) && isRef(oldValue) && !isRef(value)) {
        if (isOldValueReadonly) {
          return false;
        } else {
          oldValue.value = value;
          return true;
        }
      }
    }
    const hadKey = isArray(target) && isIntegerKey(key) ? Number(key) < target.length : hasOwn$3(target, key);
    const result = Reflect.set(target, key, value, receiver);
    if (target === toRaw(receiver)) {
      if (!hadKey) {
        trigger(target, "add", key, value);
      } else if (hasChanged(value, oldValue)) {
        trigger(target, "set", key, value);
      }
    }
    return result;
  }
  deleteProperty(target, key) {
    const hadKey = hasOwn$3(target, key);
    target[key];
    const result = Reflect.deleteProperty(target, key);
    if (result && hadKey) {
      trigger(target, "delete", key, void 0);
    }
    return result;
  }
  has(target, key) {
    const result = Reflect.has(target, key);
    if (!isSymbol(key) || !builtInSymbols.has(key)) {
      track(target, "has", key);
    }
    return result;
  }
  ownKeys(target) {
    track(
      target,
      "iterate",
      isArray(target) ? "length" : ITERATE_KEY
    );
    return Reflect.ownKeys(target);
  }
}
class ReadonlyReactiveHandler extends BaseReactiveHandler {
  constructor(isShallow2 = false) {
    super(true, isShallow2);
  }
  set(target, key) {
    return true;
  }
  deleteProperty(target, key) {
    return true;
  }
}
const mutableHandlers = /* @__PURE__ */ new MutableReactiveHandler();
const readonlyHandlers = /* @__PURE__ */ new ReadonlyReactiveHandler();
const shallowReactiveHandlers = /* @__PURE__ */ new MutableReactiveHandler(
  true
);
const shallowReadonlyHandlers = /* @__PURE__ */ new ReadonlyReactiveHandler(true);
const toShallow = (value) => value;
const getProto$2 = (v) => Reflect.getPrototypeOf(v);
function get(target, key, isReadonly2 = false, isShallow2 = false) {
  target = target["__v_raw"];
  const rawTarget = toRaw(target);
  const rawKey = toRaw(key);
  if (!isReadonly2) {
    if (hasChanged(key, rawKey)) {
      track(rawTarget, "get", key);
    }
    track(rawTarget, "get", rawKey);
  }
  const { has: has2 } = getProto$2(rawTarget);
  const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
  if (has2.call(rawTarget, key)) {
    return wrap(target.get(key));
  } else if (has2.call(rawTarget, rawKey)) {
    return wrap(target.get(rawKey));
  } else if (target !== rawTarget) {
    target.get(key);
  }
}
function has(key, isReadonly2 = false) {
  const target = this["__v_raw"];
  const rawTarget = toRaw(target);
  const rawKey = toRaw(key);
  if (!isReadonly2) {
    if (hasChanged(key, rawKey)) {
      track(rawTarget, "has", key);
    }
    track(rawTarget, "has", rawKey);
  }
  return key === rawKey ? target.has(key) : target.has(key) || target.has(rawKey);
}
function size(target, isReadonly2 = false) {
  target = target["__v_raw"];
  !isReadonly2 && track(toRaw(target), "iterate", ITERATE_KEY);
  return Reflect.get(target, "size", target);
}
function add(value) {
  value = toRaw(value);
  const target = toRaw(this);
  const proto = getProto$2(target);
  const hadKey = proto.has.call(target, value);
  if (!hadKey) {
    target.add(value);
    trigger(target, "add", value, value);
  }
  return this;
}
function set(key, value) {
  value = toRaw(value);
  const target = toRaw(this);
  const { has: has2, get: get2 } = getProto$2(target);
  let hadKey = has2.call(target, key);
  if (!hadKey) {
    key = toRaw(key);
    hadKey = has2.call(target, key);
  }
  const oldValue = get2.call(target, key);
  target.set(key, value);
  if (!hadKey) {
    trigger(target, "add", key, value);
  } else if (hasChanged(value, oldValue)) {
    trigger(target, "set", key, value);
  }
  return this;
}
function deleteEntry(key) {
  const target = toRaw(this);
  const { has: has2, get: get2 } = getProto$2(target);
  let hadKey = has2.call(target, key);
  if (!hadKey) {
    key = toRaw(key);
    hadKey = has2.call(target, key);
  }
  get2 ? get2.call(target, key) : void 0;
  const result = target.delete(key);
  if (hadKey) {
    trigger(target, "delete", key, void 0);
  }
  return result;
}
function clear() {
  const target = toRaw(this);
  const hadItems = target.size !== 0;
  const result = target.clear();
  if (hadItems) {
    trigger(target, "clear", void 0, void 0);
  }
  return result;
}
function createForEach(isReadonly2, isShallow2) {
  return function forEach3(callback, thisArg) {
    const observed = this;
    const target = observed["__v_raw"];
    const rawTarget = toRaw(target);
    const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
    !isReadonly2 && track(rawTarget, "iterate", ITERATE_KEY);
    return target.forEach((value, key) => {
      return callback.call(thisArg, wrap(value), wrap(key), observed);
    });
  };
}
function createIterableMethod(method, isReadonly2, isShallow2) {
  return function(...args) {
    const target = this["__v_raw"];
    const rawTarget = toRaw(target);
    const targetIsMap = isMap(rawTarget);
    const isPair = method === "entries" || method === Symbol.iterator && targetIsMap;
    const isKeyOnly = method === "keys" && targetIsMap;
    const innerIterator = target[method](...args);
    const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
    !isReadonly2 && track(
      rawTarget,
      "iterate",
      isKeyOnly ? MAP_KEY_ITERATE_KEY : ITERATE_KEY
    );
    return {
      next() {
        const { value, done } = innerIterator.next();
        return done ? { value, done } : {
          value: isPair ? [wrap(value[0]), wrap(value[1])] : wrap(value),
          done
        };
      },
      [Symbol.iterator]() {
        return this;
      }
    };
  };
}
function createReadonlyMethod(type2) {
  return function(...args) {
    return type2 === "delete" ? false : type2 === "clear" ? void 0 : this;
  };
}
function createInstrumentations() {
  const mutableInstrumentations2 = {
    get(key) {
      return get(this, key);
    },
    get size() {
      return size(this);
    },
    has,
    add,
    set,
    delete: deleteEntry,
    clear,
    forEach: createForEach(false, false)
  };
  const shallowInstrumentations2 = {
    get(key) {
      return get(this, key, false, true);
    },
    get size() {
      return size(this);
    },
    has,
    add,
    set,
    delete: deleteEntry,
    clear,
    forEach: createForEach(false, true)
  };
  const readonlyInstrumentations2 = {
    get(key) {
      return get(this, key, true);
    },
    get size() {
      return size(this, true);
    },
    has(key) {
      return has.call(this, key, true);
    },
    add: createReadonlyMethod("add"),
    set: createReadonlyMethod("set"),
    delete: createReadonlyMethod("delete"),
    clear: createReadonlyMethod("clear"),
    forEach: createForEach(true, false)
  };
  const shallowReadonlyInstrumentations2 = {
    get(key) {
      return get(this, key, true, true);
    },
    get size() {
      return size(this, true);
    },
    has(key) {
      return has.call(this, key, true);
    },
    add: createReadonlyMethod("add"),
    set: createReadonlyMethod("set"),
    delete: createReadonlyMethod("delete"),
    clear: createReadonlyMethod("clear"),
    forEach: createForEach(true, true)
  };
  const iteratorMethods = [
    "keys",
    "values",
    "entries",
    Symbol.iterator
  ];
  iteratorMethods.forEach((method) => {
    mutableInstrumentations2[method] = createIterableMethod(method, false, false);
    readonlyInstrumentations2[method] = createIterableMethod(method, true, false);
    shallowInstrumentations2[method] = createIterableMethod(method, false, true);
    shallowReadonlyInstrumentations2[method] = createIterableMethod(
      method,
      true,
      true
    );
  });
  return [
    mutableInstrumentations2,
    readonlyInstrumentations2,
    shallowInstrumentations2,
    shallowReadonlyInstrumentations2
  ];
}
const [
  mutableInstrumentations,
  readonlyInstrumentations,
  shallowInstrumentations,
  shallowReadonlyInstrumentations
] = /* @__PURE__ */ createInstrumentations();
function createInstrumentationGetter(isReadonly2, shallow) {
  const instrumentations = shallow ? isReadonly2 ? shallowReadonlyInstrumentations : shallowInstrumentations : isReadonly2 ? readonlyInstrumentations : mutableInstrumentations;
  return (target, key, receiver) => {
    if (key === "__v_isReactive") {
      return !isReadonly2;
    } else if (key === "__v_isReadonly") {
      return isReadonly2;
    } else if (key === "__v_raw") {
      return target;
    }
    return Reflect.get(
      hasOwn$3(instrumentations, key) && key in target ? instrumentations : target,
      key,
      receiver
    );
  };
}
const mutableCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(false, false)
};
const shallowCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(false, true)
};
const readonlyCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(true, false)
};
const shallowReadonlyCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(true, true)
};
const reactiveMap = /* @__PURE__ */ new WeakMap();
const shallowReactiveMap = /* @__PURE__ */ new WeakMap();
const readonlyMap = /* @__PURE__ */ new WeakMap();
const shallowReadonlyMap = /* @__PURE__ */ new WeakMap();
function targetTypeMap(rawType) {
  switch (rawType) {
    case "Object":
    case "Array":
      return 1;
    case "Map":
    case "Set":
    case "WeakMap":
    case "WeakSet":
      return 2;
    default:
      return 0;
  }
}
function getTargetType(value) {
  return value["__v_skip"] || !Object.isExtensible(value) ? 0 : targetTypeMap(toRawType(value));
}
function reactive(target) {
  if (isReadonly(target)) {
    return target;
  }
  return createReactiveObject(
    target,
    false,
    mutableHandlers,
    mutableCollectionHandlers,
    reactiveMap
  );
}
function shallowReactive(target) {
  return createReactiveObject(
    target,
    false,
    shallowReactiveHandlers,
    shallowCollectionHandlers,
    shallowReactiveMap
  );
}
function readonly(target) {
  return createReactiveObject(
    target,
    true,
    readonlyHandlers,
    readonlyCollectionHandlers,
    readonlyMap
  );
}
function shallowReadonly(target) {
  return createReactiveObject(
    target,
    true,
    shallowReadonlyHandlers,
    shallowReadonlyCollectionHandlers,
    shallowReadonlyMap
  );
}
function createReactiveObject(target, isReadonly2, baseHandlers, collectionHandlers, proxyMap) {
  if (!isObject(target)) {
    return target;
  }
  if (target["__v_raw"] && !(isReadonly2 && target["__v_isReactive"])) {
    return target;
  }
  const existingProxy = proxyMap.get(target);
  if (existingProxy) {
    return existingProxy;
  }
  const targetType = getTargetType(target);
  if (targetType === 0) {
    return target;
  }
  const proxy = new Proxy(
    target,
    targetType === 2 ? collectionHandlers : baseHandlers
  );
  proxyMap.set(target, proxy);
  return proxy;
}
function isReactive(value) {
  if (isReadonly(value)) {
    return isReactive(value["__v_raw"]);
  }
  return !!(value && value["__v_isReactive"]);
}
function isReadonly(value) {
  return !!(value && value["__v_isReadonly"]);
}
function isShallow(value) {
  return !!(value && value["__v_isShallow"]);
}
function isProxy(value) {
  return value ? !!value["__v_raw"] : false;
}
function toRaw(observed) {
  const raw = observed && observed["__v_raw"];
  return raw ? toRaw(raw) : observed;
}
function markRaw(value) {
  if (Object.isExtensible(value)) {
    def(value, "__v_skip", true);
  }
  return value;
}
const toReactive = (value) => isObject(value) ? reactive(value) : value;
const toReadonly = (value) => isObject(value) ? readonly(value) : value;
class ComputedRefImpl {
  constructor(getter, _setter, isReadonly2, isSSR) {
    this.getter = getter;
    this._setter = _setter;
    this.dep = void 0;
    this.__v_isRef = true;
    this["__v_isReadonly"] = false;
    this.effect = new ReactiveEffect(
      () => getter(this._value),
      () => triggerRefValue(
        this,
        this.effect._dirtyLevel === 2 ? 2 : 3
      )
    );
    this.effect.computed = this;
    this.effect.active = this._cacheable = !isSSR;
    this["__v_isReadonly"] = isReadonly2;
  }
  get value() {
    const self2 = toRaw(this);
    if ((!self2._cacheable || self2.effect.dirty) && hasChanged(self2._value, self2._value = self2.effect.run())) {
      triggerRefValue(self2, 4);
    }
    trackRefValue(self2);
    if (self2.effect._dirtyLevel >= 2) {
      triggerRefValue(self2, 2);
    }
    return self2._value;
  }
  set value(newValue) {
    this._setter(newValue);
  }
  get _dirty() {
    return this.effect.dirty;
  }
  set _dirty(v) {
    this.effect.dirty = v;
  }
}
function computed$1(getterOrOptions, debugOptions, isSSR = false) {
  let getter;
  let setter;
  const onlyGetter = isFunction$1(getterOrOptions);
  if (onlyGetter) {
    getter = getterOrOptions;
    setter = NOOP;
  } else {
    getter = getterOrOptions.get;
    setter = getterOrOptions.set;
  }
  const cRef = new ComputedRefImpl(getter, setter, onlyGetter || !setter, isSSR);
  return cRef;
}
function trackRefValue(ref2) {
  var _a;
  if (shouldTrack && activeEffect) {
    ref2 = toRaw(ref2);
    trackEffect(
      activeEffect,
      (_a = ref2.dep) != null ? _a : ref2.dep = createDep(
        () => ref2.dep = void 0,
        ref2 instanceof ComputedRefImpl ? ref2 : void 0
      )
    );
  }
}
function triggerRefValue(ref2, dirtyLevel = 4, newVal) {
  ref2 = toRaw(ref2);
  const dep = ref2.dep;
  if (dep) {
    triggerEffects(
      dep,
      dirtyLevel
    );
  }
}
function isRef(r) {
  return !!(r && r.__v_isRef === true);
}
function ref$1(value) {
  return createRef(value, false);
}
function shallowRef(value) {
  return createRef(value, true);
}
function createRef(rawValue, shallow) {
  if (isRef(rawValue)) {
    return rawValue;
  }
  return new RefImpl(rawValue, shallow);
}
class RefImpl {
  constructor(value, __v_isShallow) {
    this.__v_isShallow = __v_isShallow;
    this.dep = void 0;
    this.__v_isRef = true;
    this._rawValue = __v_isShallow ? value : toRaw(value);
    this._value = __v_isShallow ? value : toReactive(value);
  }
  get value() {
    trackRefValue(this);
    return this._value;
  }
  set value(newVal) {
    const useDirectValue = this.__v_isShallow || isShallow(newVal) || isReadonly(newVal);
    newVal = useDirectValue ? newVal : toRaw(newVal);
    if (hasChanged(newVal, this._rawValue)) {
      this._rawValue = newVal;
      this._value = useDirectValue ? newVal : toReactive(newVal);
      triggerRefValue(this, 4);
    }
  }
}
function unref(ref2) {
  return isRef(ref2) ? ref2.value : ref2;
}
const shallowUnwrapHandlers = {
  get: (target, key, receiver) => unref(Reflect.get(target, key, receiver)),
  set: (target, key, value, receiver) => {
    const oldValue = target[key];
    if (isRef(oldValue) && !isRef(value)) {
      oldValue.value = value;
      return true;
    } else {
      return Reflect.set(target, key, value, receiver);
    }
  }
};
function proxyRefs(objectWithRefs) {
  return isReactive(objectWithRefs) ? objectWithRefs : new Proxy(objectWithRefs, shallowUnwrapHandlers);
}
/**
* @vue/runtime-core v3.4.27
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
const stack = [];
function warn$1(msg, ...args) {
  pauseTracking();
  const instance = stack.length ? stack[stack.length - 1].component : null;
  const appWarnHandler = instance && instance.appContext.config.warnHandler;
  const trace = getComponentTrace();
  if (appWarnHandler) {
    callWithErrorHandling(
      appWarnHandler,
      instance,
      11,
      [
        msg + args.map((a) => {
          var _a, _b;
          return (_b = (_a = a.toString) == null ? void 0 : _a.call(a)) != null ? _b : JSON.stringify(a);
        }).join(""),
        instance && instance.proxy,
        trace.map(
          ({ vnode }) => `at <${formatComponentName(instance, vnode.type)}>`
        ).join("\n"),
        trace
      ]
    );
  } else {
    const warnArgs = [`[Vue warn]: ${msg}`, ...args];
    if (trace.length && true) {
      warnArgs.push(`
`, ...formatTrace(trace));
    }
    console.warn(...warnArgs);
  }
  resetTracking();
}
function getComponentTrace() {
  let currentVNode = stack[stack.length - 1];
  if (!currentVNode) {
    return [];
  }
  const normalizedStack = [];
  while (currentVNode) {
    const last = normalizedStack[0];
    if (last && last.vnode === currentVNode) {
      last.recurseCount++;
    } else {
      normalizedStack.push({
        vnode: currentVNode,
        recurseCount: 0
      });
    }
    const parentInstance = currentVNode.component && currentVNode.component.parent;
    currentVNode = parentInstance && parentInstance.vnode;
  }
  return normalizedStack;
}
function formatTrace(trace) {
  const logs = [];
  trace.forEach((entry, i) => {
    logs.push(...i === 0 ? [] : [`
`], ...formatTraceEntry(entry));
  });
  return logs;
}
function formatTraceEntry({ vnode, recurseCount }) {
  const postfix = recurseCount > 0 ? `... (${recurseCount} recursive calls)` : ``;
  const isRoot = vnode.component ? vnode.component.parent == null : false;
  const open = ` at <${formatComponentName(
    vnode.component,
    vnode.type,
    isRoot
  )}`;
  const close = `>` + postfix;
  return vnode.props ? [open, ...formatProps(vnode.props), close] : [open + close];
}
function formatProps(props) {
  const res = [];
  const keys3 = Object.keys(props);
  keys3.slice(0, 3).forEach((key) => {
    res.push(...formatProp(key, props[key]));
  });
  if (keys3.length > 3) {
    res.push(` ...`);
  }
  return res;
}
function formatProp(key, value, raw) {
  if (isString(value)) {
    value = JSON.stringify(value);
    return raw ? value : [`${key}=${value}`];
  } else if (typeof value === "number" || typeof value === "boolean" || value == null) {
    return raw ? value : [`${key}=${value}`];
  } else if (isRef(value)) {
    value = formatProp(key, toRaw(value.value), true);
    return raw ? value : [`${key}=Ref<`, value, `>`];
  } else if (isFunction$1(value)) {
    return [`${key}=fn${value.name ? `<${value.name}>` : ``}`];
  } else {
    value = toRaw(value);
    return raw ? value : [`${key}=`, value];
  }
}
function callWithErrorHandling(fn, instance, type2, args) {
  try {
    return args ? fn(...args) : fn();
  } catch (err2) {
    handleError(err2, instance, type2);
  }
}
function callWithAsyncErrorHandling(fn, instance, type2, args) {
  if (isFunction$1(fn)) {
    const res = callWithErrorHandling(fn, instance, type2, args);
    if (res && isPromise(res)) {
      res.catch((err2) => {
        handleError(err2, instance, type2);
      });
    }
    return res;
  }
  if (isArray(fn)) {
    const values = [];
    for (let i = 0; i < fn.length; i++) {
      values.push(callWithAsyncErrorHandling(fn[i], instance, type2, args));
    }
    return values;
  }
}
function handleError(err2, instance, type2, throwInDev = true) {
  const contextVNode = instance ? instance.vnode : null;
  if (instance) {
    let cur = instance.parent;
    const exposedInstance = instance.proxy;
    const errorInfo = `https://vuejs.org/error-reference/#runtime-${type2}`;
    while (cur) {
      const errorCapturedHooks = cur.ec;
      if (errorCapturedHooks) {
        for (let i = 0; i < errorCapturedHooks.length; i++) {
          if (errorCapturedHooks[i](err2, exposedInstance, errorInfo) === false) {
            return;
          }
        }
      }
      cur = cur.parent;
    }
    const appErrorHandler = instance.appContext.config.errorHandler;
    if (appErrorHandler) {
      pauseTracking();
      callWithErrorHandling(
        appErrorHandler,
        null,
        10,
        [err2, exposedInstance, errorInfo]
      );
      resetTracking();
      return;
    }
  }
  logError(err2, type2, contextVNode, throwInDev);
}
function logError(err2, type2, contextVNode, throwInDev = true) {
  {
    console.error(err2);
  }
}
let isFlushing = false;
let isFlushPending = false;
const queue = [];
let flushIndex = 0;
const pendingPostFlushCbs = [];
let activePostFlushCbs = null;
let postFlushIndex = 0;
const resolvedPromise = /* @__PURE__ */ Promise.resolve();
let currentFlushPromise = null;
function nextTick(fn) {
  const p2 = currentFlushPromise || resolvedPromise;
  return fn ? p2.then(this ? fn.bind(this) : fn) : p2;
}
function findInsertionIndex(id) {
  let start = flushIndex + 1;
  let end = queue.length;
  while (start < end) {
    const middle = start + end >>> 1;
    const middleJob = queue[middle];
    const middleJobId = getId(middleJob);
    if (middleJobId < id || middleJobId === id && middleJob.pre) {
      start = middle + 1;
    } else {
      end = middle;
    }
  }
  return start;
}
function queueJob(job) {
  if (!queue.length || !queue.includes(
    job,
    isFlushing && job.allowRecurse ? flushIndex + 1 : flushIndex
  )) {
    if (job.id == null) {
      queue.push(job);
    } else {
      queue.splice(findInsertionIndex(job.id), 0, job);
    }
    queueFlush();
  }
}
function queueFlush() {
  if (!isFlushing && !isFlushPending) {
    isFlushPending = true;
    currentFlushPromise = resolvedPromise.then(flushJobs);
  }
}
function invalidateJob(job) {
  const i = queue.indexOf(job);
  if (i > flushIndex) {
    queue.splice(i, 1);
  }
}
function queuePostFlushCb(cb) {
  if (!isArray(cb)) {
    if (!activePostFlushCbs || !activePostFlushCbs.includes(
      cb,
      cb.allowRecurse ? postFlushIndex + 1 : postFlushIndex
    )) {
      pendingPostFlushCbs.push(cb);
    }
  } else {
    pendingPostFlushCbs.push(...cb);
  }
  queueFlush();
}
function flushPreFlushCbs(instance, seen2, i = isFlushing ? flushIndex + 1 : 0) {
  for (; i < queue.length; i++) {
    const cb = queue[i];
    if (cb && cb.pre) {
      if (instance && cb.id !== instance.uid) {
        continue;
      }
      queue.splice(i, 1);
      i--;
      cb();
    }
  }
}
function flushPostFlushCbs(seen2) {
  if (pendingPostFlushCbs.length) {
    const deduped = [...new Set(pendingPostFlushCbs)].sort(
      (a, b) => getId(a) - getId(b)
    );
    pendingPostFlushCbs.length = 0;
    if (activePostFlushCbs) {
      activePostFlushCbs.push(...deduped);
      return;
    }
    activePostFlushCbs = deduped;
    for (postFlushIndex = 0; postFlushIndex < activePostFlushCbs.length; postFlushIndex++) {
      activePostFlushCbs[postFlushIndex]();
    }
    activePostFlushCbs = null;
    postFlushIndex = 0;
  }
}
const getId = (job) => job.id == null ? Infinity : job.id;
const comparator = (a, b) => {
  const diff = getId(a) - getId(b);
  if (diff === 0) {
    if (a.pre && !b.pre)
      return -1;
    if (b.pre && !a.pre)
      return 1;
  }
  return diff;
};
function flushJobs(seen2) {
  isFlushPending = false;
  isFlushing = true;
  queue.sort(comparator);
  const check = NOOP;
  try {
    for (flushIndex = 0; flushIndex < queue.length; flushIndex++) {
      const job = queue[flushIndex];
      if (job && job.active !== false) {
        if (false)
          ;
        callWithErrorHandling(job, null, 14);
      }
    }
  } finally {
    flushIndex = 0;
    queue.length = 0;
    flushPostFlushCbs();
    isFlushing = false;
    currentFlushPromise = null;
    if (queue.length || pendingPostFlushCbs.length) {
      flushJobs();
    }
  }
}
function emit(instance, event, ...rawArgs) {
  if (instance.isUnmounted)
    return;
  const props = instance.vnode.props || EMPTY_OBJ;
  let args = rawArgs;
  const isModelListener2 = event.startsWith("update:");
  const modelArg = isModelListener2 && event.slice(7);
  if (modelArg && modelArg in props) {
    const modifiersKey = `${modelArg === "modelValue" ? "model" : modelArg}Modifiers`;
    const { number, trim } = props[modifiersKey] || EMPTY_OBJ;
    if (trim) {
      args = rawArgs.map((a) => isString(a) ? a.trim() : a);
    }
    if (number) {
      args = rawArgs.map(looseToNumber);
    }
  }
  let handlerName;
  let handler = props[handlerName = toHandlerKey(event)] || props[handlerName = toHandlerKey(camelize(event))];
  if (!handler && isModelListener2) {
    handler = props[handlerName = toHandlerKey(hyphenate(event))];
  }
  if (handler) {
    callWithAsyncErrorHandling(
      handler,
      instance,
      6,
      args
    );
  }
  const onceHandler = props[handlerName + `Once`];
  if (onceHandler) {
    if (!instance.emitted) {
      instance.emitted = {};
    } else if (instance.emitted[handlerName]) {
      return;
    }
    instance.emitted[handlerName] = true;
    callWithAsyncErrorHandling(
      onceHandler,
      instance,
      6,
      args
    );
  }
}
function normalizeEmitsOptions(comp, appContext, asMixin = false) {
  const cache = appContext.emitsCache;
  const cached = cache.get(comp);
  if (cached !== void 0) {
    return cached;
  }
  const raw = comp.emits;
  let normalized = {};
  let hasExtends = false;
  if (!isFunction$1(comp)) {
    const extendEmits = (raw2) => {
      const normalizedFromExtend = normalizeEmitsOptions(raw2, appContext, true);
      if (normalizedFromExtend) {
        hasExtends = true;
        extend(normalized, normalizedFromExtend);
      }
    };
    if (!asMixin && appContext.mixins.length) {
      appContext.mixins.forEach(extendEmits);
    }
    if (comp.extends) {
      extendEmits(comp.extends);
    }
    if (comp.mixins) {
      comp.mixins.forEach(extendEmits);
    }
  }
  if (!raw && !hasExtends) {
    if (isObject(comp)) {
      cache.set(comp, null);
    }
    return null;
  }
  if (isArray(raw)) {
    raw.forEach((key) => normalized[key] = null);
  } else {
    extend(normalized, raw);
  }
  if (isObject(comp)) {
    cache.set(comp, normalized);
  }
  return normalized;
}
function isEmitListener(options, key) {
  if (!options || !isOn(key)) {
    return false;
  }
  key = key.slice(2).replace(/Once$/, "");
  return hasOwn$3(options, key[0].toLowerCase() + key.slice(1)) || hasOwn$3(options, hyphenate(key)) || hasOwn$3(options, key);
}
let currentRenderingInstance = null;
let currentScopeId = null;
function setCurrentRenderingInstance(instance) {
  const prev = currentRenderingInstance;
  currentRenderingInstance = instance;
  currentScopeId = instance && instance.type.__scopeId || null;
  return prev;
}
function pushScopeId(id) {
  currentScopeId = id;
}
function popScopeId() {
  currentScopeId = null;
}
function withCtx(fn, ctx = currentRenderingInstance, isNonScopedSlot) {
  if (!ctx)
    return fn;
  if (fn._n) {
    return fn;
  }
  const renderFnWithContext = (...args) => {
    if (renderFnWithContext._d) {
      setBlockTracking(-1);
    }
    const prevInstance = setCurrentRenderingInstance(ctx);
    let res;
    try {
      res = fn(...args);
    } finally {
      setCurrentRenderingInstance(prevInstance);
      if (renderFnWithContext._d) {
        setBlockTracking(1);
      }
    }
    return res;
  };
  renderFnWithContext._n = true;
  renderFnWithContext._c = true;
  renderFnWithContext._d = true;
  return renderFnWithContext;
}
function markAttrsAccessed() {
}
function renderComponentRoot(instance) {
  const {
    type: Component,
    vnode,
    proxy,
    withProxy,
    propsOptions: [propsOptions],
    slots,
    attrs,
    emit: emit2,
    render: render2,
    renderCache,
    props,
    data,
    setupState,
    ctx,
    inheritAttrs
  } = instance;
  const prev = setCurrentRenderingInstance(instance);
  let result;
  let fallthroughAttrs;
  try {
    if (vnode.shapeFlag & 4) {
      const proxyToUse = withProxy || proxy;
      const thisProxy = false ? new Proxy(proxyToUse, {
        get(target, key, receiver) {
          warn$1(
            `Property '${String(
              key
            )}' was accessed via 'this'. Avoid using 'this' in templates.`
          );
          return Reflect.get(target, key, receiver);
        }
      }) : proxyToUse;
      result = normalizeVNode(
        render2.call(
          thisProxy,
          proxyToUse,
          renderCache,
          false ? shallowReadonly(props) : props,
          setupState,
          data,
          ctx
        )
      );
      fallthroughAttrs = attrs;
    } else {
      const render22 = Component;
      if (false)
        ;
      result = normalizeVNode(
        render22.length > 1 ? render22(
          false ? shallowReadonly(props) : props,
          false ? {
            get attrs() {
              markAttrsAccessed();
              return shallowReadonly(attrs);
            },
            slots,
            emit: emit2
          } : { attrs, slots, emit: emit2 }
        ) : render22(
          false ? shallowReadonly(props) : props,
          null
        )
      );
      fallthroughAttrs = Component.props ? attrs : getFunctionalFallthrough(attrs);
    }
  } catch (err2) {
    blockStack.length = 0;
    handleError(err2, instance, 1);
    result = createVNode(Comment);
  }
  let root = result;
  if (fallthroughAttrs && inheritAttrs !== false) {
    const keys3 = Object.keys(fallthroughAttrs);
    const { shapeFlag } = root;
    if (keys3.length) {
      if (shapeFlag & (1 | 6)) {
        if (propsOptions && keys3.some(isModelListener)) {
          fallthroughAttrs = filterModelListeners(
            fallthroughAttrs,
            propsOptions
          );
        }
        root = cloneVNode(root, fallthroughAttrs, false, true);
      }
    }
  }
  if (vnode.dirs) {
    root = cloneVNode(root, null, false, true);
    root.dirs = root.dirs ? root.dirs.concat(vnode.dirs) : vnode.dirs;
  }
  if (vnode.transition) {
    root.transition = vnode.transition;
  }
  {
    result = root;
  }
  setCurrentRenderingInstance(prev);
  return result;
}
const getFunctionalFallthrough = (attrs) => {
  let res;
  for (const key in attrs) {
    if (key === "class" || key === "style" || isOn(key)) {
      (res || (res = {}))[key] = attrs[key];
    }
  }
  return res;
};
const filterModelListeners = (attrs, props) => {
  const res = {};
  for (const key in attrs) {
    if (!isModelListener(key) || !(key.slice(9) in props)) {
      res[key] = attrs[key];
    }
  }
  return res;
};
function shouldUpdateComponent(prevVNode, nextVNode, optimized) {
  const { props: prevProps, children: prevChildren, component } = prevVNode;
  const { props: nextProps, children: nextChildren, patchFlag } = nextVNode;
  const emits = component.emitsOptions;
  if (nextVNode.dirs || nextVNode.transition) {
    return true;
  }
  if (optimized && patchFlag >= 0) {
    if (patchFlag & 1024) {
      return true;
    }
    if (patchFlag & 16) {
      if (!prevProps) {
        return !!nextProps;
      }
      return hasPropsChanged(prevProps, nextProps, emits);
    } else if (patchFlag & 8) {
      const dynamicProps = nextVNode.dynamicProps;
      for (let i = 0; i < dynamicProps.length; i++) {
        const key = dynamicProps[i];
        if (nextProps[key] !== prevProps[key] && !isEmitListener(emits, key)) {
          return true;
        }
      }
    }
  } else {
    if (prevChildren || nextChildren) {
      if (!nextChildren || !nextChildren.$stable) {
        return true;
      }
    }
    if (prevProps === nextProps) {
      return false;
    }
    if (!prevProps) {
      return !!nextProps;
    }
    if (!nextProps) {
      return true;
    }
    return hasPropsChanged(prevProps, nextProps, emits);
  }
  return false;
}
function hasPropsChanged(prevProps, nextProps, emitsOptions) {
  const nextKeys = Object.keys(nextProps);
  if (nextKeys.length !== Object.keys(prevProps).length) {
    return true;
  }
  for (let i = 0; i < nextKeys.length; i++) {
    const key = nextKeys[i];
    if (nextProps[key] !== prevProps[key] && !isEmitListener(emitsOptions, key)) {
      return true;
    }
  }
  return false;
}
function updateHOCHostEl({ vnode, parent }, el) {
  while (parent) {
    const root = parent.subTree;
    if (root.suspense && root.suspense.activeBranch === vnode) {
      root.el = vnode.el;
    }
    if (root === vnode) {
      (vnode = parent.vnode).el = el;
      parent = parent.parent;
    } else {
      break;
    }
  }
}
const COMPONENTS = "components";
function resolveComponent(name, maybeSelfReference) {
  return resolveAsset(COMPONENTS, name, true, maybeSelfReference) || name;
}
const NULL_DYNAMIC_COMPONENT = Symbol.for("v-ndc");
function resolveDynamicComponent(component) {
  if (isString(component)) {
    return resolveAsset(COMPONENTS, component, false) || component;
  } else {
    return component || NULL_DYNAMIC_COMPONENT;
  }
}
function resolveAsset(type2, name, warnMissing = true, maybeSelfReference = false) {
  const instance = currentRenderingInstance || currentInstance;
  if (instance) {
    const Component = instance.type;
    if (type2 === COMPONENTS) {
      const selfName = getComponentName(
        Component,
        false
      );
      if (selfName && (selfName === name || selfName === camelize(name) || selfName === capitalize(camelize(name)))) {
        return Component;
      }
    }
    const res = resolve(instance[type2] || Component[type2], name) || resolve(instance.appContext[type2], name);
    if (!res && maybeSelfReference) {
      return Component;
    }
    return res;
  }
}
function resolve(registry, name) {
  return registry && (registry[name] || registry[camelize(name)] || registry[capitalize(camelize(name))]);
}
const isSuspense = (type2) => type2.__isSuspense;
function queueEffectWithSuspense(fn, suspense) {
  if (suspense && suspense.pendingBranch) {
    if (isArray(fn)) {
      suspense.effects.push(...fn);
    } else {
      suspense.effects.push(fn);
    }
  } else {
    queuePostFlushCb(fn);
  }
}
const ssrContextKey = Symbol.for("v-scx");
const useSSRContext = () => {
  {
    const ctx = inject(ssrContextKey);
    return ctx;
  }
};
function watchEffect(effect, options) {
  return doWatch(effect, null, options);
}
const INITIAL_WATCHER_VALUE = {};
function watch(source, cb, options) {
  return doWatch(source, cb, options);
}
function doWatch(source, cb, {
  immediate,
  deep,
  flush,
  once,
  onTrack,
  onTrigger
} = EMPTY_OBJ) {
  if (cb && once) {
    const _cb = cb;
    cb = (...args) => {
      _cb(...args);
      unwatch();
    };
  }
  const instance = currentInstance;
  const reactiveGetter = (source2) => deep === true ? source2 : traverse(source2, deep === false ? 1 : void 0);
  let getter;
  let forceTrigger = false;
  let isMultiSource = false;
  if (isRef(source)) {
    getter = () => source.value;
    forceTrigger = isShallow(source);
  } else if (isReactive(source)) {
    getter = () => reactiveGetter(source);
    forceTrigger = true;
  } else if (isArray(source)) {
    isMultiSource = true;
    forceTrigger = source.some((s) => isReactive(s) || isShallow(s));
    getter = () => source.map((s) => {
      if (isRef(s)) {
        return s.value;
      } else if (isReactive(s)) {
        return reactiveGetter(s);
      } else if (isFunction$1(s)) {
        return callWithErrorHandling(s, instance, 2);
      } else
        ;
    });
  } else if (isFunction$1(source)) {
    if (cb) {
      getter = () => callWithErrorHandling(source, instance, 2);
    } else {
      getter = () => {
        if (cleanup) {
          cleanup();
        }
        return callWithAsyncErrorHandling(
          source,
          instance,
          3,
          [onCleanup]
        );
      };
    }
  } else {
    getter = NOOP;
  }
  if (cb && deep) {
    const baseGetter = getter;
    getter = () => traverse(baseGetter());
  }
  let cleanup;
  let onCleanup = (fn) => {
    cleanup = effect.onStop = () => {
      callWithErrorHandling(fn, instance, 4);
      cleanup = effect.onStop = void 0;
    };
  };
  let ssrCleanup;
  if (isInSSRComponentSetup) {
    onCleanup = NOOP;
    if (!cb) {
      getter();
    } else if (immediate) {
      callWithAsyncErrorHandling(cb, instance, 3, [
        getter(),
        isMultiSource ? [] : void 0,
        onCleanup
      ]);
    }
    if (flush === "sync") {
      const ctx = useSSRContext();
      ssrCleanup = ctx.__watcherHandles || (ctx.__watcherHandles = []);
    } else {
      return NOOP;
    }
  }
  let oldValue = isMultiSource ? new Array(source.length).fill(INITIAL_WATCHER_VALUE) : INITIAL_WATCHER_VALUE;
  const job = () => {
    if (!effect.active || !effect.dirty) {
      return;
    }
    if (cb) {
      const newValue = effect.run();
      if (deep || forceTrigger || (isMultiSource ? newValue.some((v, i) => hasChanged(v, oldValue[i])) : hasChanged(newValue, oldValue)) || false) {
        if (cleanup) {
          cleanup();
        }
        callWithAsyncErrorHandling(cb, instance, 3, [
          newValue,
          oldValue === INITIAL_WATCHER_VALUE ? void 0 : isMultiSource && oldValue[0] === INITIAL_WATCHER_VALUE ? [] : oldValue,
          onCleanup
        ]);
        oldValue = newValue;
      }
    } else {
      effect.run();
    }
  };
  job.allowRecurse = !!cb;
  let scheduler2;
  if (flush === "sync") {
    scheduler2 = job;
  } else if (flush === "post") {
    scheduler2 = () => queuePostRenderEffect(job, instance && instance.suspense);
  } else {
    job.pre = true;
    if (instance)
      job.id = instance.uid;
    scheduler2 = () => queueJob(job);
  }
  const effect = new ReactiveEffect(getter, NOOP, scheduler2);
  const scope = getCurrentScope();
  const unwatch = () => {
    effect.stop();
    if (scope) {
      remove(scope.effects, effect);
    }
  };
  if (cb) {
    if (immediate) {
      job();
    } else {
      oldValue = effect.run();
    }
  } else if (flush === "post") {
    queuePostRenderEffect(
      effect.run.bind(effect),
      instance && instance.suspense
    );
  } else {
    effect.run();
  }
  if (ssrCleanup)
    ssrCleanup.push(unwatch);
  return unwatch;
}
function instanceWatch(source, value, options) {
  const publicThis = this.proxy;
  const getter = isString(source) ? source.includes(".") ? createPathGetter(publicThis, source) : () => publicThis[source] : source.bind(publicThis, publicThis);
  let cb;
  if (isFunction$1(value)) {
    cb = value;
  } else {
    cb = value.handler;
    options = value;
  }
  const reset = setCurrentInstance(this);
  const res = doWatch(getter, cb.bind(publicThis), options);
  reset();
  return res;
}
function createPathGetter(ctx, path) {
  const segments = path.split(".");
  return () => {
    let cur = ctx;
    for (let i = 0; i < segments.length && cur; i++) {
      cur = cur[segments[i]];
    }
    return cur;
  };
}
function traverse(value, depth = Infinity, seen2) {
  if (depth <= 0 || !isObject(value) || value["__v_skip"]) {
    return value;
  }
  seen2 = seen2 || /* @__PURE__ */ new Set();
  if (seen2.has(value)) {
    return value;
  }
  seen2.add(value);
  depth--;
  if (isRef(value)) {
    traverse(value.value, depth, seen2);
  } else if (isArray(value)) {
    for (let i = 0; i < value.length; i++) {
      traverse(value[i], depth, seen2);
    }
  } else if (isSet(value) || isMap(value)) {
    value.forEach((v) => {
      traverse(v, depth, seen2);
    });
  } else if (isPlainObject(value)) {
    for (const key in value) {
      traverse(value[key], depth, seen2);
    }
  }
  return value;
}
function withDirectives(vnode, directives) {
  if (currentRenderingInstance === null) {
    return vnode;
  }
  const instance = getExposeProxy(currentRenderingInstance) || currentRenderingInstance.proxy;
  const bindings = vnode.dirs || (vnode.dirs = []);
  for (let i = 0; i < directives.length; i++) {
    let [dir, value, arg, modifiers = EMPTY_OBJ] = directives[i];
    if (dir) {
      if (isFunction$1(dir)) {
        dir = {
          mounted: dir,
          updated: dir
        };
      }
      if (dir.deep) {
        traverse(value);
      }
      bindings.push({
        dir,
        instance,
        value,
        oldValue: void 0,
        arg,
        modifiers
      });
    }
  }
  return vnode;
}
function invokeDirectiveHook(vnode, prevVNode, instance, name) {
  const bindings = vnode.dirs;
  const oldBindings = prevVNode && prevVNode.dirs;
  for (let i = 0; i < bindings.length; i++) {
    const binding = bindings[i];
    if (oldBindings) {
      binding.oldValue = oldBindings[i].value;
    }
    let hook = binding.dir[name];
    if (hook) {
      pauseTracking();
      callWithAsyncErrorHandling(hook, instance, 8, [
        vnode.el,
        binding,
        vnode,
        prevVNode
      ]);
      resetTracking();
    }
  }
}
const leaveCbKey = Symbol("_leaveCb");
const enterCbKey$1 = Symbol("_enterCb");
function useTransitionState() {
  const state = {
    isMounted: false,
    isLeaving: false,
    isUnmounting: false,
    leavingVNodes: /* @__PURE__ */ new Map()
  };
  onMounted(() => {
    state.isMounted = true;
  });
  onBeforeUnmount(() => {
    state.isUnmounting = true;
  });
  return state;
}
const TransitionHookValidator = [Function, Array];
const BaseTransitionPropsValidators = {
  mode: String,
  appear: Boolean,
  persisted: Boolean,
  onBeforeEnter: TransitionHookValidator,
  onEnter: TransitionHookValidator,
  onAfterEnter: TransitionHookValidator,
  onEnterCancelled: TransitionHookValidator,
  onBeforeLeave: TransitionHookValidator,
  onLeave: TransitionHookValidator,
  onAfterLeave: TransitionHookValidator,
  onLeaveCancelled: TransitionHookValidator,
  onBeforeAppear: TransitionHookValidator,
  onAppear: TransitionHookValidator,
  onAfterAppear: TransitionHookValidator,
  onAppearCancelled: TransitionHookValidator
};
const BaseTransitionImpl = {
  name: `BaseTransition`,
  props: BaseTransitionPropsValidators,
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const state = useTransitionState();
    return () => {
      const children = slots.default && getTransitionRawChildren(slots.default(), true);
      if (!children || !children.length) {
        return;
      }
      let child = children[0];
      if (children.length > 1) {
        for (const c of children) {
          if (c.type !== Comment) {
            child = c;
            break;
          }
        }
      }
      const rawProps = toRaw(props);
      const { mode } = rawProps;
      if (state.isLeaving) {
        return emptyPlaceholder(child);
      }
      const innerChild = getKeepAliveChild(child);
      if (!innerChild) {
        return emptyPlaceholder(child);
      }
      const enterHooks = resolveTransitionHooks(
        innerChild,
        rawProps,
        state,
        instance
      );
      setTransitionHooks(innerChild, enterHooks);
      const oldChild = instance.subTree;
      const oldInnerChild = oldChild && getKeepAliveChild(oldChild);
      if (oldInnerChild && oldInnerChild.type !== Comment && !isSameVNodeType(innerChild, oldInnerChild)) {
        const leavingHooks = resolveTransitionHooks(
          oldInnerChild,
          rawProps,
          state,
          instance
        );
        setTransitionHooks(oldInnerChild, leavingHooks);
        if (mode === "out-in" && innerChild.type !== Comment) {
          state.isLeaving = true;
          leavingHooks.afterLeave = () => {
            state.isLeaving = false;
            if (instance.update.active !== false) {
              instance.effect.dirty = true;
              instance.update();
            }
          };
          return emptyPlaceholder(child);
        } else if (mode === "in-out" && innerChild.type !== Comment) {
          leavingHooks.delayLeave = (el, earlyRemove, delayedLeave) => {
            const leavingVNodesCache = getLeavingNodesForType(
              state,
              oldInnerChild
            );
            leavingVNodesCache[String(oldInnerChild.key)] = oldInnerChild;
            el[leaveCbKey] = () => {
              earlyRemove();
              el[leaveCbKey] = void 0;
              delete enterHooks.delayedLeave;
            };
            enterHooks.delayedLeave = delayedLeave;
          };
        }
      }
      return child;
    };
  }
};
const BaseTransition = BaseTransitionImpl;
function getLeavingNodesForType(state, vnode) {
  const { leavingVNodes } = state;
  let leavingVNodesCache = leavingVNodes.get(vnode.type);
  if (!leavingVNodesCache) {
    leavingVNodesCache = /* @__PURE__ */ Object.create(null);
    leavingVNodes.set(vnode.type, leavingVNodesCache);
  }
  return leavingVNodesCache;
}
function resolveTransitionHooks(vnode, props, state, instance) {
  const {
    appear,
    mode,
    persisted = false,
    onBeforeEnter,
    onEnter,
    onAfterEnter,
    onEnterCancelled,
    onBeforeLeave,
    onLeave,
    onAfterLeave,
    onLeaveCancelled,
    onBeforeAppear,
    onAppear,
    onAfterAppear,
    onAppearCancelled
  } = props;
  const key = String(vnode.key);
  const leavingVNodesCache = getLeavingNodesForType(state, vnode);
  const callHook2 = (hook, args) => {
    hook && callWithAsyncErrorHandling(
      hook,
      instance,
      9,
      args
    );
  };
  const callAsyncHook = (hook, args) => {
    const done = args[1];
    callHook2(hook, args);
    if (isArray(hook)) {
      if (hook.every((hook2) => hook2.length <= 1))
        done();
    } else if (hook.length <= 1) {
      done();
    }
  };
  const hooks = {
    mode,
    persisted,
    beforeEnter(el) {
      let hook = onBeforeEnter;
      if (!state.isMounted) {
        if (appear) {
          hook = onBeforeAppear || onBeforeEnter;
        } else {
          return;
        }
      }
      if (el[leaveCbKey]) {
        el[leaveCbKey](
          true
        );
      }
      const leavingVNode = leavingVNodesCache[key];
      if (leavingVNode && isSameVNodeType(vnode, leavingVNode) && leavingVNode.el[leaveCbKey]) {
        leavingVNode.el[leaveCbKey]();
      }
      callHook2(hook, [el]);
    },
    enter(el) {
      let hook = onEnter;
      let afterHook = onAfterEnter;
      let cancelHook = onEnterCancelled;
      if (!state.isMounted) {
        if (appear) {
          hook = onAppear || onEnter;
          afterHook = onAfterAppear || onAfterEnter;
          cancelHook = onAppearCancelled || onEnterCancelled;
        } else {
          return;
        }
      }
      let called = false;
      const done = el[enterCbKey$1] = (cancelled) => {
        if (called)
          return;
        called = true;
        if (cancelled) {
          callHook2(cancelHook, [el]);
        } else {
          callHook2(afterHook, [el]);
        }
        if (hooks.delayedLeave) {
          hooks.delayedLeave();
        }
        el[enterCbKey$1] = void 0;
      };
      if (hook) {
        callAsyncHook(hook, [el, done]);
      } else {
        done();
      }
    },
    leave(el, remove2) {
      const key2 = String(vnode.key);
      if (el[enterCbKey$1]) {
        el[enterCbKey$1](
          true
        );
      }
      if (state.isUnmounting) {
        return remove2();
      }
      callHook2(onBeforeLeave, [el]);
      let called = false;
      const done = el[leaveCbKey] = (cancelled) => {
        if (called)
          return;
        called = true;
        remove2();
        if (cancelled) {
          callHook2(onLeaveCancelled, [el]);
        } else {
          callHook2(onAfterLeave, [el]);
        }
        el[leaveCbKey] = void 0;
        if (leavingVNodesCache[key2] === vnode) {
          delete leavingVNodesCache[key2];
        }
      };
      leavingVNodesCache[key2] = vnode;
      if (onLeave) {
        callAsyncHook(onLeave, [el, done]);
      } else {
        done();
      }
    },
    clone(vnode2) {
      return resolveTransitionHooks(vnode2, props, state, instance);
    }
  };
  return hooks;
}
function emptyPlaceholder(vnode) {
  if (isKeepAlive(vnode)) {
    vnode = cloneVNode(vnode);
    vnode.children = null;
    return vnode;
  }
}
function getKeepAliveChild(vnode) {
  if (!isKeepAlive(vnode)) {
    return vnode;
  }
  const { shapeFlag, children } = vnode;
  if (children) {
    if (shapeFlag & 16) {
      return children[0];
    }
    if (shapeFlag & 32 && isFunction$1(children.default)) {
      return children.default();
    }
  }
}
function setTransitionHooks(vnode, hooks) {
  if (vnode.shapeFlag & 6 && vnode.component) {
    setTransitionHooks(vnode.component.subTree, hooks);
  } else if (vnode.shapeFlag & 128) {
    vnode.ssContent.transition = hooks.clone(vnode.ssContent);
    vnode.ssFallback.transition = hooks.clone(vnode.ssFallback);
  } else {
    vnode.transition = hooks;
  }
}
function getTransitionRawChildren(children, keepComment = false, parentKey) {
  let ret = [];
  let keyedFragmentCount = 0;
  for (let i = 0; i < children.length; i++) {
    let child = children[i];
    const key = parentKey == null ? child.key : String(parentKey) + String(child.key != null ? child.key : i);
    if (child.type === Fragment) {
      if (child.patchFlag & 128)
        keyedFragmentCount++;
      ret = ret.concat(
        getTransitionRawChildren(child.children, keepComment, key)
      );
    } else if (keepComment || child.type !== Comment) {
      ret.push(key != null ? cloneVNode(child, { key }) : child);
    }
  }
  if (keyedFragmentCount > 1) {
    for (let i = 0; i < ret.length; i++) {
      ret[i].patchFlag = -2;
    }
  }
  return ret;
}
/*! #__NO_SIDE_EFFECTS__ */
function defineComponent(options, extraOptions) {
  return isFunction$1(options) ? /* @__PURE__ */ (() => extend({ name: options.name }, extraOptions, { setup: options }))() : options;
}
const isAsyncWrapper = (i) => !!i.type.__asyncLoader;
const isKeepAlive = (vnode) => vnode.type.__isKeepAlive;
const KeepAliveImpl = {
  name: `KeepAlive`,
  __isKeepAlive: true,
  props: {
    include: [String, RegExp, Array],
    exclude: [String, RegExp, Array],
    max: [String, Number]
  },
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const sharedContext = instance.ctx;
    if (!sharedContext.renderer) {
      return () => {
        const children = slots.default && slots.default();
        return children && children.length === 1 ? children[0] : children;
      };
    }
    const cache = /* @__PURE__ */ new Map();
    const keys3 = /* @__PURE__ */ new Set();
    let current = null;
    const parentSuspense = instance.suspense;
    const {
      renderer: {
        p: patch,
        m: move,
        um: _unmount,
        o: { createElement }
      }
    } = sharedContext;
    const storageContainer = createElement("div");
    sharedContext.activate = (vnode, container, anchor, namespace, optimized) => {
      const instance2 = vnode.component;
      move(vnode, container, anchor, 0, parentSuspense);
      patch(
        instance2.vnode,
        vnode,
        container,
        anchor,
        instance2,
        parentSuspense,
        namespace,
        vnode.slotScopeIds,
        optimized
      );
      queuePostRenderEffect(() => {
        instance2.isDeactivated = false;
        if (instance2.a) {
          invokeArrayFns(instance2.a);
        }
        const vnodeHook = vnode.props && vnode.props.onVnodeMounted;
        if (vnodeHook) {
          invokeVNodeHook(vnodeHook, instance2.parent, vnode);
        }
      }, parentSuspense);
    };
    sharedContext.deactivate = (vnode) => {
      const instance2 = vnode.component;
      move(vnode, storageContainer, null, 1, parentSuspense);
      queuePostRenderEffect(() => {
        if (instance2.da) {
          invokeArrayFns(instance2.da);
        }
        const vnodeHook = vnode.props && vnode.props.onVnodeUnmounted;
        if (vnodeHook) {
          invokeVNodeHook(vnodeHook, instance2.parent, vnode);
        }
        instance2.isDeactivated = true;
      }, parentSuspense);
    };
    function unmount(vnode) {
      resetShapeFlag(vnode);
      _unmount(vnode, instance, parentSuspense, true);
    }
    function pruneCache(filter) {
      cache.forEach((vnode, key) => {
        const name = getComponentName(vnode.type);
        if (name && (!filter || !filter(name))) {
          pruneCacheEntry(key);
        }
      });
    }
    function pruneCacheEntry(key) {
      const cached = cache.get(key);
      if (!current || !isSameVNodeType(cached, current)) {
        unmount(cached);
      } else if (current) {
        resetShapeFlag(current);
      }
      cache.delete(key);
      keys3.delete(key);
    }
    watch(
      () => [props.include, props.exclude],
      ([include, exclude]) => {
        include && pruneCache((name) => matches(include, name));
        exclude && pruneCache((name) => !matches(exclude, name));
      },
      { flush: "post", deep: true }
    );
    let pendingCacheKey = null;
    const cacheSubtree = () => {
      if (pendingCacheKey != null) {
        cache.set(pendingCacheKey, getInnerChild(instance.subTree));
      }
    };
    onMounted(cacheSubtree);
    onUpdated(cacheSubtree);
    onBeforeUnmount(() => {
      cache.forEach((cached) => {
        const { subTree, suspense } = instance;
        const vnode = getInnerChild(subTree);
        if (cached.type === vnode.type && cached.key === vnode.key) {
          resetShapeFlag(vnode);
          const da = vnode.component.da;
          da && queuePostRenderEffect(da, suspense);
          return;
        }
        unmount(cached);
      });
    });
    return () => {
      pendingCacheKey = null;
      if (!slots.default) {
        return null;
      }
      const children = slots.default();
      const rawVNode = children[0];
      if (children.length > 1) {
        current = null;
        return children;
      } else if (!isVNode(rawVNode) || !(rawVNode.shapeFlag & 4) && !(rawVNode.shapeFlag & 128)) {
        current = null;
        return rawVNode;
      }
      let vnode = getInnerChild(rawVNode);
      const comp = vnode.type;
      const name = getComponentName(
        isAsyncWrapper(vnode) ? vnode.type.__asyncResolved || {} : comp
      );
      const { include, exclude, max: max2 } = props;
      if (include && (!name || !matches(include, name)) || exclude && name && matches(exclude, name)) {
        current = vnode;
        return rawVNode;
      }
      const key = vnode.key == null ? comp : vnode.key;
      const cachedVNode = cache.get(key);
      if (vnode.el) {
        vnode = cloneVNode(vnode);
        if (rawVNode.shapeFlag & 128) {
          rawVNode.ssContent = vnode;
        }
      }
      pendingCacheKey = key;
      if (cachedVNode) {
        vnode.el = cachedVNode.el;
        vnode.component = cachedVNode.component;
        if (vnode.transition) {
          setTransitionHooks(vnode, vnode.transition);
        }
        vnode.shapeFlag |= 512;
        keys3.delete(key);
        keys3.add(key);
      } else {
        keys3.add(key);
        if (max2 && keys3.size > parseInt(max2, 10)) {
          pruneCacheEntry(keys3.values().next().value);
        }
      }
      vnode.shapeFlag |= 256;
      current = vnode;
      return isSuspense(rawVNode.type) ? rawVNode : vnode;
    };
  }
};
const KeepAlive = KeepAliveImpl;
function matches(pattern, name) {
  if (isArray(pattern)) {
    return pattern.some((p2) => matches(p2, name));
  } else if (isString(pattern)) {
    return pattern.split(",").includes(name);
  } else if (isRegExp$1(pattern)) {
    return pattern.test(name);
  }
  return false;
}
function onActivated(hook, target) {
  registerKeepAliveHook(hook, "a", target);
}
function onDeactivated(hook, target) {
  registerKeepAliveHook(hook, "da", target);
}
function registerKeepAliveHook(hook, type2, target = currentInstance) {
  const wrappedHook = hook.__wdc || (hook.__wdc = () => {
    let current = target;
    while (current) {
      if (current.isDeactivated) {
        return;
      }
      current = current.parent;
    }
    return hook();
  });
  injectHook(type2, wrappedHook, target);
  if (target) {
    let current = target.parent;
    while (current && current.parent) {
      if (isKeepAlive(current.parent.vnode)) {
        injectToKeepAliveRoot(wrappedHook, type2, target, current);
      }
      current = current.parent;
    }
  }
}
function injectToKeepAliveRoot(hook, type2, target, keepAliveRoot) {
  const injected = injectHook(
    type2,
    hook,
    keepAliveRoot,
    true
  );
  onUnmounted(() => {
    remove(keepAliveRoot[type2], injected);
  }, target);
}
function resetShapeFlag(vnode) {
  vnode.shapeFlag &= ~256;
  vnode.shapeFlag &= ~512;
}
function getInnerChild(vnode) {
  return vnode.shapeFlag & 128 ? vnode.ssContent : vnode;
}
function injectHook(type2, hook, target = currentInstance, prepend = false) {
  if (target) {
    const hooks = target[type2] || (target[type2] = []);
    const wrappedHook = hook.__weh || (hook.__weh = (...args) => {
      if (target.isUnmounted) {
        return;
      }
      pauseTracking();
      const reset = setCurrentInstance(target);
      const res = callWithAsyncErrorHandling(hook, target, type2, args);
      reset();
      resetTracking();
      return res;
    });
    if (prepend) {
      hooks.unshift(wrappedHook);
    } else {
      hooks.push(wrappedHook);
    }
    return wrappedHook;
  }
}
const createHook = (lifecycle) => (hook, target = currentInstance) => (!isInSSRComponentSetup || lifecycle === "sp") && injectHook(lifecycle, (...args) => hook(...args), target);
const onBeforeMount = createHook("bm");
const onMounted = createHook("m");
const onBeforeUpdate = createHook("bu");
const onUpdated = createHook("u");
const onBeforeUnmount = createHook("bum");
const onUnmounted = createHook("um");
const onServerPrefetch = createHook("sp");
const onRenderTriggered = createHook(
  "rtg"
);
const onRenderTracked = createHook(
  "rtc"
);
function onErrorCaptured(hook, target = currentInstance) {
  injectHook("ec", hook, target);
}
function renderList(source, renderItem, cache, index2) {
  let ret;
  const cached = cache && cache[index2];
  if (isArray(source) || isString(source)) {
    ret = new Array(source.length);
    for (let i = 0, l = source.length; i < l; i++) {
      ret[i] = renderItem(source[i], i, void 0, cached && cached[i]);
    }
  } else if (typeof source === "number") {
    ret = new Array(source);
    for (let i = 0; i < source; i++) {
      ret[i] = renderItem(i + 1, i, void 0, cached && cached[i]);
    }
  } else if (isObject(source)) {
    if (source[Symbol.iterator]) {
      ret = Array.from(
        source,
        (item, i) => renderItem(item, i, void 0, cached && cached[i])
      );
    } else {
      const keys3 = Object.keys(source);
      ret = new Array(keys3.length);
      for (let i = 0, l = keys3.length; i < l; i++) {
        const key = keys3[i];
        ret[i] = renderItem(source[key], key, i, cached && cached[i]);
      }
    }
  } else {
    ret = [];
  }
  if (cache) {
    cache[index2] = ret;
  }
  return ret;
}
function createSlots(slots, dynamicSlots) {
  for (let i = 0; i < dynamicSlots.length; i++) {
    const slot = dynamicSlots[i];
    if (isArray(slot)) {
      for (let j = 0; j < slot.length; j++) {
        slots[slot[j].name] = slot[j].fn;
      }
    } else if (slot) {
      slots[slot.name] = slot.key ? (...args) => {
        const res = slot.fn(...args);
        if (res)
          res.key = slot.key;
        return res;
      } : slot.fn;
    }
  }
  return slots;
}
function renderSlot(slots, name, props = {}, fallback, noSlotted) {
  if (currentRenderingInstance.isCE || currentRenderingInstance.parent && isAsyncWrapper(currentRenderingInstance.parent) && currentRenderingInstance.parent.isCE) {
    if (name !== "default")
      props.name = name;
    return createVNode("slot", props, fallback && fallback());
  }
  let slot = slots[name];
  if (slot && slot._c) {
    slot._d = false;
  }
  openBlock();
  const validSlotContent = slot && ensureValidVNode(slot(props));
  const rendered = createBlock(
    Fragment,
    {
      key: props.key || validSlotContent && validSlotContent.key || `_${name}`
    },
    validSlotContent || (fallback ? fallback() : []),
    validSlotContent && slots._ === 1 ? 64 : -2
  );
  if (!noSlotted && rendered.scopeId) {
    rendered.slotScopeIds = [rendered.scopeId + "-s"];
  }
  if (slot && slot._c) {
    slot._d = true;
  }
  return rendered;
}
function ensureValidVNode(vnodes) {
  return vnodes.some((child) => {
    if (!isVNode(child))
      return true;
    if (child.type === Comment)
      return false;
    if (child.type === Fragment && !ensureValidVNode(child.children))
      return false;
    return true;
  }) ? vnodes : null;
}
const getPublicInstance = (i) => {
  if (!i)
    return null;
  if (isStatefulComponent(i))
    return getExposeProxy(i) || i.proxy;
  return getPublicInstance(i.parent);
};
const publicPropertiesMap = /* @__PURE__ */ extend(/* @__PURE__ */ Object.create(null), {
  $: (i) => i,
  $el: (i) => i.vnode.el,
  $data: (i) => i.data,
  $props: (i) => i.props,
  $attrs: (i) => i.attrs,
  $slots: (i) => i.slots,
  $refs: (i) => i.refs,
  $parent: (i) => getPublicInstance(i.parent),
  $root: (i) => getPublicInstance(i.root),
  $emit: (i) => i.emit,
  $options: (i) => resolveMergedOptions(i),
  $forceUpdate: (i) => i.f || (i.f = () => {
    i.effect.dirty = true;
    queueJob(i.update);
  }),
  $nextTick: (i) => i.n || (i.n = nextTick.bind(i.proxy)),
  $watch: (i) => instanceWatch.bind(i)
});
const hasSetupBinding = (state, key) => state !== EMPTY_OBJ && !state.__isScriptSetup && hasOwn$3(state, key);
const PublicInstanceProxyHandlers = {
  get({ _: instance }, key) {
    if (key === "__v_skip") {
      return true;
    }
    const { ctx, setupState, data, props, accessCache, type: type2, appContext } = instance;
    let normalizedProps;
    if (key[0] !== "$") {
      const n = accessCache[key];
      if (n !== void 0) {
        switch (n) {
          case 1:
            return setupState[key];
          case 2:
            return data[key];
          case 4:
            return ctx[key];
          case 3:
            return props[key];
        }
      } else if (hasSetupBinding(setupState, key)) {
        accessCache[key] = 1;
        return setupState[key];
      } else if (data !== EMPTY_OBJ && hasOwn$3(data, key)) {
        accessCache[key] = 2;
        return data[key];
      } else if ((normalizedProps = instance.propsOptions[0]) && hasOwn$3(normalizedProps, key)) {
        accessCache[key] = 3;
        return props[key];
      } else if (ctx !== EMPTY_OBJ && hasOwn$3(ctx, key)) {
        accessCache[key] = 4;
        return ctx[key];
      } else if (shouldCacheAccess) {
        accessCache[key] = 0;
      }
    }
    const publicGetter = publicPropertiesMap[key];
    let cssModule, globalProperties;
    if (publicGetter) {
      if (key === "$attrs") {
        track(instance.attrs, "get", "");
      }
      return publicGetter(instance);
    } else if ((cssModule = type2.__cssModules) && (cssModule = cssModule[key])) {
      return cssModule;
    } else if (ctx !== EMPTY_OBJ && hasOwn$3(ctx, key)) {
      accessCache[key] = 4;
      return ctx[key];
    } else if (globalProperties = appContext.config.globalProperties, hasOwn$3(globalProperties, key)) {
      {
        return globalProperties[key];
      }
    } else
      ;
  },
  set({ _: instance }, key, value) {
    const { data, setupState, ctx } = instance;
    if (hasSetupBinding(setupState, key)) {
      setupState[key] = value;
      return true;
    } else if (data !== EMPTY_OBJ && hasOwn$3(data, key)) {
      data[key] = value;
      return true;
    } else if (hasOwn$3(instance.props, key)) {
      return false;
    }
    if (key[0] === "$" && key.slice(1) in instance) {
      return false;
    } else {
      {
        ctx[key] = value;
      }
    }
    return true;
  },
  has({
    _: { data, setupState, accessCache, ctx, appContext, propsOptions }
  }, key) {
    let normalizedProps;
    return !!accessCache[key] || data !== EMPTY_OBJ && hasOwn$3(data, key) || hasSetupBinding(setupState, key) || (normalizedProps = propsOptions[0]) && hasOwn$3(normalizedProps, key) || hasOwn$3(ctx, key) || hasOwn$3(publicPropertiesMap, key) || hasOwn$3(appContext.config.globalProperties, key);
  },
  defineProperty(target, key, descriptor) {
    if (descriptor.get != null) {
      target._.accessCache[key] = 0;
    } else if (hasOwn$3(descriptor, "value")) {
      this.set(target, key, descriptor.value, null);
    }
    return Reflect.defineProperty(target, key, descriptor);
  }
};
function normalizePropsOrEmits(props) {
  return isArray(props) ? props.reduce(
    (normalized, p2) => (normalized[p2] = null, normalized),
    {}
  ) : props;
}
let shouldCacheAccess = true;
function applyOptions(instance) {
  const options = resolveMergedOptions(instance);
  const publicThis = instance.proxy;
  const ctx = instance.ctx;
  shouldCacheAccess = false;
  if (options.beforeCreate) {
    callHook$1(options.beforeCreate, instance, "bc");
  }
  const {
    data: dataOptions,
    computed: computedOptions,
    methods,
    watch: watchOptions,
    provide: provideOptions,
    inject: injectOptions,
    created,
    beforeMount,
    mounted,
    beforeUpdate,
    updated,
    activated,
    deactivated,
    beforeDestroy,
    beforeUnmount,
    destroyed,
    unmounted,
    render: render2,
    renderTracked,
    renderTriggered,
    errorCaptured,
    serverPrefetch,
    expose,
    inheritAttrs,
    components,
    directives,
    filters
  } = options;
  const checkDuplicateProperties = null;
  if (injectOptions) {
    resolveInjections(injectOptions, ctx, checkDuplicateProperties);
  }
  if (methods) {
    for (const key in methods) {
      const methodHandler = methods[key];
      if (isFunction$1(methodHandler)) {
        {
          ctx[key] = methodHandler.bind(publicThis);
        }
      }
    }
  }
  if (dataOptions) {
    const data = dataOptions.call(publicThis, publicThis);
    if (!isObject(data))
      ;
    else {
      instance.data = reactive(data);
    }
  }
  shouldCacheAccess = true;
  if (computedOptions) {
    for (const key in computedOptions) {
      const opt = computedOptions[key];
      const get2 = isFunction$1(opt) ? opt.bind(publicThis, publicThis) : isFunction$1(opt.get) ? opt.get.bind(publicThis, publicThis) : NOOP;
      const set2 = !isFunction$1(opt) && isFunction$1(opt.set) ? opt.set.bind(publicThis) : NOOP;
      const c = computed({
        get: get2,
        set: set2
      });
      Object.defineProperty(ctx, key, {
        enumerable: true,
        configurable: true,
        get: () => c.value,
        set: (v) => c.value = v
      });
    }
  }
  if (watchOptions) {
    for (const key in watchOptions) {
      createWatcher(watchOptions[key], ctx, publicThis, key);
    }
  }
  if (provideOptions) {
    const provides = isFunction$1(provideOptions) ? provideOptions.call(publicThis) : provideOptions;
    Reflect.ownKeys(provides).forEach((key) => {
      provide(key, provides[key]);
    });
  }
  if (created) {
    callHook$1(created, instance, "c");
  }
  function registerLifecycleHook(register, hook) {
    if (isArray(hook)) {
      hook.forEach((_hook) => register(_hook.bind(publicThis)));
    } else if (hook) {
      register(hook.bind(publicThis));
    }
  }
  registerLifecycleHook(onBeforeMount, beforeMount);
  registerLifecycleHook(onMounted, mounted);
  registerLifecycleHook(onBeforeUpdate, beforeUpdate);
  registerLifecycleHook(onUpdated, updated);
  registerLifecycleHook(onActivated, activated);
  registerLifecycleHook(onDeactivated, deactivated);
  registerLifecycleHook(onErrorCaptured, errorCaptured);
  registerLifecycleHook(onRenderTracked, renderTracked);
  registerLifecycleHook(onRenderTriggered, renderTriggered);
  registerLifecycleHook(onBeforeUnmount, beforeUnmount);
  registerLifecycleHook(onUnmounted, unmounted);
  registerLifecycleHook(onServerPrefetch, serverPrefetch);
  if (isArray(expose)) {
    if (expose.length) {
      const exposed = instance.exposed || (instance.exposed = {});
      expose.forEach((key) => {
        Object.defineProperty(exposed, key, {
          get: () => publicThis[key],
          set: (val) => publicThis[key] = val
        });
      });
    } else if (!instance.exposed) {
      instance.exposed = {};
    }
  }
  if (render2 && instance.render === NOOP) {
    instance.render = render2;
  }
  if (inheritAttrs != null) {
    instance.inheritAttrs = inheritAttrs;
  }
  if (components)
    instance.components = components;
  if (directives)
    instance.directives = directives;
}
function resolveInjections(injectOptions, ctx, checkDuplicateProperties = NOOP) {
  if (isArray(injectOptions)) {
    injectOptions = normalizeInject(injectOptions);
  }
  for (const key in injectOptions) {
    const opt = injectOptions[key];
    let injected;
    if (isObject(opt)) {
      if ("default" in opt) {
        injected = inject(
          opt.from || key,
          opt.default,
          true
        );
      } else {
        injected = inject(opt.from || key);
      }
    } else {
      injected = inject(opt);
    }
    if (isRef(injected)) {
      Object.defineProperty(ctx, key, {
        enumerable: true,
        configurable: true,
        get: () => injected.value,
        set: (v) => injected.value = v
      });
    } else {
      ctx[key] = injected;
    }
  }
}
function callHook$1(hook, instance, type2) {
  callWithAsyncErrorHandling(
    isArray(hook) ? hook.map((h2) => h2.bind(instance.proxy)) : hook.bind(instance.proxy),
    instance,
    type2
  );
}
function createWatcher(raw, ctx, publicThis, key) {
  const getter = key.includes(".") ? createPathGetter(publicThis, key) : () => publicThis[key];
  if (isString(raw)) {
    const handler = ctx[raw];
    if (isFunction$1(handler)) {
      watch(getter, handler);
    }
  } else if (isFunction$1(raw)) {
    watch(getter, raw.bind(publicThis));
  } else if (isObject(raw)) {
    if (isArray(raw)) {
      raw.forEach((r) => createWatcher(r, ctx, publicThis, key));
    } else {
      const handler = isFunction$1(raw.handler) ? raw.handler.bind(publicThis) : ctx[raw.handler];
      if (isFunction$1(handler)) {
        watch(getter, handler, raw);
      }
    }
  } else
    ;
}
function resolveMergedOptions(instance) {
  const base = instance.type;
  const { mixins, extends: extendsOptions } = base;
  const {
    mixins: globalMixins,
    optionsCache: cache,
    config: { optionMergeStrategies }
  } = instance.appContext;
  const cached = cache.get(base);
  let resolved;
  if (cached) {
    resolved = cached;
  } else if (!globalMixins.length && !mixins && !extendsOptions) {
    {
      resolved = base;
    }
  } else {
    resolved = {};
    if (globalMixins.length) {
      globalMixins.forEach(
        (m) => mergeOptions(resolved, m, optionMergeStrategies, true)
      );
    }
    mergeOptions(resolved, base, optionMergeStrategies);
  }
  if (isObject(base)) {
    cache.set(base, resolved);
  }
  return resolved;
}
function mergeOptions(to, from, strats, asMixin = false) {
  const { mixins, extends: extendsOptions } = from;
  if (extendsOptions) {
    mergeOptions(to, extendsOptions, strats, true);
  }
  if (mixins) {
    mixins.forEach(
      (m) => mergeOptions(to, m, strats, true)
    );
  }
  for (const key in from) {
    if (asMixin && key === "expose")
      ;
    else {
      const strat = internalOptionMergeStrats[key] || strats && strats[key];
      to[key] = strat ? strat(to[key], from[key]) : from[key];
    }
  }
  return to;
}
const internalOptionMergeStrats = {
  data: mergeDataFn,
  props: mergeEmitsOrPropsOptions,
  emits: mergeEmitsOrPropsOptions,
  methods: mergeObjectOptions,
  computed: mergeObjectOptions,
  beforeCreate: mergeAsArray,
  created: mergeAsArray,
  beforeMount: mergeAsArray,
  mounted: mergeAsArray,
  beforeUpdate: mergeAsArray,
  updated: mergeAsArray,
  beforeDestroy: mergeAsArray,
  beforeUnmount: mergeAsArray,
  destroyed: mergeAsArray,
  unmounted: mergeAsArray,
  activated: mergeAsArray,
  deactivated: mergeAsArray,
  errorCaptured: mergeAsArray,
  serverPrefetch: mergeAsArray,
  components: mergeObjectOptions,
  directives: mergeObjectOptions,
  watch: mergeWatchOptions,
  provide: mergeDataFn,
  inject: mergeInject
};
function mergeDataFn(to, from) {
  if (!from) {
    return to;
  }
  if (!to) {
    return from;
  }
  return function mergedDataFn() {
    return extend(
      isFunction$1(to) ? to.call(this, this) : to,
      isFunction$1(from) ? from.call(this, this) : from
    );
  };
}
function mergeInject(to, from) {
  return mergeObjectOptions(normalizeInject(to), normalizeInject(from));
}
function normalizeInject(raw) {
  if (isArray(raw)) {
    const res = {};
    for (let i = 0; i < raw.length; i++) {
      res[raw[i]] = raw[i];
    }
    return res;
  }
  return raw;
}
function mergeAsArray(to, from) {
  return to ? [...new Set([].concat(to, from))] : from;
}
function mergeObjectOptions(to, from) {
  return to ? extend(/* @__PURE__ */ Object.create(null), to, from) : from;
}
function mergeEmitsOrPropsOptions(to, from) {
  if (to) {
    if (isArray(to) && isArray(from)) {
      return [.../* @__PURE__ */ new Set([...to, ...from])];
    }
    return extend(
      /* @__PURE__ */ Object.create(null),
      normalizePropsOrEmits(to),
      normalizePropsOrEmits(from != null ? from : {})
    );
  } else {
    return from;
  }
}
function mergeWatchOptions(to, from) {
  if (!to)
    return from;
  if (!from)
    return to;
  const merged = extend(/* @__PURE__ */ Object.create(null), to);
  for (const key in from) {
    merged[key] = mergeAsArray(to[key], from[key]);
  }
  return merged;
}
function createAppContext() {
  return {
    app: null,
    config: {
      isNativeTag: NO,
      performance: false,
      globalProperties: {},
      optionMergeStrategies: {},
      errorHandler: void 0,
      warnHandler: void 0,
      compilerOptions: {}
    },
    mixins: [],
    components: {},
    directives: {},
    provides: /* @__PURE__ */ Object.create(null),
    optionsCache: /* @__PURE__ */ new WeakMap(),
    propsCache: /* @__PURE__ */ new WeakMap(),
    emitsCache: /* @__PURE__ */ new WeakMap()
  };
}
let uid$1 = 0;
function createAppAPI(render2, hydrate) {
  return function createApp2(rootComponent, rootProps = null) {
    if (!isFunction$1(rootComponent)) {
      rootComponent = extend({}, rootComponent);
    }
    if (rootProps != null && !isObject(rootProps)) {
      rootProps = null;
    }
    const context = createAppContext();
    const installedPlugins = /* @__PURE__ */ new WeakSet();
    let isMounted = false;
    const app2 = context.app = {
      _uid: uid$1++,
      _component: rootComponent,
      _props: rootProps,
      _container: null,
      _context: context,
      _instance: null,
      version,
      get config() {
        return context.config;
      },
      set config(v) {
      },
      use(plugin, ...options) {
        if (installedPlugins.has(plugin))
          ;
        else if (plugin && isFunction$1(plugin.install)) {
          installedPlugins.add(plugin);
          plugin.install(app2, ...options);
        } else if (isFunction$1(plugin)) {
          installedPlugins.add(plugin);
          plugin(app2, ...options);
        } else
          ;
        return app2;
      },
      mixin(mixin) {
        {
          if (!context.mixins.includes(mixin)) {
            context.mixins.push(mixin);
          }
        }
        return app2;
      },
      component(name, component) {
        if (!component) {
          return context.components[name];
        }
        context.components[name] = component;
        return app2;
      },
      directive(name, directive) {
        if (!directive) {
          return context.directives[name];
        }
        context.directives[name] = directive;
        return app2;
      },
      mount(rootContainer, isHydrate, namespace) {
        if (!isMounted) {
          const vnode = createVNode(rootComponent, rootProps);
          vnode.appContext = context;
          if (namespace === true) {
            namespace = "svg";
          } else if (namespace === false) {
            namespace = void 0;
          }
          if (isHydrate && hydrate) {
            hydrate(vnode, rootContainer);
          } else {
            render2(vnode, rootContainer, namespace);
          }
          isMounted = true;
          app2._container = rootContainer;
          rootContainer.__vue_app__ = app2;
          return getExposeProxy(vnode.component) || vnode.component.proxy;
        }
      },
      unmount() {
        if (isMounted) {
          render2(null, app2._container);
          delete app2._container.__vue_app__;
        }
      },
      provide(key, value) {
        context.provides[key] = value;
        return app2;
      },
      runWithContext(fn) {
        const lastApp = currentApp;
        currentApp = app2;
        try {
          return fn();
        } finally {
          currentApp = lastApp;
        }
      }
    };
    return app2;
  };
}
let currentApp = null;
function provide(key, value) {
  if (!currentInstance)
    ;
  else {
    let provides = currentInstance.provides;
    const parentProvides = currentInstance.parent && currentInstance.parent.provides;
    if (parentProvides === provides) {
      provides = currentInstance.provides = Object.create(parentProvides);
    }
    provides[key] = value;
  }
}
function inject(key, defaultValue, treatDefaultAsFactory = false) {
  const instance = currentInstance || currentRenderingInstance;
  if (instance || currentApp) {
    const provides = instance ? instance.parent == null ? instance.vnode.appContext && instance.vnode.appContext.provides : instance.parent.provides : currentApp._context.provides;
    if (provides && key in provides) {
      return provides[key];
    } else if (arguments.length > 1) {
      return treatDefaultAsFactory && isFunction$1(defaultValue) ? defaultValue.call(instance && instance.proxy) : defaultValue;
    } else
      ;
  }
}
const internalObjectProto = {};
const createInternalObject = () => Object.create(internalObjectProto);
const isInternalObject = (obj) => Object.getPrototypeOf(obj) === internalObjectProto;
function initProps(instance, rawProps, isStateful, isSSR = false) {
  const props = {};
  const attrs = createInternalObject();
  instance.propsDefaults = /* @__PURE__ */ Object.create(null);
  setFullProps(instance, rawProps, props, attrs);
  for (const key in instance.propsOptions[0]) {
    if (!(key in props)) {
      props[key] = void 0;
    }
  }
  if (isStateful) {
    instance.props = isSSR ? props : shallowReactive(props);
  } else {
    if (!instance.type.props) {
      instance.props = attrs;
    } else {
      instance.props = props;
    }
  }
  instance.attrs = attrs;
}
function updateProps(instance, rawProps, rawPrevProps, optimized) {
  const {
    props,
    attrs,
    vnode: { patchFlag }
  } = instance;
  const rawCurrentProps = toRaw(props);
  const [options] = instance.propsOptions;
  let hasAttrsChanged = false;
  if ((optimized || patchFlag > 0) && !(patchFlag & 16)) {
    if (patchFlag & 8) {
      const propsToUpdate = instance.vnode.dynamicProps;
      for (let i = 0; i < propsToUpdate.length; i++) {
        let key = propsToUpdate[i];
        if (isEmitListener(instance.emitsOptions, key)) {
          continue;
        }
        const value = rawProps[key];
        if (options) {
          if (hasOwn$3(attrs, key)) {
            if (value !== attrs[key]) {
              attrs[key] = value;
              hasAttrsChanged = true;
            }
          } else {
            const camelizedKey = camelize(key);
            props[camelizedKey] = resolvePropValue(
              options,
              rawCurrentProps,
              camelizedKey,
              value,
              instance,
              false
            );
          }
        } else {
          if (value !== attrs[key]) {
            attrs[key] = value;
            hasAttrsChanged = true;
          }
        }
      }
    }
  } else {
    if (setFullProps(instance, rawProps, props, attrs)) {
      hasAttrsChanged = true;
    }
    let kebabKey;
    for (const key in rawCurrentProps) {
      if (!rawProps || !hasOwn$3(rawProps, key) && ((kebabKey = hyphenate(key)) === key || !hasOwn$3(rawProps, kebabKey))) {
        if (options) {
          if (rawPrevProps && (rawPrevProps[key] !== void 0 || rawPrevProps[kebabKey] !== void 0)) {
            props[key] = resolvePropValue(
              options,
              rawCurrentProps,
              key,
              void 0,
              instance,
              true
            );
          }
        } else {
          delete props[key];
        }
      }
    }
    if (attrs !== rawCurrentProps) {
      for (const key in attrs) {
        if (!rawProps || !hasOwn$3(rawProps, key) && true) {
          delete attrs[key];
          hasAttrsChanged = true;
        }
      }
    }
  }
  if (hasAttrsChanged) {
    trigger(instance.attrs, "set", "");
  }
}
function setFullProps(instance, rawProps, props, attrs) {
  const [options, needCastKeys] = instance.propsOptions;
  let hasAttrsChanged = false;
  let rawCastValues;
  if (rawProps) {
    for (let key in rawProps) {
      if (isReservedProp(key)) {
        continue;
      }
      const value = rawProps[key];
      let camelKey;
      if (options && hasOwn$3(options, camelKey = camelize(key))) {
        if (!needCastKeys || !needCastKeys.includes(camelKey)) {
          props[camelKey] = value;
        } else {
          (rawCastValues || (rawCastValues = {}))[camelKey] = value;
        }
      } else if (!isEmitListener(instance.emitsOptions, key)) {
        if (!(key in attrs) || value !== attrs[key]) {
          attrs[key] = value;
          hasAttrsChanged = true;
        }
      }
    }
  }
  if (needCastKeys) {
    const rawCurrentProps = toRaw(props);
    const castValues = rawCastValues || EMPTY_OBJ;
    for (let i = 0; i < needCastKeys.length; i++) {
      const key = needCastKeys[i];
      props[key] = resolvePropValue(
        options,
        rawCurrentProps,
        key,
        castValues[key],
        instance,
        !hasOwn$3(castValues, key)
      );
    }
  }
  return hasAttrsChanged;
}
function resolvePropValue(options, props, key, value, instance, isAbsent) {
  const opt = options[key];
  if (opt != null) {
    const hasDefault = hasOwn$3(opt, "default");
    if (hasDefault && value === void 0) {
      const defaultValue = opt.default;
      if (opt.type !== Function && !opt.skipFactory && isFunction$1(defaultValue)) {
        const { propsDefaults } = instance;
        if (key in propsDefaults) {
          value = propsDefaults[key];
        } else {
          const reset = setCurrentInstance(instance);
          value = propsDefaults[key] = defaultValue.call(
            null,
            props
          );
          reset();
        }
      } else {
        value = defaultValue;
      }
    }
    if (opt[0]) {
      if (isAbsent && !hasDefault) {
        value = false;
      } else if (opt[1] && (value === "" || value === hyphenate(key))) {
        value = true;
      }
    }
  }
  return value;
}
function normalizePropsOptions(comp, appContext, asMixin = false) {
  const cache = appContext.propsCache;
  const cached = cache.get(comp);
  if (cached) {
    return cached;
  }
  const raw = comp.props;
  const normalized = {};
  const needCastKeys = [];
  let hasExtends = false;
  if (!isFunction$1(comp)) {
    const extendProps = (raw2) => {
      hasExtends = true;
      const [props, keys3] = normalizePropsOptions(raw2, appContext, true);
      extend(normalized, props);
      if (keys3)
        needCastKeys.push(...keys3);
    };
    if (!asMixin && appContext.mixins.length) {
      appContext.mixins.forEach(extendProps);
    }
    if (comp.extends) {
      extendProps(comp.extends);
    }
    if (comp.mixins) {
      comp.mixins.forEach(extendProps);
    }
  }
  if (!raw && !hasExtends) {
    if (isObject(comp)) {
      cache.set(comp, EMPTY_ARR);
    }
    return EMPTY_ARR;
  }
  if (isArray(raw)) {
    for (let i = 0; i < raw.length; i++) {
      const normalizedKey = camelize(raw[i]);
      if (validatePropName(normalizedKey)) {
        normalized[normalizedKey] = EMPTY_OBJ;
      }
    }
  } else if (raw) {
    for (const key in raw) {
      const normalizedKey = camelize(key);
      if (validatePropName(normalizedKey)) {
        const opt = raw[key];
        const prop = normalized[normalizedKey] = isArray(opt) || isFunction$1(opt) ? { type: opt } : extend({}, opt);
        if (prop) {
          const booleanIndex = getTypeIndex(Boolean, prop.type);
          const stringIndex = getTypeIndex(String, prop.type);
          prop[0] = booleanIndex > -1;
          prop[1] = stringIndex < 0 || booleanIndex < stringIndex;
          if (booleanIndex > -1 || hasOwn$3(prop, "default")) {
            needCastKeys.push(normalizedKey);
          }
        }
      }
    }
  }
  const res = [normalized, needCastKeys];
  if (isObject(comp)) {
    cache.set(comp, res);
  }
  return res;
}
function validatePropName(key) {
  if (key[0] !== "$" && !isReservedProp(key)) {
    return true;
  }
  return false;
}
function getType(ctor) {
  if (ctor === null) {
    return "null";
  }
  if (typeof ctor === "function") {
    return ctor.name || "";
  } else if (typeof ctor === "object") {
    const name = ctor.constructor && ctor.constructor.name;
    return name || "";
  }
  return "";
}
function isSameType(a, b) {
  return getType(a) === getType(b);
}
function getTypeIndex(type2, expectedTypes) {
  if (isArray(expectedTypes)) {
    return expectedTypes.findIndex((t) => isSameType(t, type2));
  } else if (isFunction$1(expectedTypes)) {
    return isSameType(expectedTypes, type2) ? 0 : -1;
  }
  return -1;
}
const isInternalKey = (key) => key[0] === "_" || key === "$stable";
const normalizeSlotValue = (value) => isArray(value) ? value.map(normalizeVNode) : [normalizeVNode(value)];
const normalizeSlot = (key, rawSlot, ctx) => {
  if (rawSlot._n) {
    return rawSlot;
  }
  const normalized = withCtx((...args) => {
    if (false)
      ;
    return normalizeSlotValue(rawSlot(...args));
  }, ctx);
  normalized._c = false;
  return normalized;
};
const normalizeObjectSlots = (rawSlots, slots, instance) => {
  const ctx = rawSlots._ctx;
  for (const key in rawSlots) {
    if (isInternalKey(key))
      continue;
    const value = rawSlots[key];
    if (isFunction$1(value)) {
      slots[key] = normalizeSlot(key, value, ctx);
    } else if (value != null) {
      const normalized = normalizeSlotValue(value);
      slots[key] = () => normalized;
    }
  }
};
const normalizeVNodeSlots = (instance, children) => {
  const normalized = normalizeSlotValue(children);
  instance.slots.default = () => normalized;
};
const initSlots = (instance, children) => {
  const slots = instance.slots = createInternalObject();
  if (instance.vnode.shapeFlag & 32) {
    const type2 = children._;
    if (type2) {
      extend(slots, children);
      def(slots, "_", type2, true);
    } else {
      normalizeObjectSlots(children, slots);
    }
  } else if (children) {
    normalizeVNodeSlots(instance, children);
  }
};
const updateSlots = (instance, children, optimized) => {
  const { vnode, slots } = instance;
  let needDeletionCheck = true;
  let deletionComparisonTarget = EMPTY_OBJ;
  if (vnode.shapeFlag & 32) {
    const type2 = children._;
    if (type2) {
      if (optimized && type2 === 1) {
        needDeletionCheck = false;
      } else {
        extend(slots, children);
        if (!optimized && type2 === 1) {
          delete slots._;
        }
      }
    } else {
      needDeletionCheck = !children.$stable;
      normalizeObjectSlots(children, slots);
    }
    deletionComparisonTarget = children;
  } else if (children) {
    normalizeVNodeSlots(instance, children);
    deletionComparisonTarget = { default: 1 };
  }
  if (needDeletionCheck) {
    for (const key in slots) {
      if (!isInternalKey(key) && deletionComparisonTarget[key] == null) {
        delete slots[key];
      }
    }
  }
};
function setRef(rawRef, oldRawRef, parentSuspense, vnode, isUnmount = false) {
  if (isArray(rawRef)) {
    rawRef.forEach(
      (r, i) => setRef(
        r,
        oldRawRef && (isArray(oldRawRef) ? oldRawRef[i] : oldRawRef),
        parentSuspense,
        vnode,
        isUnmount
      )
    );
    return;
  }
  if (isAsyncWrapper(vnode) && !isUnmount) {
    return;
  }
  const refValue = vnode.shapeFlag & 4 ? getExposeProxy(vnode.component) || vnode.component.proxy : vnode.el;
  const value = isUnmount ? null : refValue;
  const { i: owner, r: ref2 } = rawRef;
  const oldRef = oldRawRef && oldRawRef.r;
  const refs = owner.refs === EMPTY_OBJ ? owner.refs = {} : owner.refs;
  const setupState = owner.setupState;
  if (oldRef != null && oldRef !== ref2) {
    if (isString(oldRef)) {
      refs[oldRef] = null;
      if (hasOwn$3(setupState, oldRef)) {
        setupState[oldRef] = null;
      }
    } else if (isRef(oldRef)) {
      oldRef.value = null;
    }
  }
  if (isFunction$1(ref2)) {
    callWithErrorHandling(ref2, owner, 12, [value, refs]);
  } else {
    const _isString = isString(ref2);
    const _isRef = isRef(ref2);
    if (_isString || _isRef) {
      const doSet = () => {
        if (rawRef.f) {
          const existing = _isString ? hasOwn$3(setupState, ref2) ? setupState[ref2] : refs[ref2] : ref2.value;
          if (isUnmount) {
            isArray(existing) && remove(existing, refValue);
          } else {
            if (!isArray(existing)) {
              if (_isString) {
                refs[ref2] = [refValue];
                if (hasOwn$3(setupState, ref2)) {
                  setupState[ref2] = refs[ref2];
                }
              } else {
                ref2.value = [refValue];
                if (rawRef.k)
                  refs[rawRef.k] = ref2.value;
              }
            } else if (!existing.includes(refValue)) {
              existing.push(refValue);
            }
          }
        } else if (_isString) {
          refs[ref2] = value;
          if (hasOwn$3(setupState, ref2)) {
            setupState[ref2] = value;
          }
        } else if (_isRef) {
          ref2.value = value;
          if (rawRef.k)
            refs[rawRef.k] = value;
        } else
          ;
      };
      if (value) {
        doSet.id = -1;
        queuePostRenderEffect(doSet, parentSuspense);
      } else {
        doSet();
      }
    }
  }
}
function initFeatureFlags() {
  if (typeof __VUE_PROD_HYDRATION_MISMATCH_DETAILS__ !== "boolean") {
    getGlobalThis().__VUE_PROD_HYDRATION_MISMATCH_DETAILS__ = false;
  }
}
const queuePostRenderEffect = queueEffectWithSuspense;
function createRenderer(options) {
  return baseCreateRenderer(options);
}
function baseCreateRenderer(options, createHydrationFns) {
  {
    initFeatureFlags();
  }
  const target = getGlobalThis();
  target.__VUE__ = true;
  const {
    insert: hostInsert,
    remove: hostRemove,
    patchProp: hostPatchProp,
    createElement: hostCreateElement,
    createText: hostCreateText,
    createComment: hostCreateComment,
    setText: hostSetText,
    setElementText: hostSetElementText,
    parentNode: hostParentNode,
    nextSibling: hostNextSibling,
    setScopeId: hostSetScopeId = NOOP,
    insertStaticContent: hostInsertStaticContent
  } = options;
  const patch = (n1, n2, container, anchor = null, parentComponent = null, parentSuspense = null, namespace = void 0, slotScopeIds = null, optimized = !!n2.dynamicChildren) => {
    if (n1 === n2) {
      return;
    }
    if (n1 && !isSameVNodeType(n1, n2)) {
      anchor = getNextHostNode(n1);
      unmount(n1, parentComponent, parentSuspense, true);
      n1 = null;
    }
    if (n2.patchFlag === -2) {
      optimized = false;
      n2.dynamicChildren = null;
    }
    const { type: type2, ref: ref2, shapeFlag } = n2;
    switch (type2) {
      case Text:
        processText(n1, n2, container, anchor);
        break;
      case Comment:
        processCommentNode(n1, n2, container, anchor);
        break;
      case Static:
        if (n1 == null) {
          mountStaticNode(n2, container, anchor, namespace);
        }
        break;
      case Fragment:
        processFragment(
          n1,
          n2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
        break;
      default:
        if (shapeFlag & 1) {
          processElement(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else if (shapeFlag & 6) {
          processComponent(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else if (shapeFlag & 64) {
          type2.process(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized,
            internals
          );
        } else if (shapeFlag & 128) {
          type2.process(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized,
            internals
          );
        } else
          ;
    }
    if (ref2 != null && parentComponent) {
      setRef(ref2, n1 && n1.ref, parentSuspense, n2 || n1, !n2);
    }
  };
  const processText = (n1, n2, container, anchor) => {
    if (n1 == null) {
      hostInsert(
        n2.el = hostCreateText(n2.children),
        container,
        anchor
      );
    } else {
      const el = n2.el = n1.el;
      if (n2.children !== n1.children) {
        hostSetText(el, n2.children);
      }
    }
  };
  const processCommentNode = (n1, n2, container, anchor) => {
    if (n1 == null) {
      hostInsert(
        n2.el = hostCreateComment(n2.children || ""),
        container,
        anchor
      );
    } else {
      n2.el = n1.el;
    }
  };
  const mountStaticNode = (n2, container, anchor, namespace) => {
    [n2.el, n2.anchor] = hostInsertStaticContent(
      n2.children,
      container,
      anchor,
      namespace,
      n2.el,
      n2.anchor
    );
  };
  const moveStaticNode = ({ el, anchor }, container, nextSibling) => {
    let next;
    while (el && el !== anchor) {
      next = hostNextSibling(el);
      hostInsert(el, container, nextSibling);
      el = next;
    }
    hostInsert(anchor, container, nextSibling);
  };
  const removeStaticNode = ({ el, anchor }) => {
    let next;
    while (el && el !== anchor) {
      next = hostNextSibling(el);
      hostRemove(el);
      el = next;
    }
    hostRemove(anchor);
  };
  const processElement = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    if (n2.type === "svg") {
      namespace = "svg";
    } else if (n2.type === "math") {
      namespace = "mathml";
    }
    if (n1 == null) {
      mountElement(
        n2,
        container,
        anchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    } else {
      patchElement(
        n1,
        n2,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    }
  };
  const mountElement = (vnode, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    let el;
    let vnodeHook;
    const { props, shapeFlag, transition, dirs } = vnode;
    el = vnode.el = hostCreateElement(
      vnode.type,
      namespace,
      props && props.is,
      props
    );
    if (shapeFlag & 8) {
      hostSetElementText(el, vnode.children);
    } else if (shapeFlag & 16) {
      mountChildren(
        vnode.children,
        el,
        null,
        parentComponent,
        parentSuspense,
        resolveChildrenNamespace(vnode, namespace),
        slotScopeIds,
        optimized
      );
    }
    if (dirs) {
      invokeDirectiveHook(vnode, null, parentComponent, "created");
    }
    setScopeId(el, vnode, vnode.scopeId, slotScopeIds, parentComponent);
    if (props) {
      for (const key in props) {
        if (key !== "value" && !isReservedProp(key)) {
          hostPatchProp(
            el,
            key,
            null,
            props[key],
            namespace,
            vnode.children,
            parentComponent,
            parentSuspense,
            unmountChildren
          );
        }
      }
      if ("value" in props) {
        hostPatchProp(el, "value", null, props.value, namespace);
      }
      if (vnodeHook = props.onVnodeBeforeMount) {
        invokeVNodeHook(vnodeHook, parentComponent, vnode);
      }
    }
    if (dirs) {
      invokeDirectiveHook(vnode, null, parentComponent, "beforeMount");
    }
    const needCallTransitionHooks = needTransition(parentSuspense, transition);
    if (needCallTransitionHooks) {
      transition.beforeEnter(el);
    }
    hostInsert(el, container, anchor);
    if ((vnodeHook = props && props.onVnodeMounted) || needCallTransitionHooks || dirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
        needCallTransitionHooks && transition.enter(el);
        dirs && invokeDirectiveHook(vnode, null, parentComponent, "mounted");
      }, parentSuspense);
    }
  };
  const setScopeId = (el, vnode, scopeId, slotScopeIds, parentComponent) => {
    if (scopeId) {
      hostSetScopeId(el, scopeId);
    }
    if (slotScopeIds) {
      for (let i = 0; i < slotScopeIds.length; i++) {
        hostSetScopeId(el, slotScopeIds[i]);
      }
    }
    if (parentComponent) {
      let subTree = parentComponent.subTree;
      if (vnode === subTree) {
        const parentVNode = parentComponent.vnode;
        setScopeId(
          el,
          parentVNode,
          parentVNode.scopeId,
          parentVNode.slotScopeIds,
          parentComponent.parent
        );
      }
    }
  };
  const mountChildren = (children, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized, start = 0) => {
    for (let i = start; i < children.length; i++) {
      const child = children[i] = optimized ? cloneIfMounted(children[i]) : normalizeVNode(children[i]);
      patch(
        null,
        child,
        container,
        anchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    }
  };
  const patchElement = (n1, n2, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    const el = n2.el = n1.el;
    let { patchFlag, dynamicChildren, dirs } = n2;
    patchFlag |= n1.patchFlag & 16;
    const oldProps = n1.props || EMPTY_OBJ;
    const newProps = n2.props || EMPTY_OBJ;
    let vnodeHook;
    parentComponent && toggleRecurse(parentComponent, false);
    if (vnodeHook = newProps.onVnodeBeforeUpdate) {
      invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
    }
    if (dirs) {
      invokeDirectiveHook(n2, n1, parentComponent, "beforeUpdate");
    }
    parentComponent && toggleRecurse(parentComponent, true);
    if (dynamicChildren) {
      patchBlockChildren(
        n1.dynamicChildren,
        dynamicChildren,
        el,
        parentComponent,
        parentSuspense,
        resolveChildrenNamespace(n2, namespace),
        slotScopeIds
      );
    } else if (!optimized) {
      patchChildren(
        n1,
        n2,
        el,
        null,
        parentComponent,
        parentSuspense,
        resolveChildrenNamespace(n2, namespace),
        slotScopeIds,
        false
      );
    }
    if (patchFlag > 0) {
      if (patchFlag & 16) {
        patchProps(
          el,
          n2,
          oldProps,
          newProps,
          parentComponent,
          parentSuspense,
          namespace
        );
      } else {
        if (patchFlag & 2) {
          if (oldProps.class !== newProps.class) {
            hostPatchProp(el, "class", null, newProps.class, namespace);
          }
        }
        if (patchFlag & 4) {
          hostPatchProp(el, "style", oldProps.style, newProps.style, namespace);
        }
        if (patchFlag & 8) {
          const propsToUpdate = n2.dynamicProps;
          for (let i = 0; i < propsToUpdate.length; i++) {
            const key = propsToUpdate[i];
            const prev = oldProps[key];
            const next = newProps[key];
            if (next !== prev || key === "value") {
              hostPatchProp(
                el,
                key,
                prev,
                next,
                namespace,
                n1.children,
                parentComponent,
                parentSuspense,
                unmountChildren
              );
            }
          }
        }
      }
      if (patchFlag & 1) {
        if (n1.children !== n2.children) {
          hostSetElementText(el, n2.children);
        }
      }
    } else if (!optimized && dynamicChildren == null) {
      patchProps(
        el,
        n2,
        oldProps,
        newProps,
        parentComponent,
        parentSuspense,
        namespace
      );
    }
    if ((vnodeHook = newProps.onVnodeUpdated) || dirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
        dirs && invokeDirectiveHook(n2, n1, parentComponent, "updated");
      }, parentSuspense);
    }
  };
  const patchBlockChildren = (oldChildren, newChildren, fallbackContainer, parentComponent, parentSuspense, namespace, slotScopeIds) => {
    for (let i = 0; i < newChildren.length; i++) {
      const oldVNode = oldChildren[i];
      const newVNode = newChildren[i];
      const container = oldVNode.el && (oldVNode.type === Fragment || !isSameVNodeType(oldVNode, newVNode) || oldVNode.shapeFlag & (6 | 64)) ? hostParentNode(oldVNode.el) : fallbackContainer;
      patch(
        oldVNode,
        newVNode,
        container,
        null,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        true
      );
    }
  };
  const patchProps = (el, vnode, oldProps, newProps, parentComponent, parentSuspense, namespace) => {
    if (oldProps !== newProps) {
      if (oldProps !== EMPTY_OBJ) {
        for (const key in oldProps) {
          if (!isReservedProp(key) && !(key in newProps)) {
            hostPatchProp(
              el,
              key,
              oldProps[key],
              null,
              namespace,
              vnode.children,
              parentComponent,
              parentSuspense,
              unmountChildren
            );
          }
        }
      }
      for (const key in newProps) {
        if (isReservedProp(key))
          continue;
        const next = newProps[key];
        const prev = oldProps[key];
        if (next !== prev && key !== "value") {
          hostPatchProp(
            el,
            key,
            prev,
            next,
            namespace,
            vnode.children,
            parentComponent,
            parentSuspense,
            unmountChildren
          );
        }
      }
      if ("value" in newProps) {
        hostPatchProp(el, "value", oldProps.value, newProps.value, namespace);
      }
    }
  };
  const processFragment = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    const fragmentStartAnchor = n2.el = n1 ? n1.el : hostCreateText("");
    const fragmentEndAnchor = n2.anchor = n1 ? n1.anchor : hostCreateText("");
    let { patchFlag, dynamicChildren, slotScopeIds: fragmentSlotScopeIds } = n2;
    if (fragmentSlotScopeIds) {
      slotScopeIds = slotScopeIds ? slotScopeIds.concat(fragmentSlotScopeIds) : fragmentSlotScopeIds;
    }
    if (n1 == null) {
      hostInsert(fragmentStartAnchor, container, anchor);
      hostInsert(fragmentEndAnchor, container, anchor);
      mountChildren(
        n2.children || [],
        container,
        fragmentEndAnchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    } else {
      if (patchFlag > 0 && patchFlag & 64 && dynamicChildren && n1.dynamicChildren) {
        patchBlockChildren(
          n1.dynamicChildren,
          dynamicChildren,
          container,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds
        );
        if (n2.key != null || parentComponent && n2 === parentComponent.subTree) {
          traverseStaticChildren(
            n1,
            n2,
            true
          );
        }
      } else {
        patchChildren(
          n1,
          n2,
          container,
          fragmentEndAnchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      }
    }
  };
  const processComponent = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    n2.slotScopeIds = slotScopeIds;
    if (n1 == null) {
      if (n2.shapeFlag & 512) {
        parentComponent.ctx.activate(
          n2,
          container,
          anchor,
          namespace,
          optimized
        );
      } else {
        mountComponent(
          n2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          optimized
        );
      }
    } else {
      updateComponent(n1, n2, optimized);
    }
  };
  const mountComponent = (initialVNode, container, anchor, parentComponent, parentSuspense, namespace, optimized) => {
    const instance = initialVNode.component = createComponentInstance(
      initialVNode,
      parentComponent,
      parentSuspense
    );
    if (isKeepAlive(initialVNode)) {
      instance.ctx.renderer = internals;
    }
    {
      setupComponent(instance);
    }
    if (instance.asyncDep) {
      parentSuspense && parentSuspense.registerDep(instance, setupRenderEffect);
      if (!initialVNode.el) {
        const placeholder = instance.subTree = createVNode(Comment);
        processCommentNode(null, placeholder, container, anchor);
      }
    } else {
      setupRenderEffect(
        instance,
        initialVNode,
        container,
        anchor,
        parentSuspense,
        namespace,
        optimized
      );
    }
  };
  const updateComponent = (n1, n2, optimized) => {
    const instance = n2.component = n1.component;
    if (shouldUpdateComponent(n1, n2, optimized)) {
      if (instance.asyncDep && !instance.asyncResolved) {
        updateComponentPreRender(instance, n2, optimized);
        return;
      } else {
        instance.next = n2;
        invalidateJob(instance.update);
        instance.effect.dirty = true;
        instance.update();
      }
    } else {
      n2.el = n1.el;
      instance.vnode = n2;
    }
  };
  const setupRenderEffect = (instance, initialVNode, container, anchor, parentSuspense, namespace, optimized) => {
    const componentUpdateFn = () => {
      if (!instance.isMounted) {
        let vnodeHook;
        const { el, props } = initialVNode;
        const { bm, m, parent } = instance;
        const isAsyncWrapperVNode = isAsyncWrapper(initialVNode);
        toggleRecurse(instance, false);
        if (bm) {
          invokeArrayFns(bm);
        }
        if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeBeforeMount)) {
          invokeVNodeHook(vnodeHook, parent, initialVNode);
        }
        toggleRecurse(instance, true);
        if (el && hydrateNode) {
          const hydrateSubTree = () => {
            instance.subTree = renderComponentRoot(instance);
            hydrateNode(
              el,
              instance.subTree,
              instance,
              parentSuspense,
              null
            );
          };
          if (isAsyncWrapperVNode) {
            initialVNode.type.__asyncLoader().then(
              () => !instance.isUnmounted && hydrateSubTree()
            );
          } else {
            hydrateSubTree();
          }
        } else {
          const subTree = instance.subTree = renderComponentRoot(instance);
          patch(
            null,
            subTree,
            container,
            anchor,
            instance,
            parentSuspense,
            namespace
          );
          initialVNode.el = subTree.el;
        }
        if (m) {
          queuePostRenderEffect(m, parentSuspense);
        }
        if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeMounted)) {
          const scopedInitialVNode = initialVNode;
          queuePostRenderEffect(
            () => invokeVNodeHook(vnodeHook, parent, scopedInitialVNode),
            parentSuspense
          );
        }
        if (initialVNode.shapeFlag & 256 || parent && isAsyncWrapper(parent.vnode) && parent.vnode.shapeFlag & 256) {
          instance.a && queuePostRenderEffect(instance.a, parentSuspense);
        }
        instance.isMounted = true;
        initialVNode = container = anchor = null;
      } else {
        let { next, bu, u, parent, vnode } = instance;
        {
          const nonHydratedAsyncRoot = locateNonHydratedAsyncRoot(instance);
          if (nonHydratedAsyncRoot) {
            if (next) {
              next.el = vnode.el;
              updateComponentPreRender(instance, next, optimized);
            }
            nonHydratedAsyncRoot.asyncDep.then(() => {
              if (!instance.isUnmounted) {
                componentUpdateFn();
              }
            });
            return;
          }
        }
        let originNext = next;
        let vnodeHook;
        toggleRecurse(instance, false);
        if (next) {
          next.el = vnode.el;
          updateComponentPreRender(instance, next, optimized);
        } else {
          next = vnode;
        }
        if (bu) {
          invokeArrayFns(bu);
        }
        if (vnodeHook = next.props && next.props.onVnodeBeforeUpdate) {
          invokeVNodeHook(vnodeHook, parent, next, vnode);
        }
        toggleRecurse(instance, true);
        const nextTree = renderComponentRoot(instance);
        const prevTree = instance.subTree;
        instance.subTree = nextTree;
        patch(
          prevTree,
          nextTree,
          hostParentNode(prevTree.el),
          getNextHostNode(prevTree),
          instance,
          parentSuspense,
          namespace
        );
        next.el = nextTree.el;
        if (originNext === null) {
          updateHOCHostEl(instance, nextTree.el);
        }
        if (u) {
          queuePostRenderEffect(u, parentSuspense);
        }
        if (vnodeHook = next.props && next.props.onVnodeUpdated) {
          queuePostRenderEffect(
            () => invokeVNodeHook(vnodeHook, parent, next, vnode),
            parentSuspense
          );
        }
      }
    };
    const effect = instance.effect = new ReactiveEffect(
      componentUpdateFn,
      NOOP,
      () => queueJob(update),
      instance.scope
    );
    const update = instance.update = () => {
      if (effect.dirty) {
        effect.run();
      }
    };
    update.id = instance.uid;
    toggleRecurse(instance, true);
    update();
  };
  const updateComponentPreRender = (instance, nextVNode, optimized) => {
    nextVNode.component = instance;
    const prevProps = instance.vnode.props;
    instance.vnode = nextVNode;
    instance.next = null;
    updateProps(instance, nextVNode.props, prevProps, optimized);
    updateSlots(instance, nextVNode.children, optimized);
    pauseTracking();
    flushPreFlushCbs(instance);
    resetTracking();
  };
  const patchChildren = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized = false) => {
    const c1 = n1 && n1.children;
    const prevShapeFlag = n1 ? n1.shapeFlag : 0;
    const c2 = n2.children;
    const { patchFlag, shapeFlag } = n2;
    if (patchFlag > 0) {
      if (patchFlag & 128) {
        patchKeyedChildren(
          c1,
          c2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
        return;
      } else if (patchFlag & 256) {
        patchUnkeyedChildren(
          c1,
          c2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
        return;
      }
    }
    if (shapeFlag & 8) {
      if (prevShapeFlag & 16) {
        unmountChildren(c1, parentComponent, parentSuspense);
      }
      if (c2 !== c1) {
        hostSetElementText(container, c2);
      }
    } else {
      if (prevShapeFlag & 16) {
        if (shapeFlag & 16) {
          patchKeyedChildren(
            c1,
            c2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else {
          unmountChildren(c1, parentComponent, parentSuspense, true);
        }
      } else {
        if (prevShapeFlag & 8) {
          hostSetElementText(container, "");
        }
        if (shapeFlag & 16) {
          mountChildren(
            c2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        }
      }
    }
  };
  const patchUnkeyedChildren = (c1, c2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    c1 = c1 || EMPTY_ARR;
    c2 = c2 || EMPTY_ARR;
    const oldLength = c1.length;
    const newLength = c2.length;
    const commonLength = Math.min(oldLength, newLength);
    let i;
    for (i = 0; i < commonLength; i++) {
      const nextChild = c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]);
      patch(
        c1[i],
        nextChild,
        container,
        null,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    }
    if (oldLength > newLength) {
      unmountChildren(
        c1,
        parentComponent,
        parentSuspense,
        true,
        false,
        commonLength
      );
    } else {
      mountChildren(
        c2,
        container,
        anchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized,
        commonLength
      );
    }
  };
  const patchKeyedChildren = (c1, c2, container, parentAnchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    let i = 0;
    const l2 = c2.length;
    let e1 = c1.length - 1;
    let e2 = l2 - 1;
    while (i <= e1 && i <= e2) {
      const n1 = c1[i];
      const n2 = c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]);
      if (isSameVNodeType(n1, n2)) {
        patch(
          n1,
          n2,
          container,
          null,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      } else {
        break;
      }
      i++;
    }
    while (i <= e1 && i <= e2) {
      const n1 = c1[e1];
      const n2 = c2[e2] = optimized ? cloneIfMounted(c2[e2]) : normalizeVNode(c2[e2]);
      if (isSameVNodeType(n1, n2)) {
        patch(
          n1,
          n2,
          container,
          null,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      } else {
        break;
      }
      e1--;
      e2--;
    }
    if (i > e1) {
      if (i <= e2) {
        const nextPos = e2 + 1;
        const anchor = nextPos < l2 ? c2[nextPos].el : parentAnchor;
        while (i <= e2) {
          patch(
            null,
            c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]),
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          i++;
        }
      }
    } else if (i > e2) {
      while (i <= e1) {
        unmount(c1[i], parentComponent, parentSuspense, true);
        i++;
      }
    } else {
      const s1 = i;
      const s2 = i;
      const keyToNewIndexMap = /* @__PURE__ */ new Map();
      for (i = s2; i <= e2; i++) {
        const nextChild = c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]);
        if (nextChild.key != null) {
          keyToNewIndexMap.set(nextChild.key, i);
        }
      }
      let j;
      let patched = 0;
      const toBePatched = e2 - s2 + 1;
      let moved = false;
      let maxNewIndexSoFar = 0;
      const newIndexToOldIndexMap = new Array(toBePatched);
      for (i = 0; i < toBePatched; i++)
        newIndexToOldIndexMap[i] = 0;
      for (i = s1; i <= e1; i++) {
        const prevChild = c1[i];
        if (patched >= toBePatched) {
          unmount(prevChild, parentComponent, parentSuspense, true);
          continue;
        }
        let newIndex;
        if (prevChild.key != null) {
          newIndex = keyToNewIndexMap.get(prevChild.key);
        } else {
          for (j = s2; j <= e2; j++) {
            if (newIndexToOldIndexMap[j - s2] === 0 && isSameVNodeType(prevChild, c2[j])) {
              newIndex = j;
              break;
            }
          }
        }
        if (newIndex === void 0) {
          unmount(prevChild, parentComponent, parentSuspense, true);
        } else {
          newIndexToOldIndexMap[newIndex - s2] = i + 1;
          if (newIndex >= maxNewIndexSoFar) {
            maxNewIndexSoFar = newIndex;
          } else {
            moved = true;
          }
          patch(
            prevChild,
            c2[newIndex],
            container,
            null,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          patched++;
        }
      }
      const increasingNewIndexSequence = moved ? getSequence(newIndexToOldIndexMap) : EMPTY_ARR;
      j = increasingNewIndexSequence.length - 1;
      for (i = toBePatched - 1; i >= 0; i--) {
        const nextIndex = s2 + i;
        const nextChild = c2[nextIndex];
        const anchor = nextIndex + 1 < l2 ? c2[nextIndex + 1].el : parentAnchor;
        if (newIndexToOldIndexMap[i] === 0) {
          patch(
            null,
            nextChild,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else if (moved) {
          if (j < 0 || i !== increasingNewIndexSequence[j]) {
            move(nextChild, container, anchor, 2);
          } else {
            j--;
          }
        }
      }
    }
  };
  const move = (vnode, container, anchor, moveType, parentSuspense = null) => {
    const { el, type: type2, transition, children, shapeFlag } = vnode;
    if (shapeFlag & 6) {
      move(vnode.component.subTree, container, anchor, moveType);
      return;
    }
    if (shapeFlag & 128) {
      vnode.suspense.move(container, anchor, moveType);
      return;
    }
    if (shapeFlag & 64) {
      type2.move(vnode, container, anchor, internals);
      return;
    }
    if (type2 === Fragment) {
      hostInsert(el, container, anchor);
      for (let i = 0; i < children.length; i++) {
        move(children[i], container, anchor, moveType);
      }
      hostInsert(vnode.anchor, container, anchor);
      return;
    }
    if (type2 === Static) {
      moveStaticNode(vnode, container, anchor);
      return;
    }
    const needTransition2 = moveType !== 2 && shapeFlag & 1 && transition;
    if (needTransition2) {
      if (moveType === 0) {
        transition.beforeEnter(el);
        hostInsert(el, container, anchor);
        queuePostRenderEffect(() => transition.enter(el), parentSuspense);
      } else {
        const { leave, delayLeave, afterLeave } = transition;
        const remove22 = () => hostInsert(el, container, anchor);
        const performLeave = () => {
          leave(el, () => {
            remove22();
            afterLeave && afterLeave();
          });
        };
        if (delayLeave) {
          delayLeave(el, remove22, performLeave);
        } else {
          performLeave();
        }
      }
    } else {
      hostInsert(el, container, anchor);
    }
  };
  const unmount = (vnode, parentComponent, parentSuspense, doRemove = false, optimized = false) => {
    const {
      type: type2,
      props,
      ref: ref2,
      children,
      dynamicChildren,
      shapeFlag,
      patchFlag,
      dirs
    } = vnode;
    if (ref2 != null) {
      setRef(ref2, null, parentSuspense, vnode, true);
    }
    if (shapeFlag & 256) {
      parentComponent.ctx.deactivate(vnode);
      return;
    }
    const shouldInvokeDirs = shapeFlag & 1 && dirs;
    const shouldInvokeVnodeHook = !isAsyncWrapper(vnode);
    let vnodeHook;
    if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeBeforeUnmount)) {
      invokeVNodeHook(vnodeHook, parentComponent, vnode);
    }
    if (shapeFlag & 6) {
      unmountComponent(vnode.component, parentSuspense, doRemove);
    } else {
      if (shapeFlag & 128) {
        vnode.suspense.unmount(parentSuspense, doRemove);
        return;
      }
      if (shouldInvokeDirs) {
        invokeDirectiveHook(vnode, null, parentComponent, "beforeUnmount");
      }
      if (shapeFlag & 64) {
        vnode.type.remove(
          vnode,
          parentComponent,
          parentSuspense,
          optimized,
          internals,
          doRemove
        );
      } else if (dynamicChildren && (type2 !== Fragment || patchFlag > 0 && patchFlag & 64)) {
        unmountChildren(
          dynamicChildren,
          parentComponent,
          parentSuspense,
          false,
          true
        );
      } else if (type2 === Fragment && patchFlag & (128 | 256) || !optimized && shapeFlag & 16) {
        unmountChildren(children, parentComponent, parentSuspense);
      }
      if (doRemove) {
        remove2(vnode);
      }
    }
    if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeUnmounted) || shouldInvokeDirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
        shouldInvokeDirs && invokeDirectiveHook(vnode, null, parentComponent, "unmounted");
      }, parentSuspense);
    }
  };
  const remove2 = (vnode) => {
    const { type: type2, el, anchor, transition } = vnode;
    if (type2 === Fragment) {
      {
        removeFragment(el, anchor);
      }
      return;
    }
    if (type2 === Static) {
      removeStaticNode(vnode);
      return;
    }
    const performRemove = () => {
      hostRemove(el);
      if (transition && !transition.persisted && transition.afterLeave) {
        transition.afterLeave();
      }
    };
    if (vnode.shapeFlag & 1 && transition && !transition.persisted) {
      const { leave, delayLeave } = transition;
      const performLeave = () => leave(el, performRemove);
      if (delayLeave) {
        delayLeave(vnode.el, performRemove, performLeave);
      } else {
        performLeave();
      }
    } else {
      performRemove();
    }
  };
  const removeFragment = (cur, end) => {
    let next;
    while (cur !== end) {
      next = hostNextSibling(cur);
      hostRemove(cur);
      cur = next;
    }
    hostRemove(end);
  };
  const unmountComponent = (instance, parentSuspense, doRemove) => {
    const { bum, scope, update, subTree, um } = instance;
    if (bum) {
      invokeArrayFns(bum);
    }
    scope.stop();
    if (update) {
      update.active = false;
      unmount(subTree, instance, parentSuspense, doRemove);
    }
    if (um) {
      queuePostRenderEffect(um, parentSuspense);
    }
    queuePostRenderEffect(() => {
      instance.isUnmounted = true;
    }, parentSuspense);
    if (parentSuspense && parentSuspense.pendingBranch && !parentSuspense.isUnmounted && instance.asyncDep && !instance.asyncResolved && instance.suspenseId === parentSuspense.pendingId) {
      parentSuspense.deps--;
      if (parentSuspense.deps === 0) {
        parentSuspense.resolve();
      }
    }
  };
  const unmountChildren = (children, parentComponent, parentSuspense, doRemove = false, optimized = false, start = 0) => {
    for (let i = start; i < children.length; i++) {
      unmount(children[i], parentComponent, parentSuspense, doRemove, optimized);
    }
  };
  const getNextHostNode = (vnode) => {
    if (vnode.shapeFlag & 6) {
      return getNextHostNode(vnode.component.subTree);
    }
    if (vnode.shapeFlag & 128) {
      return vnode.suspense.next();
    }
    return hostNextSibling(vnode.anchor || vnode.el);
  };
  let isFlushing2 = false;
  const render2 = (vnode, container, namespace) => {
    if (vnode == null) {
      if (container._vnode) {
        unmount(container._vnode, null, null, true);
      }
    } else {
      patch(
        container._vnode || null,
        vnode,
        container,
        null,
        null,
        null,
        namespace
      );
    }
    if (!isFlushing2) {
      isFlushing2 = true;
      flushPreFlushCbs();
      flushPostFlushCbs();
      isFlushing2 = false;
    }
    container._vnode = vnode;
  };
  const internals = {
    p: patch,
    um: unmount,
    m: move,
    r: remove2,
    mt: mountComponent,
    mc: mountChildren,
    pc: patchChildren,
    pbc: patchBlockChildren,
    n: getNextHostNode,
    o: options
  };
  let hydrate;
  let hydrateNode;
  if (createHydrationFns) {
    [hydrate, hydrateNode] = createHydrationFns(
      internals
    );
  }
  return {
    render: render2,
    hydrate,
    createApp: createAppAPI(render2, hydrate)
  };
}
function resolveChildrenNamespace({ type: type2, props }, currentNamespace) {
  return currentNamespace === "svg" && type2 === "foreignObject" || currentNamespace === "mathml" && type2 === "annotation-xml" && props && props.encoding && props.encoding.includes("html") ? void 0 : currentNamespace;
}
function toggleRecurse({ effect, update }, allowed) {
  effect.allowRecurse = update.allowRecurse = allowed;
}
function needTransition(parentSuspense, transition) {
  return (!parentSuspense || parentSuspense && !parentSuspense.pendingBranch) && transition && !transition.persisted;
}
function traverseStaticChildren(n1, n2, shallow = false) {
  const ch1 = n1.children;
  const ch2 = n2.children;
  if (isArray(ch1) && isArray(ch2)) {
    for (let i = 0; i < ch1.length; i++) {
      const c1 = ch1[i];
      let c2 = ch2[i];
      if (c2.shapeFlag & 1 && !c2.dynamicChildren) {
        if (c2.patchFlag <= 0 || c2.patchFlag === 32) {
          c2 = ch2[i] = cloneIfMounted(ch2[i]);
          c2.el = c1.el;
        }
        if (!shallow)
          traverseStaticChildren(c1, c2);
      }
      if (c2.type === Text) {
        c2.el = c1.el;
      }
    }
  }
}
function getSequence(arr) {
  const p2 = arr.slice();
  const result = [0];
  let i, j, u, v, c;
  const len = arr.length;
  for (i = 0; i < len; i++) {
    const arrI = arr[i];
    if (arrI !== 0) {
      j = result[result.length - 1];
      if (arr[j] < arrI) {
        p2[i] = j;
        result.push(i);
        continue;
      }
      u = 0;
      v = result.length - 1;
      while (u < v) {
        c = u + v >> 1;
        if (arr[result[c]] < arrI) {
          u = c + 1;
        } else {
          v = c;
        }
      }
      if (arrI < arr[result[u]]) {
        if (u > 0) {
          p2[i] = result[u - 1];
        }
        result[u] = i;
      }
    }
  }
  u = result.length;
  v = result[u - 1];
  while (u-- > 0) {
    result[u] = v;
    v = p2[v];
  }
  return result;
}
function locateNonHydratedAsyncRoot(instance) {
  const subComponent = instance.subTree.component;
  if (subComponent) {
    if (subComponent.asyncDep && !subComponent.asyncResolved) {
      return subComponent;
    } else {
      return locateNonHydratedAsyncRoot(subComponent);
    }
  }
}
const isTeleport = (type2) => type2.__isTeleport;
const isTeleportDisabled = (props) => props && (props.disabled || props.disabled === "");
const isTargetSVG = (target) => typeof SVGElement !== "undefined" && target instanceof SVGElement;
const isTargetMathML = (target) => typeof MathMLElement === "function" && target instanceof MathMLElement;
const resolveTarget = (props, select) => {
  const targetSelector = props && props.to;
  if (isString(targetSelector)) {
    if (!select) {
      return null;
    } else {
      const target = select(targetSelector);
      return target;
    }
  } else {
    return targetSelector;
  }
};
const TeleportImpl = {
  name: "Teleport",
  __isTeleport: true,
  process(n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized, internals) {
    const {
      mc: mountChildren,
      pc: patchChildren,
      pbc: patchBlockChildren,
      o: { insert, querySelector, createText, createComment }
    } = internals;
    const disabled = isTeleportDisabled(n2.props);
    let { shapeFlag, children, dynamicChildren } = n2;
    if (n1 == null) {
      const placeholder = n2.el = createText("");
      const mainAnchor = n2.anchor = createText("");
      insert(placeholder, container, anchor);
      insert(mainAnchor, container, anchor);
      const target = n2.target = resolveTarget(n2.props, querySelector);
      const targetAnchor = n2.targetAnchor = createText("");
      if (target) {
        insert(targetAnchor, target);
        if (namespace === "svg" || isTargetSVG(target)) {
          namespace = "svg";
        } else if (namespace === "mathml" || isTargetMathML(target)) {
          namespace = "mathml";
        }
      }
      const mount = (container2, anchor2) => {
        if (shapeFlag & 16) {
          mountChildren(
            children,
            container2,
            anchor2,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        }
      };
      if (disabled) {
        mount(container, mainAnchor);
      } else if (target) {
        mount(target, targetAnchor);
      }
    } else {
      n2.el = n1.el;
      const mainAnchor = n2.anchor = n1.anchor;
      const target = n2.target = n1.target;
      const targetAnchor = n2.targetAnchor = n1.targetAnchor;
      const wasDisabled = isTeleportDisabled(n1.props);
      const currentContainer = wasDisabled ? container : target;
      const currentAnchor = wasDisabled ? mainAnchor : targetAnchor;
      if (namespace === "svg" || isTargetSVG(target)) {
        namespace = "svg";
      } else if (namespace === "mathml" || isTargetMathML(target)) {
        namespace = "mathml";
      }
      if (dynamicChildren) {
        patchBlockChildren(
          n1.dynamicChildren,
          dynamicChildren,
          currentContainer,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds
        );
        traverseStaticChildren(n1, n2, true);
      } else if (!optimized) {
        patchChildren(
          n1,
          n2,
          currentContainer,
          currentAnchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          false
        );
      }
      if (disabled) {
        if (!wasDisabled) {
          moveTeleport(
            n2,
            container,
            mainAnchor,
            internals,
            1
          );
        } else {
          if (n2.props && n1.props && n2.props.to !== n1.props.to) {
            n2.props.to = n1.props.to;
          }
        }
      } else {
        if ((n2.props && n2.props.to) !== (n1.props && n1.props.to)) {
          const nextTarget = n2.target = resolveTarget(
            n2.props,
            querySelector
          );
          if (nextTarget) {
            moveTeleport(
              n2,
              nextTarget,
              null,
              internals,
              0
            );
          }
        } else if (wasDisabled) {
          moveTeleport(
            n2,
            target,
            targetAnchor,
            internals,
            1
          );
        }
      }
    }
    updateCssVars(n2);
  },
  remove(vnode, parentComponent, parentSuspense, optimized, { um: unmount, o: { remove: hostRemove } }, doRemove) {
    const { shapeFlag, children, anchor, targetAnchor, target, props } = vnode;
    if (target) {
      hostRemove(targetAnchor);
    }
    doRemove && hostRemove(anchor);
    if (shapeFlag & 16) {
      const shouldRemove = doRemove || !isTeleportDisabled(props);
      for (let i = 0; i < children.length; i++) {
        const child = children[i];
        unmount(
          child,
          parentComponent,
          parentSuspense,
          shouldRemove,
          !!child.dynamicChildren
        );
      }
    }
  },
  move: moveTeleport,
  hydrate: hydrateTeleport
};
function moveTeleport(vnode, container, parentAnchor, { o: { insert }, m: move }, moveType = 2) {
  if (moveType === 0) {
    insert(vnode.targetAnchor, container, parentAnchor);
  }
  const { el, anchor, shapeFlag, children, props } = vnode;
  const isReorder = moveType === 2;
  if (isReorder) {
    insert(el, container, parentAnchor);
  }
  if (!isReorder || isTeleportDisabled(props)) {
    if (shapeFlag & 16) {
      for (let i = 0; i < children.length; i++) {
        move(
          children[i],
          container,
          parentAnchor,
          2
        );
      }
    }
  }
  if (isReorder) {
    insert(anchor, container, parentAnchor);
  }
}
function hydrateTeleport(node, vnode, parentComponent, parentSuspense, slotScopeIds, optimized, {
  o: { nextSibling, parentNode, querySelector }
}, hydrateChildren) {
  const target = vnode.target = resolveTarget(
    vnode.props,
    querySelector
  );
  if (target) {
    const targetNode = target._lpa || target.firstChild;
    if (vnode.shapeFlag & 16) {
      if (isTeleportDisabled(vnode.props)) {
        vnode.anchor = hydrateChildren(
          nextSibling(node),
          vnode,
          parentNode(node),
          parentComponent,
          parentSuspense,
          slotScopeIds,
          optimized
        );
        vnode.targetAnchor = targetNode;
      } else {
        vnode.anchor = nextSibling(node);
        let targetAnchor = targetNode;
        while (targetAnchor) {
          targetAnchor = nextSibling(targetAnchor);
          if (targetAnchor && targetAnchor.nodeType === 8 && targetAnchor.data === "teleport anchor") {
            vnode.targetAnchor = targetAnchor;
            target._lpa = vnode.targetAnchor && nextSibling(vnode.targetAnchor);
            break;
          }
        }
        hydrateChildren(
          targetNode,
          vnode,
          target,
          parentComponent,
          parentSuspense,
          slotScopeIds,
          optimized
        );
      }
    }
    updateCssVars(vnode);
  }
  return vnode.anchor && nextSibling(vnode.anchor);
}
const Teleport = TeleportImpl;
function updateCssVars(vnode) {
  const ctx = vnode.ctx;
  if (ctx && ctx.ut) {
    let node = vnode.children[0].el;
    while (node && node !== vnode.targetAnchor) {
      if (node.nodeType === 1)
        node.setAttribute("data-v-owner", ctx.uid);
      node = node.nextSibling;
    }
    ctx.ut();
  }
}
const Fragment = Symbol.for("v-fgt");
const Text = Symbol.for("v-txt");
const Comment = Symbol.for("v-cmt");
const Static = Symbol.for("v-stc");
const blockStack = [];
let currentBlock = null;
function openBlock(disableTracking = false) {
  blockStack.push(currentBlock = disableTracking ? null : []);
}
function closeBlock() {
  blockStack.pop();
  currentBlock = blockStack[blockStack.length - 1] || null;
}
let isBlockTreeEnabled = 1;
function setBlockTracking(value) {
  isBlockTreeEnabled += value;
}
function setupBlock(vnode) {
  vnode.dynamicChildren = isBlockTreeEnabled > 0 ? currentBlock || EMPTY_ARR : null;
  closeBlock();
  if (isBlockTreeEnabled > 0 && currentBlock) {
    currentBlock.push(vnode);
  }
  return vnode;
}
function createElementBlock(type2, props, children, patchFlag, dynamicProps, shapeFlag) {
  return setupBlock(
    createBaseVNode(
      type2,
      props,
      children,
      patchFlag,
      dynamicProps,
      shapeFlag,
      true
    )
  );
}
function createBlock(type2, props, children, patchFlag, dynamicProps) {
  return setupBlock(
    createVNode(
      type2,
      props,
      children,
      patchFlag,
      dynamicProps,
      true
    )
  );
}
function isVNode(value) {
  return value ? value.__v_isVNode === true : false;
}
function isSameVNodeType(n1, n2) {
  return n1.type === n2.type && n1.key === n2.key;
}
const normalizeKey = ({ key }) => key != null ? key : null;
const normalizeRef = ({
  ref: ref2,
  ref_key,
  ref_for
}) => {
  if (typeof ref2 === "number") {
    ref2 = "" + ref2;
  }
  return ref2 != null ? isString(ref2) || isRef(ref2) || isFunction$1(ref2) ? { i: currentRenderingInstance, r: ref2, k: ref_key, f: !!ref_for } : ref2 : null;
};
function createBaseVNode(type2, props = null, children = null, patchFlag = 0, dynamicProps = null, shapeFlag = type2 === Fragment ? 0 : 1, isBlockNode = false, needFullChildrenNormalization = false) {
  const vnode = {
    __v_isVNode: true,
    __v_skip: true,
    type: type2,
    props,
    key: props && normalizeKey(props),
    ref: props && normalizeRef(props),
    scopeId: currentScopeId,
    slotScopeIds: null,
    children,
    component: null,
    suspense: null,
    ssContent: null,
    ssFallback: null,
    dirs: null,
    transition: null,
    el: null,
    anchor: null,
    target: null,
    targetAnchor: null,
    staticCount: 0,
    shapeFlag,
    patchFlag,
    dynamicProps,
    dynamicChildren: null,
    appContext: null,
    ctx: currentRenderingInstance
  };
  if (needFullChildrenNormalization) {
    normalizeChildren(vnode, children);
    if (shapeFlag & 128) {
      type2.normalize(vnode);
    }
  } else if (children) {
    vnode.shapeFlag |= isString(children) ? 8 : 16;
  }
  if (isBlockTreeEnabled > 0 && !isBlockNode && currentBlock && (vnode.patchFlag > 0 || shapeFlag & 6) && vnode.patchFlag !== 32) {
    currentBlock.push(vnode);
  }
  return vnode;
}
const createVNode = _createVNode;
function _createVNode(type2, props = null, children = null, patchFlag = 0, dynamicProps = null, isBlockNode = false) {
  if (!type2 || type2 === NULL_DYNAMIC_COMPONENT) {
    type2 = Comment;
  }
  if (isVNode(type2)) {
    const cloned = cloneVNode(
      type2,
      props,
      true
    );
    if (children) {
      normalizeChildren(cloned, children);
    }
    if (isBlockTreeEnabled > 0 && !isBlockNode && currentBlock) {
      if (cloned.shapeFlag & 6) {
        currentBlock[currentBlock.indexOf(type2)] = cloned;
      } else {
        currentBlock.push(cloned);
      }
    }
    cloned.patchFlag |= -2;
    return cloned;
  }
  if (isClassComponent(type2)) {
    type2 = type2.__vccOpts;
  }
  if (props) {
    props = guardReactiveProps(props);
    let { class: klass, style: style2 } = props;
    if (klass && !isString(klass)) {
      props.class = normalizeClass(klass);
    }
    if (isObject(style2)) {
      if (isProxy(style2) && !isArray(style2)) {
        style2 = extend({}, style2);
      }
      props.style = normalizeStyle(style2);
    }
  }
  const shapeFlag = isString(type2) ? 1 : isSuspense(type2) ? 128 : isTeleport(type2) ? 64 : isObject(type2) ? 4 : isFunction$1(type2) ? 2 : 0;
  return createBaseVNode(
    type2,
    props,
    children,
    patchFlag,
    dynamicProps,
    shapeFlag,
    isBlockNode,
    true
  );
}
function guardReactiveProps(props) {
  if (!props)
    return null;
  return isProxy(props) || isInternalObject(props) ? extend({}, props) : props;
}
function cloneVNode(vnode, extraProps, mergeRef = false, cloneTransition = false) {
  const { props, ref: ref2, patchFlag, children, transition } = vnode;
  const mergedProps = extraProps ? mergeProps(props || {}, extraProps) : props;
  const cloned = {
    __v_isVNode: true,
    __v_skip: true,
    type: vnode.type,
    props: mergedProps,
    key: mergedProps && normalizeKey(mergedProps),
    ref: extraProps && extraProps.ref ? mergeRef && ref2 ? isArray(ref2) ? ref2.concat(normalizeRef(extraProps)) : [ref2, normalizeRef(extraProps)] : normalizeRef(extraProps) : ref2,
    scopeId: vnode.scopeId,
    slotScopeIds: vnode.slotScopeIds,
    children,
    target: vnode.target,
    targetAnchor: vnode.targetAnchor,
    staticCount: vnode.staticCount,
    shapeFlag: vnode.shapeFlag,
    patchFlag: extraProps && vnode.type !== Fragment ? patchFlag === -1 ? 16 : patchFlag | 16 : patchFlag,
    dynamicProps: vnode.dynamicProps,
    dynamicChildren: vnode.dynamicChildren,
    appContext: vnode.appContext,
    dirs: vnode.dirs,
    transition,
    component: vnode.component,
    suspense: vnode.suspense,
    ssContent: vnode.ssContent && cloneVNode(vnode.ssContent),
    ssFallback: vnode.ssFallback && cloneVNode(vnode.ssFallback),
    el: vnode.el,
    anchor: vnode.anchor,
    ctx: vnode.ctx,
    ce: vnode.ce
  };
  if (transition && cloneTransition) {
    cloned.transition = transition.clone(cloned);
  }
  return cloned;
}
function createTextVNode(text = " ", flag = 0) {
  return createVNode(Text, null, text, flag);
}
function createStaticVNode(content, numberOfNodes) {
  const vnode = createVNode(Static, null, content);
  vnode.staticCount = numberOfNodes;
  return vnode;
}
function createCommentVNode(text = "", asBlock = false) {
  return asBlock ? (openBlock(), createBlock(Comment, null, text)) : createVNode(Comment, null, text);
}
function normalizeVNode(child) {
  if (child == null || typeof child === "boolean") {
    return createVNode(Comment);
  } else if (isArray(child)) {
    return createVNode(
      Fragment,
      null,
      child.slice()
    );
  } else if (typeof child === "object") {
    return cloneIfMounted(child);
  } else {
    return createVNode(Text, null, String(child));
  }
}
function cloneIfMounted(child) {
  return child.el === null && child.patchFlag !== -1 || child.memo ? child : cloneVNode(child);
}
function normalizeChildren(vnode, children) {
  let type2 = 0;
  const { shapeFlag } = vnode;
  if (children == null) {
    children = null;
  } else if (isArray(children)) {
    type2 = 16;
  } else if (typeof children === "object") {
    if (shapeFlag & (1 | 64)) {
      const slot = children.default;
      if (slot) {
        slot._c && (slot._d = false);
        normalizeChildren(vnode, slot());
        slot._c && (slot._d = true);
      }
      return;
    } else {
      type2 = 32;
      const slotFlag = children._;
      if (!slotFlag && !isInternalObject(children)) {
        children._ctx = currentRenderingInstance;
      } else if (slotFlag === 3 && currentRenderingInstance) {
        if (currentRenderingInstance.slots._ === 1) {
          children._ = 1;
        } else {
          children._ = 2;
          vnode.patchFlag |= 1024;
        }
      }
    }
  } else if (isFunction$1(children)) {
    children = { default: children, _ctx: currentRenderingInstance };
    type2 = 32;
  } else {
    children = String(children);
    if (shapeFlag & 64) {
      type2 = 16;
      children = [createTextVNode(children)];
    } else {
      type2 = 8;
    }
  }
  vnode.children = children;
  vnode.shapeFlag |= type2;
}
function mergeProps(...args) {
  const ret = {};
  for (let i = 0; i < args.length; i++) {
    const toMerge = args[i];
    for (const key in toMerge) {
      if (key === "class") {
        if (ret.class !== toMerge.class) {
          ret.class = normalizeClass([ret.class, toMerge.class]);
        }
      } else if (key === "style") {
        ret.style = normalizeStyle([ret.style, toMerge.style]);
      } else if (isOn(key)) {
        const existing = ret[key];
        const incoming = toMerge[key];
        if (incoming && existing !== incoming && !(isArray(existing) && existing.includes(incoming))) {
          ret[key] = existing ? [].concat(existing, incoming) : incoming;
        }
      } else if (key !== "") {
        ret[key] = toMerge[key];
      }
    }
  }
  return ret;
}
function invokeVNodeHook(hook, instance, vnode, prevVNode = null) {
  callWithAsyncErrorHandling(hook, instance, 7, [
    vnode,
    prevVNode
  ]);
}
const emptyAppContext = createAppContext();
let uid = 0;
function createComponentInstance(vnode, parent, suspense) {
  const type2 = vnode.type;
  const appContext = (parent ? parent.appContext : vnode.appContext) || emptyAppContext;
  const instance = {
    uid: uid++,
    vnode,
    type: type2,
    parent,
    appContext,
    root: null,
    next: null,
    subTree: null,
    effect: null,
    update: null,
    scope: new EffectScope(
      true
    ),
    render: null,
    proxy: null,
    exposed: null,
    exposeProxy: null,
    withProxy: null,
    provides: parent ? parent.provides : Object.create(appContext.provides),
    accessCache: null,
    renderCache: [],
    components: null,
    directives: null,
    propsOptions: normalizePropsOptions(type2, appContext),
    emitsOptions: normalizeEmitsOptions(type2, appContext),
    emit: null,
    emitted: null,
    propsDefaults: EMPTY_OBJ,
    inheritAttrs: type2.inheritAttrs,
    ctx: EMPTY_OBJ,
    data: EMPTY_OBJ,
    props: EMPTY_OBJ,
    attrs: EMPTY_OBJ,
    slots: EMPTY_OBJ,
    refs: EMPTY_OBJ,
    setupState: EMPTY_OBJ,
    setupContext: null,
    attrsProxy: null,
    slotsProxy: null,
    suspense,
    suspenseId: suspense ? suspense.pendingId : 0,
    asyncDep: null,
    asyncResolved: false,
    isMounted: false,
    isUnmounted: false,
    isDeactivated: false,
    bc: null,
    c: null,
    bm: null,
    m: null,
    bu: null,
    u: null,
    um: null,
    bum: null,
    da: null,
    a: null,
    rtg: null,
    rtc: null,
    ec: null,
    sp: null
  };
  {
    instance.ctx = { _: instance };
  }
  instance.root = parent ? parent.root : instance;
  instance.emit = emit.bind(null, instance);
  if (vnode.ce) {
    vnode.ce(instance);
  }
  return instance;
}
let currentInstance = null;
const getCurrentInstance = () => currentInstance || currentRenderingInstance;
let internalSetCurrentInstance;
let setInSSRSetupState;
{
  const g2 = getGlobalThis();
  const registerGlobalSetter = (key, setter) => {
    let setters;
    if (!(setters = g2[key]))
      setters = g2[key] = [];
    setters.push(setter);
    return (v) => {
      if (setters.length > 1)
        setters.forEach((set2) => set2(v));
      else
        setters[0](v);
    };
  };
  internalSetCurrentInstance = registerGlobalSetter(
    `__VUE_INSTANCE_SETTERS__`,
    (v) => currentInstance = v
  );
  setInSSRSetupState = registerGlobalSetter(
    `__VUE_SSR_SETTERS__`,
    (v) => isInSSRComponentSetup = v
  );
}
const setCurrentInstance = (instance) => {
  const prev = currentInstance;
  internalSetCurrentInstance(instance);
  instance.scope.on();
  return () => {
    instance.scope.off();
    internalSetCurrentInstance(prev);
  };
};
const unsetCurrentInstance = () => {
  currentInstance && currentInstance.scope.off();
  internalSetCurrentInstance(null);
};
function isStatefulComponent(instance) {
  return instance.vnode.shapeFlag & 4;
}
let isInSSRComponentSetup = false;
function setupComponent(instance, isSSR = false) {
  isSSR && setInSSRSetupState(isSSR);
  const { props, children } = instance.vnode;
  const isStateful = isStatefulComponent(instance);
  initProps(instance, props, isStateful, isSSR);
  initSlots(instance, children);
  const setupResult = isStateful ? setupStatefulComponent(instance, isSSR) : void 0;
  isSSR && setInSSRSetupState(false);
  return setupResult;
}
function setupStatefulComponent(instance, isSSR) {
  const Component = instance.type;
  instance.accessCache = /* @__PURE__ */ Object.create(null);
  instance.proxy = new Proxy(instance.ctx, PublicInstanceProxyHandlers);
  const { setup } = Component;
  if (setup) {
    const setupContext = instance.setupContext = setup.length > 1 ? createSetupContext(instance) : null;
    const reset = setCurrentInstance(instance);
    pauseTracking();
    const setupResult = callWithErrorHandling(
      setup,
      instance,
      0,
      [
        instance.props,
        setupContext
      ]
    );
    resetTracking();
    reset();
    if (isPromise(setupResult)) {
      setupResult.then(unsetCurrentInstance, unsetCurrentInstance);
      if (isSSR) {
        return setupResult.then((resolvedResult) => {
          handleSetupResult(instance, resolvedResult, isSSR);
        }).catch((e) => {
          handleError(e, instance, 0);
        });
      } else {
        instance.asyncDep = setupResult;
      }
    } else {
      handleSetupResult(instance, setupResult, isSSR);
    }
  } else {
    finishComponentSetup(instance, isSSR);
  }
}
function handleSetupResult(instance, setupResult, isSSR) {
  if (isFunction$1(setupResult)) {
    if (instance.type.__ssrInlineRender) {
      instance.ssrRender = setupResult;
    } else {
      instance.render = setupResult;
    }
  } else if (isObject(setupResult)) {
    instance.setupState = proxyRefs(setupResult);
  } else
    ;
  finishComponentSetup(instance, isSSR);
}
let compile;
function finishComponentSetup(instance, isSSR, skipOptions) {
  const Component = instance.type;
  if (!instance.render) {
    if (!isSSR && compile && !Component.render) {
      const template = Component.template || resolveMergedOptions(instance).template;
      if (template) {
        const { isCustomElement, compilerOptions } = instance.appContext.config;
        const { delimiters, compilerOptions: componentCompilerOptions } = Component;
        const finalCompilerOptions = extend(
          extend(
            {
              isCustomElement,
              delimiters
            },
            compilerOptions
          ),
          componentCompilerOptions
        );
        Component.render = compile(template, finalCompilerOptions);
      }
    }
    instance.render = Component.render || NOOP;
  }
  {
    const reset = setCurrentInstance(instance);
    pauseTracking();
    try {
      applyOptions(instance);
    } finally {
      resetTracking();
      reset();
    }
  }
}
const attrsProxyHandlers = {
  get(target, key) {
    track(target, "get", "");
    return target[key];
  }
};
function createSetupContext(instance) {
  const expose = (exposed) => {
    instance.exposed = exposed || {};
  };
  {
    return {
      attrs: new Proxy(instance.attrs, attrsProxyHandlers),
      slots: instance.slots,
      emit: instance.emit,
      expose
    };
  }
}
function getExposeProxy(instance) {
  if (instance.exposed) {
    return instance.exposeProxy || (instance.exposeProxy = new Proxy(proxyRefs(markRaw(instance.exposed)), {
      get(target, key) {
        if (key in target) {
          return target[key];
        } else if (key in publicPropertiesMap) {
          return publicPropertiesMap[key](instance);
        }
      },
      has(target, key) {
        return key in target || key in publicPropertiesMap;
      }
    }));
  }
}
const classifyRE = /(?:^|[-_])(\w)/g;
const classify = (str) => str.replace(classifyRE, (c) => c.toUpperCase()).replace(/[-_]/g, "");
function getComponentName(Component, includeInferred = true) {
  return isFunction$1(Component) ? Component.displayName || Component.name : Component.name || includeInferred && Component.__name;
}
function formatComponentName(instance, Component, isRoot = false) {
  let name = getComponentName(Component);
  if (!name && Component.__file) {
    const match = Component.__file.match(/([^/\\]+)\.\w+$/);
    if (match) {
      name = match[1];
    }
  }
  if (!name && instance && instance.parent) {
    const inferFromRegistry = (registry) => {
      for (const key in registry) {
        if (registry[key] === Component) {
          return key;
        }
      }
    };
    name = inferFromRegistry(
      instance.components || instance.parent.type.components
    ) || inferFromRegistry(instance.appContext.components);
  }
  return name ? classify(name) : isRoot ? `App` : `Anonymous`;
}
function isClassComponent(value) {
  return isFunction$1(value) && "__vccOpts" in value;
}
const computed = (getterOrOptions, debugOptions) => {
  const c = computed$1(getterOrOptions, debugOptions, isInSSRComponentSetup);
  return c;
};
function h(type2, propsOrChildren, children) {
  const l = arguments.length;
  if (l === 2) {
    if (isObject(propsOrChildren) && !isArray(propsOrChildren)) {
      if (isVNode(propsOrChildren)) {
        return createVNode(type2, null, [propsOrChildren]);
      }
      return createVNode(type2, propsOrChildren);
    } else {
      return createVNode(type2, null, propsOrChildren);
    }
  } else {
    if (l > 3) {
      children = Array.prototype.slice.call(arguments, 2);
    } else if (l === 3 && isVNode(children)) {
      children = [children];
    }
    return createVNode(type2, propsOrChildren, children);
  }
}
const version = "3.4.27";
NOOP;
/**
* @vue/runtime-dom v3.4.27
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
const svgNS = "http://www.w3.org/2000/svg";
const mathmlNS = "http://www.w3.org/1998/Math/MathML";
const doc = typeof document !== "undefined" ? document : null;
const templateContainer = doc && /* @__PURE__ */ doc.createElement("template");
const nodeOps = {
  insert: (child, parent, anchor) => {
    parent.insertBefore(child, anchor || null);
  },
  remove: (child) => {
    const parent = child.parentNode;
    if (parent) {
      parent.removeChild(child);
    }
  },
  createElement: (tag, namespace, is2, props) => {
    const el = namespace === "svg" ? doc.createElementNS(svgNS, tag) : namespace === "mathml" ? doc.createElementNS(mathmlNS, tag) : doc.createElement(tag, is2 ? { is: is2 } : void 0);
    if (tag === "select" && props && props.multiple != null) {
      el.setAttribute("multiple", props.multiple);
    }
    return el;
  },
  createText: (text) => doc.createTextNode(text),
  createComment: (text) => doc.createComment(text),
  setText: (node, text) => {
    node.nodeValue = text;
  },
  setElementText: (el, text) => {
    el.textContent = text;
  },
  parentNode: (node) => node.parentNode,
  nextSibling: (node) => node.nextSibling,
  querySelector: (selector) => doc.querySelector(selector),
  setScopeId(el, id) {
    el.setAttribute(id, "");
  },
  insertStaticContent(content, parent, anchor, namespace, start, end) {
    const before = anchor ? anchor.previousSibling : parent.lastChild;
    if (start && (start === end || start.nextSibling)) {
      while (true) {
        parent.insertBefore(start.cloneNode(true), anchor);
        if (start === end || !(start = start.nextSibling))
          break;
      }
    } else {
      templateContainer.innerHTML = namespace === "svg" ? `<svg>${content}</svg>` : namespace === "mathml" ? `<math>${content}</math>` : content;
      const template = templateContainer.content;
      if (namespace === "svg" || namespace === "mathml") {
        const wrapper = template.firstChild;
        while (wrapper.firstChild) {
          template.appendChild(wrapper.firstChild);
        }
        template.removeChild(wrapper);
      }
      parent.insertBefore(template, anchor);
    }
    return [
      before ? before.nextSibling : parent.firstChild,
      anchor ? anchor.previousSibling : parent.lastChild
    ];
  }
};
const TRANSITION = "transition";
const ANIMATION = "animation";
const vtcKey = Symbol("_vtc");
const Transition = (props, { slots }) => h(BaseTransition, resolveTransitionProps(props), slots);
Transition.displayName = "Transition";
const DOMTransitionPropsValidators = {
  name: String,
  type: String,
  css: {
    type: Boolean,
    default: true
  },
  duration: [String, Number, Object],
  enterFromClass: String,
  enterActiveClass: String,
  enterToClass: String,
  appearFromClass: String,
  appearActiveClass: String,
  appearToClass: String,
  leaveFromClass: String,
  leaveActiveClass: String,
  leaveToClass: String
};
const TransitionPropsValidators = Transition.props = /* @__PURE__ */ extend(
  {},
  BaseTransitionPropsValidators,
  DOMTransitionPropsValidators
);
const callHook = (hook, args = []) => {
  if (isArray(hook)) {
    hook.forEach((h2) => h2(...args));
  } else if (hook) {
    hook(...args);
  }
};
const hasExplicitCallback = (hook) => {
  return hook ? isArray(hook) ? hook.some((h2) => h2.length > 1) : hook.length > 1 : false;
};
function resolveTransitionProps(rawProps) {
  const baseProps = {};
  for (const key in rawProps) {
    if (!(key in DOMTransitionPropsValidators)) {
      baseProps[key] = rawProps[key];
    }
  }
  if (rawProps.css === false) {
    return baseProps;
  }
  const {
    name = "v",
    type: type2,
    duration,
    enterFromClass = `${name}-enter-from`,
    enterActiveClass = `${name}-enter-active`,
    enterToClass = `${name}-enter-to`,
    appearFromClass = enterFromClass,
    appearActiveClass = enterActiveClass,
    appearToClass = enterToClass,
    leaveFromClass = `${name}-leave-from`,
    leaveActiveClass = `${name}-leave-active`,
    leaveToClass = `${name}-leave-to`
  } = rawProps;
  const durations = normalizeDuration(duration);
  const enterDuration = durations && durations[0];
  const leaveDuration = durations && durations[1];
  const {
    onBeforeEnter,
    onEnter,
    onEnterCancelled,
    onLeave,
    onLeaveCancelled,
    onBeforeAppear = onBeforeEnter,
    onAppear = onEnter,
    onAppearCancelled = onEnterCancelled
  } = baseProps;
  const finishEnter = (el, isAppear, done) => {
    removeTransitionClass(el, isAppear ? appearToClass : enterToClass);
    removeTransitionClass(el, isAppear ? appearActiveClass : enterActiveClass);
    done && done();
  };
  const finishLeave = (el, done) => {
    el._isLeaving = false;
    removeTransitionClass(el, leaveFromClass);
    removeTransitionClass(el, leaveToClass);
    removeTransitionClass(el, leaveActiveClass);
    done && done();
  };
  const makeEnterHook = (isAppear) => {
    return (el, done) => {
      const hook = isAppear ? onAppear : onEnter;
      const resolve2 = () => finishEnter(el, isAppear, done);
      callHook(hook, [el, resolve2]);
      nextFrame(() => {
        removeTransitionClass(el, isAppear ? appearFromClass : enterFromClass);
        addTransitionClass(el, isAppear ? appearToClass : enterToClass);
        if (!hasExplicitCallback(hook)) {
          whenTransitionEnds(el, type2, enterDuration, resolve2);
        }
      });
    };
  };
  return extend(baseProps, {
    onBeforeEnter(el) {
      callHook(onBeforeEnter, [el]);
      addTransitionClass(el, enterFromClass);
      addTransitionClass(el, enterActiveClass);
    },
    onBeforeAppear(el) {
      callHook(onBeforeAppear, [el]);
      addTransitionClass(el, appearFromClass);
      addTransitionClass(el, appearActiveClass);
    },
    onEnter: makeEnterHook(false),
    onAppear: makeEnterHook(true),
    onLeave(el, done) {
      el._isLeaving = true;
      const resolve2 = () => finishLeave(el, done);
      addTransitionClass(el, leaveFromClass);
      addTransitionClass(el, leaveActiveClass);
      forceReflow();
      nextFrame(() => {
        if (!el._isLeaving) {
          return;
        }
        removeTransitionClass(el, leaveFromClass);
        addTransitionClass(el, leaveToClass);
        if (!hasExplicitCallback(onLeave)) {
          whenTransitionEnds(el, type2, leaveDuration, resolve2);
        }
      });
      callHook(onLeave, [el, resolve2]);
    },
    onEnterCancelled(el) {
      finishEnter(el, false);
      callHook(onEnterCancelled, [el]);
    },
    onAppearCancelled(el) {
      finishEnter(el, true);
      callHook(onAppearCancelled, [el]);
    },
    onLeaveCancelled(el) {
      finishLeave(el);
      callHook(onLeaveCancelled, [el]);
    }
  });
}
function normalizeDuration(duration) {
  if (duration == null) {
    return null;
  } else if (isObject(duration)) {
    return [NumberOf(duration.enter), NumberOf(duration.leave)];
  } else {
    const n = NumberOf(duration);
    return [n, n];
  }
}
function NumberOf(val) {
  const res = toNumber(val);
  return res;
}
function addTransitionClass(el, cls) {
  cls.split(/\s+/).forEach((c) => c && el.classList.add(c));
  (el[vtcKey] || (el[vtcKey] = /* @__PURE__ */ new Set())).add(cls);
}
function removeTransitionClass(el, cls) {
  cls.split(/\s+/).forEach((c) => c && el.classList.remove(c));
  const _vtc = el[vtcKey];
  if (_vtc) {
    _vtc.delete(cls);
    if (!_vtc.size) {
      el[vtcKey] = void 0;
    }
  }
}
function nextFrame(cb) {
  requestAnimationFrame(() => {
    requestAnimationFrame(cb);
  });
}
let endId = 0;
function whenTransitionEnds(el, expectedType, explicitTimeout, resolve2) {
  const id = el._endId = ++endId;
  const resolveIfNotStale = () => {
    if (id === el._endId) {
      resolve2();
    }
  };
  if (explicitTimeout) {
    return setTimeout(resolveIfNotStale, explicitTimeout);
  }
  const { type: type2, timeout, propCount } = getTransitionInfo(el, expectedType);
  if (!type2) {
    return resolve2();
  }
  const endEvent = type2 + "end";
  let ended = 0;
  const end = () => {
    el.removeEventListener(endEvent, onEnd);
    resolveIfNotStale();
  };
  const onEnd = (e) => {
    if (e.target === el && ++ended >= propCount) {
      end();
    }
  };
  setTimeout(() => {
    if (ended < propCount) {
      end();
    }
  }, timeout + 1);
  el.addEventListener(endEvent, onEnd);
}
function getTransitionInfo(el, expectedType) {
  const styles = window.getComputedStyle(el);
  const getStyleProperties = (key) => (styles[key] || "").split(", ");
  const transitionDelays = getStyleProperties(`${TRANSITION}Delay`);
  const transitionDurations = getStyleProperties(`${TRANSITION}Duration`);
  const transitionTimeout = getTimeout(transitionDelays, transitionDurations);
  const animationDelays = getStyleProperties(`${ANIMATION}Delay`);
  const animationDurations = getStyleProperties(`${ANIMATION}Duration`);
  const animationTimeout = getTimeout(animationDelays, animationDurations);
  let type2 = null;
  let timeout = 0;
  let propCount = 0;
  if (expectedType === TRANSITION) {
    if (transitionTimeout > 0) {
      type2 = TRANSITION;
      timeout = transitionTimeout;
      propCount = transitionDurations.length;
    }
  } else if (expectedType === ANIMATION) {
    if (animationTimeout > 0) {
      type2 = ANIMATION;
      timeout = animationTimeout;
      propCount = animationDurations.length;
    }
  } else {
    timeout = Math.max(transitionTimeout, animationTimeout);
    type2 = timeout > 0 ? transitionTimeout > animationTimeout ? TRANSITION : ANIMATION : null;
    propCount = type2 ? type2 === TRANSITION ? transitionDurations.length : animationDurations.length : 0;
  }
  const hasTransform = type2 === TRANSITION && /\b(transform|all)(,|$)/.test(
    getStyleProperties(`${TRANSITION}Property`).toString()
  );
  return {
    type: type2,
    timeout,
    propCount,
    hasTransform
  };
}
function getTimeout(delays, durations) {
  while (delays.length < durations.length) {
    delays = delays.concat(delays);
  }
  return Math.max(...durations.map((d, i) => toMs(d) + toMs(delays[i])));
}
function toMs(s) {
  if (s === "auto")
    return 0;
  return Number(s.slice(0, -1).replace(",", ".")) * 1e3;
}
function forceReflow() {
  return document.body.offsetHeight;
}
function patchClass(el, value, isSVG) {
  const transitionClasses = el[vtcKey];
  if (transitionClasses) {
    value = (value ? [value, ...transitionClasses] : [...transitionClasses]).join(" ");
  }
  if (value == null) {
    el.removeAttribute("class");
  } else if (isSVG) {
    el.setAttribute("class", value);
  } else {
    el.className = value;
  }
}
const vShowOriginalDisplay = Symbol("_vod");
const vShowHidden = Symbol("_vsh");
const CSS_VAR_TEXT = Symbol("");
const displayRE = /(^|;)\s*display\s*:/;
function patchStyle(el, prev, next) {
  const style2 = el.style;
  const isCssString = isString(next);
  let hasControlledDisplay = false;
  if (next && !isCssString) {
    if (prev) {
      if (!isString(prev)) {
        for (const key in prev) {
          if (next[key] == null) {
            setStyle(style2, key, "");
          }
        }
      } else {
        for (const prevStyle of prev.split(";")) {
          const key = prevStyle.slice(0, prevStyle.indexOf(":")).trim();
          if (next[key] == null) {
            setStyle(style2, key, "");
          }
        }
      }
    }
    for (const key in next) {
      if (key === "display") {
        hasControlledDisplay = true;
      }
      setStyle(style2, key, next[key]);
    }
  } else {
    if (isCssString) {
      if (prev !== next) {
        const cssVarText = style2[CSS_VAR_TEXT];
        if (cssVarText) {
          next += ";" + cssVarText;
        }
        style2.cssText = next;
        hasControlledDisplay = displayRE.test(next);
      }
    } else if (prev) {
      el.removeAttribute("style");
    }
  }
  if (vShowOriginalDisplay in el) {
    el[vShowOriginalDisplay] = hasControlledDisplay ? style2.display : "";
    if (el[vShowHidden]) {
      style2.display = "none";
    }
  }
}
const importantRE = /\s*!important$/;
function setStyle(style2, name, val) {
  if (isArray(val)) {
    val.forEach((v) => setStyle(style2, name, v));
  } else {
    if (val == null)
      val = "";
    if (name.startsWith("--")) {
      style2.setProperty(name, val);
    } else {
      const prefixed = autoPrefix(style2, name);
      if (importantRE.test(val)) {
        style2.setProperty(
          hyphenate(prefixed),
          val.replace(importantRE, ""),
          "important"
        );
      } else {
        style2[prefixed] = val;
      }
    }
  }
}
const prefixes = ["Webkit", "Moz", "ms"];
const prefixCache = {};
function autoPrefix(style2, rawName) {
  const cached = prefixCache[rawName];
  if (cached) {
    return cached;
  }
  let name = camelize(rawName);
  if (name !== "filter" && name in style2) {
    return prefixCache[rawName] = name;
  }
  name = capitalize(name);
  for (let i = 0; i < prefixes.length; i++) {
    const prefixed = prefixes[i] + name;
    if (prefixed in style2) {
      return prefixCache[rawName] = prefixed;
    }
  }
  return rawName;
}
const xlinkNS = "http://www.w3.org/1999/xlink";
function patchAttr(el, key, value, isSVG, instance) {
  if (isSVG && key.startsWith("xlink:")) {
    if (value == null) {
      el.removeAttributeNS(xlinkNS, key.slice(6, key.length));
    } else {
      el.setAttributeNS(xlinkNS, key, value);
    }
  } else {
    const isBoolean = isSpecialBooleanAttr(key);
    if (value == null || isBoolean && !includeBooleanAttr(value)) {
      el.removeAttribute(key);
    } else {
      el.setAttribute(key, isBoolean ? "" : value);
    }
  }
}
function patchDOMProp(el, key, value, prevChildren, parentComponent, parentSuspense, unmountChildren) {
  if (key === "innerHTML" || key === "textContent") {
    if (prevChildren) {
      unmountChildren(prevChildren, parentComponent, parentSuspense);
    }
    el[key] = value == null ? "" : value;
    return;
  }
  const tag = el.tagName;
  if (key === "value" && tag !== "PROGRESS" && !tag.includes("-")) {
    const oldValue = tag === "OPTION" ? el.getAttribute("value") || "" : el.value;
    const newValue = value == null ? "" : value;
    if (oldValue !== newValue || !("_value" in el)) {
      el.value = newValue;
    }
    if (value == null) {
      el.removeAttribute(key);
    }
    el._value = value;
    return;
  }
  let needRemove = false;
  if (value === "" || value == null) {
    const type2 = typeof el[key];
    if (type2 === "boolean") {
      value = includeBooleanAttr(value);
    } else if (value == null && type2 === "string") {
      value = "";
      needRemove = true;
    } else if (type2 === "number") {
      value = 0;
      needRemove = true;
    }
  }
  try {
    el[key] = value;
  } catch (e) {
  }
  needRemove && el.removeAttribute(key);
}
function addEventListener(el, event, handler, options) {
  el.addEventListener(event, handler, options);
}
function removeEventListener(el, event, handler, options) {
  el.removeEventListener(event, handler, options);
}
const veiKey = Symbol("_vei");
function patchEvent(el, rawName, prevValue, nextValue, instance = null) {
  const invokers = el[veiKey] || (el[veiKey] = {});
  const existingInvoker = invokers[rawName];
  if (nextValue && existingInvoker) {
    existingInvoker.value = nextValue;
  } else {
    const [name, options] = parseName(rawName);
    if (nextValue) {
      const invoker = invokers[rawName] = createInvoker(
        nextValue,
        instance
      );
      addEventListener(el, name, invoker, options);
    } else if (existingInvoker) {
      removeEventListener(el, name, existingInvoker, options);
      invokers[rawName] = void 0;
    }
  }
}
const optionsModifierRE = /(?:Once|Passive|Capture)$/;
function parseName(name) {
  let options;
  if (optionsModifierRE.test(name)) {
    options = {};
    let m;
    while (m = name.match(optionsModifierRE)) {
      name = name.slice(0, name.length - m[0].length);
      options[m[0].toLowerCase()] = true;
    }
  }
  const event = name[2] === ":" ? name.slice(3) : hyphenate(name.slice(2));
  return [event, options];
}
let cachedNow = 0;
const p = /* @__PURE__ */ Promise.resolve();
const getNow = () => cachedNow || (p.then(() => cachedNow = 0), cachedNow = Date.now());
function createInvoker(initialValue, instance) {
  const invoker = (e) => {
    if (!e._vts) {
      e._vts = Date.now();
    } else if (e._vts <= invoker.attached) {
      return;
    }
    callWithAsyncErrorHandling(
      patchStopImmediatePropagation(e, invoker.value),
      instance,
      5,
      [e]
    );
  };
  invoker.value = initialValue;
  invoker.attached = getNow();
  return invoker;
}
function patchStopImmediatePropagation(e, value) {
  if (isArray(value)) {
    const originalStop = e.stopImmediatePropagation;
    e.stopImmediatePropagation = () => {
      originalStop.call(e);
      e._stopped = true;
    };
    return value.map(
      (fn) => (e2) => !e2._stopped && fn && fn(e2)
    );
  } else {
    return value;
  }
}
const isNativeOn = (key) => key.charCodeAt(0) === 111 && key.charCodeAt(1) === 110 && key.charCodeAt(2) > 96 && key.charCodeAt(2) < 123;
const patchProp = (el, key, prevValue, nextValue, namespace, prevChildren, parentComponent, parentSuspense, unmountChildren) => {
  const isSVG = namespace === "svg";
  if (key === "class") {
    patchClass(el, nextValue, isSVG);
  } else if (key === "style") {
    patchStyle(el, prevValue, nextValue);
  } else if (isOn(key)) {
    if (!isModelListener(key)) {
      patchEvent(el, key, prevValue, nextValue, parentComponent);
    }
  } else if (key[0] === "." ? (key = key.slice(1), true) : key[0] === "^" ? (key = key.slice(1), false) : shouldSetAsProp(el, key, nextValue, isSVG)) {
    patchDOMProp(
      el,
      key,
      nextValue,
      prevChildren,
      parentComponent,
      parentSuspense,
      unmountChildren
    );
  } else {
    if (key === "true-value") {
      el._trueValue = nextValue;
    } else if (key === "false-value") {
      el._falseValue = nextValue;
    }
    patchAttr(el, key, nextValue, isSVG);
  }
};
function shouldSetAsProp(el, key, value, isSVG) {
  if (isSVG) {
    if (key === "innerHTML" || key === "textContent") {
      return true;
    }
    if (key in el && isNativeOn(key) && isFunction$1(value)) {
      return true;
    }
    return false;
  }
  if (key === "spellcheck" || key === "draggable" || key === "translate") {
    return false;
  }
  if (key === "form") {
    return false;
  }
  if (key === "list" && el.tagName === "INPUT") {
    return false;
  }
  if (key === "type" && el.tagName === "TEXTAREA") {
    return false;
  }
  if (key === "width" || key === "height") {
    const tag = el.tagName;
    if (tag === "IMG" || tag === "VIDEO" || tag === "CANVAS" || tag === "SOURCE") {
      return false;
    }
  }
  if (isNativeOn(key) && isString(value)) {
    return false;
  }
  return key in el;
}
const positionMap = /* @__PURE__ */ new WeakMap();
const newPositionMap = /* @__PURE__ */ new WeakMap();
const moveCbKey = Symbol("_moveCb");
const enterCbKey = Symbol("_enterCb");
const TransitionGroupImpl = {
  name: "TransitionGroup",
  props: /* @__PURE__ */ extend({}, TransitionPropsValidators, {
    tag: String,
    moveClass: String
  }),
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const state = useTransitionState();
    let prevChildren;
    let children;
    onUpdated(() => {
      if (!prevChildren.length) {
        return;
      }
      const moveClass = props.moveClass || `${props.name || "v"}-move`;
      if (!hasCSSTransform(
        prevChildren[0].el,
        instance.vnode.el,
        moveClass
      )) {
        return;
      }
      prevChildren.forEach(callPendingCbs);
      prevChildren.forEach(recordPosition);
      const movedChildren = prevChildren.filter(applyTranslation);
      forceReflow();
      movedChildren.forEach((c) => {
        const el = c.el;
        const style2 = el.style;
        addTransitionClass(el, moveClass);
        style2.transform = style2.webkitTransform = style2.transitionDuration = "";
        const cb = el[moveCbKey] = (e) => {
          if (e && e.target !== el) {
            return;
          }
          if (!e || /transform$/.test(e.propertyName)) {
            el.removeEventListener("transitionend", cb);
            el[moveCbKey] = null;
            removeTransitionClass(el, moveClass);
          }
        };
        el.addEventListener("transitionend", cb);
      });
    });
    return () => {
      const rawProps = toRaw(props);
      const cssTransitionProps = resolveTransitionProps(rawProps);
      let tag = rawProps.tag || Fragment;
      prevChildren = [];
      if (children) {
        for (let i = 0; i < children.length; i++) {
          const child = children[i];
          if (child.el && child.el instanceof Element) {
            prevChildren.push(child);
            setTransitionHooks(
              child,
              resolveTransitionHooks(
                child,
                cssTransitionProps,
                state,
                instance
              )
            );
            positionMap.set(
              child,
              child.el.getBoundingClientRect()
            );
          }
        }
      }
      children = slots.default ? getTransitionRawChildren(slots.default()) : [];
      for (let i = 0; i < children.length; i++) {
        const child = children[i];
        if (child.key != null) {
          setTransitionHooks(
            child,
            resolveTransitionHooks(child, cssTransitionProps, state, instance)
          );
        }
      }
      return createVNode(tag, null, children);
    };
  }
};
const removeMode = (props) => delete props.mode;
/* @__PURE__ */ removeMode(TransitionGroupImpl.props);
const TransitionGroup = TransitionGroupImpl;
function callPendingCbs(c) {
  const el = c.el;
  if (el[moveCbKey]) {
    el[moveCbKey]();
  }
  if (el[enterCbKey]) {
    el[enterCbKey]();
  }
}
function recordPosition(c) {
  newPositionMap.set(c, c.el.getBoundingClientRect());
}
function applyTranslation(c) {
  const oldPos = positionMap.get(c);
  const newPos = newPositionMap.get(c);
  const dx = oldPos.left - newPos.left;
  const dy = oldPos.top - newPos.top;
  if (dx || dy) {
    const s = c.el.style;
    s.transform = s.webkitTransform = `translate(${dx}px,${dy}px)`;
    s.transitionDuration = "0s";
    return c;
  }
}
function hasCSSTransform(el, root, moveClass) {
  const clone = el.cloneNode();
  const _vtc = el[vtcKey];
  if (_vtc) {
    _vtc.forEach((cls) => {
      cls.split(/\s+/).forEach((c) => c && clone.classList.remove(c));
    });
  }
  moveClass.split(/\s+/).forEach((c) => c && clone.classList.add(c));
  clone.style.display = "none";
  const container = root.nodeType === 1 ? root : root.parentNode;
  container.appendChild(clone);
  const { hasTransform } = getTransitionInfo(clone);
  container.removeChild(clone);
  return hasTransform;
}
const getModelAssigner = (vnode) => {
  const fn = vnode.props["onUpdate:modelValue"] || false;
  return isArray(fn) ? (value) => invokeArrayFns(fn, value) : fn;
};
function onCompositionStart(e) {
  e.target.composing = true;
}
function onCompositionEnd(e) {
  const target = e.target;
  if (target.composing) {
    target.composing = false;
    target.dispatchEvent(new Event("input"));
  }
}
const assignKey = Symbol("_assign");
const vModelText = {
  created(el, { modifiers: { lazy, trim, number } }, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    const castToNumber = number || vnode.props && vnode.props.type === "number";
    addEventListener(el, lazy ? "change" : "input", (e) => {
      if (e.target.composing)
        return;
      let domValue = el.value;
      if (trim) {
        domValue = domValue.trim();
      }
      if (castToNumber) {
        domValue = looseToNumber(domValue);
      }
      el[assignKey](domValue);
    });
    if (trim) {
      addEventListener(el, "change", () => {
        el.value = el.value.trim();
      });
    }
    if (!lazy) {
      addEventListener(el, "compositionstart", onCompositionStart);
      addEventListener(el, "compositionend", onCompositionEnd);
      addEventListener(el, "change", onCompositionEnd);
    }
  },
  mounted(el, { value }) {
    el.value = value == null ? "" : value;
  },
  beforeUpdate(el, { value, modifiers: { lazy, trim, number } }, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    if (el.composing)
      return;
    const elValue = (number || el.type === "number") && !/^0\d/.test(el.value) ? looseToNumber(el.value) : el.value;
    const newValue = value == null ? "" : value;
    if (elValue === newValue) {
      return;
    }
    if (document.activeElement === el && el.type !== "range") {
      if (lazy) {
        return;
      }
      if (trim && el.value.trim() === newValue) {
        return;
      }
    }
    el.value = newValue;
  }
};
const vModelCheckbox = {
  deep: true,
  created(el, _, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    addEventListener(el, "change", () => {
      const modelValue = el._modelValue;
      const elementValue = getValue(el);
      const checked = el.checked;
      const assign3 = el[assignKey];
      if (isArray(modelValue)) {
        const index2 = looseIndexOf(modelValue, elementValue);
        const found = index2 !== -1;
        if (checked && !found) {
          assign3(modelValue.concat(elementValue));
        } else if (!checked && found) {
          const filtered = [...modelValue];
          filtered.splice(index2, 1);
          assign3(filtered);
        }
      } else if (isSet(modelValue)) {
        const cloned = new Set(modelValue);
        if (checked) {
          cloned.add(elementValue);
        } else {
          cloned.delete(elementValue);
        }
        assign3(cloned);
      } else {
        assign3(getCheckboxValue(el, checked));
      }
    });
  },
  mounted: setChecked,
  beforeUpdate(el, binding, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    setChecked(el, binding, vnode);
  }
};
function setChecked(el, { value, oldValue }, vnode) {
  el._modelValue = value;
  if (isArray(value)) {
    el.checked = looseIndexOf(value, vnode.props.value) > -1;
  } else if (isSet(value)) {
    el.checked = value.has(vnode.props.value);
  } else if (value !== oldValue) {
    el.checked = looseEqual(value, getCheckboxValue(el, true));
  }
}
const vModelSelect = {
  deep: true,
  created(el, { value, modifiers: { number } }, vnode) {
    const isSetModel = isSet(value);
    addEventListener(el, "change", () => {
      const selectedVal = Array.prototype.filter.call(el.options, (o) => o.selected).map(
        (o) => number ? looseToNumber(getValue(o)) : getValue(o)
      );
      el[assignKey](
        el.multiple ? isSetModel ? new Set(selectedVal) : selectedVal : selectedVal[0]
      );
      el._assigning = true;
      nextTick(() => {
        el._assigning = false;
      });
    });
    el[assignKey] = getModelAssigner(vnode);
  },
  mounted(el, { value, modifiers: { number } }) {
    setSelected(el, value);
  },
  beforeUpdate(el, _binding, vnode) {
    el[assignKey] = getModelAssigner(vnode);
  },
  updated(el, { value, modifiers: { number } }) {
    if (!el._assigning) {
      setSelected(el, value);
    }
  }
};
function setSelected(el, value, number) {
  const isMultiple = el.multiple;
  const isArrayValue = isArray(value);
  if (isMultiple && !isArrayValue && !isSet(value)) {
    return;
  }
  for (let i = 0, l = el.options.length; i < l; i++) {
    const option = el.options[i];
    const optionValue = getValue(option);
    if (isMultiple) {
      if (isArrayValue) {
        const optionType = typeof optionValue;
        if (optionType === "string" || optionType === "number") {
          option.selected = value.some((v) => String(v) === String(optionValue));
        } else {
          option.selected = looseIndexOf(value, optionValue) > -1;
        }
      } else {
        option.selected = value.has(optionValue);
      }
    } else if (looseEqual(getValue(option), value)) {
      if (el.selectedIndex !== i)
        el.selectedIndex = i;
      return;
    }
  }
  if (!isMultiple && el.selectedIndex !== -1) {
    el.selectedIndex = -1;
  }
}
function getValue(el) {
  return "_value" in el ? el._value : el.value;
}
function getCheckboxValue(el, checked) {
  const key = checked ? "_trueValue" : "_falseValue";
  return key in el ? el[key] : checked;
}
const systemModifiers = ["ctrl", "shift", "alt", "meta"];
const modifierGuards = {
  stop: (e) => e.stopPropagation(),
  prevent: (e) => e.preventDefault(),
  self: (e) => e.target !== e.currentTarget,
  ctrl: (e) => !e.ctrlKey,
  shift: (e) => !e.shiftKey,
  alt: (e) => !e.altKey,
  meta: (e) => !e.metaKey,
  left: (e) => "button" in e && e.button !== 0,
  middle: (e) => "button" in e && e.button !== 1,
  right: (e) => "button" in e && e.button !== 2,
  exact: (e, modifiers) => systemModifiers.some((m) => e[`${m}Key`] && !modifiers.includes(m))
};
const withModifiers = (fn, modifiers) => {
  const cache = fn._withMods || (fn._withMods = {});
  const cacheKey = modifiers.join(".");
  return cache[cacheKey] || (cache[cacheKey] = (event, ...args) => {
    for (let i = 0; i < modifiers.length; i++) {
      const guard = modifierGuards[modifiers[i]];
      if (guard && guard(event, modifiers))
        return;
    }
    return fn(event, ...args);
  });
};
const keyNames = {
  esc: "escape",
  space: " ",
  up: "arrow-up",
  left: "arrow-left",
  right: "arrow-right",
  down: "arrow-down",
  delete: "backspace"
};
const withKeys = (fn, modifiers) => {
  const cache = fn._withKeys || (fn._withKeys = {});
  const cacheKey = modifiers.join(".");
  return cache[cacheKey] || (cache[cacheKey] = (event) => {
    if (!("key" in event)) {
      return;
    }
    const eventKey = hyphenate(event.key);
    if (modifiers.some((k) => k === eventKey || keyNames[k] === eventKey)) {
      return fn(event);
    }
  });
};
const rendererOptions = /* @__PURE__ */ extend({ patchProp }, nodeOps);
let renderer;
function ensureRenderer() {
  return renderer || (renderer = createRenderer(rendererOptions));
}
const createApp = (...args) => {
  const app2 = ensureRenderer().createApp(...args);
  const { mount } = app2;
  app2.mount = (containerOrSelector) => {
    const container = normalizeContainer(containerOrSelector);
    if (!container)
      return;
    const component = app2._component;
    if (!isFunction$1(component) && !component.render && !component.template) {
      component.template = container.innerHTML;
    }
    container.innerHTML = "";
    const proxy = mount(container, false, resolveRootNamespace(container));
    if (container instanceof Element) {
      container.removeAttribute("v-cloak");
      container.setAttribute("data-v-app", "");
    }
    return proxy;
  };
  return app2;
};
function resolveRootNamespace(container) {
  if (container instanceof SVGElement) {
    return "svg";
  }
  if (typeof MathMLElement === "function" && container instanceof MathMLElement) {
    return "mathml";
  }
}
function normalizeContainer(container) {
  if (isString(container)) {
    const res = document.querySelector(container);
    return res;
  }
  return container;
}
const scheduler = "";
const index = "";
const style = "";
const scriptRel = "modulepreload";
const assetsURL = function(dep, importerUrl) {
  return new URL(dep, importerUrl).href;
};
const seen = {};
const __vitePreload = function preload(baseModule, deps, importerUrl) {
  if (!deps || deps.length === 0) {
    return baseModule();
  }
  const links = document.getElementsByTagName("link");
  return Promise.all(deps.map((dep) => {
    dep = assetsURL(dep, importerUrl);
    if (dep in seen)
      return;
    seen[dep] = true;
    const isCss = dep.endsWith(".css");
    const cssSelector = isCss ? '[rel="stylesheet"]' : "";
    const isBaseRelative = !!importerUrl;
    if (isBaseRelative) {
      for (let i = links.length - 1; i >= 0; i--) {
        const link2 = links[i];
        if (link2.href === dep && (!isCss || link2.rel === "stylesheet")) {
          return;
        }
      }
    } else if (document.querySelector(`link[href="${dep}"]${cssSelector}`)) {
      return;
    }
    const link = document.createElement("link");
    link.rel = isCss ? "stylesheet" : scriptRel;
    if (!isCss) {
      link.as = "script";
      link.crossOrigin = "";
    }
    link.href = dep;
    document.head.appendChild(link);
    if (isCss) {
      return new Promise((res, rej) => {
        link.addEventListener("load", res);
        link.addEventListener("error", () => rej(new Error(`Unable to preload CSS for ${dep}`)));
      });
    }
  })).then(() => baseModule());
};
function render$d(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M16.023 9.348h4.992v-.001M2.985 19.644v-4.992m0 0h4.992m-4.993 0 3.181 3.183a8.25 8.25 0 0 0 13.803-3.7M4.031 9.865a8.25 8.25 0 0 1 13.803-3.7l3.181 3.182m0-4.991v4.99"
    })
  ]);
}
function render$c(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M3.75 6.75h16.5M3.75 12h16.5m-16.5 5.25h16.5"
    })
  ]);
}
function render$b(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M3 4.5h14.25M3 9h9.75M3 13.5h9.75m4.5-4.5v12m0 0-3.75-3.75M17.25 21 21 17.25"
    })
  ]);
}
function render$a(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M3 4.5h14.25M3 9h9.75M3 13.5h5.25m5.25-.75L17.25 9m0 0L21 12.75M17.25 9v12"
    })
  ]);
}
function render$9(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M6.75 3v2.25M17.25 3v2.25M3 18.75V7.5a2.25 2.25 0 0 1 2.25-2.25h13.5A2.25 2.25 0 0 1 21 7.5v11.25m-18 0A2.25 2.25 0 0 0 5.25 21h13.5A2.25 2.25 0 0 0 21 18.75m-18 0v-7.5A2.25 2.25 0 0 1 5.25 9h13.5A2.25 2.25 0 0 1 21 11.25v7.5m-9-6h.008v.008H12v-.008ZM12 15h.008v.008H12V15Zm0 2.25h.008v.008H12v-.008ZM9.75 15h.008v.008H9.75V15Zm0 2.25h.008v.008H9.75v-.008ZM7.5 15h.008v.008H7.5V15Zm0 2.25h.008v.008H7.5v-.008Zm6.75-4.5h.008v.008h-.008v-.008Zm0 2.25h.008v.008h-.008V15Zm0 2.25h.008v.008h-.008v-.008Zm2.25-4.5h.008v.008H16.5v-.008Zm0 2.25h.008v.008H16.5V15Z"
    })
  ]);
}
function render$8(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "m16.862 4.487 1.687-1.688a1.875 1.875 0 1 1 2.652 2.652L6.832 19.82a4.5 4.5 0 0 1-1.897 1.13l-2.685.8.8-2.685a4.5 4.5 0 0 1 1.13-1.897L16.863 4.487Zm0 0L19.5 7.125"
    })
  ]);
}
function render$7(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M5.25 5.653c0-.856.917-1.398 1.667-.986l11.54 6.347a1.125 1.125 0 0 1 0 1.972l-11.54 6.347a1.125 1.125 0 0 1-1.667-.986V5.653Z"
    })
  ]);
}
function render$6(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M3.375 19.5h17.25m-17.25 0a1.125 1.125 0 0 1-1.125-1.125M3.375 19.5h7.5c.621 0 1.125-.504 1.125-1.125m-9.75 0V5.625m0 12.75v-1.5c0-.621.504-1.125 1.125-1.125m18.375 2.625V5.625m0 12.75c0 .621-.504 1.125-1.125 1.125m1.125-1.125v-1.5c0-.621-.504-1.125-1.125-1.125m0 3.75h-7.5A1.125 1.125 0 0 1 12 18.375m9.75-12.75c0-.621-.504-1.125-1.125-1.125H3.375c-.621 0-1.125.504-1.125 1.125m19.5 0v1.5c0 .621-.504 1.125-1.125 1.125M2.25 5.625v1.5c0 .621.504 1.125 1.125 1.125m0 0h17.25m-17.25 0h7.5c.621 0 1.125.504 1.125 1.125M3.375 8.25c-.621 0-1.125.504-1.125 1.125v1.5c0 .621.504 1.125 1.125 1.125m17.25-3.75h-7.5c-.621 0-1.125.504-1.125 1.125m8.625-1.125c.621 0 1.125.504 1.125 1.125v1.5c0 .621-.504 1.125-1.125 1.125m-17.25 0h7.5m-7.5 0c-.621 0-1.125.504-1.125 1.125v1.5c0 .621.504 1.125 1.125 1.125M12 10.875v-1.5m0 1.5c0 .621-.504 1.125-1.125 1.125M12 10.875c0 .621.504 1.125 1.125 1.125m-2.25 0c.621 0 1.125.504 1.125 1.125M13.125 12h7.5m-7.5 0c-.621 0-1.125.504-1.125 1.125M20.625 12c.621 0 1.125.504 1.125 1.125v1.5c0 .621-.504 1.125-1.125 1.125m-17.25 0h7.5M12 14.625v-1.5m0 1.5c0 .621-.504 1.125-1.125 1.125M12 14.625c0 .621.504 1.125 1.125 1.125m-2.25 0c.621 0 1.125.504 1.125 1.125m0 1.5v-1.5m0 0c0-.621.504-1.125 1.125-1.125m0 0h7.5"
    })
  ]);
}
function render$5(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "m14.74 9-.346 9m-4.788 0L9.26 9m9.968-3.21c.342.052.682.107 1.022.166m-1.022-.165L18.16 19.673a2.25 2.25 0 0 1-2.244 2.077H8.084a2.25 2.25 0 0 1-2.244-2.077L4.772 5.79m14.456 0a48.108 48.108 0 0 0-3.478-.397m-12 .562c.34-.059.68-.114 1.022-.165m0 0a48.11 48.11 0 0 1 3.478-.397m7.5 0v-.916c0-1.18-.91-2.164-2.09-2.201a51.964 51.964 0 0 0-3.32 0c-1.18.037-2.09 1.022-2.09 2.201v.916m7.5 0a48.667 48.667 0 0 0-7.5 0"
    })
  ]);
}
const _hoisted_1$g = { role: "status" };
const _hoisted_2$d = /* @__PURE__ */ createBaseVNode("path", {
  d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
  fill: "currentColor"
}, null, -1);
const _hoisted_3$c = /* @__PURE__ */ createBaseVNode("path", {
  d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
  fill: "currentFill"
}, null, -1);
const _hoisted_4$c = [
  _hoisted_2$d,
  _hoisted_3$c
];
const _hoisted_5$b = /* @__PURE__ */ createBaseVNode("span", { class: "sr-only" }, "Loading...", -1);
const _sfc_main$i = /* @__PURE__ */ defineComponent({
  __name: "CustomLoadingSpinner",
  props: {
    baseColor: {},
    fillColor: {},
    width: {},
    height: {}
  },
  setup(__props) {
    const props = __props;
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$g, [
        (openBlock(), createElementBlock("svg", {
          "aria-hidden": "true",
          class: normalizeClass(["inline", props.height, props.width, "mr-2", props.baseColor, "animate-spin", props.fillColor]),
          viewBox: "0 0 100 101",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg"
        }, _hoisted_4$c, 2)),
        _hoisted_5$b
      ]);
    };
  }
});
function useSpawn(argv = [], opts = {}, stderr = "message") {
  const state = {
    loading: true,
    status: 0,
    stdout: "",
    stderr: "",
    argv: [...argv],
    proc: null,
    _promise: null,
    promise: () => state._promise,
    argvPretty: () => {
      return argv.map((token) => /\s/.match(token) ? `"${token}"` : token).join(" ");
    },
    errorStringHTML(fullArgv = false) {
      return `<span class="font-mono text-sm whitespace-pre-wrap"><span class="font-semibold">${this.argv[0]}: </span><span>${errorString(this)} (${this.status})</span></span>` + (fullArgv ? `<span class="text-gray-500 font-mono text-sm whitespace-pre-wrap">${this.argvPretty()}</span>` : "");
    }
  };
  if (!opts.superuser)
    opts.superuser = "require";
  if (!opts.err)
    opts.err = stderr;
  state.proc = cockpit.spawn(argv, opts);
  state._promise = new Promise((resolve2, reject) => {
    state.proc.then((_stdout, _stderr) => {
      state.stdout = _stdout;
      state.stderr = _stderr;
      resolve2(state);
    }).catch((ex, _stdout) => {
      var _a;
      state.stdout = _stdout;
      state.stderr = (_a = ex.message) != null ? _a : ex.problem;
      state.status = ex.exit_status;
      reject(state);
    }).finally(() => {
      state.loading = false;
    });
  });
  return state;
}
function errorString(state) {
  var _a, _b;
  if (typeof state === "string")
    return state;
  return (_b = (_a = state == null ? void 0 : state.stderr) != null ? _a : state == null ? void 0 : state.message) != null ? _b : JSON.stringify(state);
}
class BetterCockpitFile {
  constructor(path, opts) {
    var _a;
    const opts_ = { ...opts };
    this.failIfDNE = opts_.dne === "fail";
    delete opts_.dne;
    this.persistStat = (_a = opts_.persistStat) != null ? _a : false;
    delete opts_.persistStat;
    this.fileHandle = cockpit.file(path, opts_);
    this.hookedFileHandle = {
      ...this.fileHandle,
      read: this.read,
      replace: this.replace,
      modify: this.modify,
      close: this.close
    };
    this.path = path;
  }
  read() {
    if (this.failIfDNE)
      return new Promise((resolve2, reject) => {
        this.fileHandle.read().then((content, tag) => {
          if (content === null && tag === "-")
            reject(new Error("File does not exist: " + this.path));
          else
            resolve2(content, tag);
        }).catch((error) => reject(error));
      });
    else
      return this.fileHandle.read();
  }
  replace(content, expected_tag) {
    if (this.persistStat)
      return new Promise(async (resolve2, reject) => {
        await this.getStat();
        this.fileHandle.replace(content, expected_tag).then(
          (content2, tag) => this.setStat().then(() => resolve2(content2, tag)).catch((error) => reject(error))
        ).catch((error) => reject(error));
      });
    else
      return this.fileHandle.replace(content, expected_tag);
  }
  modify(callback, initial_content, initial_tag) {
    if (this.persistStat)
      return new Promise(async (resolve2, reject) => {
        await this.getStat();
        this.fileHandle.modify(callback, initial_content, initial_tag).then(
          (content, tag) => this.setStat().then(() => resolve2(content, tag)).catch((error) => reject(error))
        ).catch((error) => reject(error));
      });
    else
      return this.fileHandle.modify(callback, initial_content, initial_tag);
  }
  watch(callback, opts) {
    return this.hookedFileHandle.watch(callback, opts);
  }
  close() {
    return this.fileHandle.close();
  }
  async getStat() {
    try {
      const statFields = (await useSpawn(["stat", this.path, "--format=%u:%g:%a"]).promise()).stdout.split(":").map((a) => a.trim());
      this.stat = { uid: statFields[0], gid: statFields[1], permissions: statFields[2] };
      return { ...this.stat };
    } catch (state) {
      throw new Error(errorString(state));
    }
  }
  async setStat(stat = {}) {
    const tmpStat = { ...this.stat, ...stat };
    let ownership = "";
    if (tmpStat.uid)
      ownership += tmpStat.uid;
    if (tmpStat.gid)
      ownership += ":" + tmpStat.gid;
    if (ownership) {
      try {
        await useSpawn(["chown", ownership, this.path]).promise();
      } catch (state) {
        throw new Error(errorString(state));
      }
    }
    if (tmpStat.permissions) {
      try {
        await useSpawn(["chmod", tmpStat.permissions, this.path]).promise();
      } catch (state) {
        throw new Error(errorString(state));
      }
    }
    this.stat = tmpStat;
  }
}
const get_zfs_data_script = `import subprocess
import json
import argparse

def get_local_zfs_pools():
    try:
        result = subprocess.run(['zpool', 'list', '-H', '-o', 'name'], stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True, check=True)
        pools = result.stdout.strip().split('\\n')
        return {"success": True, "data": pools, "error": None}
    except subprocess.CalledProcessError as e:
        print(f"Error {e}")
        return {"success": False, "data": [], "error": str(e)}

def get_remote_zfs_pools(host, port=22, user='root'):
    try:
        ssh_cmd = ['ssh']
        if port != '22':
            ssh_cmd.extend(['-p', port])
        ssh_cmd.append(f"{user}@{host}")
        ssh_cmd.extend(['zpool', 'list', '-H', '-o', 'name'])
        
        result = subprocess.check_output(ssh_cmd, stderr=subprocess.STDOUT, universal_newlines=True)
        pools = result.strip().split('\\n')
        return {"success": True, "data": pools, "error": None}
    except subprocess.CalledProcessError as e:
        print(f"Error {e}")
        return {"success": False, "data": [], "error": str(e)}

def get_local_zfs_datasets(pool):
    try:
        result = subprocess.run(['zfs', 'list', '-H', '-o', 'name', '-r', pool], stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True, check=True)
        datasets = result.stdout.strip().split('\\n')
        return {"success": True, "data": datasets, "error": None}
    except subprocess.CalledProcessError as e:
        print(f"Error {e}")
        return {"success": False, "data": [], "error": str(e)}

def get_remote_zfs_datasets(pool, host, port=22, user='root'):
    try:
        ssh_cmd = ['ssh']
        if port != '22':
            ssh_cmd.extend(['-p', port])
        ssh_cmd.append(f"{user}@{host}")
        ssh_cmd.extend(['zfs', 'list', '-H', '-o', 'name', '-r', pool])
        
        result = subprocess.check_output(ssh_cmd, stderr=subprocess.STDOUT, universal_newlines=True)
        datasets = result.strip().split('\\n')
        return {"success": True, "data": datasets, "error": None}
    except subprocess.CalledProcessError as e:
        print(f"Error {e}")
        return {"success": False, "data": [], "error": str(e)}

def main():
    parser = argparse.ArgumentParser(description='Get Pools or Datasets from Local or Remote system')
    parser.add_argument('-t', '--type', type=str, choices=['pools', 'datasets'], required=True, help='Specify whether to get pools or datasets')
    parser.add_argument('-H', '--host', type=str, help='hostname of remote system')
    parser.add_argument('-p', '--port', type=str, default='22', help='port to connect via ssh (22 by default)')
    parser.add_argument('-u', '--user', type=str, default='root', help='user of remote system (root by default)')
    parser.add_argument('-P', '--pool', type=str, help='zfs pool to get datasets from (required if type is datasets)')

    args = parser.parse_args()
    
    if args.type == 'pools':
        if args.host:
            result = get_remote_zfs_pools(args.host, args.port, args.user)
        else:
            result = get_local_zfs_pools()
    elif args.type == 'datasets':
        if not args.pool:
            parser.error("the following arguments are required: -P/--pool")
        if args.host:
            result = get_remote_zfs_datasets(args.pool, args.host, args.port, args.user)
        else:
            result = get_local_zfs_datasets(args.pool)
    
    print(json.dumps(result))

if __name__ == "__main__":
    main()
`;
const test_ssh_script = `import subprocess
import argparse

def test_passwordless_ssh(target):
    try:
        # Attempt to run a command on the remote host without providing a password
        test_cmd = ['ssh', target, 'echo Success']

        process_test = subprocess.Popen(
            test_cmd,
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE,  
        )

        stdout, stderr = process_test.communicate()

        if process_test.returncode != 0:
            # raise Exception(f"Error: {stderr.decode('utf-8')}")
            return False
        else:
            print(stdout)
            return True

    
    except subprocess.CalledProcessError as e:
        # If there is an error, notify the user and return False
        print(f"Error: {e.stderr}")
        print("Passwordless SSH connection failed.")
        return False

def main():
    parser = argparse.ArgumentParser(description='Test passwordless SSH connection')
  
    parser.add_argument('sshTarget', type=str, help='ssh target')
    
    args = parser.parse_args()

    ssh_target = args.sshTarget
    
    result = test_passwordless_ssh(ssh_target)
    print(result)

if __name__ == "__main__":
    main()`;
const task_file_creation_script = `import re
import subprocess
import argparse
import json
import os
import logging

logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')

def read_template_file(template_file_path):
    logging.debug(f'Reading template file: {template_file_path}')
    with open(template_file_path, 'r') as file:
        content = file.read()
    logging.debug('Template file read successfully')
    return content

def parse_env_file(parameter_env_file_path):
    logging.debug(f'Parsing env file: {parameter_env_file_path}')
    parameters = {}
    with open(parameter_env_file_path, "r") as f:
        for line in f:
            key, value = line.strip().split('=')
            parameters[key] = value
        
    logging.debug('Env file parsed successfully')
    return parameters

def generate_exec_start(templateName, parameters, scriptPath):
    base_python_command = f"python3 {scriptPath}"
    
    if templateName == 'ScrubTask':
        return('zpool scrub ' + parameters['scrubConfig_pool_pool'])   
    else:
        return(base_python_command)

def read_schedule_json(file_path):
    logging.debug(f'Reading schedule JSON file: {file_path}')
    try:
        with open(file_path, 'r') as file:
            data = json.load(file)
            logging.debug('Schedule JSON file read successfully')
            return data
    except (FileNotFoundError, json.JSONDecodeError) as e:
        logging.error(f"Error reading JSON from file {file_path}: {e}")
        return None

def interval_to_on_calendar(interval):
    logging.debug(f'Converting interval to OnCalendar format: {interval}')
    parts = []
    
    if 'dayOfWeek' in interval and interval['dayOfWeek']:
        day_of_week = ','.join(interval['dayOfWeek'])
        parts.append(day_of_week)
    
    year_part = interval.get('year', {}).get('value', '*')
    month_part = interval.get('month', {}).get('value', '*')
    day_part = interval.get('day', {}).get('value', '*')
    
    # Modify the parts if they contain a slash and the base is not an asterisk
    if '/' in day_part:
        base, step = day_part.split('/')
        if base == '*':
            base = '1'  # Default to starting from the 1st day if base is '*'
        day_part = f'{base}/{step}'
    
    date_part = f'{year_part}-{month_part}-{day_part}'
    parts.append(date_part)
    
    hour = interval.get('hour', {}).get('value', '*')
    minute = interval.get('minute', {}).get('value', '*')
    second = interval.get('second', {}).get('value', '0')
    
    # Modify the parts if they contain a slash
    if '/' in hour:
        base, step = hour.split('/')
        if base == '*':
            base = '0'  # Default to starting from 0 if base is '*'
        hour = f'{base}/{step}'
    
    if '/' in minute:
        base, step = minute.split('/')
        if base == '*':
            base = '0'  # Default to starting from 0 if base is '*'
        minute = f'{base}/{step}'
    
    time_part = f'{hour}:{minute}:{second}'
    parts.append(time_part)
    
    on_calendar_value = ' '.join(parts)
    
    return 'OnCalendar=' + on_calendar_value

def replace_placeholders(template_content, parameters):
    logging.debug('Replacing placeholders in the template')
    for key, value in parameters.items():
        placeholder = "{" + key + "}"
        template_content = template_content.replace(placeholder, value)
    return template_content

def generate_concrete_file(template_content, output_file_path):
    logging.debug(f'Generating concrete file at: {output_file_path}')
    with open(output_file_path, 'w') as file:
        file.write(template_content)
    logging.debug('Concrete file generated successfully')

def manage_service(unit_name, action):
    logging.debug(f'Managing service: {unit_name} with action: {action}')
    try:
        subprocess.run(['sudo', 'systemctl', 'daemon-reload'], check=True)
        subprocess.run(['sudo', 'systemctl', action, unit_name], check=True)
        logging.debug(f'{unit_name} has been {action}d')
    except subprocess.CalledProcessError as e:
        logging.error(f"Failed to {action} {unit_name}: {e}")

def start_timer(timer_name):
    logging.debug(f'Starting timer: {timer_name}')
    try:
        subprocess.run(['sudo', 'systemctl', 'daemon-reload'], check=True)

        result = subprocess.run(['sudo', 'systemctl', 'is-enabled', timer_name], universal_newlines=True, stdout=subprocess.PIPE)
        
        if result.stdout.strip() == 'enabled':
            logging.debug(f'Timer {timer_name} is active, restarting it')
            subprocess.run(['sudo', 'systemctl', 'restart', timer_name], check=True)
            logging.debug(f'{timer_name} has been restarted')
        else:
            logging.debug(f'Timer {timer_name} is inactive, starting it')
            subprocess.run(['sudo', 'systemctl', 'start', timer_name], check=True)
            logging.debug(f'{timer_name} has been started')
    except subprocess.CalledProcessError as e:
        logging.error(f"Failed to start {timer_name}: {e}")

def create_task(template_name, script_path, param_env_path):
    logging.debug(f'Creating task with service template: {template_name} and env file: {param_env_path}')
    param_env_filename = os.path.basename(param_env_path)
    parts = param_env_filename.split('_')
    task_instance_name = '_'.join(parts[2:]).split('.env')[0]
    service_file_name = f'houston_scheduler_{task_instance_name}.service'
    output_path_service = f'/etc/systemd/system/{service_file_name}'
    
    service_template_content = read_template_file('/opt/45drives/houston/scheduler/templates/Task.service')
    parameters = parse_env_file(param_env_path)
    exec_start_command = generate_exec_start(template_name, parameters, script_path)
    service_template_content = service_template_content.replace("{task_name}", task_instance_name)
    service_template_content = service_template_content.replace("{env_path}", param_env_path)
    service_template_content = service_template_content.replace("{ExecStart}", exec_start_command)
    
    generate_concrete_file(service_template_content, output_path_service)
    logging.debug("Standalone concrete service file generated successfully.")

def create_schedule(schedule_json_path, timer_template_path, full_unit_name):
    logging.debug(f'Creating schedule with timer template: {timer_template_path} and schedule file: {schedule_json_path}')
    output_path_timer = f"/etc/systemd/system/{full_unit_name}.timer"
    schedule_data = read_schedule_json(schedule_json_path)
    
    if not schedule_data:
        logging.error("Invalid schedule data.")
        return

    timer_template_content = read_template_file(timer_template_path)
    on_calendar_lines = [interval_to_on_calendar(interval) for interval in schedule_data['intervals']]
    on_calendar_lines_str = "\\n".join(on_calendar_lines)
    timer_template_content = timer_template_content.replace("{description}", f"Timer for {full_unit_name}").replace("{on_calendar_lines}", on_calendar_lines_str)
    
    generate_concrete_file(timer_template_content, output_path_timer)
    logging.debug("Concrete timer file generated successfully.")
    
    manage_service(full_unit_name + '.timer', 'enable')
    start_timer(full_unit_name + '.timer')

def main():
    logging.debug('Starting main function')
    parser = argparse.ArgumentParser(description='Manage Service and Timer Files')
    parser.add_argument('-tN', '--templateName', type=str, help='Task Template Name')
    parser.add_argument('-t', '--type', type=str, choices=['create-task', 'create-schedule', 'create-task-schedule'], required=True, help='Type of operation to perform')
    parser.add_argument('-sP', '--scriptPath', type=str, help='Script Path')
    parser.add_argument('-e', '--env', type=str, help='Env file path')
    parser.add_argument('-tt', '--timerTemplate', type=str, help='Template timer file path')
    parser.add_argument('-s', '--schedule', type=str, help='Schedule JSON file path')
    parser.add_argument('-n', '--name', type=str, help='Full task/unit name (required for schedule)')
    
    args = parser.parse_args()

    if args.type == 'create-task':
        if not args.templateName or not args.scriptPath or not args.env:
            parser.error("the following arguments are required for create-task: -tN/--templateName, -sP/--scriptPath, -e/--env")
        create_task(args.templateName, args.scriptPath, args.env)
    elif args.type == 'create-schedule':
        if not args.timerTemplate or not args.schedule or not args.name:
            parser.error("the following arguments are required for create-schedule: -tt/--timerTemplate, -s/--schedule, -n/--name")
        create_schedule(args.schedule, args.timerTemplate, args.name)
    elif args.type == 'create-task-schedule':
        if not args.templateName or not args.scriptPath or not args.env or not args.timerTemplate or not args.schedule:
            parser.error("the following arguments are required for create-task-schedule: -tN/--templateName, -sP/--scriptPath, -e/--env, -tt/--timerTemplate, -s/--schedule")
        
        create_task(args.templateName, args.scriptPath, args.env)
        
        param_env_filename = os.path.basename(args.env)
        parts = param_env_filename.split('_')
        task_instance_name = '_'.join(parts[2:]).split('.env')[0]
        full_unit_name = f"houston_scheduler_{task_instance_name}"
        
        create_schedule(args.schedule, args.timerTemplate, full_unit_name)
    logging.debug('Main function execution completed')
        
if __name__ == "__main__":
    main()`;
const remove_task_script = `import os
import subprocess
import sys

def delete_task_files(unit_name):
    system_dir = '/etc/systemd/system/'
    
    prefix = "houston_scheduler_"
    suffixes = ['.env', '.json', '.service', '.timer']
    deleted_count = 0
    
    # Iterate through each file in the system directory
    for file in os.listdir(system_dir):
        # Check if the file matches the pattern for task files
        if file.startswith(prefix) and file.endswith(tuple(suffixes)):
            base_name = file[:file.rfind('.')]
            if base_name == unit_name:
                # If it matches the task name/unit, delete the file
                full_path = os.path.join(system_dir, file)
                os.remove(full_path)
                deleted_count += 1
                print(f"Deleted file: {full_path}")

def check_for_timer_file(unit_name):
    system_dir = '/etc/systemd/system/'
    prefix = "houston_scheduler_"
    suffix = '.timer'
    
    # Check for timer file presence
    for file in os.listdir(system_dir):
        print(f"Checking file: {file}")  # Debugging output
        if file.startswith(prefix) and file.endswith(suffix):
            base_name = file[:file.rfind('.')]
            print(f"Found timer file with base_name: {base_name}")  # Debugging output
            if base_name == unit_name:
                print(f"Timer file for unit {unit_name} exists.")  # Debugging output
                return True

    return False

def stop_systemd_timer(unit_name):
    # Stop the timer
    subprocess.run(['sudo', 'systemctl', 'stop', f'{unit_name}.timer'], check=True)
    # Disable the timer
    subprocess.run(['sudo', 'systemctl', 'disable', f'{unit_name}.timer'], check=True)
    # Reload systemd to recognize new or changed units
    subprocess.run(['sudo', 'systemctl', 'reset-failed'], check=True)
    subprocess.run(['sudo', 'systemctl', 'daemon-reload'], check=True)

def remove_systemd_service(unit_name):
    # Stop the service
    subprocess.run(['sudo', 'systemctl', 'stop', f'{unit_name}.service'], check=True)
    # Disable the service
    subprocess.run(['sudo', 'systemctl', 'disable', f'{unit_name}.service'], check=True)
    # Reload systemd to recognize new or changed units
    subprocess.run(['sudo', 'systemctl', 'daemon-reload'], check=True)

def main():
    unit_name = sys.argv[1]
    
    if check_for_timer_file(unit_name):
        stop_systemd_timer(unit_name)
    remove_systemd_service(unit_name)
    delete_task_files(unit_name)
    subprocess.run(['sudo', 'systemctl', 'daemon-reload'], check=True)
    
if __name__ == "__main__":
    main()
    
    
    `;
const run_task_script = `import subprocess
import sys
import os

def run_task_now(unit_name):
    try:
        # Reload systemd to recognize new or changed units
        subprocess.run(['sudo', 'systemctl', 'daemon-reload'], check=True)
        # Start the service 
        subprocess.run(['sudo', 'systemctl', 'start', f'{unit_name}.service'], check=True)
    except subprocess.CalledProcessError as e:
        print(f"Failed to run task: {e}")
        sys.exit(1)
        
def check_for_service_file(unit_name):
    system_dir = '/etc/systemd/system/'
    prefix = "houston_scheduler_"
    suffix = '.service'
    
    # Check for service file presence
    for file in os.listdir(system_dir):
        if file.startswith(prefix) and file.endswith(suffix):
            base_name = file[:file.rfind('.')]
            if base_name == unit_name:
                return True
    return False

def main():
    unit_name = sys.argv[1]
    
    if check_for_service_file(unit_name):
        run_task_now(unit_name)
    else:
        print(f'error: could not find task service file')
    
if __name__ == "__main__":
    main()`;
const get_disks_script = `import subprocess
import json

def main():
    result = subprocess.run(['lsdev', '-jdHmtTsfcp'], stdout=subprocess.PIPE)

    json_data = json.loads(result.stdout)

    disks = []

    for row in json_data['rows']:
        for disk in row:
            if not disk['occupied']:
                continue

            device_path = disk['dev']

            disks.append({
                'name': disk['bay-id'],
                'capacity': disk['capacity'],
                'model': disk['model-name'],
                'type': disk['disk_type'],
                'health': disk['health'],
                'phy_path': disk['dev-by-path'],
                'sd_path': device_path,
                'vdev_path': f'/dev/disk/by-vdev/{disk["bay-id"]}',
                'serial': disk['serial'],
                'temp': disk['temp-c'],
            })

    print(json.dumps(disks, indent=4))

if __name__ == '__main__':
    main()
`;
function injectWithCheck(key, errorMessage) {
  const injectedValue = inject(key);
  if (!injectedValue) {
    throw new Error(errorMessage);
  }
  return injectedValue;
}
function findValue(obj, targetKey, valueKey) {
  var _a;
  if (!obj || typeof obj !== "object")
    return null;
  if (obj.key === targetKey) {
    if (targetKey === valueKey && obj.value !== void 0) {
      return obj.value;
    }
    let foundChild = (_a = obj.children) == null ? void 0 : _a.find((child) => child.key === valueKey);
    if (foundChild && foundChild.value !== void 0) {
      return foundChild.value;
    }
  }
  if (Array.isArray(obj.children)) {
    for (let child of obj.children) {
      const result = findValue(child, targetKey, valueKey);
      if (result !== null) {
        return result;
      }
    }
  }
  return null;
}
async function getPoolData(host, port, user) {
  try {
    const cmd = ["/usr/bin/env", "python3", "-c", get_zfs_data_script, "-t", "pools"];
    if (host) {
      cmd.push("--host");
      cmd.push(host);
    }
    if (port) {
      cmd.push("--port");
      cmd.push(port);
    }
    if (user) {
      cmd.push("--user");
      cmd.push(user);
    }
    const state = useSpawn(cmd, { superuser: "try" });
    try {
      const result = (await state.promise()).stdout;
      const parsedResult = JSON.parse(result);
      if (parsedResult.success) {
        console.log("Pools array:", parsedResult.data);
        return parsedResult.data;
      } else if (parsedResult.error) {
        console.error("Script error:", parsedResult.error);
      } else {
        console.log("Script executed but no pools found.");
      }
    } catch (error) {
      return [];
    }
  } catch (state) {
    console.error(errorString(state));
    return null;
  }
}
async function getDatasetData(pool, host, port, user) {
  try {
    const cmd = ["/usr/bin/env", "python3", "-c", get_zfs_data_script, "-t", "datasets"];
    cmd.push("--pool");
    cmd.push(pool);
    if (host) {
      cmd.push("--host");
      cmd.push(host);
    }
    if (port) {
      cmd.push("--port");
      cmd.push(port);
    }
    if (user) {
      cmd.push("--user");
      cmd.push(user);
    }
    const state = useSpawn(cmd, { superuser: "try" });
    try {
      const result = (await state.promise()).stdout;
      const parsedResult = JSON.parse(result);
      if (parsedResult.success) {
        console.log("Datasets array:", parsedResult.data);
        return parsedResult.data;
      } else if (parsedResult.error) {
        console.error("Script error:", parsedResult.error);
      } else {
        console.log("Script executed but no pools found.");
      }
    } catch (error) {
      return [];
    }
  } catch (state) {
    console.error(errorString(state));
    return null;
  }
}
async function testSSH(sshTarget) {
  try {
    console.log(`target: ${sshTarget}`);
    const state = useSpawn(["/usr/bin/env", "python3", "-c", test_ssh_script, sshTarget], { superuser: "try", stderr: "out" });
    const output = await state.promise();
    console.log("testSSH output:", output);
    if (output.stdout.includes("True")) {
      return true;
    } else {
      return false;
    }
  } catch (error) {
    console.error(errorString(error));
    return false;
  }
}
async function executePythonScript(script, args) {
  try {
    const command = ["/usr/bin/env", "python3", "-c", script, ...args];
    const state = useSpawn(command, { superuser: "try" });
    const output = await state.promise();
    return output.stdout;
  } catch (error) {
    console.error(errorString(error));
    return false;
  }
}
async function createTaskFiles(templateName, scriptPath, envFile, timerTemplate, scheduleFile) {
  return executePythonScript(task_file_creation_script, ["-tN", templateName, "-t", "create-task-schedule", "-sP", scriptPath, "-e", envFile, "-tt", timerTemplate, "-s", scheduleFile]);
}
async function createStandaloneTask(templateName, scriptPath, envFile) {
  return executePythonScript(task_file_creation_script, ["-tN", templateName, "-t", "create-task", "-sP", scriptPath, "-e", envFile]);
}
async function createScheduleForTask(taskName, timerTemplate, scheduleFile) {
  return executePythonScript(task_file_creation_script, ["-t", "create-schedule", "-n", taskName, "-tt", timerTemplate, "-s", scheduleFile]);
}
async function removeTask(taskName) {
  return executePythonScript(remove_task_script, [taskName]);
}
async function runTask(taskName) {
  return executePythonScript(run_task_script, [taskName]);
}
const upperCaseWord = (word) => {
  let lowerCaseWord = word.toLowerCase();
  let firstLetter = lowerCaseWord.charAt(0);
  let remainingLetters = lowerCaseWord.substring(1);
  let firstLetterCap = firstLetter.toUpperCase();
  return firstLetterCap + remainingLetters;
};
function boolToYesNo(state) {
  if (state == true) {
    return "Yes";
  } else if (state == false) {
    return "No";
  }
}
function formatTemplateName(templateName) {
  let words = templateName.split(" ");
  let formattedWords = words.map((word) => word.charAt(0).toUpperCase() + word.slice(1).toLowerCase());
  let formattedTemplateName = formattedWords.join("");
  return formattedTemplateName;
}
async function getDisks(diskGroup) {
  try {
    const state = useSpawn(["/usr/bin/env", "python3", "-c", get_disks_script], { superuser: "try" });
    const disks = (await state.promise()).stdout;
    const parsedJSON = JSON.parse(disks);
    for (let i = 0; i < parsedJSON.length; i++) {
      const disk = {
        name: parsedJSON[i].name,
        capacity: parsedJSON[i].capacity,
        model: parsedJSON[i].model,
        type: parsedJSON[i].type,
        phy_path: parsedJSON[i].phy_path,
        sd_path: parsedJSON[i].sd_path,
        vdev_path: parsedJSON[i].vdev_path,
        serial: parsedJSON[i].serial,
        health: parsedJSON[i].health,
        temp: parsedJSON[i].temp
      };
      diskGroup.value.push(disk);
    }
  } catch (state) {
    console.error(errorString(state));
    return null;
  }
}
function getDiskIDName(disks, diskIdentifier, selectedDiskName) {
  const phyPathPrefix = "/dev/disk/by-path/";
  const sdPathPrefix = "/dev/";
  const newDisk = ref$1();
  const diskName = ref$1("");
  const diskPath = ref$1("");
  newDisk.value = disks.find((disk) => disk.name === selectedDiskName);
  switch (diskIdentifier) {
    case "vdev_path":
      diskPath.value = newDisk.value.vdev_path;
      diskName.value = selectedDiskName;
      break;
    case "phy_path":
      diskPath.value = newDisk.value.phy_path;
      diskName.value = diskPath.value.replace(phyPathPrefix, "");
      break;
    case "sd_path":
      diskPath.value = newDisk.value.sd_path;
      diskName.value = diskPath.value.replace(sdPathPrefix, "");
      break;
    default:
      console.log("error with selectedDiskNames/diskIdentifier");
      break;
  }
  return { diskName: diskName.value, diskPath: diskPath.value };
}
function truncateName(name, threshold) {
  return name.length > threshold ? name.slice(0, threshold) + "..." : name;
}
function splitAndClean(inputString, isDisk) {
  const cleanedString = inputString.trim().replace(/^['"]|['"]$/g, "");
  const parts = cleanedString.split(",");
  const cleanedParts = parts.map((part) => {
    let cleanedPart = part.trim();
    return cleanedPart;
  });
  return cleanedParts;
}
const loadingInjectionKey = Symbol("loading");
const schedulerInjectionKey = Symbol("scheduler");
const logInjectionKey = Symbol("log");
const taskInstancesInjectionKey = Symbol("task-instances");
const taskTemplatesInjectionKey = Symbol("task-templates");
const truncateTextInjectionKey = Symbol("truncate-text");
const _hoisted_1$f = {
  key: 0,
  class: "grid grid-cols-4 items-left text-left"
};
const _hoisted_2$c = { class: "col-span-1" };
const _hoisted_3$b = ["title"];
const _hoisted_4$b = /* @__PURE__ */ createBaseVNode("b", null, "ZFS Replication Task", -1);
const _hoisted_5$a = ["title"];
const _hoisted_6$9 = { key: 0 };
const _hoisted_7$9 = { key: 1 };
const _hoisted_8$9 = ["title"];
const _hoisted_9$9 = ["title"];
const _hoisted_10$9 = {
  key: 1,
  class: "my-2 truncate",
  title: `No Snapshot Limit (Keep All)`
};
const _hoisted_11$8 = {
  key: 2,
  class: "my-2"
};
const _hoisted_12$7 = ["title"];
const _hoisted_13$5 = ["title"];
const _hoisted_14$3 = { class: "col-span-1" };
const _hoisted_15$3 = ["title"];
const _hoisted_16$3 = ["title"];
const _hoisted_17$2 = ["title"];
const _hoisted_18$2 = ["title"];
const _hoisted_19$2 = {
  key: 1,
  class: "my-2 truncate",
  title: `No Snapshot Limit (Keep All)`
};
const _hoisted_20$2 = { class: "col-span-2 row-span-2" };
const _hoisted_21$2 = /* @__PURE__ */ createBaseVNode("p", { class: "my-2 font-bold" }, "Current Schedules:", -1);
const _hoisted_22$2 = ["title"];
const _hoisted_23$2 = { key: 1 };
const _hoisted_24$2 = /* @__PURE__ */ createBaseVNode("p", null, "No Intervals Currently Scheduled", -1);
const _hoisted_25$2 = [
  _hoisted_24$2
];
const _sfc_main$h = /* @__PURE__ */ defineComponent({
  __name: "ZfsRepTaskDetails",
  props: {
    task: {}
  },
  setup(__props) {
    const props = __props;
    const taskInstance = ref$1(props.task);
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    return (_ctx, _cache) => {
      return taskInstance.value.template.name === "ZFS Replication Task" ? (openBlock(), createElementBlock("div", _hoisted_1$f, [
        createBaseVNode("div", _hoisted_2$c, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Task Type: ${taskInstance.value.template.name}`
          }, [
            createTextVNode(" Task Type: "),
            _hoisted_4$b
          ], 8, _hoisted_3$b),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Send Type: ${unref(findValue)(taskInstance.value.parameters, "destDataset", "host") !== "" ? "Remote" : "Local"}`
          }, [
            createTextVNode(" Send Type: "),
            unref(findValue)(taskInstance.value.parameters, "destDataset", "host") !== "" ? (openBlock(), createElementBlock("b", _hoisted_6$9, "Remote")) : createCommentVNode("", true),
            unref(findValue)(taskInstance.value.parameters, "destDataset", "host") === "" ? (openBlock(), createElementBlock("b", _hoisted_7$9, "Local")) : createCommentVNode("", true)
          ], 8, _hoisted_5$a),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Source: ${unref(findValue)(taskInstance.value.parameters, "sourceDataset", "dataset")}`
          }, [
            createTextVNode(" Source: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "sourceDataset",
              "dataset"
            )), 1)
          ], 8, _hoisted_8$9),
          unref(findValue)(
            taskInstance.value.parameters,
            "snapRetention",
            "source"
          ) > 0 ? (openBlock(), createElementBlock("p", {
            key: 0,
            class: "my-2 truncate",
            title: `Source Snapshots to Keep: ${unref(findValue)(taskInstance.value.parameters, "snapRetention", "source")}`
          }, [
            createTextVNode(" Source Snapshots to Keep: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "snapRetention",
              "source"
            )), 1)
          ], 8, _hoisted_9$9)) : (openBlock(), createElementBlock("p", _hoisted_10$9, " No Snapshot Limit Set (Keep All) ")),
          unref(findValue)(taskInstance.value.parameters, "destDataset", "host") !== "" ? (openBlock(), createElementBlock("p", _hoisted_11$8, [
            createBaseVNode("span", {
              class: "truncate",
              title: `Remote SSH Host: ${unref(findValue)(taskInstance.value.parameters, "destDataset", "host")}`
            }, [
              createTextVNode(" Remote SSH Host: "),
              createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "destDataset", "host")), 1)
            ], 8, _hoisted_12$7),
            createBaseVNode("span", {
              class: "truncate",
              title: `Remote SSH Port: ${unref(findValue)(taskInstance.value.parameters, "destDataset", "port")}`
            }, [
              createTextVNode(" Remote SSH Port: : "),
              createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "destDataset", "port")), 1)
            ], 8, _hoisted_13$5)
          ])) : createCommentVNode("", true)
        ]),
        createBaseVNode("div", _hoisted_14$3, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Compression: ${unref(findValue)(taskInstance.value.parameters, "sendOptions", "raw_flag") ? "Raw" : unref(findValue)(taskInstance.value.parameters, "sendOptions", "compressed_flag") ? "Compressed" : "None"}`
          }, [
            createTextVNode(" Compression: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "sendOptions",
              "raw_flag"
            ) ? "Raw" : unref(findValue)(
              taskInstance.value.parameters,
              "sendOptions",
              "compressed_flag"
            ) ? "Compressed" : "None"), 1)
          ], 8, _hoisted_15$3),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Recursive Send: ${unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "sendOptions", "recursive_flag"))}`
          }, [
            createTextVNode(" Recursive Send: "),
            createBaseVNode("b", null, toDisplayString(unref(boolToYesNo)(unref(findValue)(
              taskInstance.value.parameters,
              "sendOptions",
              "recursive_flag"
            ))), 1)
          ], 8, _hoisted_16$3),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Destination: ${unref(findValue)(taskInstance.value.parameters, "destDataset", "dataset")}`
          }, [
            createTextVNode(" Destination: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "destDataset",
              "dataset"
            )), 1)
          ], 8, _hoisted_17$2),
          unref(findValue)(
            taskInstance.value.parameters,
            "snapRetention",
            "destination"
          ) > 0 ? (openBlock(), createElementBlock("p", {
            key: 0,
            class: "my-2 truncate",
            title: `Destination Snapshots to Keep: ${unref(findValue)(taskInstance.value.parameters, "snapRetention", "destination")}`
          }, [
            createTextVNode(" Destination Snapshots to Keep: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "snapRetention",
              "destination"
            )), 1)
          ], 8, _hoisted_18$2)) : (openBlock(), createElementBlock("p", _hoisted_19$2, " No Snapshot Limit Set (Keep All) "))
        ]),
        createBaseVNode("div", _hoisted_20$2, [
          _hoisted_21$2,
          taskInstance.value.schedule.intervals.length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(taskInstance.value.schedule.intervals, (interval, idx) => {
            return openBlock(), createElementBlock("div", {
              key: idx,
              class: "flex flex-row col-span-2 divide divide-y divide-default p-1",
              title: `Run ${unref(myScheduler).parseIntervalIntoString(interval)}.`
            }, [
              createBaseVNode("p", null, "Run " + toDisplayString(unref(myScheduler).parseIntervalIntoString(interval)) + ".", 1)
            ], 8, _hoisted_22$2);
          }), 128)) : (openBlock(), createElementBlock("div", _hoisted_23$2, _hoisted_25$2))
        ])
      ])) : createCommentVNode("", true);
    };
  }
});
const _hoisted_1$e = {
  key: 0,
  class: "grid grid-cols-4 items-left text-left"
};
const _hoisted_2$b = { class: "col-span-1" };
const _hoisted_3$a = ["title"];
const _hoisted_4$a = /* @__PURE__ */ createBaseVNode("b", null, "Automated Snapshot Task", -1);
const _hoisted_5$9 = ["title"];
const _hoisted_6$8 = ["title"];
const _hoisted_7$8 = { class: "col-span-1" };
const _hoisted_8$8 = ["title"];
const _hoisted_9$8 = ["title"];
const _hoisted_10$8 = {
  key: 1,
  class: "my-2 truncate",
  title: `No Snapshot Limit (Keep All)`
};
const _hoisted_11$7 = { class: "col-span-2 row-span-2" };
const _hoisted_12$6 = /* @__PURE__ */ createBaseVNode("p", { class: "my-2 font-bold" }, "Current Schedules:", -1);
const _hoisted_13$4 = ["title"];
const _hoisted_14$2 = { key: 1 };
const _hoisted_15$2 = /* @__PURE__ */ createBaseVNode("p", null, "No Intervals Currently Scheduled", -1);
const _hoisted_16$2 = [
  _hoisted_15$2
];
const _sfc_main$g = /* @__PURE__ */ defineComponent({
  __name: "AutomatedSnapshotTaskDetails",
  props: {
    task: {}
  },
  setup(__props) {
    const props = __props;
    const taskInstance = ref$1(props.task);
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    return (_ctx, _cache) => {
      return taskInstance.value.template.name === "Automated Snapshot Task" ? (openBlock(), createElementBlock("div", _hoisted_1$e, [
        createBaseVNode("div", _hoisted_2$b, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Task Type: ${taskInstance.value.template.name}`
          }, [
            createTextVNode(" Task Type: "),
            _hoisted_4$a
          ], 8, _hoisted_3$a),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Filesystem: ${unref(findValue)(taskInstance.value.parameters, "filesystem", "dataset")}`
          }, [
            createTextVNode(" Filesystem: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "filesystem",
              "dataset"
            )), 1)
          ], 8, _hoisted_5$9),
          unref(findValue)(taskInstance.value.parameters, "customName_flag", "customName_flag") ? (openBlock(), createElementBlock("p", {
            key: 0,
            class: "my-2 truncate",
            title: `Custom Snapshot Name: ${unref(findValue)(taskInstance.value.parameters, "customName", "customName")}`
          }, [
            createTextVNode(" Custom Snapshot Name: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "customName",
              "customName"
            )), 1)
          ], 8, _hoisted_6$8)) : createCommentVNode("", true)
        ]),
        createBaseVNode("div", _hoisted_7$8, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Recursive Snapshots: ${unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "recursive_flag", "recursive_flag"))}`
          }, [
            createTextVNode(" Recursive Snapshots: "),
            createBaseVNode("b", null, toDisplayString(unref(boolToYesNo)(unref(findValue)(
              taskInstance.value.parameters,
              "recursive_flag",
              "recursive_flag"
            ))), 1)
          ], 8, _hoisted_8$8),
          unref(findValue)(
            taskInstance.value.parameters,
            "snapRetention",
            "snapRetention"
          ) > 0 ? (openBlock(), createElementBlock("p", {
            key: 0,
            class: "my-2 truncate",
            title: `Snapshots to Keep: ${unref(findValue)(taskInstance.value.parameters, "snapRetention", "snapRetention")}`
          }, [
            createTextVNode(" Snapshots to Keep: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(
              taskInstance.value.parameters,
              "snapRetention",
              "snapRetention"
            )), 1)
          ], 8, _hoisted_9$8)) : (openBlock(), createElementBlock("p", _hoisted_10$8, " No Snapshot Limit Set (Keep All) "))
        ]),
        createBaseVNode("div", _hoisted_11$7, [
          _hoisted_12$6,
          taskInstance.value.schedule.intervals.length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(taskInstance.value.schedule.intervals, (interval, idx) => {
            return openBlock(), createElementBlock("div", {
              key: idx,
              class: "flex flex-row col-span-2 divide divide-y divide-default p-1",
              title: `Run ${unref(myScheduler).parseIntervalIntoString(interval)}.`
            }, [
              createBaseVNode("p", null, "Run " + toDisplayString(unref(myScheduler).parseIntervalIntoString(interval)) + ".", 1)
            ], 8, _hoisted_13$4);
          }), 128)) : (openBlock(), createElementBlock("div", _hoisted_14$2, _hoisted_16$2))
        ])
      ])) : createCommentVNode("", true);
    };
  }
});
const _hoisted_1$d = {
  key: 0,
  class: "grid grid-cols-4 items-left text-left"
};
const _hoisted_2$a = { class: "col-span-1" };
const _hoisted_3$9 = ["title"];
const _hoisted_4$9 = /* @__PURE__ */ createBaseVNode("b", null, "Rsync Task", -1);
const _hoisted_5$8 = ["title"];
const _hoisted_6$7 = ["title"];
const _hoisted_7$7 = ["title"];
const _hoisted_8$7 = ["title"];
const _hoisted_9$7 = { key: 0 };
const _hoisted_10$7 = { key: 1 };
const _hoisted_11$6 = {
  key: 0,
  class: "my-2"
};
const _hoisted_12$5 = ["title"];
const _hoisted_13$3 = ["title"];
const _hoisted_14$1 = { class: "col-span-1" };
const _hoisted_15$1 = ["title"];
const _hoisted_16$1 = ["title"];
const _hoisted_17$1 = ["title"];
const _hoisted_18$1 = ["title"];
const _hoisted_19$1 = ["title"];
const _hoisted_20$1 = { class: "col-span-2 row-span-2" };
const _hoisted_21$1 = /* @__PURE__ */ createBaseVNode("p", { class: "my-2 font-bold" }, "Current Schedules:", -1);
const _hoisted_22$1 = ["title"];
const _hoisted_23$1 = { key: 1 };
const _hoisted_24$1 = /* @__PURE__ */ createBaseVNode("p", null, "No Intervals Currently Scheduled", -1);
const _hoisted_25$1 = [
  _hoisted_24$1
];
const _sfc_main$f = /* @__PURE__ */ defineComponent({
  __name: "RsyncTaskDetails",
  props: {
    task: {}
  },
  setup(__props) {
    const props = __props;
    const taskInstance = ref$1(props.task);
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    return (_ctx, _cache) => {
      return taskInstance.value.template.name === "Rsync Task" ? (openBlock(), createElementBlock("div", _hoisted_1$d, [
        createBaseVNode("div", _hoisted_2$a, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Task Type: ${taskInstance.value.template.name}`
          }, [
            createTextVNode(" Task Type: "),
            _hoisted_4$9
          ], 8, _hoisted_3$9),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Direction: ${unref(upperCaseWord)(unref(findValue)(taskInstance.value.parameters, "direction", "direction"))}`
          }, [
            createTextVNode(" Direction: "),
            createBaseVNode("b", null, toDisplayString(unref(upperCaseWord)(unref(findValue)(taskInstance.value.parameters, "direction", "direction"))), 1)
          ], 8, _hoisted_5$8),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Local Path: ${unref(findValue)(taskInstance.value.parameters, "local_path", "local_path")}`
          }, [
            createTextVNode(" Local Path: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "local_path", "local_path")), 1)
          ], 8, _hoisted_6$7),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Target Path: ${unref(findValue)(taskInstance.value.parameters, "target_info", "path")}`
          }, [
            createTextVNode(" Target Path: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "target_info", "path")), 1)
          ], 8, _hoisted_7$7),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Send Type: ${unref(findValue)(taskInstance.value.parameters, "target_info", "host") !== "" ? "Remote" : "Local"}`
          }, [
            createTextVNode(" Transfer Type: "),
            unref(findValue)(taskInstance.value.parameters, "target_info", "host") !== "" ? (openBlock(), createElementBlock("b", _hoisted_9$7, "Remote")) : createCommentVNode("", true),
            unref(findValue)(taskInstance.value.parameters, "target_info", "host") === "" ? (openBlock(), createElementBlock("b", _hoisted_10$7, "Local")) : createCommentVNode("", true)
          ], 8, _hoisted_8$7),
          unref(findValue)(taskInstance.value.parameters, "target_info", "host") !== "" ? (openBlock(), createElementBlock("p", _hoisted_11$6, [
            createBaseVNode("span", {
              class: "truncate",
              title: `Remote SSH Host: ${unref(findValue)(taskInstance.value.parameters, "target_info", "host")}`
            }, [
              createTextVNode(" Remote SSH Host: "),
              createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "target_info", "host")), 1)
            ], 8, _hoisted_12$5),
            createBaseVNode("span", {
              class: "truncate",
              title: `Remote SSH Port: ${unref(findValue)(taskInstance.value.parameters, "target_info", "port")}`
            }, [
              createTextVNode(" Remote SSH Port: : "),
              createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "target_info", "port")), 1)
            ], 8, _hoisted_13$3)
          ])) : createCommentVNode("", true)
        ]),
        createBaseVNode("div", _hoisted_14$1, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Archive Mode: ${unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "archive_flag"))}`
          }, [
            createTextVNode(" Archive Mode: "),
            createBaseVNode("b", null, toDisplayString(unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "archive_flag"))), 1)
          ], 8, _hoisted_15$1),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Recursive: ${unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "recursive_flag"))}`
          }, [
            createTextVNode(" Recursive: "),
            createBaseVNode("b", null, toDisplayString(unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "recursive_flag"))), 1)
          ], 8, _hoisted_16$1),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Compressed: ${unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "compressed_flag"))}`
          }, [
            createTextVNode(" Compressed: "),
            createBaseVNode("b", null, toDisplayString(unref(boolToYesNo)(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "compressed_flag"))), 1)
          ], 8, _hoisted_17$1),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Bandwidth Limit: ${unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "bandwidth_limit_kbps") !== 0 ? `${unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "bandwidth_limit_kbps")} kb/s` : "No"}`
          }, [
            createTextVNode(" Bandwidth Limit: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "bandwidth_limit_kbps") !== 0 ? `${unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "bandwidth_limit_kbps")} kb/s` : "No"), 1)
          ], 8, _hoisted_18$1),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Parallel Threads: ${unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "parallel_threads") !== 0 ? unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "parallel_threads") : "No"}`
          }, [
            createTextVNode(" Parallel Threads: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "parallel_threads") !== 0 ? unref(findValue)(taskInstance.value.parameters, "rsyncOptions", "parallel_threads") : "No"), 1)
          ], 8, _hoisted_19$1)
        ]),
        createBaseVNode("div", _hoisted_20$1, [
          _hoisted_21$1,
          taskInstance.value.schedule.intervals.length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(taskInstance.value.schedule.intervals, (interval, idx) => {
            return openBlock(), createElementBlock("div", {
              key: idx,
              class: "flex flex-row col-span-2 divide divide-y divide-default p-1",
              title: `Run ${unref(myScheduler).parseIntervalIntoString(interval)}.`
            }, [
              createBaseVNode("p", null, "Run " + toDisplayString(unref(myScheduler).parseIntervalIntoString(interval)) + ".", 1)
            ], 8, _hoisted_22$1);
          }), 128)) : (openBlock(), createElementBlock("div", _hoisted_23$1, _hoisted_25$1))
        ])
      ])) : createCommentVNode("", true);
    };
  }
});
const _hoisted_1$c = {
  key: 0,
  class: "grid grid-cols-4 items-left text-left"
};
const _hoisted_2$9 = { class: "col-span-1" };
const _hoisted_3$8 = ["title"];
const _hoisted_4$8 = /* @__PURE__ */ createBaseVNode("b", null, "Scrub Task", -1);
const _hoisted_5$7 = ["title"];
const _hoisted_6$6 = /* @__PURE__ */ createBaseVNode("div", { class: "col-span-1" }, null, -1);
const _hoisted_7$6 = { class: "col-span-2 row-span-2" };
const _hoisted_8$6 = /* @__PURE__ */ createBaseVNode("p", { class: "my-2 font-bold" }, "Current Schedules:", -1);
const _hoisted_9$6 = ["title"];
const _hoisted_10$6 = { key: 1 };
const _hoisted_11$5 = /* @__PURE__ */ createBaseVNode("p", null, "No Intervals Currently Scheduled", -1);
const _hoisted_12$4 = [
  _hoisted_11$5
];
const _sfc_main$e = /* @__PURE__ */ defineComponent({
  __name: "ScrubTaskDetails",
  props: {
    task: {}
  },
  setup(__props) {
    const props = __props;
    const taskInstance = ref$1(props.task);
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    return (_ctx, _cache) => {
      return taskInstance.value.template.name === "Scrub Task" ? (openBlock(), createElementBlock("div", _hoisted_1$c, [
        createBaseVNode("div", _hoisted_2$9, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Task Type: ${taskInstance.value.template.name}`
          }, [
            createTextVNode(" Task Type: "),
            _hoisted_4$8
          ], 8, _hoisted_3$8),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Pool: ${unref(findValue)(taskInstance.value.parameters, "pool", "pool")}`
          }, [
            createTextVNode(" Pool: "),
            createBaseVNode("b", null, toDisplayString(unref(findValue)(taskInstance.value.parameters, "pool", "pool")), 1)
          ], 8, _hoisted_5$7)
        ]),
        _hoisted_6$6,
        createBaseVNode("div", _hoisted_7$6, [
          _hoisted_8$6,
          taskInstance.value.schedule.intervals.length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(taskInstance.value.schedule.intervals, (interval, idx) => {
            return openBlock(), createElementBlock("div", {
              key: idx,
              class: "flex flex-row col-span-2 divide divide-y divide-default p-1",
              title: `Run ${unref(myScheduler).parseIntervalIntoString(interval)}.`
            }, [
              createBaseVNode("p", null, "Run " + toDisplayString(unref(myScheduler).parseIntervalIntoString(interval)) + ".", 1)
            ], 8, _hoisted_9$6);
          }), 128)) : (openBlock(), createElementBlock("div", _hoisted_10$6, _hoisted_12$4))
        ])
      ])) : createCommentVNode("", true);
    };
  }
});
const _hoisted_1$b = {
  key: 0,
  class: "grid grid-cols-4 items-left text-left"
};
const _hoisted_2$8 = { class: "col-span-2" };
const _hoisted_3$7 = ["title"];
const _hoisted_4$7 = /* @__PURE__ */ createBaseVNode("b", null, "SMART Test Task", -1);
const _hoisted_5$6 = ["title"];
const _hoisted_6$5 = ["title"];
const _hoisted_7$5 = { class: "p-1 mx-1 font-medium border border-default rounded-lg bg-accent" };
const _hoisted_8$5 = { class: "col-span-2 row-span-2" };
const _hoisted_9$5 = /* @__PURE__ */ createBaseVNode("p", { class: "my-2 font-bold" }, "Current Schedules:", -1);
const _hoisted_10$5 = ["title"];
const _hoisted_11$4 = { key: 1 };
const _hoisted_12$3 = /* @__PURE__ */ createBaseVNode("p", null, "No Intervals Currently Scheduled", -1);
const _hoisted_13$2 = [
  _hoisted_12$3
];
const _sfc_main$9 = /* @__PURE__ */ defineComponent({
  __name: "SmartTestTaskDetails",
  props: {
    task: {}
  },
  setup(__props) {
    const props = __props;
    const taskInstance = ref$1(props.task);
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    const disksArray = splitAndClean(findValue(taskInstance.value.parameters, "disks", "disks"));
    return (_ctx, _cache) => {
      return taskInstance.value.template.name === "SMART Test" ? (openBlock(), createElementBlock("div", _hoisted_1$b, [
        createBaseVNode("div", _hoisted_2$8, [
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: `Task Type: ${taskInstance.value.template.name}`
          }, [
            createTextVNode(" Task Type: "),
            _hoisted_4$7
          ], 8, _hoisted_3$7),
          createBaseVNode("p", {
            class: "my-2 truncate",
            title: ` Test Type: ${unref(upperCaseWord)(unref(findValue)(taskInstance.value.parameters, "testType", "testType"))}`
          }, [
            createTextVNode(" Test Type: "),
            createBaseVNode("b", null, toDisplayString(unref(upperCaseWord)(unref(findValue)(taskInstance.value.parameters, "testType", "testType"))), 1)
          ], 8, _hoisted_5$6),
          createBaseVNode("p", {
            class: "my-2",
            title: `Disks: ${unref(findValue)(taskInstance.value.parameters, "disks", "disks")}`
          }, [
            createTextVNode(" Disks: "),
            (openBlock(true), createElementBlock(Fragment, null, renderList(unref(disksArray), (disk, idx) => {
              return openBlock(), createElementBlock("span", _hoisted_7$5, toDisplayString(unref(disksArray)[idx]), 1);
            }), 256))
          ], 8, _hoisted_6$5)
        ]),
        createBaseVNode("div", _hoisted_8$5, [
          _hoisted_9$5,
          taskInstance.value.schedule.intervals.length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(taskInstance.value.schedule.intervals, (interval, idx) => {
            return openBlock(), createElementBlock("div", {
              key: idx,
              class: "flex flex-row col-span-2 divide divide-y divide-default p-1",
              title: `Run ${unref(myScheduler).parseIntervalIntoString(interval)}.`
            }, [
              createBaseVNode("p", null, "Run " + toDisplayString(unref(myScheduler).parseIntervalIntoString(interval)) + ".", 1)
            ], 8, _hoisted_10$5);
          }), 128)) : (openBlock(), createElementBlock("div", _hoisted_11$4, _hoisted_13$2))
        ])
      ])) : createCommentVNode("", true);
    };
  }
});
const _sfc_main$8 = /* @__PURE__ */ defineComponent({
  __name: "TaskInstanceDetails",
  props: {
    task: {}
  },
  setup(__props) {
    const props = __props;
    const template = computed(() => props.task.template);
    const activeComponent = ref$1(null);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", null, [
        template.value.name == "ZFS Replication Task" ? (openBlock(), createBlock(_sfc_main$h, {
          key: 0,
          ref_key: "activeComponent",
          ref: activeComponent,
          task: props.task
        }, null, 8, ["task"])) : template.value.name == "Automated Snapshot Task" ? (openBlock(), createBlock(_sfc_main$g, {
          key: 1,
          ref_key: "activeComponent",
          ref: activeComponent,
          task: props.task
        }, null, 8, ["task"])) : template.value.name == "Rsync Task" ? (openBlock(), createBlock(_sfc_main$f, {
          key: 2,
          ref_key: "activeComponent",
          ref: activeComponent,
          task: props.task
        }, null, 8, ["task"])) : template.value.name == "Scrub Task" ? (openBlock(), createBlock(_sfc_main$e, {
          key: 3,
          ref_key: "activeComponent",
          ref: activeComponent,
          task: props.task
        }, null, 8, ["task"])) : template.value.name == "SMART Test" ? (openBlock(), createBlock(_sfc_main$9, {
          key: 4,
          ref_key: "activeComponent",
          ref: activeComponent,
          task: props.task
        }, null, 8, ["task"])) : createCommentVNode("", true)
      ]);
    };
  }
});
const _hoisted_1$6 = ["title"];
const _hoisted_2$7 = ["title"];
const _hoisted_3$6 = {
  key: 1,
  title: "Disabled",
  class: "truncate text-base font-medium text-default border-r border-default text-left ml-4 col-span-2"
};
const _hoisted_4$6 = ["title"];
const _hoisted_5$5 = { class: "truncate text-base font-medium text-default border-r border-default text-left ml-4 col-span-1" };
const _hoisted_6$4 = ["title", "checked"];
const _hoisted_7$4 = {
  key: 1,
  disabled: "",
  type: "checkbox",
  title: "No Schedule Found",
  class: "ml-2 h-4 w-4 rounded bg-gray-300 dark:bg-gray-400"
};
const _hoisted_8$4 = { class: "truncate text-base font-medium text-default border-default m-1 col-span-1" };
const _hoisted_9$4 = {
  key: 2,
  class: "col-span-8 h-full px-2 mx-2 py-1 border-t border-default"
};
const _hoisted_10$4 = { class: "button-group-row justify-center col-span-5 mt-2" };
const _hoisted_11$3 = { key: 0 };
const _hoisted_12$2 = { key: 1 };
const _sfc_main$7 = /* @__PURE__ */ defineComponent({
  __name: "TaskInstanceTableRow",
  props: {
    task: {},
    isExpanded: { type: Boolean }
  },
  emits: ["runTask", "manageSchedule", "removeTask", "editTask", "viewLogs", "toggleDetails"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const taskInstance = ref$1(props.task);
    injectWithCheck(taskInstancesInjectionKey, "taskInstances not provided!");
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    const myTaskLog = injectWithCheck(logInjectionKey, "log not provided!");
    const latestTaskExecution = ref$1("");
    const taskStatus = ref$1("");
    const emit2 = __emit;
    async function runTaskBtn() {
      emit2("runTask", props.task);
    }
    function manageScheduleBtn() {
      emit2("manageSchedule", props.task);
    }
    function removeTaskBtn() {
      emit2("removeTask", props.task);
    }
    function editTaskBtn() {
      emit2("editTask", props.task);
    }
    function viewLogsBtn() {
      emit2("viewLogs", props.task);
    }
    function toggleTaskDetails() {
      emit2("toggleDetails", taskInstance.value.name);
    }
    async function loadConfirmationDialog(dialogRef) {
      const module = await __vitePreload(() => import("./ConfirmationDialog.95d4bb09.js"), true ? ["./ConfirmationDialog.95d4bb09.js","./Modal.vue_vue_type_script_setup_true_lang.9365df46.js"] : void 0, import.meta.url);
      dialogRef.value = module.default;
    }
    const showEnablePrompt = ref$1(false);
    const enableDialog = ref$1();
    const enabling = ref$1(false);
    async function showEnableDialog() {
      await loadConfirmationDialog(enableDialog);
      return new Promise((resolve2) => {
        showEnablePrompt.value = true;
        const unwatch = watch(showEnablePrompt, (newValue) => {
          if (!newValue) {
            unwatch();
            resolve2(enableDialog.value === "yes");
          }
        });
      });
    }
    const enableYes = async () => {
      enabling.value = true;
      console.log("enabling schedule for:", taskInstance.value.name);
      await myScheduler.enableSchedule(taskInstance.value);
      await updateTaskStatus(taskInstance.value, taskInstance.value.schedule.enabled);
      updateShowEnablePrompt(false);
      enabling.value = false;
    };
    const enableNo = () => {
      console.log("leaving task schedule as is");
      updateShowEnablePrompt(false);
    };
    const updateShowEnablePrompt = (newVal) => {
      showEnablePrompt.value = newVal;
    };
    const showDisablePrompt = ref$1(false);
    const disableDialog = ref$1();
    const disabling = ref$1(false);
    async function showDisableDialog() {
      await loadConfirmationDialog(disableDialog);
      return new Promise((resolve2) => {
        showDisablePrompt.value = true;
        const unwatch = watch(showDisablePrompt, (newValue) => {
          if (!newValue) {
            unwatch();
            resolve2(disableDialog.value === "yes");
          }
        });
      });
    }
    const disableYes = async () => {
      disabling.value = true;
      console.log("disabling schedule for:", taskInstance.value.name);
      await myScheduler.disableSchedule(taskInstance.value);
      await updateTaskStatus(taskInstance.value, taskInstance.value.schedule.enabled);
      updateShowDisablePrompt(false);
      disabling.value = false;
    };
    const disableNo = () => {
      console.log("leaving task schedule as is");
      updateShowDisablePrompt(false);
    };
    const updateShowDisablePrompt = (newVal) => {
      showDisablePrompt.value = newVal;
    };
    async function toggleTaskSchedule(event) {
      const intendedValue = !taskInstance.value.schedule.enabled;
      event.preventDefault();
      if (intendedValue) {
        const confirmed = await showEnableDialog();
        if (confirmed) {
          enableYes().then(() => {
            taskInstance.value.schedule.enabled = true;
          });
        }
      } else {
        const confirmed = await showDisableDialog();
        if (confirmed) {
          disableYes().then(() => {
            taskInstance.value.schedule.enabled = false;
          });
        }
      }
    }
    onMounted(async () => {
      await updateTaskStatus(taskInstance.value, taskInstance.value.schedule.enabled);
      await fetchLatestLog(taskInstance.value);
      const intervalId = setInterval(async () => {
        await updateTaskStatus(taskInstance.value, taskInstance.value.schedule.enabled);
        await fetchLatestLog(taskInstance.value);
      }, 1500);
      onUnmounted(() => clearInterval(intervalId));
    });
    watch(taskInstance, async (newTask) => {
      await updateTaskStatus(newTask, taskInstance.value.schedule.enabled);
      await fetchLatestLog(newTask);
    });
    async function updateTaskStatus(task, timerEnabled) {
      let status;
      if (timerEnabled) {
        status = await myScheduler.getTimerStatus(task);
      } else {
        status = await myScheduler.getServiceStatus(task);
      }
      taskStatus.value = status.toString();
    }
    function taskStatusClass(status) {
      if (status) {
        if (status.includes("active") || status.includes("Active") || status.includes("Starting") || status.includes("Completed")) {
          return "text-success";
        } else if (status.includes("inactive") || status.includes("Disabled")) {
          return "text-warning";
        } else if (status.includes("failed") || status.includes("Failed")) {
          return "text-danger";
        } else if (status.includes("No schedule found") || status.includes("Not scheduled")) {
          return "text-muted";
        } else if (status == "Disabled") {
          return "text-45d";
        }
      }
    }
    async function fetchLatestLog(task) {
      try {
        const latestLog = await myTaskLog.getLatestEntryFor(task);
        if (latestLog) {
          if (latestLog.startDate) {
            latestTaskExecution.value = latestLog.startDate;
          } else {
            latestTaskExecution.value = latestLog.output || "Task hasn't run yet.";
          }
        } else {
          latestTaskExecution.value = "Task hasn't run yet.";
        }
      } catch (error) {
        console.error("Failed to fetch logs:", error);
      }
    }
    __expose({
      updateTaskStatus,
      fetchLatestLog
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("tr", {
          class: normalizeClass([_ctx.isExpanded ? "border-2 border-red-700 dark:border-red-800 bg-default" : "", "border border-default border-collapse grid grid-cols-8 grid-flow-cols w-full text-center items-center rounded-sm p-1"])
        }, [
          createBaseVNode("td", {
            title: taskInstance.value.name,
            class: "truncate text-base font-medium text-default border-r border-default text-left ml-4 col-span-2"
          }, toDisplayString(taskInstance.value.name), 9, _hoisted_1$6),
          taskInstance.value.schedule.enabled ? (openBlock(), createElementBlock("td", {
            key: 0,
            title: taskStatus.value,
            class: "truncate text-base font-medium text-default border-r border-default text-left ml-4 col-span-2"
          }, [
            createBaseVNode("span", {
              class: normalizeClass(taskStatusClass(taskStatus.value))
            }, toDisplayString(taskStatus.value || "N/A"), 3)
          ], 8, _hoisted_2$7)) : createCommentVNode("", true),
          !taskInstance.value.schedule.enabled ? (openBlock(), createElementBlock("td", _hoisted_3$6, [
            createBaseVNode("span", {
              class: normalizeClass(taskStatusClass(taskStatus.value))
            }, toDisplayString(taskStatus.value || "N/A"), 3)
          ])) : createCommentVNode("", true),
          createBaseVNode("td", {
            title: latestTaskExecution.value,
            class: "truncate font-medium border-r border-default text-left ml-4 col-span-2"
          }, [
            createBaseVNode("span", null, toDisplayString(latestTaskExecution.value), 1)
          ], 8, _hoisted_4$6),
          createBaseVNode("td", _hoisted_5$5, [
            taskInstance.value.schedule.intervals.length > 0 ? (openBlock(), createElementBlock("input", {
              key: 0,
              title: `Schedule is ${taskInstance.value.schedule.enabled ? "Enabled" : "Disabled"}`,
              type: "checkbox",
              checked: taskInstance.value.schedule.enabled,
              onClick: withModifiers(toggleTaskSchedule, ["prevent"]),
              class: "ml-2 h-4 w-4 rounded"
            }, null, 8, _hoisted_6$4)) : (openBlock(), createElementBlock("input", _hoisted_7$4))
          ]),
          createBaseVNode("td", _hoisted_8$4, [
            _ctx.isExpanded ? (openBlock(), createElementBlock("button", {
              key: 0,
              onClick: _cache[0] || (_cache[0] = ($event) => toggleTaskDetails()),
              class: "btn text-gray-50 bg-red-700 hover:bg-red-800 dark:hover:bg-red-900 dark:bg-red-800"
            }, "Close Details")) : (openBlock(), createElementBlock("button", {
              key: 1,
              onClick: _cache[1] || (_cache[1] = ($event) => toggleTaskDetails()),
              class: "btn btn-secondary"
            }, "View Details"))
          ]),
          _ctx.isExpanded ? (openBlock(), createElementBlock("td", _hoisted_9$4, [
            createBaseVNode("div", null, [
              createVNode(_sfc_main$8, { task: taskInstance.value }, null, 8, ["task"])
            ]),
            createBaseVNode("div", _hoisted_10$4, [
              createBaseVNode("button", {
                onClick: _cache[2] || (_cache[2] = ($event) => runTaskBtn()),
                class: "flex flex-row min-h-fit flex-nowrap btn btn-primary"
              }, [
                createTextVNode(" Run Now "),
                createVNode(unref(render$7), { class: "h-5 ml-2 mt-0.5" })
              ]),
              createBaseVNode("button", {
                onClick: _cache[3] || (_cache[3] = ($event) => editTaskBtn()),
                class: "flex flex-row min-h-fit flex-nowrap btn btn-secondary"
              }, [
                createTextVNode(" Edit Task "),
                createVNode(unref(render$8), { class: "h-5 ml-2 mt-0.5" })
              ]),
              createBaseVNode("button", {
                onClick: _cache[4] || (_cache[4] = ($event) => manageScheduleBtn()),
                class: "flex flex-row min-h-fit flex-nowrap btn btn-secondary"
              }, [
                createTextVNode(" Manage Schedule "),
                createVNode(unref(render$9), { class: "h-5 ml-2 mt-0.5" })
              ]),
              createBaseVNode("button", {
                onClick: _cache[5] || (_cache[5] = ($event) => viewLogsBtn()),
                class: "flex flex-row min-h-fit flex-nowrap btn btn-secondary"
              }, [
                createTextVNode(" View Logs "),
                createVNode(unref(render$6), { class: "h-5 ml-2 mt-0.5" })
              ]),
              createBaseVNode("button", {
                onClick: _cache[6] || (_cache[6] = ($event) => removeTaskBtn()),
                class: "flex flex-row min-h-fit flex-nowrap btn btn-danger"
              }, [
                createTextVNode(" Remove "),
                createVNode(unref(render$5), { class: "h-5 ml-2 mt-0.5" })
              ])
            ])
          ])) : createCommentVNode("", true)
        ], 2),
        showEnablePrompt.value ? (openBlock(), createElementBlock("div", _hoisted_11$3, [
          (openBlock(), createBlock(resolveDynamicComponent(enableDialog.value), {
            onClose: updateShowEnablePrompt,
            showFlag: showEnablePrompt.value,
            title: "Enable Schedule",
            message: "Do you wish to enable the schedule for this task?",
            confirmYes: enableYes,
            confirmNo: enableNo,
            operating: enabling.value,
            operation: "enabling"
          }, null, 40, ["showFlag", "operating"]))
        ])) : createCommentVNode("", true),
        showDisablePrompt.value ? (openBlock(), createElementBlock("div", _hoisted_12$2, [
          (openBlock(), createBlock(resolveDynamicComponent(disableDialog.value), {
            onClose: updateShowDisablePrompt,
            showFlag: showDisablePrompt.value,
            title: "Disable Schedule",
            message: "Do you wish to disable the schedule for this task?",
            confirmYes: disableYes,
            confirmNo: disableNo,
            operating: disabling.value,
            operation: "disabling"
          }, null, 40, ["showFlag", "operating"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
var __defProp2 = Object.defineProperty;
var __defNormalProp2 = (obj, key, value) => key in obj ? __defProp2(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField2 = (obj, key, value) => {
  __defNormalProp2(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
const _sfc_main$d = defineComponent({});
const _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _hoisted_1$a = { class: "aspect-square animate-spin border-2 border-neutral-300 border-t-neutral-500 dark:border-neutral-500 dark:border-t-neutral-200 rounded-full" };
function _sfc_render$6(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$a);
}
const LoadingSpinner = /* @__PURE__ */ _export_sfc(_sfc_main$d, [["render", _sfc_render$6], ["__scopeId", "data-v-648425c9"]]);
const defaultErrorConfig = {
  withStackTrace: false
};
const createNeverThrowError = (message, result, config = defaultErrorConfig) => {
  const data = result.isOk() ? { type: "Ok", value: result.value } : { type: "Err", value: result.error };
  const maybeStack = config.withStackTrace ? new Error().stack : void 0;
  return {
    data,
    message,
    stack: maybeStack
  };
};
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve2) {
      resolve2(value);
    });
  }
  return new (P || (P = Promise))(function(resolve2, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve2(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, [])).next());
  });
}
function __values(o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m)
    return m.call(o);
  if (o && typeof o.length === "number")
    return {
      next: function() {
        if (o && i >= o.length)
          o = void 0;
        return { value: o && o[i++], done: !o };
      }
    };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __await(v) {
  return this instanceof __await ? (this.v = v, this) : new __await(v);
}
function __asyncGenerator(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g2 = generator.apply(thisArg, _arguments || []), i, q = [];
  return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function verb(n) {
    if (g2[n])
      i[n] = function(v) {
        return new Promise(function(a, b) {
          q.push([n, v, a, b]) > 1 || resume(n, v);
        });
      };
  }
  function resume(n, v) {
    try {
      step(g2[n](v));
    } catch (e) {
      settle(q[0][3], e);
    }
  }
  function step(r) {
    r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f, v) {
    if (f(v), q.shift(), q.length)
      resume(q[0][0], q[0][1]);
  }
}
function __asyncDelegator(o) {
  var i, p2;
  return i = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i[Symbol.iterator] = function() {
    return this;
  }, i;
  function verb(n, f) {
    i[n] = o[n] ? function(v) {
      return (p2 = !p2) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v;
    } : f;
  }
}
function __asyncValues(o) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m = o[Symbol.asyncIterator], i;
  return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i);
  function verb(n) {
    i[n] = o[n] && function(v) {
      return new Promise(function(resolve2, reject) {
        v = o[n](v), settle(resolve2, reject, v.done, v.value);
      });
    };
  }
  function settle(resolve2, reject, d, v) {
    Promise.resolve(v).then(function(v2) {
      resolve2({ value: v2, done: d });
    }, reject);
  }
}
class ResultAsync {
  constructor(res) {
    this._promise = res;
  }
  static fromSafePromise(promise) {
    const newPromise = promise.then((value) => new Ok(value));
    return new ResultAsync(newPromise);
  }
  static fromPromise(promise, errorFn) {
    const newPromise = promise.then((value) => new Ok(value)).catch((e) => new Err(errorFn(e)));
    return new ResultAsync(newPromise);
  }
  static fromThrowable(fn, errorFn) {
    return (...args) => {
      return new ResultAsync((() => __awaiter(this, void 0, void 0, function* () {
        try {
          return new Ok(yield fn(...args));
        } catch (error) {
          return new Err(errorFn ? errorFn(error) : error);
        }
      }))());
    };
  }
  static combine(asyncResultList) {
    return combineResultAsyncList(asyncResultList);
  }
  static combineWithAllErrors(asyncResultList) {
    return combineResultAsyncListWithAllErrors(asyncResultList);
  }
  map(f) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, void 0, void 0, function* () {
      if (res.isErr()) {
        return new Err(res.error);
      }
      return new Ok(yield f(res.value));
    })));
  }
  mapErr(f) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, void 0, void 0, function* () {
      if (res.isOk()) {
        return new Ok(res.value);
      }
      return new Err(yield f(res.error));
    })));
  }
  andThen(f) {
    return new ResultAsync(this._promise.then((res) => {
      if (res.isErr()) {
        return new Err(res.error);
      }
      const newValue = f(res.value);
      return newValue instanceof ResultAsync ? newValue._promise : newValue;
    }));
  }
  orElse(f) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, void 0, void 0, function* () {
      if (res.isErr()) {
        return f(res.error);
      }
      return new Ok(res.value);
    })));
  }
  match(ok2, _err) {
    return this._promise.then((res) => res.match(ok2, _err));
  }
  unwrapOr(t) {
    return this._promise.then((res) => res.unwrapOr(t));
  }
  safeUnwrap() {
    return __asyncGenerator(this, arguments, function* safeUnwrap_1() {
      return yield __await(yield __await(yield* __asyncDelegator(__asyncValues(yield __await(this._promise.then((res) => res.safeUnwrap()))))));
    });
  }
  then(successCallback, failureCallback) {
    return this._promise.then(successCallback, failureCallback);
  }
}
const errAsync = (err2) => new ResultAsync(Promise.resolve(new Err(err2)));
ResultAsync.fromPromise;
ResultAsync.fromSafePromise;
ResultAsync.fromThrowable;
const appendValueToEndOfList = (value) => (list) => [...list, value];
const combineResultList = (resultList) => resultList.reduce((acc, result) => acc.isOk() ? result.isErr() ? err(result.error) : acc.map(appendValueToEndOfList(result.value)) : acc, ok([]));
const combineResultAsyncList = (asyncResultList) => ResultAsync.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultList);
const combineResultListWithAllErrors = (resultList) => resultList.reduce((acc, result) => result.isErr() ? acc.isErr() ? err([...acc.error, result.error]) : err([result.error]) : acc.isErr() ? acc : ok([...acc.value, result.value]), ok([]));
const combineResultAsyncListWithAllErrors = (asyncResultList) => ResultAsync.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultListWithAllErrors);
var Result;
(function(Result2) {
  function fromThrowable(fn, errorFn) {
    return (...args) => {
      try {
        const result = fn(...args);
        return ok(result);
      } catch (e) {
        return err(errorFn ? errorFn(e) : e);
      }
    };
  }
  Result2.fromThrowable = fromThrowable;
  function combine(resultList) {
    return combineResultList(resultList);
  }
  Result2.combine = combine;
  function combineWithAllErrors(resultList) {
    return combineResultListWithAllErrors(resultList);
  }
  Result2.combineWithAllErrors = combineWithAllErrors;
})(Result || (Result = {}));
const ok = (value) => new Ok(value);
const err = (err2) => new Err(err2);
class Ok {
  constructor(value) {
    this.value = value;
  }
  isOk() {
    return true;
  }
  isErr() {
    return !this.isOk();
  }
  map(f) {
    return ok(f(this.value));
  }
  mapErr(_f) {
    return ok(this.value);
  }
  andThen(f) {
    return f(this.value);
  }
  orElse(_f) {
    return ok(this.value);
  }
  asyncAndThen(f) {
    return f(this.value);
  }
  asyncMap(f) {
    return ResultAsync.fromSafePromise(f(this.value));
  }
  unwrapOr(_v) {
    return this.value;
  }
  match(ok2, _err) {
    return ok2(this.value);
  }
  safeUnwrap() {
    const value = this.value;
    return function* () {
      return value;
    }();
  }
  _unsafeUnwrap(_) {
    return this.value;
  }
  _unsafeUnwrapErr(config) {
    throw createNeverThrowError("Called `_unsafeUnwrapErr` on an Ok", this, config);
  }
}
class Err {
  constructor(error) {
    this.error = error;
  }
  isOk() {
    return false;
  }
  isErr() {
    return !this.isOk();
  }
  map(_f) {
    return err(this.error);
  }
  mapErr(f) {
    return err(f(this.error));
  }
  andThen(_f) {
    return err(this.error);
  }
  orElse(f) {
    return f(this.error);
  }
  asyncAndThen(_f) {
    return errAsync(this.error);
  }
  asyncMap(_f) {
    return errAsync(this.error);
  }
  unwrapOr(v) {
    return v;
  }
  match(_ok, err2) {
    return err2(this.error);
  }
  safeUnwrap() {
    const error = this.error;
    return function* () {
      yield err(error);
      throw new Error("Do not use this generator out of `safeTry`");
    }();
  }
  _unsafeUnwrap(config) {
    throw createNeverThrowError("Called `_unsafeUnwrap` on an Err", this, config);
  }
  _unsafeUnwrapErr(_) {
    return this.error;
  }
}
Result.fromThrowable;
const globalProcessingState = ref$1(0);
function useGlobalProcessingState() {
  return globalProcessingState;
}
const darkModeState = ref$1(false);
function isCockpitStyleValue(value) {
  return value !== null && ["auto", "dark", "light"].includes(value);
}
const setDarkMode = (style2) => {
  var _a2;
  var _a;
  style2 = (_a2 = style2 != null ? style2 : localStorage.getItem("shell:style")) != null ? _a2 : "auto";
  if (((_a = window.matchMedia) == null ? void 0 : _a.call(window, "(prefers-color-scheme: dark)").matches) && style2 === "auto" || style2 === "dark") {
    darkModeState.value = true;
    document.documentElement.classList.add("dark");
    console.log("setting dark mode");
  } else {
    darkModeState.value = false;
    document.documentElement.classList.remove("dark");
    console.log("unsetting dark mode");
  }
};
window.addEventListener("storage", (event) => {
  console.log("storage event listener:", event);
  if (event.key === "shell:style" && isCockpitStyleValue(event.newValue)) {
    setDarkMode(event.newValue);
  }
});
window.addEventListener("cockpit-style", (event) => {
  var _a;
  console.log("cockpit-style event listener:", event);
  const styleEvent = event;
  const style2 = (_a = styleEvent.detail) == null ? void 0 : _a.style;
  if (style2 === void 0 || !isCockpitStyleValue(style2)) {
    return;
  }
  setDarkMode(style2);
});
window.matchMedia("(prefers-color-scheme: dark)").addEventListener("change", () => {
  setDarkMode();
});
setDarkMode();
function useDarkModeState() {
  return darkModeState;
}
const _hoisted_1$9 = {
  viewBox: "0 0 927.2956 162.9455",
  version: "1.1"
};
const _hoisted_2$6 = ["fill"];
const _hoisted_3$5 = ["fill"];
const _hoisted_4$5 = ["fill"];
const _hoisted_5$4 = ["fill"];
const _hoisted_6$3 = ["fill"];
const _hoisted_7$3 = ["fill"];
const _hoisted_8$3 = ["fill"];
const _hoisted_9$3 = ["fill"];
const _hoisted_10$3 = ["fill"];
const _sfc_main$c = /* @__PURE__ */ defineComponent({
  __name: "Logo45Drives",
  setup(__props) {
    const darkMode = useDarkModeState();
    const colorFanAnd45 = computed(() => darkMode.value ? "#FFFFFF" : "#333333");
    const colorDrives = computed(() => darkMode.value ? "#DC2626" : "#981c20");
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("svg", _hoisted_1$9, [
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorFanAnd45.value,
          "fill-opacity": "1",
          d: "m 84.980446,60.092653 c -8.78957,-1.65104 -17.43357,2.98987 -21.35048,9.44463 0.16472,0.046 0.3218,0.10348 0.48267,0.13023 3.7407,0.64932 7.44883,1.4461 11.0995,2.49763 0.34284,0.0995 0.62631,0.0709 0.93853,-0.12258 1.1109,-0.68761 2.31567,-1.15112 3.61235,-1.33691 0.35626,-0.0498 0.54205,-0.20686 0.69911,-0.51716 1.59357,-3.12394 3.0684,-6.30344 4.34785,-9.57104 0.0652,-0.16855 0.11301,-0.34668 0.17047,-0.5248 m -15.11406,39.15754 c 0.0575,-0.27389 0.11108,-0.49607 0.1513,-0.72209 0.61675,-3.57787 1.38481,-7.12512 2.38844,-10.61491 0.15707,-0.54779 0.1111,-0.98831 -0.17621,-1.4729 -0.79295,-1.32734 -1.24881,-2.77152 -1.3235,-4.32296 -0.0173,-0.37733 -0.15898,-0.58418 -0.52099,-0.74315 -3.07606,-1.34842 -6.18852,-2.60298 -9.36992,-3.68132 -0.18962,-0.0632 -0.38306,-0.113 -0.57843,-0.17047 -1.7219,9.07304 2.82323,17.59447 9.42931,21.7278 m 32.947954,-14.54713 c 0.73932,-4.91289 0.0134,-9.50974 -2.36164,-13.76375 -1.980484,-3.54915 -4.706034,-6.43942 -8.421824,-8.44288 -0.0881,0.64354 -0.16856,1.19326 -0.24134,1.74297 -0.43286,3.29057 -0.99981,6.55818 -1.7085,9.79896 -0.0823,0.37541 -0.0478,0.67421 0.18388,0.99024 0.97684,1.335 1.63572,2.80982 1.87514,4.45512 0.0478,0.32369 0.20302,0.49991 0.49415,0.64929 3.14694,1.59551 6.33218,3.10098 9.626594,4.37085 0.15131,0.0593 0.30645,0.11109 0.55354,0.1992 M 77.843826,102.34732 c 2.11456,0.76615 8.17091,0.4616 11.91543,-1.15304 4.56813,-1.970887 8.06558,-5.091007 10.630234,-9.456117 -0.551614,-0.0843 -0.997904,-0.1628 -1.444184,-0.21834 -3.33463,-0.4233 -6.64054,-0.99408 -9.92346,-1.70276 -0.53246,-0.11492 -0.94236,-0.0556 -1.40394,0.249 -1.31394,0.86575 -2.69875,1.58591 -4.30382,1.7583 -0.47308,0.0497 -0.94235,0.13215 -1.42119,0.20111 -1.51887,3.39593 -2.9056,6.80908 -4.04907,10.321847 m 10.57085,-53.235397 c -5.29405,-1.1588 -10.5019,-0.91363 -15.61973,0.45584 -6.94124,1.85982 -12.5609,5.80545 -17.0524,11.39255 -1.63381,2.03028 -4.11802,6.24405 -4.18697,7.18641 0.14556,0.0134 0.29113,0.0249 0.43477,0.0383 1.64147,0.15706 3.28484,0.29687 4.92438,0.475 1.38863,0.15132 2.77536,0.3352 4.16017,0.53057 0.40031,0.0556 0.64929,-0.0344 0.88872,-0.38116 0.57077,-0.82361 1.18369,-1.61848 1.80235,-2.40761 2.85006,-3.63918 6.57733,-5.9874 10.93668,-7.3971 1.86173,-0.60142 3.78665,-0.82553 5.72691,-0.97109 1.37906,-0.10151 2.75429,-0.0613 4.12569,0.12066 0.36582,0.0479 0.73358,0.0939 1.09941,0.13983 1.10325,-3.02243 2.05134,-6.01997 2.76002,-9.18222 M 68.424116,111.3725 c 0.0365,-0.24517 0.0709,-0.42522 0.0881,-0.60908 0.16662,-1.7449 0.31602,-3.49362 0.50182,-5.23659 0.13024,-1.22391 0.29305,-2.44591 0.48267,-3.66217 0.0727,-0.47309 -0.004,-0.79869 -0.45011,-1.03236 -0.2739,-0.14367 -0.5114,-0.35818 -0.76424,-0.54588 -1.59739,-1.181777 -3.16798,-2.398027 -4.44745,-3.932227 -4.56046,-5.46643 -6.20958,-11.75263 -5.23849,-18.76475 0.0268,-0.20302 0.0421,-0.40796 0.067,-0.65697 -3.05882,-0.96342 -6.11381,-1.81385 -9.23201,-2.4344 -3.42274,16.10621 5.4894,30.957887 18.99267,36.874427 M 104.55727,85.317903 c 1.41929,0.67995 7.58673,2.53786 9.13625,2.74471 3.3423,-14.86317 -4.53364,-31.03834 -19.532804,-37.12726 -0.58993,3.21396 -1.18177,6.42984 -1.78702,9.72426 4.49342,2.31949 7.835724,5.81118 10.099674,10.33143 2.27544,4.53938 2.7447,9.3546 2.0839,14.32686 M 74.815616,113.38362 c 6.42411,1.58975 15.88023,0.97874 23.75425,-3.96096 6.046784,-3.7924 10.643644,-8.89301 13.357704,-15.562277 -3.26568,-0.60908 -6.45859,-1.20666 -9.72618,-1.81766 -1.59549,2.89219 -3.587474,5.49132 -6.249824,7.535 -2.66617,2.047527 -5.57751,3.610447 -8.87958,4.313397 -3.24078,0.68761 -6.51413,0.93469 -9.77598,0.26239 -0.54588,1.29096 -1.9958,6.7095 -2.48039,9.23011 M 49.619106,67.962863 c 2.13371,-4.92437 5.08718,-9.32779 9.22817,-12.88078 4.12762,-3.53766 8.80491,-6.05252 14.07214,-7.38369 5.24616,-1.32542 10.5517,-1.45568 15.84957,-0.34668 0.50374,-1.42503 1.5725,-8.76084 1.42311,-9.67446 -24.59509,-4.84969 -45.44182,11.26421 -50.91592,30.06343 3.39593,0.0727 6.79569,0.14556 10.34293,0.22218 m -11.62812,4.76349 c -1.80045,8.11728 -1.38097,20.72606 5.79586,32.020927 5.80736,9.14199 13.82696,15.5546 24.28289,18.82413 0.0134,-0.15899 0.0326,-0.29881 0.0364,-0.44055 0.0651,-3.15267 0.12449,-6.30535 0.20686,-9.45803 0.008,-0.31411 -0.11683,-0.44627 -0.36393,-0.56502 -0.69527,-0.33711 -1.38288,-0.68953 -2.07431,-1.03238 -3.55108,-1.76213 -6.72291,-4.03374 -9.43123,-6.94508 -2.20265,-2.36929 -4.09311,-4.95694 -5.59093,-7.826137 -2.26585,-4.33637 -3.56256,-8.93323 -3.82879,-13.8327 -0.14939,-2.72365 -0.0748,-5.4243 0.40796,-8.10963 0.0727,-0.40223 0.12452,-0.80829 0.19154,-1.24497 -3.23503,-0.62633 -6.42218,-1.109 -9.63231,-1.39056 m 35.09123,52.180057 c 24.03198,4.65814 44.970654,-10.66472 50.806754,-30.099837 -3.34423,-0.22983 -6.69035,-0.4616 -10.12458,-0.6991 -1.66061,3.60087 -3.50893,7.174917 -6.26704,10.187787 -2.76003,3.01476 -5.88781,5.56219 -9.496344,7.49286 -3.58172,1.91727 -7.36455,3.25228 -11.41361,3.76369 -4.04141,0.51139 -8.07132,0.53437 -12.05718,-0.35818 -0.4003,0.91938 -1.52271,8.48694 -1.448,9.71278 m 21.34282,-75.855777 c 0.0958,0.0536 0.22027,0.12832 0.34858,0.19154 0.86385,0.42137 1.72766,0.83893 2.5915,1.25838 3.882414,1.89238 7.228544,4.48194 10.084344,7.71698 3.61237,4.09121 6.19043,8.73977 7.62695,14.01466 0.64165,2.35014 0.91745,4.75392 1.07452,7.17301 0.15897,2.44591 0.067,4.88415 -0.35243,7.30326 -0.10151,0.59184 -0.19345,1.18368 -0.29496,1.81191 3.2427,0.65697 6.43559,1.20285 9.73576,1.46718 1.99963,-11.50938 0.34284,-22.33114 -5.88589,-32.19714 -5.76714,-9.13434 -13.80973,-15.53737 -24.215874,-18.78199 -0.23365,3.30015 -0.46925,6.62522 -0.7125,10.04221 m 0.72974,-12.04184 c 0.98068,0.362 1.95942,0.72016 2.93625,1.08408 9.705114,3.62194 17.201814,9.95411 22.725704,18.65367 2.08966,3.28866 3.70047,6.82249 4.88991,10.54211 0.57461,1.79278 1.03429,3.61429 1.35799,5.46452 0.45586,2.59531 0.65505,5.22317 0.74698,7.85296 0.10152,2.9075 -0.15897,5.79969 -0.67228,8.66506 -0.0498,0.27773 -0.0843,0.55737 -0.13217,0.87532 3.29442,0.25283 6.4988,0.3237 9.75299,0.24516 2.12606,-14.54711 -0.48841,-28.06188 -8.75508,-40.2014 -8.09813,-11.89245 -19.14591,-19.79521 -33.271664,-23.2256 0.14174,3.35186 0.27964,6.66351 0.42137,10.04412 m -57.83993,30.76445 c 0.19921,-0.54205 0.40798,-1.086 0.60335,-1.63572 1.53803,-4.33061 3.49744,-8.43905 6.27471,-12.13378 2.13945,-2.85005 4.51641,-5.47792 7.19982,-7.81848 3.50127,-3.05691 7.41052,-5.47984 11.66643,-7.34731 3.41509,-1.49973 6.93934,-2.66235 10.64556,-3.15267 2.2333,-0.29496 4.48576,-0.45395 6.73247,-0.62442 2.46698,-0.1877 4.92247,0.0268 7.36839,0.35243 0.86381,0.11301 1.72381,0.25858 2.62977,0.39648 0.23943,-3.24078 0.38499,-6.43942 0.24709,-9.63807 -12.28127,-2.17585 -28.90465,-0.15705 -42.62243,10.40038 -10.59575,8.15368 -17.73237,18.60195 -20.8544,31.7432 3.39975,-0.18195 6.7095,-0.36008 10.10924,-0.54204 m 88.456914,27.05441 c -3.49552,11.193337 -10.26822,19.919697 -20.31045,26.041177 -10.067104,6.13873 -20.994224,7.74953 -32.595524,5.88972 -0.23941,3.23504 -0.40031,6.45092 -0.31028,9.66488 33.225684,5.33235 58.539024,-18.70728 63.279534,-42.017167 -3.31164,0.13792 -6.62139,0.27773 -10.06328,0.42139 M 26.452896,72.216873 c -2.11074,11.97672 -0.28348,28.552207 10.26055,42.394497 8.16134,10.71449 18.69197,17.88942 31.91366,21.02868 -0.18194,-3.40549 -0.36199,-6.73629 -0.54395,-10.09584 -0.15706,-0.0632 -0.32753,-0.1379 -0.4999,-0.20111 -2.43443,-0.88297 -4.86884,-1.76787 -7.1826,-2.94007 -5.0527,-2.56083 -9.42547,-6.01805 -13.21595,-10.20886 -4.57961,-5.06611 -7.82997,-10.90029 -9.88133,-17.408667 -0.98449,-3.12394 -1.50356,-6.33215 -1.74298,-9.59017 -0.0995,-1.33309 -0.2394,-2.6681 -0.23557,-4.0031 0.008,-2.12796 0.10725,-4.25784 0.45009,-6.36665 0.11876,-0.7355 0.22219,-1.4729 0.33904,-2.26203 -3.24271,-0.26049 -6.42604,-0.37925 -9.66106,-0.34668 M 148.4496,89.673423 c 0.0308,-0.10338 0.0593,-0.16088 0.067,-0.22027 0.28346,-2.11455 0.46926,-4.23675 0.48458,-6.36663 0.0115,-1.58784 -0.0517,-3.17376 -0.11109,-4.75966 -0.0919,-2.5053 -0.2988,-5.00292 -0.66463,-7.48139 -0.85808,-5.79969 -2.57423,-11.34658 -4.89374,-16.71723 -3.79623,-8.79341 -9.41205,-16.26903 -16.45865,-22.70272 -2.57807,-2.35588 -5.28063,-4.56047 -8.19198,-6.49689 -4.25976,-2.8328 -8.81447,-5.091 -13.5952,-6.90101 -3.74069,-1.41545 -7.628864,-2.28694 -11.528534,-3.1182 -0.13025,-0.0268 -0.27198,-0.004 -0.38306,-0.004 0.46733,3.39593 0.9251,6.74012 1.3867,10.10732 0.49609,0.1379 0.99599,0.28731 1.49973,0.41947 3.17566,0.82743 6.284294,1.86938 9.268414,3.21971 7.94489,3.59513 14.7425,8.73784 20.36599,15.40712 6.26129,7.42584 10.37739,15.90512 12.38659,25.40721 0.66847,3.1546 0.91747,6.35706 1.0956,9.57103 0.18387,3.32698 0.0498,6.63862 -0.41947,9.93495 -0.0632,0.44437 -0.10918,0.89063 -0.16854,1.39055 3.35569,-0.1494 6.61946,-0.33328 9.86025,-0.68954 M 89.973726,14.392413 c -0.15322,-0.0383 -0.25281,-0.0785 -0.35433,-0.0881 -1.6836,-0.1379 -3.36912,-0.2988 -5.05654,-0.40222 -2.42293,-0.1494 -4.84394,-0.0173 -7.26303,0.13215 -2.45931,0.15132 -4.91482,0.36584 -7.34731,0.77381 -3.94181,0.66463 -7.7706,1.74871 -11.52661,3.1048 -10.32377,3.72918 -19.08078,9.78171 -26.49514,17.83386 -4.77498,5.18487 -8.75125,10.89838 -11.64345,17.34548 -0.9615,2.14519 -1.8962,4.29996 -2.63169,6.53327 -1.02663,3.11819 -1.76214,6.3111 -2.42293,9.52124 -0.0401,0.19345 -0.0689,0.38882 -0.10535,0.59759 3.42275,-0.42329 6.77079,-0.83701 10.15715,-1.25648 0.0652,-0.19154 0.14364,-0.40414 0.20685,-0.62249 0.22218,-0.78338 0.44436,-1.56676 0.65889,-2.35205 1.25647,-4.59494 3.03392,-8.97345 5.42236,-13.09722 1.62614,-2.8079 3.4917,-5.45109 5.55263,-7.95255 2.26394,-2.75046 4.76349,-5.26915 7.5101,-7.53693 9.30289,-7.67674 19.95418,-12.08015 31.97496,-13.16424 3.93031,-0.35434 7.84531,-0.2241 11.75646,0.24133 0.73742,0.0881 1.47866,0.15515 2.27545,0.23751 -0.0996,-3.34229 -0.31987,-6.60223 -0.66847,-9.84875 m 47.843704,79.83587 c -0.18388,0.64547 -0.38499,1.3235 -0.57078,2.00538 -1.17795,4.345937 -2.7313,8.542487 -4.91482,12.497687 -3.19672,5.79588 -7.20555,10.94627 -12.12037,15.3784 -4.83628,4.35935 -10.25097,7.81849 -16.25562,10.34101 -3.997354,1.67785 -8.117274,2.96306 -12.400024,3.65641 -3.89967,0.63208 -7.83189,0.90022 -11.78519,0.80636 -2.00538,-0.0478 -4.00118,-0.20111 -5.98548,-0.49224 -0.38307,-0.0575 -0.77189,-0.0843 -1.21816,-0.13216 0.0861,3.33464 0.26431,6.60032 0.62823,9.94453 17.33205,1.90387 33.170134,-1.98048 47.485514,-11.95756 14.68887,-10.94627 24.10476,-25.208 27.31489,-43.423047 -3.40741,0.45969 -6.76695,0.91363 -10.17819,1.37523 M 14.688796,72.871903 c -2.13563,16.2384 1.80042,36.866787 16.42035,53.068787 10.52871,11.66835 23.38841,19.02523 38.94303,21.76226 -0.42331,-3.42656 -0.83702,-6.77459 -1.2565,-10.16287 -0.50947,-0.13982 -1.02661,-0.29113 -1.55143,-0.4252 -6.4739,-1.65297 -12.49004,-4.30765 -18.01775,-8.08664 -7.96788,-5.44727 -14.21962,-12.42109 -18.7341,-20.94443 -4.54322,-8.575027 -6.62905,-17.749597 -6.59458,-27.427897 0.01,-2.55125 0.20686,-5.09101 0.57844,-7.61546 0.0344,-0.23557 0.0401,-0.47691 0.0632,-0.76231 -3.34996,0.0422 -6.60991,0.26433 -9.85068,0.59376 M 3.2234465,71.954453 c 0.19537,-0.0152 0.30072,-0.0134 0.40223,-0.0326 3.07415,-0.58419 6.14638,-1.1741 9.2205195,-1.75445 0.28539,-0.0536 0.4367,-0.1858 0.49033,-0.47311 0.12067,-0.6359 0.26241,-1.26796 0.39649,-1.90003 0.64929,-3.0818 1.40011,-6.13872 2.36354,-9.14008 0.79296,-2.4689 1.79086,-4.85926 2.94199,-7.17684 8.87002,-17.88942 22.75253,-30.03087 41.73752,-36.28832 3.25612,-1.07261 6.58309,-1.89621 9.98667,-2.32141 2.2563,-0.28348 4.52791,-0.45203 6.79568,-0.6474 3.63152,-0.31412 7.26112,-0.25283 10.88689,0.1379 0.4233,0.046 0.85042,0.067 1.32543,0.10339 -0.34476,-3.3346402 -0.82359,-6.5658402 -1.36947,-9.7740602 -16.60039,-1.51313 -38.52932,2.37312 -56.76542,17.5235902 -16.22307,13.47835 -25.6389695,30.76061 -28.4123995,51.74334 M 92.816176,12.909723 c 0.35818,0.0766 0.72402,0.15896 1.08985,0.23366 3.00519,0.62058 6.00847,1.25456 8.935134,2.18926 8.24945,2.63553 15.70593,6.75162 22.42307,12.20081 7.29752,5.92036 13.1451,13.04932 17.54467,21.35431 5.11401,9.65531 7.76295,19.95418 7.99279,30.87553 0.0594,2.84431 -0.10727,5.67905 -0.36775,8.50993 -0.0344,0.3869 -0.046,0.77574 -0.0727,1.22582 3.33846,-0.39456 6.59267,-0.80826 9.88899,-1.43076 1.2967,-21.17618 -4.14674,-40.21865 -17.60021,-56.72327 C 126.80811,11.909893 105.6281,4.4036228 90.617446,2.9422028 c 0.72784,3.29825 1.45376,6.59073 2.19884,9.9675202 M 70.347216,149.59911 c -1.04196,-0.2241 -2.08008,-0.44629 -3.1182,-0.67421 -3.32315,-0.73167 -6.61947,-1.55527 -9.8162,-2.74472 -5.49133,-2.04367 -10.61491,-4.78263 -15.42053,-8.1211 -4.70795,-3.2676 -8.93132,-7.08107 -12.68732,-11.40595 -4.57962,-5.27298 -8.29542,-11.09757 -11.10141,-17.49678 -1.97665,-4.50683 -3.50127,-9.159237 -4.48384,-13.987827 -0.56886,-2.78686 -0.88874,-5.60817 -1.08985,-8.44099 -0.12641,-1.79086 -0.22026,-3.58554 -0.2643,-5.38023 -0.0575,-2.3827 0.0882,-4.75966 0.34284,-7.12897 0.0401,-0.36583 0.0593,-0.73166 0.0862,-1.09749 -1.20668,-0.0401 -9.0385695,1.10707 -9.8104595,1.42119 -1.92301,23.00344 6.00465,47.495087 25.6102295,65.196817 12.42684,11.22015 26.98928,17.86453 43.67012,19.83542 -0.64548,-3.35953 -1.27946,-6.65394 -1.91727,-9.97516 m 4.43213,10.25481 c 18.74561,1.63955 42.951874,-3.33272 62.124584,-22.33114 13.16425,-13.04357 20.8161,-28.81269 23.03216,-47.242267 -3.36528,0.74508 -6.65968,1.47292 -9.99049,2.21033 -0.0518,0.20112 -0.11492,0.41947 -0.16472,0.63972 -0.38499,1.71042 -0.76231,3.42275 -1.15496,5.13125 -0.59951,2.608707 -1.35799,5.171447 -2.30801,7.670987 -1.1224,2.94966 -2.47272,5.79971 -3.99543,8.56548 -3.79432,6.88762 -8.59995,12.97653 -14.44369,18.23611 -5.15997,4.64283 -10.88115,8.45247 -17.18651,11.35806 -6.39345,2.94582 -13.049324,5.01824 -20.065274,5.79204 -3.77516,0.41563 -7.56565,0.71825 -11.37147,0.55929 -1.335,-0.0556 -2.66618,-0.15515 -3.99927,-0.24326 -0.59758,-0.0403 -1.19325,-0.10151 -1.87321,-0.15897 0.34859,3.33846 0.80637,6.59075 1.39629,9.81237 M 162.94896,81.492863 c -0.006,45.072167 -36.5086,81.544377 -81.655474,81.452447 C 36.481816,162.85531 -0.04212354,126.70485 3.6462668e-5,81.389443 0.04013646,36.133393 36.619716,-0.1013072 81.649746,2.1280257e-4 126.86173,0.1035928 162.93556,36.704173 162.94896,81.492863",
          id: "path2"
        }, null, 8, _hoisted_2$6),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorFanAnd45.value,
          "fill-opacity": "1",
          d: "m 237.2253,77.106913 c 0,-8.39843 0.76172,-21.21093 1.17579,-29.60937 h -0.83204 c -3.32812,7.46875 -7.07812,14.79297 -10.82421,22.33594 l -17.34766,28.85547 h 71.62109 V 122.00926 H 180.07296 V 100.8452 l 48.25781,-79.484377 h 37.4336 V 153.54832 H 237.2253 Z m 0,0",
          id: "path4"
        }, null, 8, _hoisted_3$5),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorFanAnd45.value,
          "fill-opacity": "1",
          d: "m 292.35421,137.45848 13.76953,-19.32813 c 7.91016,7.29688 17.28906,13.22266 28.54688,13.22266 13.51562,0 22.20312,-7.17188 22.20312,-20.73438 0,-13.218747 -8.51562,-20.441397 -20.75781,-20.441397 -7.66406,0 -11.65234,1.6914 -19.5625,6.75781 l -13.64453,-8.81641 3.625,-66.75781 h 74.96484 v 25.72266 h -48.55859 l -2.17578,24.79297 c 5.01562,-2.14063 9.2539,-3.03516 14.6875,-3.03516 22.82031,0 42.09375,12.90625 42.09375,41.019527 0,29.33594 -22.70313,46.18359 -48.48828,46.18359 -21.57422,0 -36.32032,-8.20312 -46.70313,-18.58593",
          id: "path6"
        }, null, 8, _hoisted_4$5),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 449.63155,139.60301 c 31.23438,0 46.81641,-19.57422 46.81641,-53.351557 0,-33.78125 -15.58203,-52.39063 -46.81641,-52.39063 H 434.4714 V 139.60301 Z M 417.46749,19.915513 h 33.42969 c 41.08594,0 63.11328,23.8789 63.11328,66.33594 0,42.453117 -22.02734,67.296867 -62.36719,67.296867 h -34.17578 z m 0,0",
          id: "path8"
        }, null, 8, _hoisted_5$4),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 542.74484,54.575663 h 13.83203 l 1.41406,18.02344 h 0.55859 c 6.89063,-12.55859 17.00391,-20.46875 28.14063,-20.46875 4.3789,0 7.45703,0.5586 10.5625,2.03906 l -3.125,14.69141 c -3.40625,-1.07422 -5.63672,-1.62891 -9.60156,-1.62891 -8.35938,0 -18.34375,6.02344 -25.03516,22.76563 v 63.550777 h -16.74609 z m 0,0",
          id: "path10"
        }, null, 8, _hoisted_6$3),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 615.01827,54.575663 h 16.7461 v 98.972657 h -16.7461 z m -3.0664,-31.16406 c 0,-6.57812 5.05859,-10.8164 11.5664,-10.8164 6.51563,0 11.57032,4.23828 11.57032,10.8164 0,6.32031 -5.05469,10.82031 -11.57032,10.82031 -6.50781,0 -11.5664,-4.5 -11.5664,-10.82031",
          id: "path12"
        }, null, 8, _hoisted_7$3),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 652.4753,54.575663 h 17.26172 l 18.71485,56.222657 c 2.95703,9.66797 6.17187,19.73828 9.13281,29.19141 h 0.8125 c 2.95703,-9.45313 6.17187,-19.52344 9.13281,-29.19141 l 18.71485,-56.222657 h 16.40625 l -35,98.972657 h -19.46875 z m 0,0",
          id: "path14"
        }, null, 8, _hoisted_8$3),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 824.45968,96.091293 c 0,-19.83203 -8.918,-30.61328 -24.3945,-30.61328 -13.918,0 -26.3516,11.16797 -28.3868,30.61328 z m -69.1875,8.097657 c 0,-32.210937 21.7109,-52.058597 44.4922,-52.058597 25.2422,0 39.4961,18.13281 39.4961,46.44141 0,3.535147 -0.3008,7.070307 -0.7813,9.515617 h -66.6523 c 1.1992,20.96485 14.0195,34.5586 32.8828,34.5586 9.4961,0 17.3008,-3.06641 24.6289,-7.91016 l 6,10.99219 c -8.6797,5.67578 -19.2226,10.26172 -32.6836,10.26172 -26.3789,0 -47.3828,-19.28907 -47.3828,-51.80078",
          id: "path16"
        }, null, 8, _hoisted_9$3),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 854.26048,142.25145 8.2695,-11.03125 c 8.5938,6.92578 17.3281,11.72656 29.2149,11.72656 12.9921,0 19.4453,-6.92578 19.4453,-15.375 0,-10.1836 -11.6836,-14.6836 -22.6328,-18.75391 -13.8711,-5.07031 -29.5157,-11.894527 -29.5157,-28.589837 0,-15.83594 12.6836,-28.09375 34.1368,-28.09375 12.3203,0 23.1015,5.04297 30.7734,11.11719 l -8.0117,10.73437 c -6.8164,-5.03906 -13.8125,-8.80859 -22.5703,-8.80859 -12.4649,0 -18.2227,6.64453 -18.2227,14.1914 0,9.41016 10.7617,12.99219 21.9688,17.17188 14.2773,5.382807 30.1796,11.187497 30.1796,30.027337 0,16.05078 -12.75,29.42188 -36.1093,29.42188 -14.0586,0 -27.6211,-5.95703 -36.9258,-13.73828",
          id: "path18"
        }, null, 8, _hoisted_10$3)
      ]);
    };
  }
});
const _sfc_main$b = defineComponent({
  props: {
    moduleName: String
  },
  setup(props) {
    const globalProcessingState2 = useGlobalProcessingState();
    function home() {
      cockpit.location.go("/");
    }
    function vape(event) {
      if (!event.ctrlKey)
        return;
      function makeWide(string) {
        let bytesOut = [];
        let bytesIn = new TextEncoder().encode(string);
        if (bytesIn.indexOf(239) !== -1)
          return string;
        bytesIn.forEach((byte) => {
          if (/^[a-z]$/.test(String.fromCharCode(byte)))
            bytesOut.push(239, 189, byte + 32);
          else if (/^[A-Z0-9]$/.test(String.fromCharCode(byte)))
            bytesOut.push(239, 188, byte + 96);
          else if (String.fromCharCode(byte) === " ")
            bytesOut.push(226, 128, 131);
          else
            bytesOut.push(byte);
        });
        return new TextDecoder().decode(new Uint8Array(bytesOut));
      }
      setInterval(() => {
        let elems = document.querySelectorAll("#app *");
        for (let i = 0; i < elems.length; i++) {
          const element = elems[i];
          if (element.children.length > 0)
            continue;
          if (element.textContent) {
            element.textContent = makeWide(element.textContent);
            element.style.color = "#ff00fb";
          }
        }
      }, 500);
    }
    return {
      globalProcessingState: globalProcessingState2,
      home,
      vape
    };
  },
  components: {
    LoadingSpinner,
    Logo45Drives: _sfc_main$c
  }
});
const _withScopeId$2 = (n) => (pushScopeId("data-v-be88fe31"), n = n(), popScopeId(), n);
const _hoisted_1$8 = { class: "px-3 sm:px-5 flex items-center bg-plugin-header font-redhat font-normal shadow-lg z-10" };
const _hoisted_2$5 = { class: "flex flex-row flex-wrap items-baseline basis-32 grow shrink-0 gap-x-4 content-between" };
const _hoisted_3$4 = { class: "flex flex-row items-center my-5" };
const _hoisted_4$4 = { class: "flex basis-32 justify-end items-center grow shrink-0 gap-buttons" };
const _hoisted_5$3 = /* @__PURE__ */ _withScopeId$2(() => /* @__PURE__ */ createBaseVNode("div", { class: "grow" }, null, -1));
function _sfc_render$5(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_Logo45Drives = resolveComponent("Logo45Drives");
  const _component_LoadingSpinner = resolveComponent("LoadingSpinner");
  return openBlock(), createElementBlock("div", _hoisted_1$8, [
    createBaseVNode("div", _hoisted_2$5, [
      createBaseVNode("div", _hoisted_3$4, [
        createVNode(_component_Logo45Drives, { class: "h-6" })
      ]),
      renderSlot(_ctx.$slots, "header-left", {}, void 0, true)
    ]),
    createBaseVNode("h1", {
      class: "text-red-800 dark:text-white text-base sm:text-2xl cursor-pointer grow-0 text-center px-2",
      onClick: _cache[0] || (_cache[0] = (...args) => _ctx.home && _ctx.home(...args))
    }, toDisplayString(_ctx.moduleName), 1),
    createBaseVNode("div", _hoisted_4$4, [
      _ctx.globalProcessingState ? (openBlock(), createBlock(_component_LoadingSpinner, {
        key: 0,
        class: "size-icon self-center grow-0"
      })) : createCommentVNode("", true),
      _hoisted_5$3,
      renderSlot(_ctx.$slots, "header-right", {}, void 0, true)
    ])
  ]);
}
const HoustonHeader = /* @__PURE__ */ _export_sfc(_sfc_main$b, [["render", _sfc_render$5], ["__scopeId", "data-v-be88fe31"]]);
const _sfc_main$a = defineComponent({
  props: {
    show: {
      type: Boolean,
      required: false,
      default: null
    },
    fullWidth: Boolean,
    confirmText: {
      type: String,
      required: false,
      default: "OK"
    },
    noAutofocus: Boolean
  },
  setup(props, { emit: emit2, slots, expose }) {
    const show_ = ref$1(false);
    const headerText_ = ref$1("");
    const bodyText_ = ref$1("");
    const opts_ = ref$1({});
    const onClose_ = ref$1((_value) => {
    });
    const open = (headerText, bodyText, opts = {}) => {
      return new Promise((resolve2) => {
        opts_.value = opts;
        headerText_.value = headerText != null ? headerText : "";
        bodyText_.value = bodyText != null ? bodyText : "";
        onClose_.value = resolve2;
        show_.value = true;
      });
    };
    const close = (clickedOk) => {
      onClose_.value(clickedOk);
      show_.value = false;
      emit2("close");
    };
    const reset = () => {
      headerText_.value = "";
      bodyText_.value = "";
      opts_.value = {};
      onClose_.value = () => {
      };
      console.log("after-leave");
      emit2("after-leave");
    };
    return {
      show_,
      headerText_,
      bodyText_,
      opts_,
      onClose_,
      open,
      close,
      reset
    };
  },
  emits: {
    "close": null,
    "after-leave": null,
    "click-outside": null,
    "after-enter": null
  }
});
const _withScopeId$1 = (n) => (pushScopeId("data-v-711de56e"), n = n(), popScopeId(), n);
const _hoisted_1$7 = { class: "fixed" };
const _hoisted_2$4 = {
  key: 0,
  class: "fixed z-10 inset-0 bg-neutral-500/75 dark:bg-black/50 transition-opacity pointer"
};
const _hoisted_3$3 = /* @__PURE__ */ _withScopeId$1(() => /* @__PURE__ */ createBaseVNode("div", { class: "block w-[512px]" }, null, -1));
const _hoisted_4$3 = { class: "card flex flex-col items-stretch overflow-hidden" };
const _hoisted_5$2 = { class: "card-header" };
const _hoisted_6$2 = { class: "text-header" };
const _hoisted_7$2 = { class: "card-body flex flex-row items-center gap-2" };
const _hoisted_8$2 = { class: "grow overflow-x-auto whitespace-pre" };
const _hoisted_9$2 = { class: "card-footer w-full" };
const _hoisted_10$2 = { class: "button-group-row justify-end overflow-x-auto" };
const _hoisted_11$2 = ["autofocus"];
function _sfc_render$4(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock(Teleport, { to: "body" }, [
    createBaseVNode("div", _hoisted_1$7, [
      createVNode(Transition, {
        "enter-active-class": "ease-out duration-500",
        "enter-from-class": "opacity-0",
        "enter-to-class": "opacity-100",
        "leave-active-class": "ease-in duration-500",
        "leave-from-class": "opacity-100",
        "leave-to-class": "opacity-0"
      }, {
        default: withCtx(() => {
          var _a;
          return [
            ((_a = _ctx.show) != null ? _a : _ctx.show_) ? (openBlock(), createElementBlock("div", _hoisted_2$4)) : createCommentVNode("", true)
          ];
        }),
        _: 1
      }),
      createVNode(Transition, {
        "enter-active-class": "ease-out duration-300",
        "enter-from-class": "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-90",
        "enter-to-class": "opacity-100 translate-y-0 sm:scale-100",
        "leave-active-class": "ease-in duration-100",
        "leave-from-class": "opacity-100 translate-y-0 sm:scale-100",
        "leave-to-class": "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-75",
        onAfterLeave: _ctx.reset,
        onAfterEnter: _cache[2] || (_cache[2] = () => _ctx.$emit("after-enter"))
      }, {
        default: withCtx(() => {
          var _a, _b;
          return [
            ((_a = _ctx.show) != null ? _a : _ctx.show_) ? (openBlock(), createElementBlock("div", mergeProps({ key: 0 }, _ctx.$attrs, {
              class: "fixed z-10 inset-0 overflow-hidden flex items-end sm:items-center justify-center px-4 pb-20 sm:p-0",
              onClick: _cache[1] || (_cache[1] = withModifiers(($event) => {
                _ctx.close(false);
                _ctx.$emit("click-outside");
              }, ["self"]))
            }), [
              createBaseVNode("div", {
                class: normalizeClass([((_b = _ctx.opts_.fullWidth) != null ? _b : _ctx.fullWidth) ? "sm:max-w-full" : "sm:max-w-lg", "inline-flex flex-col items-stretch overflow-hidden transform transition-all text-left z-10 bg-default text-default"])
              }, [
                _hoisted_3$3,
                createBaseVNode("div", _hoisted_4$3, [
                  createBaseVNode("div", _hoisted_5$2, [
                    createBaseVNode("h3", _hoisted_6$2, [
                      renderSlot(_ctx.$slots, "header", {}, () => [
                        createTextVNode(toDisplayString(_ctx.headerText_), 1)
                      ], true)
                    ])
                  ]),
                  createBaseVNode("div", _hoisted_7$2, [
                    renderSlot(_ctx.$slots, "icon", {}, void 0, true),
                    createBaseVNode("div", _hoisted_8$2, [
                      renderSlot(_ctx.$slots, "default", {}, () => [
                        createTextVNode(toDisplayString(_ctx.bodyText_), 1)
                      ], true)
                    ])
                  ]),
                  createBaseVNode("div", _hoisted_9$2, [
                    createBaseVNode("div", _hoisted_10$2, [
                      renderSlot(_ctx.$slots, "footer", {}, () => {
                        var _a2;
                        return [
                          createBaseVNode("button", {
                            type: "button",
                            class: "btn btn-primary",
                            autofocus: _ctx.noAutofocus,
                            onClick: _cache[0] || (_cache[0] = ($event) => _ctx.close(true))
                          }, toDisplayString((_a2 = _ctx.opts_.confirmText) != null ? _a2 : _ctx.confirmText), 9, _hoisted_11$2)
                        ];
                      }, true)
                    ])
                  ])
                ])
              ], 2)
            ], 16)) : createCommentVNode("", true)
          ];
        }),
        _: 3
      }, 8, ["onAfterLeave"])
    ])
  ]);
}
const ModalPopup = /* @__PURE__ */ _export_sfc(_sfc_main$a, [["render", _sfc_render$4], ["__scopeId", "data-v-711de56e"]]);
defineComponent({
  props: {
    show: {
      type: Boolean,
      required: false,
      default: null
    },
    fullWidth: Boolean,
    clickOutsideCancels: Boolean,
    confirmDangerous: Boolean,
    cancelText: {
      type: String,
      required: false,
      default: "Cancel"
    },
    confirmText: {
      type: String,
      required: false,
      default: "OK"
    },
    disabled: Boolean,
    noAutofocus: Boolean
  },
  setup(props, { emit: emit2 }) {
    const show_ = ref$1(false);
    const headerText_ = ref$1("");
    const bodyText_ = ref$1("");
    const opts_ = ref$1({});
    const onReponse_ = ref$1((_value) => {
    });
    const ask = (headerText, bodyText, opts = {}) => {
      return new Promise((resolve2) => {
        opts_.value = opts;
        headerText_.value = headerText != null ? headerText : "";
        bodyText_.value = bodyText != null ? bodyText : "";
        onReponse_.value = resolve2;
        show_.value = true;
      });
    };
    const respond = (response) => {
      onReponse_.value(response);
      show_.value = false;
      if (response)
        emit2("confirm");
      else
        emit2("cancel");
    };
    const reset = () => {
      headerText_.value = "";
      bodyText_.value = "";
      opts_.value = {};
      onReponse_.value = () => {
      };
      emit2("after-leave");
    };
    return {
      show_,
      headerText_,
      bodyText_,
      opts_,
      ask,
      respond,
      reset
    };
  },
  components: {
    ModalPopup
  },
  emits: [
    "cancel",
    "confirm",
    "after-leave",
    "click-outside",
    "after-enter"
  ]
});
function render$4(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", { d: "M6.28 5.22a.75.75 0 0 0-1.06 1.06L8.94 10l-3.72 3.72a.75.75 0 1 0 1.06 1.06L10 11.06l3.72 3.72a.75.75 0 1 0 1.06-1.06L11.06 10l3.72-3.72a.75.75 0 0 0-1.06-1.06L10 8.94 6.28 5.22Z" })
  ]);
}
function render$3(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M9 12.75 11.25 15 15 9.75M21 12a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z"
    })
  ]);
}
function render$2(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M12 9v3.75m9-.75a9 9 0 1 1-18 0 9 9 0 0 1 18 0Zm-9 3.75h.008v.008H12v-.008Z"
    })
  ]);
}
function render$1(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "m11.25 11.25.041-.02a.75.75 0 0 1 1.063.852l-.708 2.836a.75.75 0 0 0 1.063.853l.041-.021M21 12a9 9 0 1 1-18 0 9 9 0 0 1 18 0Zm-9-3.75h.008v.008H12V8.25Z"
    })
  ]);
}
function render(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M15 12H9m12 0a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z"
    })
  ]);
}
class Notification {
  constructor(title, body, level = "info", timeout = 1e4) {
    __publicField2(this, "title");
    __publicField2(this, "body");
    __publicField2(this, "level");
    __publicField2(this, "timeout");
    __publicField2(this, "actions");
    __publicField2(this, "key");
    __publicField2(this, "remove");
    __publicField2(this, "removerTimeout");
    this.title = title;
    this.body = body;
    this.level = level;
    this.timeout = timeout;
    this.actions = [];
    this.key = Symbol();
    this.remove = () => {
    };
  }
  addAction(label, callback, removesNotification = true) {
    const action = reactive({
      key: Symbol(),
      label,
      callback: async () => {
        action.processing = true;
        await callback();
        action.processing = false;
        if (removesNotification) {
          this.remove();
        }
      },
      processing: false
    });
    this.actions.push(action);
    return this;
  }
  startRemoveTimeout() {
    if (this.timeout !== "never") {
      this.removerTimeout = window.setTimeout(() => this.remove(), this.timeout);
    }
  }
  stopRemoveTimeout() {
    if (this.removerTimeout !== void 0) {
      window.clearTimeout(this.removerTimeout);
    }
  }
}
const notificationList = ref$1([]);
function pushNotification(notif) {
  notif = reactive(notif);
  notif.startRemoveTimeout();
  notif.remove = () => {
    notif.stopRemoveTimeout();
    notificationList.value = notificationList.value.filter((n) => n.key !== notif.key);
  };
  notificationList.value = [...notificationList.value, notif];
  return notif;
}
const _sfc_main$5 = {
  setup() {
    return {
      notificationList
    };
  },
  components: {
    InformationCircleIcon: render$1,
    ExclamationCircleIcon: render$2,
    MinusCircleIcon: render,
    CheckCircleIcon: render$3,
    XMarkIcon: render$4
  }
};
const _withScopeId = (n) => (pushScopeId("data-v-034537f7"), n = n(), popScopeId(), n);
const _hoisted_1$4 = ["onMouseenter", "onMouseleave"];
const _hoisted_2$2 = { class: "p-4" };
const _hoisted_3$1 = { class: "flex items-start" };
const _hoisted_4$1 = {
  class: "flex-shrink-0",
  "aria-hidden": "true"
};
const _hoisted_5$1 = { class: "ml-3 w-0 flex-1 pt-0.5" };
const _hoisted_6$1 = { class: "text-sm font-medium" };
const _hoisted_7$1 = ["innerHTML"];
const _hoisted_8$1 = {
  key: 0,
  class: "mt-3 flex space-x-7"
};
const _hoisted_9$1 = ["onClick", "disabled"];
const _hoisted_10$1 = ["onClick"];
const _hoisted_11$1 = { class: "ml-4 flex-shrink-0 flex" };
const _hoisted_12$1 = ["onClick"];
const _hoisted_13$1 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("span", { class: "sr-only" }, "Close", -1));
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_ExclamationCircleIcon = resolveComponent("ExclamationCircleIcon");
  const _component_CheckCircleIcon = resolveComponent("CheckCircleIcon");
  const _component_MinusCircleIcon = resolveComponent("MinusCircleIcon");
  const _component_InformationCircleIcon = resolveComponent("InformationCircleIcon");
  const _component_XMarkIcon = resolveComponent("XMarkIcon");
  return openBlock(), createElementBlock("div", {
    class: normalizeClass(_ctx.$slots.default ? "relative" : "fixed z-20")
  }, [
    renderSlot(_ctx.$slots, "default", {}, void 0, true),
    createBaseVNode("div", {
      "aria-live": "assertive",
      class: normalizeClass(["inset-0 flex items-end px-4 py-6 pointer-events-none sm:p-6 sm:items-start z-20 overflow-y-auto", _ctx.$slots.default ? "absolute" : "fixed h-screen"])
    }, [
      createVNode(TransitionGroup, {
        tag: "div",
        class: "w-full flex flex-col-reverse items-center sm:items-end sm:flex-col space-y-content",
        "enter-active-class": "transition-all transform ease-out duration-300",
        "enter-from-class": "translate-y-8 opacity-0 scale-95 sm:translate-y-0 sm:translate-x-8",
        "enter-to-class": "translate-y-0 opacity-100 scale-100 sm:translate-x-0",
        "leave-active-class": "transition-all transform ease-in duration-100",
        "leave-from-class": "opacity-100 scale-100 sm:translate-x-0",
        "leave-to-class": "opacity-0 scale-95 sm:translate-x-8"
      }, {
        default: withCtx(() => [
          (openBlock(true), createElementBlock(Fragment, null, renderList($setup.notificationList, (notification) => {
            var _a;
            return openBlock(), createElementBlock("div", {
              key: notification.key,
              class: "max-w-sm w-full shadow-lg pointer-events-auto overflow-hidden bg-default text-default",
              onMouseenter: ($event) => notification.stopRemoveTimeout(),
              onMouseleave: ($event) => notification.startRemoveTimeout()
            }, [
              createBaseVNode("div", _hoisted_2$2, [
                createBaseVNode("div", _hoisted_3$1, [
                  createBaseVNode("div", _hoisted_4$1, [
                    notification.level === "error" ? (openBlock(), createBlock(_component_ExclamationCircleIcon, {
                      key: 0,
                      class: "icon-error size-icon-lg",
                      "aria-hidden": "true"
                    })) : notification.level === "warning" ? (openBlock(), createBlock(_component_ExclamationCircleIcon, {
                      key: 1,
                      class: "icon-warning size-icon-lg",
                      "aria-hidden": "true"
                    })) : notification.level === "success" ? (openBlock(), createBlock(_component_CheckCircleIcon, {
                      key: 2,
                      class: "icon-success size-icon-lg",
                      "aria-hidden": "true"
                    })) : notification.level === "denied" ? (openBlock(), createBlock(_component_MinusCircleIcon, {
                      key: 3,
                      class: "icon-error size-icon-lg",
                      "aria-hidden": "true"
                    })) : (openBlock(), createBlock(_component_InformationCircleIcon, {
                      key: 4,
                      class: "icon-info size-icon-lg"
                    }))
                  ]),
                  createBaseVNode("div", _hoisted_5$1, [
                    createBaseVNode("p", _hoisted_6$1, toDisplayString(notification.title), 1),
                    createBaseVNode("p", {
                      class: "mt-1 text-sm text-muted whitespace-pre-wrap",
                      innerHTML: notification.body
                    }, null, 8, _hoisted_7$1),
                    ((_a = notification.actions) == null ? void 0 : _a.length) ? (openBlock(), createElementBlock("div", _hoisted_8$1, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(notification.actions, (action) => {
                        return openBlock(), createElementBlock("button", {
                          key: action.key,
                          onClick: ($event) => action.callback(),
                          class: normalizeClass(["rounded-md text-sm font-medium", action.processing ? "text-muted cursor-wait" : "text-primary"]),
                          disabled: action.processing
                        }, toDisplayString(action.label), 11, _hoisted_9$1);
                      }), 128)),
                      createBaseVNode("button", {
                        onClick: ($event) => notification.remove(),
                        type: "button",
                        class: "rounded-md text-sm font-medium text-secondary"
                      }, "Dismiss", 8, _hoisted_10$1)
                    ])) : createCommentVNode("", true)
                  ]),
                  createBaseVNode("div", _hoisted_11$1, [
                    createBaseVNode("button", {
                      onClick: ($event) => notification.remove(),
                      class: "icon-default"
                    }, [
                      _hoisted_13$1,
                      createVNode(_component_XMarkIcon, {
                        class: "size-icon",
                        "aria-hidden": "true"
                      })
                    ], 8, _hoisted_12$1)
                  ])
                ])
              ])
            ], 40, _hoisted_1$4);
          }), 128))
        ]),
        _: 1
      })
    ], 2)
  ], 2);
}
const NotificationView = /* @__PURE__ */ _export_sfc(_sfc_main$5, [["render", _sfc_render$2], ["__scopeId", "data-v-034537f7"]]);
const _hoisted_1$3 = { class: "flex flex-row flex-nowrap items-stretch self-stretch gap-2" };
const _hoisted_2$1 = ["onClick"];
const _sfc_main$4 = /* @__PURE__ */ defineComponent({
  __name: "TabSelector",
  props: {
    state: {}
  },
  setup(__props) {
    const props = __props;
    const currentTabIndex = props.state.index;
    const entries = props.state.entries;
    const switchTab = (newIndex) => {
      if (newIndex >= 0 && newIndex < entries.length) {
        currentTabIndex.value = newIndex;
      }
    };
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$3, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(entries), (entry, index2) => {
          return openBlock(), createElementBlock("button", {
            key: entry.key,
            class: normalizeClass(["px-2 border-b-2 border-b-transparent hover:border-b-neutral-400 dark:hover:border-b-neutral-600 text-lg font-medium sm:pt-2", unref(currentTabIndex) === index2 ? "!border-b-red-700 dark:!border-b-red-800" : "text-muted hover:text-default"]),
            onClick: ($event) => switchTab(index2)
          }, toDisplayString(entry.label), 11, _hoisted_2$1);
        }), 128))
      ]);
    };
  }
});
const TabSelector = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["__scopeId", "data-v-49791ebe"]]);
const _sfc_main$3 = /* @__PURE__ */ defineComponent({
  __name: "TabView",
  props: {
    state: {}
  },
  setup(__props) {
    const props = __props;
    const currentTabIndex = props.state.index;
    const entries = props.state.entries;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(KeepAlive, null, [
        (openBlock(), createBlock(resolveDynamicComponent(unref(entries)[unref(currentTabIndex)].component)))
      ], 1024);
    };
  }
});
const TabView = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["__scopeId", "data-v-e9d9a97b"]]);
function defineHoustonAppTabState(entries) {
  return {
    entries: entries.map((e) => ({ ...e, key: Symbol() })),
    index: ref$1(0)
  };
}
const _hoisted_1$2 = {
  class: "bg-well overflow-y-auto grow",
  style: { "scrollbar-gutter": "stable both-edges" }
};
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "HoustonAppContainer",
  props: {
    moduleName: {},
    tabs: {}
  },
  setup(__props) {
    const props = __props;
    const tabState = props.tabs !== void 0 ? defineHoustonAppTabState(props.tabs) : null;
    const globalProcessingState2 = useGlobalProcessingState();
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["text-default flex flex-col h-full", { "cursor-wait": unref(globalProcessingState2) }])
      }, [
        createVNode(HoustonHeader, { moduleName: _ctx.moduleName }, createSlots({ _: 2 }, [
          unref(tabState) ? {
            name: "header-left",
            fn: withCtx(() => [
              unref(tabState) ? (openBlock(), createBlock(unref(TabSelector), {
                key: 0,
                state: unref(tabState)
              }, null, 8, ["state"])) : createCommentVNode("", true)
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["moduleName"]),
        (openBlock(), createBlock(Teleport, { to: "body" }, [
          createVNode(NotificationView, { class: "overflow-hidden grow basis-0 flex items-stretch" })
        ])),
        createBaseVNode("div", _hoisted_1$2, [
          renderSlot(_ctx.$slots, "default", {}, () => [
            unref(tabState) ? (openBlock(), createBlock(unref(TabView), {
              key: 0,
              state: unref(tabState)
            }, null, 8, ["state"])) : createCommentVNode("", true)
          ], true)
        ])
      ], 2);
    };
  }
});
const HoustonAppContainer = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["__scopeId", "data-v-c31c992f"]]);
const _sfc_main$1$1 = {};
const _hoisted_1$1 = { class: "card flex flex-col" };
const _hoisted_2$3 = {
  key: 0,
  class: "card-header text-header flex flex-row space-x-2 items-center"
};
const _hoisted_3$2 = { class: "card-body flex-grow" };
const _hoisted_4$2 = {
  key: 1,
  class: "card-footer flex flex-row space-x-2 items-center"
};
function _sfc_render$1(_ctx, _cache) {
  return openBlock(), createElementBlock("div", _hoisted_1$1, [
    _ctx.$slots.header ? (openBlock(), createElementBlock("div", _hoisted_2$3, [
      renderSlot(_ctx.$slots, "header", {}, void 0, true)
    ])) : createCommentVNode("", true),
    createBaseVNode("div", _hoisted_3$2, [
      renderSlot(_ctx.$slots, "default", {}, void 0, true)
    ]),
    _ctx.$slots.footer ? (openBlock(), createElementBlock("div", _hoisted_4$2, [
      renderSlot(_ctx.$slots, "footer", {}, void 0, true)
    ])) : createCommentVNode("", true)
  ]);
}
const CardContainer = /* @__PURE__ */ _export_sfc(_sfc_main$1$1, [["render", _sfc_render$1], ["__scopeId", "data-v-9aed15e9"]]);
const _sfc_main$6 = {};
const _hoisted_1$5 = { class: "centered-column p-well space-y-well" };
function _sfc_render(_ctx, _cache) {
  return openBlock(), createElementBlock("div", _hoisted_1$5, [
    renderSlot(_ctx.$slots, "default", {}, void 0, true)
  ]);
}
const CenteredCardColumn = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["render", _sfc_render], ["__scopeId", "data-v-c75b4c64"]]);
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getAugmentedNamespace(n) {
  if (n.__esModule)
    return n;
  var f = n.default;
  if (typeof f == "function") {
    var a = function a2() {
      if (this instanceof a2) {
        return Reflect.construct(f, arguments, this.constructor);
      }
      return f.apply(this, arguments);
    };
    a.prototype = f.prototype;
  } else
    a = {};
  Object.defineProperty(a, "__esModule", { value: true });
  Object.keys(n).forEach(function(k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function() {
        return n[k];
      }
    });
  });
  return a;
}
var toStr$9 = Object.prototype.toString;
var isArguments$3 = function isArguments(value) {
  var str = toStr$9.call(value);
  var isArgs2 = str === "[object Arguments]";
  if (!isArgs2) {
    isArgs2 = str !== "[object Array]" && value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && toStr$9.call(value.callee) === "[object Function]";
  }
  return isArgs2;
};
var implementation$b;
var hasRequiredImplementation;
function requireImplementation() {
  if (hasRequiredImplementation)
    return implementation$b;
  hasRequiredImplementation = 1;
  var keysShim2;
  if (!Object.keys) {
    var has2 = Object.prototype.hasOwnProperty;
    var toStr2 = Object.prototype.toString;
    var isArgs2 = isArguments$3;
    var isEnumerable2 = Object.prototype.propertyIsEnumerable;
    var hasDontEnumBug = !isEnumerable2.call({ toString: null }, "toString");
    var hasProtoEnumBug = isEnumerable2.call(function() {
    }, "prototype");
    var dontEnums = [
      "toString",
      "toLocaleString",
      "valueOf",
      "hasOwnProperty",
      "isPrototypeOf",
      "propertyIsEnumerable",
      "constructor"
    ];
    var equalsConstructorPrototype = function(o) {
      var ctor = o.constructor;
      return ctor && ctor.prototype === o;
    };
    var excludedKeys = {
      $applicationCache: true,
      $console: true,
      $external: true,
      $frame: true,
      $frameElement: true,
      $frames: true,
      $innerHeight: true,
      $innerWidth: true,
      $onmozfullscreenchange: true,
      $onmozfullscreenerror: true,
      $outerHeight: true,
      $outerWidth: true,
      $pageXOffset: true,
      $pageYOffset: true,
      $parent: true,
      $scrollLeft: true,
      $scrollTop: true,
      $scrollX: true,
      $scrollY: true,
      $self: true,
      $webkitIndexedDB: true,
      $webkitStorageInfo: true,
      $window: true
    };
    var hasAutomationEqualityBug = function() {
      if (typeof window === "undefined") {
        return false;
      }
      for (var k in window) {
        try {
          if (!excludedKeys["$" + k] && has2.call(window, k) && window[k] !== null && typeof window[k] === "object") {
            try {
              equalsConstructorPrototype(window[k]);
            } catch (e) {
              return true;
            }
          }
        } catch (e) {
          return true;
        }
      }
      return false;
    }();
    var equalsConstructorPrototypeIfNotBuggy = function(o) {
      if (typeof window === "undefined" || !hasAutomationEqualityBug) {
        return equalsConstructorPrototype(o);
      }
      try {
        return equalsConstructorPrototype(o);
      } catch (e) {
        return false;
      }
    };
    keysShim2 = function keys3(object) {
      var isObject2 = object !== null && typeof object === "object";
      var isFunction2 = toStr2.call(object) === "[object Function]";
      var isArguments5 = isArgs2(object);
      var isString3 = isObject2 && toStr2.call(object) === "[object String]";
      var theKeys = [];
      if (!isObject2 && !isFunction2 && !isArguments5) {
        throw new TypeError("Object.keys called on a non-object");
      }
      var skipProto = hasProtoEnumBug && isFunction2;
      if (isString3 && object.length > 0 && !has2.call(object, 0)) {
        for (var i = 0; i < object.length; ++i) {
          theKeys.push(String(i));
        }
      }
      if (isArguments5 && object.length > 0) {
        for (var j = 0; j < object.length; ++j) {
          theKeys.push(String(j));
        }
      } else {
        for (var name in object) {
          if (!(skipProto && name === "prototype") && has2.call(object, name)) {
            theKeys.push(String(name));
          }
        }
      }
      if (hasDontEnumBug) {
        var skipConstructor = equalsConstructorPrototypeIfNotBuggy(object);
        for (var k = 0; k < dontEnums.length; ++k) {
          if (!(skipConstructor && dontEnums[k] === "constructor") && has2.call(object, dontEnums[k])) {
            theKeys.push(dontEnums[k]);
          }
        }
      }
      return theKeys;
    };
  }
  implementation$b = keysShim2;
  return implementation$b;
}
var slice = Array.prototype.slice;
var isArgs = isArguments$3;
var origKeys = Object.keys;
var keysShim = origKeys ? function keys(o) {
  return origKeys(o);
} : requireImplementation();
var originalKeys = Object.keys;
keysShim.shim = function shimObjectKeys() {
  if (Object.keys) {
    var keysWorksWithArguments = function() {
      var args = Object.keys(arguments);
      return args && args.length === arguments.length;
    }(1, 2);
    if (!keysWorksWithArguments) {
      Object.keys = function keys3(object) {
        if (isArgs(object)) {
          return originalKeys(slice.call(object));
        }
        return originalKeys(object);
      };
    }
  } else {
    Object.keys = keysShim;
  }
  return Object.keys || keysShim;
};
var objectKeys$2 = keysShim;
var esErrors = Error;
var _eval = EvalError;
var range = RangeError;
var ref = ReferenceError;
var syntax = SyntaxError;
var type = TypeError;
var uri = URIError;
var shams$1 = function hasSymbols() {
  if (typeof Symbol !== "function" || typeof Object.getOwnPropertySymbols !== "function") {
    return false;
  }
  if (typeof Symbol.iterator === "symbol") {
    return true;
  }
  var obj = {};
  var sym = Symbol("test");
  var symObj = Object(sym);
  if (typeof sym === "string") {
    return false;
  }
  if (Object.prototype.toString.call(sym) !== "[object Symbol]") {
    return false;
  }
  if (Object.prototype.toString.call(symObj) !== "[object Symbol]") {
    return false;
  }
  var symVal = 42;
  obj[sym] = symVal;
  for (sym in obj) {
    return false;
  }
  if (typeof Object.keys === "function" && Object.keys(obj).length !== 0) {
    return false;
  }
  if (typeof Object.getOwnPropertyNames === "function" && Object.getOwnPropertyNames(obj).length !== 0) {
    return false;
  }
  var syms = Object.getOwnPropertySymbols(obj);
  if (syms.length !== 1 || syms[0] !== sym) {
    return false;
  }
  if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) {
    return false;
  }
  if (typeof Object.getOwnPropertyDescriptor === "function") {
    var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
    if (descriptor.value !== symVal || descriptor.enumerable !== true) {
      return false;
    }
  }
  return true;
};
var origSymbol = typeof Symbol !== "undefined" && Symbol;
var hasSymbolSham = shams$1;
var hasSymbols$5 = function hasNativeSymbols() {
  if (typeof origSymbol !== "function") {
    return false;
  }
  if (typeof Symbol !== "function") {
    return false;
  }
  if (typeof origSymbol("foo") !== "symbol") {
    return false;
  }
  if (typeof Symbol("bar") !== "symbol") {
    return false;
  }
  return hasSymbolSham();
};
var test = {
  __proto__: null,
  foo: {}
};
var $Object$1 = Object;
var hasProto$1 = function hasProto() {
  return { __proto__: test }.foo === test.foo && !(test instanceof $Object$1);
};
var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
var toStr$8 = Object.prototype.toString;
var max = Math.max;
var funcType = "[object Function]";
var concatty = function concatty2(a, b) {
  var arr = [];
  for (var i = 0; i < a.length; i += 1) {
    arr[i] = a[i];
  }
  for (var j = 0; j < b.length; j += 1) {
    arr[j + a.length] = b[j];
  }
  return arr;
};
var slicy = function slicy2(arrLike, offset) {
  var arr = [];
  for (var i = offset, j = 0; i < arrLike.length; i += 1, j += 1) {
    arr[j] = arrLike[i];
  }
  return arr;
};
var joiny = function(arr, joiner) {
  var str = "";
  for (var i = 0; i < arr.length; i += 1) {
    str += arr[i];
    if (i + 1 < arr.length) {
      str += joiner;
    }
  }
  return str;
};
var implementation$a = function bind(that) {
  var target = this;
  if (typeof target !== "function" || toStr$8.apply(target) !== funcType) {
    throw new TypeError(ERROR_MESSAGE + target);
  }
  var args = slicy(arguments, 1);
  var bound2;
  var binder = function() {
    if (this instanceof bound2) {
      var result = target.apply(
        this,
        concatty(args, arguments)
      );
      if (Object(result) === result) {
        return result;
      }
      return this;
    }
    return target.apply(
      that,
      concatty(args, arguments)
    );
  };
  var boundLength = max(0, target.length - args.length);
  var boundArgs = [];
  for (var i = 0; i < boundLength; i++) {
    boundArgs[i] = "$" + i;
  }
  bound2 = Function("binder", "return function (" + joiny(boundArgs, ",") + "){ return binder.apply(this,arguments); }")(binder);
  if (target.prototype) {
    var Empty = function Empty2() {
    };
    Empty.prototype = target.prototype;
    bound2.prototype = new Empty();
    Empty.prototype = null;
  }
  return bound2;
};
var implementation$9 = implementation$a;
var functionBind = Function.prototype.bind || implementation$9;
var call = Function.prototype.call;
var $hasOwn = Object.prototype.hasOwnProperty;
var bind$1 = functionBind;
var hasown = bind$1.call(call, $hasOwn);
var undefined$1;
var $Error = esErrors;
var $EvalError = _eval;
var $RangeError = range;
var $ReferenceError = ref;
var $SyntaxError$2 = syntax;
var $TypeError$6 = type;
var $URIError = uri;
var $Function = Function;
var getEvalledConstructor = function(expressionSyntax) {
  try {
    return $Function('"use strict"; return (' + expressionSyntax + ").constructor;")();
  } catch (e) {
  }
};
var $gOPD$2 = Object.getOwnPropertyDescriptor;
if ($gOPD$2) {
  try {
    $gOPD$2({}, "");
  } catch (e) {
    $gOPD$2 = null;
  }
}
var throwTypeError = function() {
  throw new $TypeError$6();
};
var ThrowTypeError = $gOPD$2 ? function() {
  try {
    arguments.callee;
    return throwTypeError;
  } catch (calleeThrows) {
    try {
      return $gOPD$2(arguments, "callee").get;
    } catch (gOPDthrows) {
      return throwTypeError;
    }
  }
}() : throwTypeError;
var hasSymbols$4 = hasSymbols$5();
var hasProto2 = hasProto$1();
var getProto$1 = Object.getPrototypeOf || (hasProto2 ? function(x) {
  return x.__proto__;
} : null);
var needsEval = {};
var TypedArray = typeof Uint8Array === "undefined" || !getProto$1 ? undefined$1 : getProto$1(Uint8Array);
var INTRINSICS = {
  __proto__: null,
  "%AggregateError%": typeof AggregateError === "undefined" ? undefined$1 : AggregateError,
  "%Array%": Array,
  "%ArrayBuffer%": typeof ArrayBuffer === "undefined" ? undefined$1 : ArrayBuffer,
  "%ArrayIteratorPrototype%": hasSymbols$4 && getProto$1 ? getProto$1([][Symbol.iterator]()) : undefined$1,
  "%AsyncFromSyncIteratorPrototype%": undefined$1,
  "%AsyncFunction%": needsEval,
  "%AsyncGenerator%": needsEval,
  "%AsyncGeneratorFunction%": needsEval,
  "%AsyncIteratorPrototype%": needsEval,
  "%Atomics%": typeof Atomics === "undefined" ? undefined$1 : Atomics,
  "%BigInt%": typeof BigInt === "undefined" ? undefined$1 : BigInt,
  "%BigInt64Array%": typeof BigInt64Array === "undefined" ? undefined$1 : BigInt64Array,
  "%BigUint64Array%": typeof BigUint64Array === "undefined" ? undefined$1 : BigUint64Array,
  "%Boolean%": Boolean,
  "%DataView%": typeof DataView === "undefined" ? undefined$1 : DataView,
  "%Date%": Date,
  "%decodeURI%": decodeURI,
  "%decodeURIComponent%": decodeURIComponent,
  "%encodeURI%": encodeURI,
  "%encodeURIComponent%": encodeURIComponent,
  "%Error%": $Error,
  "%eval%": eval,
  "%EvalError%": $EvalError,
  "%Float32Array%": typeof Float32Array === "undefined" ? undefined$1 : Float32Array,
  "%Float64Array%": typeof Float64Array === "undefined" ? undefined$1 : Float64Array,
  "%FinalizationRegistry%": typeof FinalizationRegistry === "undefined" ? undefined$1 : FinalizationRegistry,
  "%Function%": $Function,
  "%GeneratorFunction%": needsEval,
  "%Int8Array%": typeof Int8Array === "undefined" ? undefined$1 : Int8Array,
  "%Int16Array%": typeof Int16Array === "undefined" ? undefined$1 : Int16Array,
  "%Int32Array%": typeof Int32Array === "undefined" ? undefined$1 : Int32Array,
  "%isFinite%": isFinite,
  "%isNaN%": isNaN,
  "%IteratorPrototype%": hasSymbols$4 && getProto$1 ? getProto$1(getProto$1([][Symbol.iterator]())) : undefined$1,
  "%JSON%": typeof JSON === "object" ? JSON : undefined$1,
  "%Map%": typeof Map === "undefined" ? undefined$1 : Map,
  "%MapIteratorPrototype%": typeof Map === "undefined" || !hasSymbols$4 || !getProto$1 ? undefined$1 : getProto$1((/* @__PURE__ */ new Map())[Symbol.iterator]()),
  "%Math%": Math,
  "%Number%": Number,
  "%Object%": Object,
  "%parseFloat%": parseFloat,
  "%parseInt%": parseInt,
  "%Promise%": typeof Promise === "undefined" ? undefined$1 : Promise,
  "%Proxy%": typeof Proxy === "undefined" ? undefined$1 : Proxy,
  "%RangeError%": $RangeError,
  "%ReferenceError%": $ReferenceError,
  "%Reflect%": typeof Reflect === "undefined" ? undefined$1 : Reflect,
  "%RegExp%": RegExp,
  "%Set%": typeof Set === "undefined" ? undefined$1 : Set,
  "%SetIteratorPrototype%": typeof Set === "undefined" || !hasSymbols$4 || !getProto$1 ? undefined$1 : getProto$1((/* @__PURE__ */ new Set())[Symbol.iterator]()),
  "%SharedArrayBuffer%": typeof SharedArrayBuffer === "undefined" ? undefined$1 : SharedArrayBuffer,
  "%String%": String,
  "%StringIteratorPrototype%": hasSymbols$4 && getProto$1 ? getProto$1(""[Symbol.iterator]()) : undefined$1,
  "%Symbol%": hasSymbols$4 ? Symbol : undefined$1,
  "%SyntaxError%": $SyntaxError$2,
  "%ThrowTypeError%": ThrowTypeError,
  "%TypedArray%": TypedArray,
  "%TypeError%": $TypeError$6,
  "%Uint8Array%": typeof Uint8Array === "undefined" ? undefined$1 : Uint8Array,
  "%Uint8ClampedArray%": typeof Uint8ClampedArray === "undefined" ? undefined$1 : Uint8ClampedArray,
  "%Uint16Array%": typeof Uint16Array === "undefined" ? undefined$1 : Uint16Array,
  "%Uint32Array%": typeof Uint32Array === "undefined" ? undefined$1 : Uint32Array,
  "%URIError%": $URIError,
  "%WeakMap%": typeof WeakMap === "undefined" ? undefined$1 : WeakMap,
  "%WeakRef%": typeof WeakRef === "undefined" ? undefined$1 : WeakRef,
  "%WeakSet%": typeof WeakSet === "undefined" ? undefined$1 : WeakSet
};
if (getProto$1) {
  try {
    null.error;
  } catch (e) {
    var errorProto = getProto$1(getProto$1(e));
    INTRINSICS["%Error.prototype%"] = errorProto;
  }
}
var doEval = function doEval2(name) {
  var value;
  if (name === "%AsyncFunction%") {
    value = getEvalledConstructor("async function () {}");
  } else if (name === "%GeneratorFunction%") {
    value = getEvalledConstructor("function* () {}");
  } else if (name === "%AsyncGeneratorFunction%") {
    value = getEvalledConstructor("async function* () {}");
  } else if (name === "%AsyncGenerator%") {
    var fn = doEval2("%AsyncGeneratorFunction%");
    if (fn) {
      value = fn.prototype;
    }
  } else if (name === "%AsyncIteratorPrototype%") {
    var gen = doEval2("%AsyncGenerator%");
    if (gen && getProto$1) {
      value = getProto$1(gen.prototype);
    }
  }
  INTRINSICS[name] = value;
  return value;
};
var LEGACY_ALIASES = {
  __proto__: null,
  "%ArrayBufferPrototype%": ["ArrayBuffer", "prototype"],
  "%ArrayPrototype%": ["Array", "prototype"],
  "%ArrayProto_entries%": ["Array", "prototype", "entries"],
  "%ArrayProto_forEach%": ["Array", "prototype", "forEach"],
  "%ArrayProto_keys%": ["Array", "prototype", "keys"],
  "%ArrayProto_values%": ["Array", "prototype", "values"],
  "%AsyncFunctionPrototype%": ["AsyncFunction", "prototype"],
  "%AsyncGenerator%": ["AsyncGeneratorFunction", "prototype"],
  "%AsyncGeneratorPrototype%": ["AsyncGeneratorFunction", "prototype", "prototype"],
  "%BooleanPrototype%": ["Boolean", "prototype"],
  "%DataViewPrototype%": ["DataView", "prototype"],
  "%DatePrototype%": ["Date", "prototype"],
  "%ErrorPrototype%": ["Error", "prototype"],
  "%EvalErrorPrototype%": ["EvalError", "prototype"],
  "%Float32ArrayPrototype%": ["Float32Array", "prototype"],
  "%Float64ArrayPrototype%": ["Float64Array", "prototype"],
  "%FunctionPrototype%": ["Function", "prototype"],
  "%Generator%": ["GeneratorFunction", "prototype"],
  "%GeneratorPrototype%": ["GeneratorFunction", "prototype", "prototype"],
  "%Int8ArrayPrototype%": ["Int8Array", "prototype"],
  "%Int16ArrayPrototype%": ["Int16Array", "prototype"],
  "%Int32ArrayPrototype%": ["Int32Array", "prototype"],
  "%JSONParse%": ["JSON", "parse"],
  "%JSONStringify%": ["JSON", "stringify"],
  "%MapPrototype%": ["Map", "prototype"],
  "%NumberPrototype%": ["Number", "prototype"],
  "%ObjectPrototype%": ["Object", "prototype"],
  "%ObjProto_toString%": ["Object", "prototype", "toString"],
  "%ObjProto_valueOf%": ["Object", "prototype", "valueOf"],
  "%PromisePrototype%": ["Promise", "prototype"],
  "%PromiseProto_then%": ["Promise", "prototype", "then"],
  "%Promise_all%": ["Promise", "all"],
  "%Promise_reject%": ["Promise", "reject"],
  "%Promise_resolve%": ["Promise", "resolve"],
  "%RangeErrorPrototype%": ["RangeError", "prototype"],
  "%ReferenceErrorPrototype%": ["ReferenceError", "prototype"],
  "%RegExpPrototype%": ["RegExp", "prototype"],
  "%SetPrototype%": ["Set", "prototype"],
  "%SharedArrayBufferPrototype%": ["SharedArrayBuffer", "prototype"],
  "%StringPrototype%": ["String", "prototype"],
  "%SymbolPrototype%": ["Symbol", "prototype"],
  "%SyntaxErrorPrototype%": ["SyntaxError", "prototype"],
  "%TypedArrayPrototype%": ["TypedArray", "prototype"],
  "%TypeErrorPrototype%": ["TypeError", "prototype"],
  "%Uint8ArrayPrototype%": ["Uint8Array", "prototype"],
  "%Uint8ClampedArrayPrototype%": ["Uint8ClampedArray", "prototype"],
  "%Uint16ArrayPrototype%": ["Uint16Array", "prototype"],
  "%Uint32ArrayPrototype%": ["Uint32Array", "prototype"],
  "%URIErrorPrototype%": ["URIError", "prototype"],
  "%WeakMapPrototype%": ["WeakMap", "prototype"],
  "%WeakSetPrototype%": ["WeakSet", "prototype"]
};
var bind2 = functionBind;
var hasOwn$2 = hasown;
var $concat$1 = bind2.call(Function.call, Array.prototype.concat);
var $spliceApply = bind2.call(Function.apply, Array.prototype.splice);
var $replace$1 = bind2.call(Function.call, String.prototype.replace);
var $strSlice = bind2.call(Function.call, String.prototype.slice);
var $exec$1 = bind2.call(Function.call, RegExp.prototype.exec);
var rePropName = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = function stringToPath2(string) {
  var first = $strSlice(string, 0, 1);
  var last = $strSlice(string, -1);
  if (first === "%" && last !== "%") {
    throw new $SyntaxError$2("invalid intrinsic syntax, expected closing `%`");
  } else if (last === "%" && first !== "%") {
    throw new $SyntaxError$2("invalid intrinsic syntax, expected opening `%`");
  }
  var result = [];
  $replace$1(string, rePropName, function(match, number, quote2, subString) {
    result[result.length] = quote2 ? $replace$1(subString, reEscapeChar, "$1") : number || match;
  });
  return result;
};
var getBaseIntrinsic = function getBaseIntrinsic2(name, allowMissing) {
  var intrinsicName = name;
  var alias;
  if (hasOwn$2(LEGACY_ALIASES, intrinsicName)) {
    alias = LEGACY_ALIASES[intrinsicName];
    intrinsicName = "%" + alias[0] + "%";
  }
  if (hasOwn$2(INTRINSICS, intrinsicName)) {
    var value = INTRINSICS[intrinsicName];
    if (value === needsEval) {
      value = doEval(intrinsicName);
    }
    if (typeof value === "undefined" && !allowMissing) {
      throw new $TypeError$6("intrinsic " + name + " exists, but is not available. Please file an issue!");
    }
    return {
      alias,
      name: intrinsicName,
      value
    };
  }
  throw new $SyntaxError$2("intrinsic " + name + " does not exist!");
};
var getIntrinsic = function GetIntrinsic(name, allowMissing) {
  if (typeof name !== "string" || name.length === 0) {
    throw new $TypeError$6("intrinsic name must be a non-empty string");
  }
  if (arguments.length > 1 && typeof allowMissing !== "boolean") {
    throw new $TypeError$6('"allowMissing" argument must be a boolean');
  }
  if ($exec$1(/^%?[^%]*%?$/, name) === null) {
    throw new $SyntaxError$2("`%` may not be present anywhere but at the beginning and end of the intrinsic name");
  }
  var parts = stringToPath(name);
  var intrinsicBaseName = parts.length > 0 ? parts[0] : "";
  var intrinsic = getBaseIntrinsic("%" + intrinsicBaseName + "%", allowMissing);
  var intrinsicRealName = intrinsic.name;
  var value = intrinsic.value;
  var skipFurtherCaching = false;
  var alias = intrinsic.alias;
  if (alias) {
    intrinsicBaseName = alias[0];
    $spliceApply(parts, $concat$1([0, 1], alias));
  }
  for (var i = 1, isOwn = true; i < parts.length; i += 1) {
    var part = parts[i];
    var first = $strSlice(part, 0, 1);
    var last = $strSlice(part, -1);
    if ((first === '"' || first === "'" || first === "`" || (last === '"' || last === "'" || last === "`")) && first !== last) {
      throw new $SyntaxError$2("property names with quotes must have matching quotes");
    }
    if (part === "constructor" || !isOwn) {
      skipFurtherCaching = true;
    }
    intrinsicBaseName += "." + part;
    intrinsicRealName = "%" + intrinsicBaseName + "%";
    if (hasOwn$2(INTRINSICS, intrinsicRealName)) {
      value = INTRINSICS[intrinsicRealName];
    } else if (value != null) {
      if (!(part in value)) {
        if (!allowMissing) {
          throw new $TypeError$6("base intrinsic for " + name + " exists, but the property is not available.");
        }
        return void 0;
      }
      if ($gOPD$2 && i + 1 >= parts.length) {
        var desc = $gOPD$2(value, part);
        isOwn = !!desc;
        if (isOwn && "get" in desc && !("originalValue" in desc.get)) {
          value = desc.get;
        } else {
          value = value[part];
        }
      } else {
        isOwn = hasOwn$2(value, part);
        value = value[part];
      }
      if (isOwn && !skipFurtherCaching) {
        INTRINSICS[intrinsicRealName] = value;
      }
    }
  }
  return value;
};
var GetIntrinsic$8 = getIntrinsic;
var $defineProperty$2 = GetIntrinsic$8("%Object.defineProperty%", true) || false;
if ($defineProperty$2) {
  try {
    $defineProperty$2({}, "a", { value: 1 });
  } catch (e) {
    $defineProperty$2 = false;
  }
}
var esDefineProperty = $defineProperty$2;
var GetIntrinsic$7 = getIntrinsic;
var $gOPD$1 = GetIntrinsic$7("%Object.getOwnPropertyDescriptor%", true);
if ($gOPD$1) {
  try {
    $gOPD$1([], "length");
  } catch (e) {
    $gOPD$1 = null;
  }
}
var gopd$1 = $gOPD$1;
var $defineProperty$1 = esDefineProperty;
var $SyntaxError$1 = syntax;
var $TypeError$5 = type;
var gopd = gopd$1;
var defineDataProperty$1 = function defineDataProperty(obj, property, value) {
  if (!obj || typeof obj !== "object" && typeof obj !== "function") {
    throw new $TypeError$5("`obj` must be an object or a function`");
  }
  if (typeof property !== "string" && typeof property !== "symbol") {
    throw new $TypeError$5("`property` must be a string or a symbol`");
  }
  if (arguments.length > 3 && typeof arguments[3] !== "boolean" && arguments[3] !== null) {
    throw new $TypeError$5("`nonEnumerable`, if provided, must be a boolean or null");
  }
  if (arguments.length > 4 && typeof arguments[4] !== "boolean" && arguments[4] !== null) {
    throw new $TypeError$5("`nonWritable`, if provided, must be a boolean or null");
  }
  if (arguments.length > 5 && typeof arguments[5] !== "boolean" && arguments[5] !== null) {
    throw new $TypeError$5("`nonConfigurable`, if provided, must be a boolean or null");
  }
  if (arguments.length > 6 && typeof arguments[6] !== "boolean") {
    throw new $TypeError$5("`loose`, if provided, must be a boolean");
  }
  var nonEnumerable = arguments.length > 3 ? arguments[3] : null;
  var nonWritable = arguments.length > 4 ? arguments[4] : null;
  var nonConfigurable = arguments.length > 5 ? arguments[5] : null;
  var loose = arguments.length > 6 ? arguments[6] : false;
  var desc = !!gopd && gopd(obj, property);
  if ($defineProperty$1) {
    $defineProperty$1(obj, property, {
      configurable: nonConfigurable === null && desc ? desc.configurable : !nonConfigurable,
      enumerable: nonEnumerable === null && desc ? desc.enumerable : !nonEnumerable,
      value,
      writable: nonWritable === null && desc ? desc.writable : !nonWritable
    });
  } else if (loose || !nonEnumerable && !nonWritable && !nonConfigurable) {
    obj[property] = value;
  } else {
    throw new $SyntaxError$1("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.");
  }
};
var $defineProperty = esDefineProperty;
var hasPropertyDescriptors = function hasPropertyDescriptors2() {
  return !!$defineProperty;
};
hasPropertyDescriptors.hasArrayLengthDefineBug = function hasArrayLengthDefineBug() {
  if (!$defineProperty) {
    return null;
  }
  try {
    return $defineProperty([], "length", { value: 1 }).length !== 1;
  } catch (e) {
    return true;
  }
};
var hasPropertyDescriptors_1 = hasPropertyDescriptors;
var keys2 = objectKeys$2;
var hasSymbols$3 = typeof Symbol === "function" && typeof Symbol("foo") === "symbol";
var toStr$7 = Object.prototype.toString;
var concat = Array.prototype.concat;
var defineDataProperty2 = defineDataProperty$1;
var isFunction = function(fn) {
  return typeof fn === "function" && toStr$7.call(fn) === "[object Function]";
};
var supportsDescriptors$2 = hasPropertyDescriptors_1();
var defineProperty$1 = function(object, name, value, predicate) {
  if (name in object) {
    if (predicate === true) {
      if (object[name] === value) {
        return;
      }
    } else if (!isFunction(predicate) || !predicate()) {
      return;
    }
  }
  if (supportsDescriptors$2) {
    defineDataProperty2(object, name, value, true);
  } else {
    defineDataProperty2(object, name, value);
  }
};
var defineProperties$1 = function(object, map) {
  var predicates = arguments.length > 2 ? arguments[2] : {};
  var props = keys2(map);
  if (hasSymbols$3) {
    props = concat.call(props, Object.getOwnPropertySymbols(map));
  }
  for (var i = 0; i < props.length; i += 1) {
    defineProperty$1(object, props[i], map[props[i]], predicates[props[i]]);
  }
};
defineProperties$1.supportsDescriptors = !!supportsDescriptors$2;
var defineProperties_1 = defineProperties$1;
var callBind$6 = { exports: {} };
var GetIntrinsic$6 = getIntrinsic;
var define$5 = defineDataProperty$1;
var hasDescriptors$1 = hasPropertyDescriptors_1();
var gOPD$4 = gopd$1;
var $TypeError$4 = type;
var $floor$1 = GetIntrinsic$6("%Math.floor%");
var setFunctionLength = function setFunctionLength2(fn, length) {
  if (typeof fn !== "function") {
    throw new $TypeError$4("`fn` is not a function");
  }
  if (typeof length !== "number" || length < 0 || length > 4294967295 || $floor$1(length) !== length) {
    throw new $TypeError$4("`length` must be a positive 32-bit integer");
  }
  var loose = arguments.length > 2 && !!arguments[2];
  var functionLengthIsConfigurable = true;
  var functionLengthIsWritable = true;
  if ("length" in fn && gOPD$4) {
    var desc = gOPD$4(fn, "length");
    if (desc && !desc.configurable) {
      functionLengthIsConfigurable = false;
    }
    if (desc && !desc.writable) {
      functionLengthIsWritable = false;
    }
  }
  if (functionLengthIsConfigurable || functionLengthIsWritable || !loose) {
    if (hasDescriptors$1) {
      define$5(
        fn,
        "length",
        length,
        true,
        true
      );
    } else {
      define$5(
        fn,
        "length",
        length
      );
    }
  }
  return fn;
};
(function(module) {
  var bind3 = functionBind;
  var GetIntrinsic3 = getIntrinsic;
  var setFunctionLength$1 = setFunctionLength;
  var $TypeError2 = type;
  var $apply = GetIntrinsic3("%Function.prototype.apply%");
  var $call = GetIntrinsic3("%Function.prototype.call%");
  var $reflectApply = GetIntrinsic3("%Reflect.apply%", true) || bind3.call($call, $apply);
  var $defineProperty2 = esDefineProperty;
  var $max = GetIntrinsic3("%Math.max%");
  module.exports = function callBind2(originalFunction) {
    if (typeof originalFunction !== "function") {
      throw new $TypeError2("a function is required");
    }
    var func = $reflectApply(bind3, $call, arguments);
    return setFunctionLength$1(
      func,
      1 + $max(0, originalFunction.length - (arguments.length - 1)),
      true
    );
  };
  var applyBind = function applyBind2() {
    return $reflectApply(bind3, $apply, arguments);
  };
  if ($defineProperty2) {
    $defineProperty2(module.exports, "apply", { value: applyBind });
  } else {
    module.exports.apply = applyBind;
  }
})(callBind$6);
var callBindExports = callBind$6.exports;
var GetIntrinsic$5 = getIntrinsic;
var callBind$5 = callBindExports;
var $indexOf$1 = callBind$5(GetIntrinsic$5("String.prototype.indexOf"));
var callBound$c = function callBoundIntrinsic(name, allowMissing) {
  var intrinsic = GetIntrinsic$5(name, !!allowMissing);
  if (typeof intrinsic === "function" && $indexOf$1(name, ".prototype.") > -1) {
    return callBind$5(intrinsic);
  }
  return intrinsic;
};
var objectKeys$1 = objectKeys$2;
var hasSymbols$2 = shams$1();
var callBound$b = callBound$c;
var toObject = Object;
var $push = callBound$b("Array.prototype.push");
var $propIsEnumerable = callBound$b("Object.prototype.propertyIsEnumerable");
var originalGetSymbols = hasSymbols$2 ? Object.getOwnPropertySymbols : null;
var implementation$8 = function assign(target, source1) {
  if (target == null) {
    throw new TypeError("target must be an object");
  }
  var to = toObject(target);
  if (arguments.length === 1) {
    return to;
  }
  for (var s = 1; s < arguments.length; ++s) {
    var from = toObject(arguments[s]);
    var keys3 = objectKeys$1(from);
    var getSymbols = hasSymbols$2 && (Object.getOwnPropertySymbols || originalGetSymbols);
    if (getSymbols) {
      var syms = getSymbols(from);
      for (var j = 0; j < syms.length; ++j) {
        var key = syms[j];
        if ($propIsEnumerable(from, key)) {
          $push(keys3, key);
        }
      }
    }
    for (var i = 0; i < keys3.length; ++i) {
      var nextKey = keys3[i];
      if ($propIsEnumerable(from, nextKey)) {
        var propValue = from[nextKey];
        to[nextKey] = propValue;
      }
    }
  }
  return to;
};
var implementation$7 = implementation$8;
var lacksProperEnumerationOrder = function() {
  if (!Object.assign) {
    return false;
  }
  var str = "abcdefghijklmnopqrst";
  var letters = str.split("");
  var map = {};
  for (var i = 0; i < letters.length; ++i) {
    map[letters[i]] = letters[i];
  }
  var obj = Object.assign({}, map);
  var actual = "";
  for (var k in obj) {
    actual += k;
  }
  return str !== actual;
};
var assignHasPendingExceptions = function() {
  if (!Object.assign || !Object.preventExtensions) {
    return false;
  }
  var thrower = Object.preventExtensions({ 1: 2 });
  try {
    Object.assign(thrower, "xy");
  } catch (e) {
    return thrower[1] === "y";
  }
  return false;
};
var polyfill$4 = function getPolyfill() {
  if (!Object.assign) {
    return implementation$7;
  }
  if (lacksProperEnumerationOrder()) {
    return implementation$7;
  }
  if (assignHasPendingExceptions()) {
    return implementation$7;
  }
  return Object.assign;
};
var define$4 = defineProperties_1;
var getPolyfill$5 = polyfill$4;
var shim$5 = function shimAssign() {
  var polyfill22 = getPolyfill$5();
  define$4(
    Object,
    { assign: polyfill22 },
    { assign: function() {
      return Object.assign !== polyfill22;
    } }
  );
  return polyfill22;
};
var defineProperties = defineProperties_1;
var callBind$4 = callBindExports;
var implementation$6 = implementation$8;
var getPolyfill$4 = polyfill$4;
var shim$4 = shim$5;
var polyfill$3 = callBind$4.apply(getPolyfill$4());
var bound = function assign2(target, source1) {
  return polyfill$3(Object, arguments);
};
defineProperties(bound, {
  getPolyfill: getPolyfill$4,
  implementation: implementation$6,
  shim: shim$4
});
var functionsHaveNames = function functionsHaveNames2() {
  return typeof function f() {
  }.name === "string";
};
var gOPD$3 = Object.getOwnPropertyDescriptor;
if (gOPD$3) {
  try {
    gOPD$3([], "length");
  } catch (e) {
    gOPD$3 = null;
  }
}
functionsHaveNames.functionsHaveConfigurableNames = function functionsHaveConfigurableNames() {
  if (!functionsHaveNames() || !gOPD$3) {
    return false;
  }
  var desc = gOPD$3(function() {
  }, "name");
  return !!desc && !!desc.configurable;
};
var $bind = Function.prototype.bind;
functionsHaveNames.boundFunctionsHaveNames = function boundFunctionsHaveNames() {
  return functionsHaveNames() && typeof $bind === "function" && function f() {
  }.bind().name !== "";
};
var functionsHaveNames_1 = functionsHaveNames;
var define$3 = defineDataProperty$1;
var hasDescriptors = hasPropertyDescriptors_1();
var functionsHaveConfigurableNames2 = functionsHaveNames_1.functionsHaveConfigurableNames();
var $TypeError$3 = type;
var setFunctionName$1 = function setFunctionName(fn, name) {
  if (typeof fn !== "function") {
    throw new $TypeError$3("`fn` is not a function");
  }
  var loose = arguments.length > 2 && !!arguments[2];
  if (!loose || functionsHaveConfigurableNames2) {
    if (hasDescriptors) {
      define$3(
        fn,
        "name",
        name,
        true,
        true
      );
    } else {
      define$3(
        fn,
        "name",
        name
      );
    }
  }
  return fn;
};
var setFunctionName2 = setFunctionName$1;
var $TypeError$2 = type;
var $Object = Object;
var implementation$5 = setFunctionName2(function flags() {
  if (this == null || this !== $Object(this)) {
    throw new $TypeError$2("RegExp.prototype.flags getter called on non-object");
  }
  var result = "";
  if (this.hasIndices) {
    result += "d";
  }
  if (this.global) {
    result += "g";
  }
  if (this.ignoreCase) {
    result += "i";
  }
  if (this.multiline) {
    result += "m";
  }
  if (this.dotAll) {
    result += "s";
  }
  if (this.unicode) {
    result += "u";
  }
  if (this.unicodeSets) {
    result += "v";
  }
  if (this.sticky) {
    result += "y";
  }
  return result;
}, "get flags", true);
var implementation$4 = implementation$5;
var supportsDescriptors$1 = defineProperties_1.supportsDescriptors;
var $gOPD = Object.getOwnPropertyDescriptor;
var polyfill$2 = function getPolyfill2() {
  if (supportsDescriptors$1 && /a/mig.flags === "gim") {
    var descriptor = $gOPD(RegExp.prototype, "flags");
    if (descriptor && typeof descriptor.get === "function" && typeof RegExp.prototype.dotAll === "boolean" && typeof RegExp.prototype.hasIndices === "boolean") {
      var calls = "";
      var o = {};
      Object.defineProperty(o, "hasIndices", {
        get: function() {
          calls += "d";
        }
      });
      Object.defineProperty(o, "sticky", {
        get: function() {
          calls += "y";
        }
      });
      if (calls === "dy") {
        return descriptor.get;
      }
    }
  }
  return implementation$4;
};
var supportsDescriptors = defineProperties_1.supportsDescriptors;
var getPolyfill$3 = polyfill$2;
var gOPD$2 = Object.getOwnPropertyDescriptor;
var defineProperty = Object.defineProperty;
var TypeErr = TypeError;
var getProto = Object.getPrototypeOf;
var regex = /a/;
var shim$3 = function shimFlags() {
  if (!supportsDescriptors || !getProto) {
    throw new TypeErr("RegExp.prototype.flags requires a true ES5 environment that supports property descriptors");
  }
  var polyfill22 = getPolyfill$3();
  var proto = getProto(regex);
  var descriptor = gOPD$2(proto, "flags");
  if (!descriptor || descriptor.get !== polyfill22) {
    defineProperty(proto, "flags", {
      configurable: true,
      enumerable: false,
      get: polyfill22
    });
  }
  return polyfill22;
};
var define$2 = defineProperties_1;
var callBind$3 = callBindExports;
var implementation$3 = implementation$5;
var getPolyfill$2 = polyfill$2;
var shim$2 = shim$3;
var flagsBound = callBind$3(getPolyfill$2());
define$2(flagsBound, {
  getPolyfill: getPolyfill$2,
  implementation: implementation$3,
  shim: shim$2
});
var hasSymbols$1 = shams$1;
var shams = function hasToStringTagShams() {
  return hasSymbols$1() && !!Symbol.toStringTag;
};
var hasToStringTag$7 = shams();
var callBound$a = callBound$c;
var $toString$4 = callBound$a("Object.prototype.toString");
var isStandardArguments = function isArguments2(value) {
  if (hasToStringTag$7 && value && typeof value === "object" && Symbol.toStringTag in value) {
    return false;
  }
  return $toString$4(value) === "[object Arguments]";
};
var isLegacyArguments = function isArguments3(value) {
  if (isStandardArguments(value)) {
    return true;
  }
  return value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && $toString$4(value) !== "[object Array]" && $toString$4(value.callee) === "[object Function]";
};
(function() {
  return isStandardArguments(arguments);
})();
isStandardArguments.isLegacyArguments = isLegacyArguments;
const __viteBrowserExternal = {};
const __viteBrowserExternal$1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: __viteBrowserExternal
}, Symbol.toStringTag, { value: "Module" }));
const require$$0 = /* @__PURE__ */ getAugmentedNamespace(__viteBrowserExternal$1);
var hasMap = typeof Map === "function" && Map.prototype;
var mapSizeDescriptor = Object.getOwnPropertyDescriptor && hasMap ? Object.getOwnPropertyDescriptor(Map.prototype, "size") : null;
var mapSize = hasMap && mapSizeDescriptor && typeof mapSizeDescriptor.get === "function" ? mapSizeDescriptor.get : null;
var mapForEach = hasMap && Map.prototype.forEach;
var hasSet = typeof Set === "function" && Set.prototype;
var setSizeDescriptor = Object.getOwnPropertyDescriptor && hasSet ? Object.getOwnPropertyDescriptor(Set.prototype, "size") : null;
var setSize = hasSet && setSizeDescriptor && typeof setSizeDescriptor.get === "function" ? setSizeDescriptor.get : null;
var setForEach = hasSet && Set.prototype.forEach;
var hasWeakMap = typeof WeakMap === "function" && WeakMap.prototype;
var weakMapHas = hasWeakMap ? WeakMap.prototype.has : null;
var hasWeakSet = typeof WeakSet === "function" && WeakSet.prototype;
var weakSetHas = hasWeakSet ? WeakSet.prototype.has : null;
var hasWeakRef = typeof WeakRef === "function" && WeakRef.prototype;
var weakRefDeref = hasWeakRef ? WeakRef.prototype.deref : null;
var booleanValueOf = Boolean.prototype.valueOf;
var objectToString = Object.prototype.toString;
var functionToString = Function.prototype.toString;
var $match = String.prototype.match;
var $slice$1 = String.prototype.slice;
var $replace = String.prototype.replace;
var $toUpperCase = String.prototype.toUpperCase;
var $toLowerCase = String.prototype.toLowerCase;
var $test = RegExp.prototype.test;
var $concat = Array.prototype.concat;
var $join = Array.prototype.join;
var $arrSlice = Array.prototype.slice;
var $floor = Math.floor;
var bigIntValueOf$1 = typeof BigInt === "function" ? BigInt.prototype.valueOf : null;
var gOPS = Object.getOwnPropertySymbols;
var symToString = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? Symbol.prototype.toString : null;
var hasShammedSymbols = typeof Symbol === "function" && typeof Symbol.iterator === "object";
var toStringTag = typeof Symbol === "function" && Symbol.toStringTag && (typeof Symbol.toStringTag === hasShammedSymbols ? "object" : "symbol") ? Symbol.toStringTag : null;
var isEnumerable = Object.prototype.propertyIsEnumerable;
var gPO$1 = (typeof Reflect === "function" ? Reflect.getPrototypeOf : Object.getPrototypeOf) || ([].__proto__ === Array.prototype ? function(O) {
  return O.__proto__;
} : null);
function addNumericSeparator(num, str) {
  if (num === Infinity || num === -Infinity || num !== num || num && num > -1e3 && num < 1e3 || $test.call(/e/, str)) {
    return str;
  }
  var sepRegex = /[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;
  if (typeof num === "number") {
    var int = num < 0 ? -$floor(-num) : $floor(num);
    if (int !== num) {
      var intStr = String(int);
      var dec = $slice$1.call(str, intStr.length + 1);
      return $replace.call(intStr, sepRegex, "$&_") + "." + $replace.call($replace.call(dec, /([0-9]{3})/g, "$&_"), /_$/, "");
    }
  }
  return $replace.call(str, sepRegex, "$&_");
}
var utilInspect = require$$0;
var inspectCustom = utilInspect.custom;
var inspectSymbol = isSymbol$2(inspectCustom) ? inspectCustom : null;
var objectInspect = function inspect_(obj, options, depth, seen2) {
  var opts = options || {};
  if (has$1(opts, "quoteStyle") && (opts.quoteStyle !== "single" && opts.quoteStyle !== "double")) {
    throw new TypeError('option "quoteStyle" must be "single" or "double"');
  }
  if (has$1(opts, "maxStringLength") && (typeof opts.maxStringLength === "number" ? opts.maxStringLength < 0 && opts.maxStringLength !== Infinity : opts.maxStringLength !== null)) {
    throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');
  }
  var customInspect = has$1(opts, "customInspect") ? opts.customInspect : true;
  if (typeof customInspect !== "boolean" && customInspect !== "symbol") {
    throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");
  }
  if (has$1(opts, "indent") && opts.indent !== null && opts.indent !== "	" && !(parseInt(opts.indent, 10) === opts.indent && opts.indent > 0)) {
    throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');
  }
  if (has$1(opts, "numericSeparator") && typeof opts.numericSeparator !== "boolean") {
    throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');
  }
  var numericSeparator = opts.numericSeparator;
  if (typeof obj === "undefined") {
    return "undefined";
  }
  if (obj === null) {
    return "null";
  }
  if (typeof obj === "boolean") {
    return obj ? "true" : "false";
  }
  if (typeof obj === "string") {
    return inspectString(obj, opts);
  }
  if (typeof obj === "number") {
    if (obj === 0) {
      return Infinity / obj > 0 ? "0" : "-0";
    }
    var str = String(obj);
    return numericSeparator ? addNumericSeparator(obj, str) : str;
  }
  if (typeof obj === "bigint") {
    var bigIntStr = String(obj) + "n";
    return numericSeparator ? addNumericSeparator(obj, bigIntStr) : bigIntStr;
  }
  var maxDepth = typeof opts.depth === "undefined" ? 5 : opts.depth;
  if (typeof depth === "undefined") {
    depth = 0;
  }
  if (depth >= maxDepth && maxDepth > 0 && typeof obj === "object") {
    return isArray$2(obj) ? "[Array]" : "[Object]";
  }
  var indent = getIndent(opts, depth);
  if (typeof seen2 === "undefined") {
    seen2 = [];
  } else if (indexOf(seen2, obj) >= 0) {
    return "[Circular]";
  }
  function inspect2(value, from, noIndent) {
    if (from) {
      seen2 = $arrSlice.call(seen2);
      seen2.push(from);
    }
    if (noIndent) {
      var newOpts = {
        depth: opts.depth
      };
      if (has$1(opts, "quoteStyle")) {
        newOpts.quoteStyle = opts.quoteStyle;
      }
      return inspect_(value, newOpts, depth + 1, seen2);
    }
    return inspect_(value, opts, depth + 1, seen2);
  }
  if (typeof obj === "function" && !isRegExp(obj)) {
    var name = nameOf(obj);
    var keys3 = arrObjKeys(obj, inspect2);
    return "[Function" + (name ? ": " + name : " (anonymous)") + "]" + (keys3.length > 0 ? " { " + $join.call(keys3, ", ") + " }" : "");
  }
  if (isSymbol$2(obj)) {
    var symString = hasShammedSymbols ? $replace.call(String(obj), /^(Symbol\(.*\))_[^)]*$/, "$1") : symToString.call(obj);
    return typeof obj === "object" && !hasShammedSymbols ? markBoxed(symString) : symString;
  }
  if (isElement(obj)) {
    var s = "<" + $toLowerCase.call(String(obj.nodeName));
    var attrs = obj.attributes || [];
    for (var i = 0; i < attrs.length; i++) {
      s += " " + attrs[i].name + "=" + wrapQuotes(quote(attrs[i].value), "double", opts);
    }
    s += ">";
    if (obj.childNodes && obj.childNodes.length) {
      s += "...";
    }
    s += "</" + $toLowerCase.call(String(obj.nodeName)) + ">";
    return s;
  }
  if (isArray$2(obj)) {
    if (obj.length === 0) {
      return "[]";
    }
    var xs = arrObjKeys(obj, inspect2);
    if (indent && !singleLineValues(xs)) {
      return "[" + indentedJoin(xs, indent) + "]";
    }
    return "[ " + $join.call(xs, ", ") + " ]";
  }
  if (isError(obj)) {
    var parts = arrObjKeys(obj, inspect2);
    if (!("cause" in Error.prototype) && "cause" in obj && !isEnumerable.call(obj, "cause")) {
      return "{ [" + String(obj) + "] " + $join.call($concat.call("[cause]: " + inspect2(obj.cause), parts), ", ") + " }";
    }
    if (parts.length === 0) {
      return "[" + String(obj) + "]";
    }
    return "{ [" + String(obj) + "] " + $join.call(parts, ", ") + " }";
  }
  if (typeof obj === "object" && customInspect) {
    if (inspectSymbol && typeof obj[inspectSymbol] === "function" && utilInspect) {
      return utilInspect(obj, { depth: maxDepth - depth });
    } else if (customInspect !== "symbol" && typeof obj.inspect === "function") {
      return obj.inspect();
    }
  }
  if (isMap$3(obj)) {
    var mapParts = [];
    if (mapForEach) {
      mapForEach.call(obj, function(value, key) {
        mapParts.push(inspect2(key, obj, true) + " => " + inspect2(value, obj));
      });
    }
    return collectionOf("Map", mapSize.call(obj), mapParts, indent);
  }
  if (isSet$3(obj)) {
    var setParts = [];
    if (setForEach) {
      setForEach.call(obj, function(value) {
        setParts.push(inspect2(value, obj));
      });
    }
    return collectionOf("Set", setSize.call(obj), setParts, indent);
  }
  if (isWeakMap$1(obj)) {
    return weakCollectionOf("WeakMap");
  }
  if (isWeakSet$1(obj)) {
    return weakCollectionOf("WeakSet");
  }
  if (isWeakRef(obj)) {
    return weakCollectionOf("WeakRef");
  }
  if (isNumber$1(obj)) {
    return markBoxed(inspect2(Number(obj)));
  }
  if (isBigInt$1(obj)) {
    return markBoxed(inspect2(bigIntValueOf$1.call(obj)));
  }
  if (isBoolean$1(obj)) {
    return markBoxed(booleanValueOf.call(obj));
  }
  if (isString$3(obj)) {
    return markBoxed(inspect2(String(obj)));
  }
  if (typeof window !== "undefined" && obj === window) {
    return "{ [object Window] }";
  }
  if (obj === commonjsGlobal) {
    return "{ [object globalThis] }";
  }
  if (!isDate$1(obj) && !isRegExp(obj)) {
    var ys = arrObjKeys(obj, inspect2);
    var isPlainObject2 = gPO$1 ? gPO$1(obj) === Object.prototype : obj instanceof Object || obj.constructor === Object;
    var protoTag = obj instanceof Object ? "" : "null prototype";
    var stringTag = !isPlainObject2 && toStringTag && Object(obj) === obj && toStringTag in obj ? $slice$1.call(toStr$6(obj), 8, -1) : protoTag ? "Object" : "";
    var constructorTag = isPlainObject2 || typeof obj.constructor !== "function" ? "" : obj.constructor.name ? obj.constructor.name + " " : "";
    var tag = constructorTag + (stringTag || protoTag ? "[" + $join.call($concat.call([], stringTag || [], protoTag || []), ": ") + "] " : "");
    if (ys.length === 0) {
      return tag + "{}";
    }
    if (indent) {
      return tag + "{" + indentedJoin(ys, indent) + "}";
    }
    return tag + "{ " + $join.call(ys, ", ") + " }";
  }
  return String(obj);
};
function wrapQuotes(s, defaultStyle, opts) {
  var quoteChar = (opts.quoteStyle || defaultStyle) === "double" ? '"' : "'";
  return quoteChar + s + quoteChar;
}
function quote(s) {
  return $replace.call(String(s), /"/g, "&quot;");
}
function isArray$2(obj) {
  return toStr$6(obj) === "[object Array]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isDate$1(obj) {
  return toStr$6(obj) === "[object Date]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isRegExp(obj) {
  return toStr$6(obj) === "[object RegExp]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isError(obj) {
  return toStr$6(obj) === "[object Error]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isString$3(obj) {
  return toStr$6(obj) === "[object String]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isNumber$1(obj) {
  return toStr$6(obj) === "[object Number]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isBoolean$1(obj) {
  return toStr$6(obj) === "[object Boolean]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isSymbol$2(obj) {
  if (hasShammedSymbols) {
    return obj && typeof obj === "object" && obj instanceof Symbol;
  }
  if (typeof obj === "symbol") {
    return true;
  }
  if (!obj || typeof obj !== "object" || !symToString) {
    return false;
  }
  try {
    symToString.call(obj);
    return true;
  } catch (e) {
  }
  return false;
}
function isBigInt$1(obj) {
  if (!obj || typeof obj !== "object" || !bigIntValueOf$1) {
    return false;
  }
  try {
    bigIntValueOf$1.call(obj);
    return true;
  } catch (e) {
  }
  return false;
}
var hasOwn$1 = Object.prototype.hasOwnProperty || function(key) {
  return key in this;
};
function has$1(obj, key) {
  return hasOwn$1.call(obj, key);
}
function toStr$6(obj) {
  return objectToString.call(obj);
}
function nameOf(f) {
  if (f.name) {
    return f.name;
  }
  var m = $match.call(functionToString.call(f), /^function\s*([\w$]+)/);
  if (m) {
    return m[1];
  }
  return null;
}
function indexOf(xs, x) {
  if (xs.indexOf) {
    return xs.indexOf(x);
  }
  for (var i = 0, l = xs.length; i < l; i++) {
    if (xs[i] === x) {
      return i;
    }
  }
  return -1;
}
function isMap$3(x) {
  if (!mapSize || !x || typeof x !== "object") {
    return false;
  }
  try {
    mapSize.call(x);
    try {
      setSize.call(x);
    } catch (s) {
      return true;
    }
    return x instanceof Map;
  } catch (e) {
  }
  return false;
}
function isWeakMap$1(x) {
  if (!weakMapHas || !x || typeof x !== "object") {
    return false;
  }
  try {
    weakMapHas.call(x, weakMapHas);
    try {
      weakSetHas.call(x, weakSetHas);
    } catch (s) {
      return true;
    }
    return x instanceof WeakMap;
  } catch (e) {
  }
  return false;
}
function isWeakRef(x) {
  if (!weakRefDeref || !x || typeof x !== "object") {
    return false;
  }
  try {
    weakRefDeref.call(x);
    return true;
  } catch (e) {
  }
  return false;
}
function isSet$3(x) {
  if (!setSize || !x || typeof x !== "object") {
    return false;
  }
  try {
    setSize.call(x);
    try {
      mapSize.call(x);
    } catch (m) {
      return true;
    }
    return x instanceof Set;
  } catch (e) {
  }
  return false;
}
function isWeakSet$1(x) {
  if (!weakSetHas || !x || typeof x !== "object") {
    return false;
  }
  try {
    weakSetHas.call(x, weakSetHas);
    try {
      weakMapHas.call(x, weakMapHas);
    } catch (s) {
      return true;
    }
    return x instanceof WeakSet;
  } catch (e) {
  }
  return false;
}
function isElement(x) {
  if (!x || typeof x !== "object") {
    return false;
  }
  if (typeof HTMLElement !== "undefined" && x instanceof HTMLElement) {
    return true;
  }
  return typeof x.nodeName === "string" && typeof x.getAttribute === "function";
}
function inspectString(str, opts) {
  if (str.length > opts.maxStringLength) {
    var remaining = str.length - opts.maxStringLength;
    var trailer = "... " + remaining + " more character" + (remaining > 1 ? "s" : "");
    return inspectString($slice$1.call(str, 0, opts.maxStringLength), opts) + trailer;
  }
  var s = $replace.call($replace.call(str, /(['\\])/g, "\\$1"), /[\x00-\x1f]/g, lowbyte);
  return wrapQuotes(s, "single", opts);
}
function lowbyte(c) {
  var n = c.charCodeAt(0);
  var x = {
    8: "b",
    9: "t",
    10: "n",
    12: "f",
    13: "r"
  }[n];
  if (x) {
    return "\\" + x;
  }
  return "\\x" + (n < 16 ? "0" : "") + $toUpperCase.call(n.toString(16));
}
function markBoxed(str) {
  return "Object(" + str + ")";
}
function weakCollectionOf(type2) {
  return type2 + " { ? }";
}
function collectionOf(type2, size2, entries, indent) {
  var joinedEntries = indent ? indentedJoin(entries, indent) : $join.call(entries, ", ");
  return type2 + " (" + size2 + ") {" + joinedEntries + "}";
}
function singleLineValues(xs) {
  for (var i = 0; i < xs.length; i++) {
    if (indexOf(xs[i], "\n") >= 0) {
      return false;
    }
  }
  return true;
}
function getIndent(opts, depth) {
  var baseIndent;
  if (opts.indent === "	") {
    baseIndent = "	";
  } else if (typeof opts.indent === "number" && opts.indent > 0) {
    baseIndent = $join.call(Array(opts.indent + 1), " ");
  } else {
    return null;
  }
  return {
    base: baseIndent,
    prev: $join.call(Array(depth + 1), baseIndent)
  };
}
function indentedJoin(xs, indent) {
  if (xs.length === 0) {
    return "";
  }
  var lineJoiner = "\n" + indent.prev + indent.base;
  return lineJoiner + $join.call(xs, "," + lineJoiner) + "\n" + indent.prev;
}
function arrObjKeys(obj, inspect2) {
  var isArr = isArray$2(obj);
  var xs = [];
  if (isArr) {
    xs.length = obj.length;
    for (var i = 0; i < obj.length; i++) {
      xs[i] = has$1(obj, i) ? inspect2(obj[i], obj) : "";
    }
  }
  var syms = typeof gOPS === "function" ? gOPS(obj) : [];
  var symMap;
  if (hasShammedSymbols) {
    symMap = {};
    for (var k = 0; k < syms.length; k++) {
      symMap["$" + syms[k]] = syms[k];
    }
  }
  for (var key in obj) {
    if (!has$1(obj, key)) {
      continue;
    }
    if (isArr && String(Number(key)) === key && key < obj.length) {
      continue;
    }
    if (hasShammedSymbols && symMap["$" + key] instanceof Symbol) {
      continue;
    } else if ($test.call(/[^\w$]/, key)) {
      xs.push(inspect2(key, obj) + ": " + inspect2(obj[key], obj));
    } else {
      xs.push(key + ": " + inspect2(obj[key], obj));
    }
  }
  if (typeof gOPS === "function") {
    for (var j = 0; j < syms.length; j++) {
      if (isEnumerable.call(obj, syms[j])) {
        xs.push("[" + inspect2(syms[j]) + "]: " + inspect2(obj[syms[j]], obj));
      }
    }
  }
  return xs;
}
var GetIntrinsic$4 = getIntrinsic;
var callBound$9 = callBound$c;
var inspect = objectInspect;
var $TypeError$1 = type;
var $WeakMap$1 = GetIntrinsic$4("%WeakMap%", true);
var $Map$3 = GetIntrinsic$4("%Map%", true);
var $weakMapGet = callBound$9("WeakMap.prototype.get", true);
var $weakMapSet = callBound$9("WeakMap.prototype.set", true);
var $weakMapHas = callBound$9("WeakMap.prototype.has", true);
var $mapGet$1 = callBound$9("Map.prototype.get", true);
var $mapSet = callBound$9("Map.prototype.set", true);
var $mapHas$5 = callBound$9("Map.prototype.has", true);
var listGetNode = function(list, key) {
  var prev = list;
  var curr;
  for (; (curr = prev.next) !== null; prev = curr) {
    if (curr.key === key) {
      prev.next = curr.next;
      curr.next = list.next;
      list.next = curr;
      return curr;
    }
  }
};
var listGet = function(objects, key) {
  var node = listGetNode(objects, key);
  return node && node.value;
};
var listSet = function(objects, key, value) {
  var node = listGetNode(objects, key);
  if (node) {
    node.value = value;
  } else {
    objects.next = {
      key,
      next: objects.next,
      value
    };
  }
};
var listHas = function(objects, key) {
  return !!listGetNode(objects, key);
};
var sideChannel = function getSideChannel() {
  var $wm;
  var $m;
  var $o;
  var channel2 = {
    assert: function(key) {
      if (!channel2.has(key)) {
        throw new $TypeError$1("Side channel does not contain " + inspect(key));
      }
    },
    get: function(key) {
      if ($WeakMap$1 && key && (typeof key === "object" || typeof key === "function")) {
        if ($wm) {
          return $weakMapGet($wm, key);
        }
      } else if ($Map$3) {
        if ($m) {
          return $mapGet$1($m, key);
        }
      } else {
        if ($o) {
          return listGet($o, key);
        }
      }
    },
    has: function(key) {
      if ($WeakMap$1 && key && (typeof key === "object" || typeof key === "function")) {
        if ($wm) {
          return $weakMapHas($wm, key);
        }
      } else if ($Map$3) {
        if ($m) {
          return $mapHas$5($m, key);
        }
      } else {
        if ($o) {
          return listHas($o, key);
        }
      }
      return false;
    },
    set: function(key, value) {
      if ($WeakMap$1 && key && (typeof key === "object" || typeof key === "function")) {
        if (!$wm) {
          $wm = new $WeakMap$1();
        }
        $weakMapSet($wm, key, value);
      } else if ($Map$3) {
        if (!$m) {
          $m = new $Map$3();
        }
        $mapSet($m, key, value);
      } else {
        if (!$o) {
          $o = { key: {}, next: null };
        }
        listSet($o, key, value);
      }
    }
  };
  return channel2;
};
var hasOwn = hasown;
var channel = sideChannel();
var $TypeError = type;
var SLOT$1 = {
  assert: function(O, slot) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    channel.assert(O);
    if (!SLOT$1.has(O, slot)) {
      throw new $TypeError("`" + slot + "` is not present on `O`");
    }
  },
  get: function(O, slot) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    var slots = channel.get(O);
    return slots && slots["$" + slot];
  },
  has: function(O, slot) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    var slots = channel.get(O);
    return !!slots && hasOwn(slots, "$" + slot);
  },
  set: function(O, slot, V) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    var slots = channel.get(O);
    if (!slots) {
      slots = {};
      channel.set(O, slots);
    }
    slots["$" + slot] = V;
  }
};
if (Object.freeze) {
  Object.freeze(SLOT$1);
}
typeof StopIteration === "object" ? StopIteration : null;
shams();
if (hasSymbols$5() || shams$1())
  ;
else {
  var GetIntrinsic$3 = getIntrinsic;
  var $Map = GetIntrinsic$3("%Map%", true);
  var $Set$1 = GetIntrinsic$3("%Set%", true);
  var callBound$8 = callBound$c;
  callBound$8("Array.prototype.push");
  callBound$8("String.prototype.charCodeAt");
  callBound$8("String.prototype.slice");
  if (!$Map && !$Set$1)
    ;
  else {
    callBound$8("Map.prototype.forEach", true);
    callBound$8("Set.prototype.forEach", true);
    if (typeof process === "undefined" || !process.versions || !process.versions.node) {
      callBound$8("Map.prototype.iterator", true);
      callBound$8("Set.prototype.iterator", true);
    }
    callBound$8("Map.prototype.@@iterator", true) || callBound$8("Map.prototype._es6-shim iterator_", true);
    callBound$8("Set.prototype.@@iterator", true) || callBound$8("Set.prototype._es6-shim iterator_", true);
  }
}
var numberIsNaN = function(value) {
  return value !== value;
};
var implementation$2 = function is(a, b) {
  if (a === 0 && b === 0) {
    return 1 / a === 1 / b;
  }
  if (a === b) {
    return true;
  }
  if (numberIsNaN(a) && numberIsNaN(b)) {
    return true;
  }
  return false;
};
var implementation$1 = implementation$2;
var polyfill$1 = function getPolyfill3() {
  return typeof Object.is === "function" ? Object.is : implementation$1;
};
var getPolyfill$1 = polyfill$1;
var define$1 = defineProperties_1;
var shim$1 = function shimObjectIs() {
  var polyfill22 = getPolyfill$1();
  define$1(Object, { is: polyfill22 }, {
    is: function testObjectIs() {
      return Object.is !== polyfill22;
    }
  });
  return polyfill22;
};
var define = defineProperties_1;
var callBind$2 = callBindExports;
var implementation = implementation$2;
var getPolyfill4 = polyfill$1;
var shim = shim$1;
var polyfill2 = callBind$2(getPolyfill4(), Object);
define(polyfill2, {
  getPolyfill: getPolyfill4,
  implementation,
  shim
});
var callBind$1 = callBindExports;
var callBound$7 = callBound$c;
var GetIntrinsic$2 = getIntrinsic;
var $ArrayBuffer = GetIntrinsic$2("%ArrayBuffer%", true);
var $byteLength$2 = callBound$7("ArrayBuffer.prototype.byteLength", true);
callBound$7("Object.prototype.toString");
var abSlice = !!$ArrayBuffer && !$byteLength$2 && new $ArrayBuffer(0).slice;
!!abSlice && callBind$1(abSlice);
shams();
var callBound$6 = callBound$c;
var hasToStringTag$4 = shams();
var isRegexMarker;
var badStringifier;
if (hasToStringTag$4) {
  callBound$6("Object.prototype.hasOwnProperty");
  callBound$6("RegExp.prototype.exec");
  isRegexMarker = {};
  var throwRegexMarker = function() {
    throw isRegexMarker;
  };
  badStringifier = {
    toString: throwRegexMarker,
    valueOf: throwRegexMarker
  };
  if (typeof Symbol.toPrimitive === "symbol") {
    badStringifier[Symbol.toPrimitive] = throwRegexMarker;
  }
}
callBound$6("Object.prototype.toString");
var callBound$5 = callBound$c;
callBound$5("SharedArrayBuffer.prototype.byteLength", true);
shams();
var callBound$4 = callBound$c;
callBound$4("Boolean.prototype.toString");
callBound$4("Object.prototype.toString");
shams();
hasSymbols$5();
var $BigInt = typeof BigInt !== "undefined" && BigInt;
var hasBigints = function hasNativeBigInts() {
  return typeof $BigInt === "function" && typeof BigInt === "function" && typeof $BigInt(42) === "bigint" && typeof BigInt(42) === "bigint";
};
hasBigints();
var $WeakMap = typeof WeakMap === "function" && WeakMap.prototype ? WeakMap : null;
var $WeakSet$1 = typeof WeakSet === "function" && WeakSet.prototype ? WeakSet : null;
$WeakMap ? $WeakMap.prototype.has : null;
$WeakSet$1 ? $WeakSet$1.prototype.has : null;
var GetIntrinsic$1 = getIntrinsic;
var callBound$3 = callBound$c;
GetIntrinsic$1("%WeakSet%", true);
var $setHas$1 = callBound$3("WeakSet.prototype.has", true);
if ($setHas$1) {
  callBound$3("WeakMap.prototype.has", true);
}
var fnToStr = Function.prototype.toString;
var reflectApply = typeof Reflect === "object" && Reflect !== null && Reflect.apply;
var badArrayLike;
var isCallableMarker;
if (typeof reflectApply === "function" && typeof Object.defineProperty === "function") {
  try {
    badArrayLike = Object.defineProperty({}, "length", {
      get: function() {
        throw isCallableMarker;
      }
    });
    isCallableMarker = {};
    reflectApply(function() {
      throw 42;
    }, null, badArrayLike);
  } catch (_) {
    if (_ !== isCallableMarker) {
      reflectApply = null;
    }
  }
} else {
  reflectApply = null;
}
var constructorRegex = /^\s*class\b/;
var isES6ClassFn = function isES6ClassFunction(value) {
  try {
    var fnStr = fnToStr.call(value);
    return constructorRegex.test(fnStr);
  } catch (e) {
    return false;
  }
};
var tryFunctionObject = function tryFunctionToStr(value) {
  try {
    if (isES6ClassFn(value)) {
      return false;
    }
    fnToStr.call(value);
    return true;
  } catch (e) {
    return false;
  }
};
var toStr$1 = Object.prototype.toString;
var objectClass = "[object Object]";
var fnClass = "[object Function]";
var genClass = "[object GeneratorFunction]";
var ddaClass = "[object HTMLAllCollection]";
var ddaClass2 = "[object HTML document.all class]";
var ddaClass3 = "[object HTMLCollection]";
var hasToStringTag$1 = typeof Symbol === "function" && !!Symbol.toStringTag;
var isIE68 = !(0 in [,]);
var isDDA = function isDocumentDotAll() {
  return false;
};
if (typeof document === "object") {
  var all = document.all;
  if (toStr$1.call(all) === toStr$1.call(document.all)) {
    isDDA = function isDocumentDotAll2(value) {
      if ((isIE68 || !value) && (typeof value === "undefined" || typeof value === "object")) {
        try {
          var str = toStr$1.call(value);
          return (str === ddaClass || str === ddaClass2 || str === ddaClass3 || str === objectClass) && value("") == null;
        } catch (e) {
        }
      }
      return false;
    };
  }
}
var isCallable$1 = reflectApply ? function isCallable(value) {
  if (isDDA(value)) {
    return true;
  }
  if (!value) {
    return false;
  }
  if (typeof value !== "function" && typeof value !== "object") {
    return false;
  }
  try {
    reflectApply(value, null, badArrayLike);
  } catch (e) {
    if (e !== isCallableMarker) {
      return false;
    }
  }
  return !isES6ClassFn(value) && tryFunctionObject(value);
} : function isCallable2(value) {
  if (isDDA(value)) {
    return true;
  }
  if (!value) {
    return false;
  }
  if (typeof value !== "function" && typeof value !== "object") {
    return false;
  }
  if (hasToStringTag$1) {
    return tryFunctionObject(value);
  }
  if (isES6ClassFn(value)) {
    return false;
  }
  var strClass2 = toStr$1.call(value);
  if (strClass2 !== fnClass && strClass2 !== genClass && !/^\[object HTML/.test(strClass2)) {
    return false;
  }
  return tryFunctionObject(value);
};
var isCallable3 = isCallable$1;
var toStr = Object.prototype.toString;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var forEachArray = function forEachArray2(array, iterator, receiver) {
  for (var i = 0, len = array.length; i < len; i++) {
    if (hasOwnProperty.call(array, i)) {
      if (receiver == null) {
        iterator(array[i], i, array);
      } else {
        iterator.call(receiver, array[i], i, array);
      }
    }
  }
};
var forEachString = function forEachString2(string, iterator, receiver) {
  for (var i = 0, len = string.length; i < len; i++) {
    if (receiver == null) {
      iterator(string.charAt(i), i, string);
    } else {
      iterator.call(receiver, string.charAt(i), i, string);
    }
  }
};
var forEachObject = function forEachObject2(object, iterator, receiver) {
  for (var k in object) {
    if (hasOwnProperty.call(object, k)) {
      if (receiver == null) {
        iterator(object[k], k, object);
      } else {
        iterator.call(receiver, object[k], k, object);
      }
    }
  }
};
var forEach$1 = function forEach(list, iterator, thisArg) {
  if (!isCallable3(iterator)) {
    throw new TypeError("iterator must be a function");
  }
  var receiver;
  if (arguments.length >= 3) {
    receiver = thisArg;
  }
  if (toStr.call(list) === "[object Array]") {
    forEachArray(list, iterator, receiver);
  } else if (typeof list === "string") {
    forEachString(list, iterator, receiver);
  } else {
    forEachObject(list, iterator, receiver);
  }
};
var forEach_1 = forEach$1;
var possibleTypedArrayNames = [
  "Float32Array",
  "Float64Array",
  "Int8Array",
  "Int16Array",
  "Int32Array",
  "Uint8Array",
  "Uint8ClampedArray",
  "Uint16Array",
  "Uint32Array",
  "BigInt64Array",
  "BigUint64Array"
];
var possibleNames = possibleTypedArrayNames;
var g$1 = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
var availableTypedArrays$1 = function availableTypedArrays() {
  var out = [];
  for (var i = 0; i < possibleNames.length; i++) {
    if (typeof g$1[possibleNames[i]] === "function") {
      out[out.length] = possibleNames[i];
    }
  }
  return out;
};
var forEach2 = forEach_1;
var availableTypedArrays2 = availableTypedArrays$1;
var callBind = callBindExports;
var callBound$2 = callBound$c;
var gOPD = gopd$1;
callBound$2("Object.prototype.toString");
var hasToStringTag = shams();
var g = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
var typedArrays = availableTypedArrays2();
callBound$2("String.prototype.slice");
var getPrototypeOf = Object.getPrototypeOf;
callBound$2("Array.prototype.indexOf", true) || function indexOf2(array, value) {
  for (var i = 0; i < array.length; i += 1) {
    if (array[i] === value) {
      return i;
    }
  }
  return -1;
};
if (hasToStringTag && gOPD && getPrototypeOf) {
  forEach2(typedArrays, function(typedArray) {
    var arr = new g[typedArray]();
    if (Symbol.toStringTag in arr) {
      var proto = getPrototypeOf(arr);
      var descriptor = gOPD(proto, Symbol.toStringTag);
      if (!descriptor) {
        var superProto = getPrototypeOf(proto);
        descriptor = gOPD(superProto, Symbol.toStringTag);
      }
      callBind(descriptor.get);
    }
  });
} else {
  forEach2(typedArrays, function(typedArray) {
    var arr = new g[typedArray]();
    var fn = arr.slice || arr.set;
    if (fn) {
      callBind(fn);
    }
  });
}
var callBound$1 = callBound$c;
callBound$1("ArrayBuffer.prototype.byteLength", true);
var callBound = callBound$c;
var GetIntrinsic2 = getIntrinsic;
callBound("SharedArrayBuffer.prototype.byteLength", true);
callBound("Date.prototype.getTime");
callBound("Object.prototype.toString");
GetIntrinsic2("%Set%", true);
callBound("Map.prototype.has", true);
callBound("Map.prototype.get", true);
callBound("Map.prototype.size", true);
callBound("Set.prototype.add", true);
callBound("Set.prototype.delete", true);
callBound("Set.prototype.has", true);
callBound("Set.prototype.size", true);
const _hoisted_1 = { class: "flex flex-row justify-between sm:flex sm:items-center" };
const _hoisted_2 = /* @__PURE__ */ createBaseVNode("div", { class: "px-4 sm:px-0 sm:flex-auto" }, [
  /* @__PURE__ */ createBaseVNode("p", { class: "mt-4 text-medium text-default" }, "All tasks currently configured on the system are listed here. ")
], -1);
const _hoisted_3 = { class: "flex flex-row justify-between" };
const _hoisted_4 = { class: "px-3" };
const _hoisted_5 = /* @__PURE__ */ createBaseVNode("label", { class: "block text-medium font-medium leading-6 text-default" }, "Search Tasks", -1);
const _hoisted_6 = { class: "mt-5 py-0.5 px-3" };
const _hoisted_7 = { class: "mt-5 py-0.5 px-3" };
const _hoisted_8 = { class: "my-4 flow-root" };
const _hoisted_9 = { class: "-mx-4 overflow-x-auto sm:-mx-6 lg:-mx-8" };
const _hoisted_10 = { class: "inline-block min-w-full py-2 align-middle sm:px-6 lg:px-8 overflow-x-auto" };
const _hoisted_11 = {
  key: 0,
  class: "flex items-center justify-center"
};
const _hoisted_12 = {
  key: 1,
  class: "min-w-full min-h-full items-center text-center bg-well"
};
const _hoisted_13 = /* @__PURE__ */ createBaseVNode("h2", null, "No Tasks Found", -1);
const _hoisted_14 = [
  _hoisted_13
];
const _hoisted_15 = {
  key: 2,
  class: "relative"
};
const _hoisted_16 = { class: "overflow-x-auto" };
const _hoisted_17 = { class: "min-w-full divide-y divide-default" };
const _hoisted_18 = { class: "bg-well" };
const _hoisted_19 = { class: "border border-default border-collapse grid grid-cols-8 w-full" };
const _hoisted_20 = {
  scope: "col",
  class: "px-3 py-3.5 text-left text-sm font-semibold text-default border border-default border-collapse col-span-2"
};
const _hoisted_21 = /* @__PURE__ */ createBaseVNode("th", {
  scope: "col",
  class: "px-3 py-3.5 text-left text-sm font-semibold text-default border border-default border-collapse col-span-2"
}, " Status ", -1);
const _hoisted_22 = /* @__PURE__ */ createBaseVNode("th", {
  scope: "col",
  class: "px-3 py-3.5 text-left text-sm font-semibold text-default border border-default border-collapse col-span-2"
}, " Last Run ", -1);
const _hoisted_23 = /* @__PURE__ */ createBaseVNode("th", {
  scope: "col",
  class: "px-3 py-3.5 text-left text-sm font-semibold text-default border border-default border-collapse col-span-1"
}, " Scheduled ", -1);
const _hoisted_24 = /* @__PURE__ */ createBaseVNode("th", {
  scope: "col",
  class: "px-3 py-3.5 text-left text-sm font-semibold text-default border border-default border-collapse col-span-1"
}, " Details ", -1);
const _hoisted_25 = { class: "bg-accent" };
const _hoisted_26 = { key: 0 };
const _hoisted_27 = { key: 1 };
const _hoisted_28 = { key: 2 };
const _hoisted_29 = { key: 3 };
const _hoisted_30 = { key: 4 };
const _hoisted_31 = { key: 5 };
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "SchedulerView",
  setup(__props) {
    const taskInstances = injectWithCheck(taskInstancesInjectionKey, "taskInstances not provided!");
    const loading = injectWithCheck(loadingInjectionKey, "loading not provided!");
    injectWithCheck(truncateTextInjectionKey, "truncateText not provided!");
    const myScheduler = injectWithCheck(schedulerInjectionKey, "scheduler not provided!");
    const selectedTask = ref$1();
    const taskTableRow = ref$1([]);
    async function updateStatusAndTime(task, index2) {
      const target = taskTableRow.value[index2];
      await target.updateTaskStatus(task);
      await target.fetchLatestLog(task);
    }
    async function refreshBtn() {
      loading.value = true;
      await myScheduler.loadTaskInstances();
      loading.value = false;
    }
    const expandedTaskName = ref$1(null);
    function toggleDetails(taskName) {
      expandedTaskName.value = expandedTaskName.value === taskName ? null : taskName;
    }
    const showTaskWizard = ref$1(false);
    async function addTaskBtn() {
      await loadAddTaskComponent();
      showTaskWizard.value = true;
    }
    const addTaskComponent = ref$1();
    async function loadAddTaskComponent() {
      const module = await __vitePreload(() => import("./AddTask.e21b12cf.js"), true ? ["./AddTask.e21b12cf.js","./Modal.vue_vue_type_script_setup_true_lang.9365df46.js","./ParameterInput.vue_vue_type_script_setup_true_lang.2d1ccee3.js","./InfoTile.vue_vue_type_script_setup_true_lang.59beec9a.js","./switch.85ed3546.js","./ParameterInput.b383480d.css"] : void 0, import.meta.url);
      addTaskComponent.value = module.default;
    }
    const showEditTaskWizard = ref$1(false);
    async function editTaskBtn(task) {
      selectedTask.value = task;
      await loadEditTaskComponent();
      showEditTaskWizard.value = true;
    }
    const editTaskComponent = ref$1();
    async function loadEditTaskComponent() {
      const module = await __vitePreload(() => import("./EditTask.1884094c.js"), true ? ["./EditTask.1884094c.js","./Modal.vue_vue_type_script_setup_true_lang.9365df46.js","./ParameterInput.vue_vue_type_script_setup_true_lang.2d1ccee3.js","./InfoTile.vue_vue_type_script_setup_true_lang.59beec9a.js","./switch.85ed3546.js","./ParameterInput.b383480d.css"] : void 0, import.meta.url);
      editTaskComponent.value = module.default;
    }
    async function loadConfirmationDialog(dialogRef) {
      const module = await __vitePreload(() => import("./ConfirmationDialog.95d4bb09.js"), true ? ["./ConfirmationDialog.95d4bb09.js","./Modal.vue_vue_type_script_setup_true_lang.9365df46.js"] : void 0, import.meta.url);
      dialogRef.value = module.default;
    }
    const showRunNowPrompt = ref$1(false);
    const runNowDialog = ref$1();
    const running = ref$1(false);
    function runTaskBtn(task) {
      selectedTask.value = task;
      showRunNowDialog();
    }
    async function showRunNowDialog() {
      await loadConfirmationDialog(runNowDialog);
      showRunNowPrompt.value = true;
    }
    const updateShowRunNowPrompt = (newVal) => {
      showRunNowPrompt.value = newVal;
    };
    const runNowNo = async () => {
      updateShowRunNowPrompt(false);
    };
    const runNowYes = async () => {
      running.value = true;
      pushNotification(new Notification("Task Started", `Task ${selectedTask.value.name} has started running.`, "info", 5e3));
      const taskIndex = taskInstances.value.indexOf(selectedTask.value);
      await updateStatusAndTime(selectedTask.value, taskIndex);
      updateShowRunNowPrompt(false);
      await myScheduler.runTaskNow(selectedTask.value).then(() => {
        pushNotification(new Notification("Task Successful", `Task ${selectedTask.value.name} has successfully completed.`, "success", 8e3));
      }).catch((error) => {
        pushNotification(new Notification("Task Failed", `Task ${selectedTask.value.name} failed to complete.`, "error", 8e3));
      });
      await updateStatusAndTime(selectedTask.value, taskIndex);
      updateShowRunNowPrompt(false);
      running.value = false;
    };
    const showRemoveTaskPrompt = ref$1(false);
    const removeTaskDialog = ref$1();
    const removing = ref$1(false);
    function removeTaskBtn(task) {
      console.log("removeTaskBtn triggered");
      selectedTask.value = task;
      showRemoveTaskDialog();
    }
    async function showRemoveTaskDialog() {
      await loadConfirmationDialog(removeTaskDialog);
      showRemoveTaskPrompt.value = true;
    }
    const removeTaskYes = async () => {
      removing.value = true;
      await myScheduler.unregisterTaskInstance(selectedTask.value);
      loading.value = true;
      await myScheduler.loadTaskInstances();
      loading.value = false;
      removing.value = false;
      updateShowRemoveTaskPrompt(false);
    };
    const removeTaskNo = async () => {
      updateShowRemoveTaskPrompt(false);
    };
    const updateShowRemoveTaskPrompt = (newVal) => {
      showRemoveTaskPrompt.value = newVal;
    };
    const scheduleMode = ref$1("");
    const showThisScheduleWizard = ref$1(false);
    function manageScheduleBtn(task) {
      selectedTask.value = task;
      scheduleMode.value = "edit";
      showThisScheduleWizardComponent();
    }
    const scheduleWizardComponent = ref$1();
    const loadScheduleWizardComponent = async () => {
      console.log("loadScheduleWizard triggered");
      const module = await __vitePreload(() => import("./ManageSchedule.27539125.js"), true ? ["./ManageSchedule.27539125.js","./Modal.vue_vue_type_script_setup_true_lang.9365df46.js","./InfoTile.vue_vue_type_script_setup_true_lang.59beec9a.js"] : void 0, import.meta.url);
      scheduleWizardComponent.value = module.default;
    };
    async function showThisScheduleWizardComponent() {
      console.log("Attempting to load Schedule Wizard Component...");
      try {
        await loadScheduleWizardComponent();
        console.log("schedulerView: Component loaded, setting showThisScheduleWizard to true.");
        showThisScheduleWizard.value = true;
      } catch (error) {
        console.error("Failed to load Schedule Wizard Component:", error);
      }
    }
    const updateShowThisScheduleWizardComponent = (newVal) => {
      console.log("updateShowThisScheduleWizard triggered");
      showThisScheduleWizard.value = newVal;
    };
    const addScheduleHandler = async (task) => {
      selectedTask.value = task;
      scheduleMode.value = "new";
      await loadScheduleWizardComponent();
      showThisScheduleWizard.value = true;
    };
    const showLogView = ref$1(false);
    async function viewLogsBtn(task) {
      selectedTask.value = task;
      await loadLogViewComponent();
      showLogView.value = true;
    }
    const logViewComponent = ref$1();
    async function loadLogViewComponent() {
      const module = await __vitePreload(() => import("./LogView.a7456e84.js"), true ? ["./LogView.a7456e84.js","./Modal.vue_vue_type_script_setup_true_lang.9365df46.js","./switch.85ed3546.js"] : void 0, import.meta.url);
      logViewComponent.value = module.default;
    }
    const updateShowLogViewComponent = (newVal) => {
      showLogView.value = newVal;
    };
    const searchItem = ref$1("");
    const filterItem = ref$1("no_filter");
    const sortMode = ref$1(null);
    const sort = ref$1({
      field: null,
      order: 1
    });
    const filteredAndSortedTasks = computed(() => {
      let filteredTasks = taskInstances.value;
      if (searchItem.value) {
        const searchQuery = searchItem.value.toLowerCase();
        filteredTasks = filteredTasks.filter((task) => {
          for (const key in task) {
            const value = task[key];
            if (value && value.toString().toLowerCase().includes(searchQuery)) {
              return true;
            }
          }
          return false;
        });
      }
      if (filterItem.value && filterItem.value !== "no_filter")
        ;
      return sortTasks(filteredTasks);
    });
    const sortTasks = (tasksToSort) => {
      if (!sort.value.field)
        return tasksToSort;
      const field = sort.value.field;
      return [...tasksToSort].sort((a, b) => {
        const factor = sort.value.order === 1 ? 1 : -1;
        const valueA = a[field];
        const valueB = b[field];
        if (valueA === null || valueB === null) {
          return valueA === null ? 1 : -1;
        }
        if (typeof valueA === "string" && typeof valueB === "string") {
          return factor * valueA.localeCompare(valueB);
        }
        return factor * (valueA - valueB);
      });
    };
    const sortBy = (field) => {
      if (sort.value.field === field) {
        sort.value.order = -sort.value.order;
      } else {
        sort.value.field = field;
        sort.value.order = 1;
      }
      sortIconFlip();
    };
    function sortIconFlip() {
      if (sort.value.order == 1) {
        sortMode.value = "asc";
      } else if (sort.value.order == -1) {
        sortMode.value = "desc";
      } else {
        sortMode.value = null;
      }
    }
    provide("show-task-wizard", showTaskWizard);
    provide("show-schedule-wizard", showThisScheduleWizard);
    provide("show-edit-task-wizard", showEditTaskWizard);
    provide("show-log-view", showLogView);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createBaseVNode("div", null, [
          createBaseVNode("div", _hoisted_1, [
            _hoisted_2,
            createBaseVNode("div", _hoisted_3, [
              createBaseVNode("div", _hoisted_4, [
                _hoisted_5,
                withDirectives(createBaseVNode("input", {
                  type: "text",
                  onKeydown: _cache[0] || (_cache[0] = withKeys(() => {
                  }, ["enter"])),
                  "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => searchItem.value = $event),
                  class: "text-default bg-default block w-fit input-textlike sm:text-sm",
                  placeholder: "Search..."
                }, null, 544), [
                  [vModelText, searchItem.value]
                ])
              ]),
              createBaseVNode("div", _hoisted_6, [
                createBaseVNode("button", {
                  onClick: _cache[2] || (_cache[2] = ($event) => refreshBtn()),
                  class: "btn btn-secondary"
                }, [
                  createVNode(unref(render$d), { class: "w-5 h-5 m-0.5" })
                ])
              ]),
              createBaseVNode("div", _hoisted_7, [
                createBaseVNode("button", {
                  onClick: _cache[3] || (_cache[3] = ($event) => addTaskBtn()),
                  class: "btn btn-primary"
                }, "Add New Task")
              ])
            ])
          ]),
          createBaseVNode("div", _hoisted_8, [
            createBaseVNode("div", _hoisted_9, [
              createBaseVNode("div", _hoisted_10, [
                unref(loading) ? (openBlock(), createElementBlock("div", _hoisted_11, [
                  createVNode(_sfc_main$i, {
                    width: "w-32",
                    height: "h-32",
                    baseColor: "text-gray-200",
                    fillColor: "fill-gray-500"
                  })
                ])) : unref(taskInstances).length === 0 ? (openBlock(), createElementBlock("div", _hoisted_12, _hoisted_14)) : (openBlock(), createElementBlock("div", _hoisted_15, [
                  createBaseVNode("div", _hoisted_16, [
                    createBaseVNode("table", _hoisted_17, [
                      createBaseVNode("thead", _hoisted_18, [
                        createBaseVNode("tr", _hoisted_19, [
                          createBaseVNode("th", _hoisted_20, [
                            createBaseVNode("button", {
                              onClick: _cache[4] || (_cache[4] = ($event) => sortBy("name")),
                              class: "flex w-full justify-between whitespace-nowrap"
                            }, [
                              createTextVNode(" Name "),
                              sort.value.field === "name" && sortMode.value == "desc" ? (openBlock(), createBlock(unref(render$b), {
                                key: 0,
                                class: "ml-1 aspect-square w-5 h-5 text-muted"
                              })) : sort.value.field === "name" && sortMode.value == "asc" ? (openBlock(), createBlock(unref(render$a), {
                                key: 1,
                                class: "ml-1 aspect-square w-5 h-5 text-muted"
                              })) : (openBlock(), createBlock(unref(render$c), {
                                key: 2,
                                class: "ml-1 aspect-square w-5 h-5 text-muted"
                              }))
                            ])
                          ]),
                          _hoisted_21,
                          _hoisted_22,
                          _hoisted_23,
                          _hoisted_24
                        ])
                      ]),
                      createBaseVNode("tbody", _hoisted_25, [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(filteredAndSortedTasks.value, (taskInstance, index2) => {
                          return openBlock(), createElementBlock("div", { key: index2 }, [
                            createVNode(_sfc_main$7, {
                              task: taskInstance,
                              isExpanded: expandedTaskName.value === taskInstance.name,
                              onRunTask: _cache[5] || (_cache[5] = (task) => runTaskBtn(task)),
                              onEditTask: _cache[6] || (_cache[6] = (task) => editTaskBtn(task)),
                              onManageSchedule: _cache[7] || (_cache[7] = (task) => manageScheduleBtn(task)),
                              onRemoveTask: _cache[8] || (_cache[8] = (task) => removeTaskBtn(task)),
                              onViewLogs: _cache[9] || (_cache[9] = (task) => viewLogsBtn(task)),
                              onToggleDetails: toggleDetails,
                              ref_for: true,
                              ref_key: "taskTableRow",
                              ref: taskTableRow,
                              attr: taskInstance
                            }, null, 8, ["task", "isExpanded", "attr"])
                          ]);
                        }), 128))
                      ])
                    ])
                  ])
                ]))
              ])
            ])
          ])
        ]),
        showTaskWizard.value ? (openBlock(), createElementBlock("div", _hoisted_26, [
          (openBlock(), createBlock(resolveDynamicComponent(addTaskComponent.value), {
            "id-key": "add-task-modal",
            onManageSchedule: addScheduleHandler
          }, null, 32))
        ])) : createCommentVNode("", true),
        showEditTaskWizard.value ? (openBlock(), createElementBlock("div", _hoisted_27, [
          (openBlock(), createBlock(resolveDynamicComponent(editTaskComponent.value), {
            "id-key": "edit-task-modal",
            task: selectedTask.value
          }, null, 8, ["task"]))
        ])) : createCommentVNode("", true),
        showThisScheduleWizard.value ? (openBlock(), createElementBlock("div", _hoisted_28, [
          (openBlock(), createBlock(resolveDynamicComponent(scheduleWizardComponent.value), {
            onClose: updateShowThisScheduleWizardComponent,
            task: selectedTask.value,
            mode: scheduleMode.value
          }, null, 40, ["task", "mode"]))
        ])) : createCommentVNode("", true),
        showRunNowPrompt.value ? (openBlock(), createElementBlock("div", _hoisted_29, [
          (openBlock(), createBlock(resolveDynamicComponent(runNowDialog.value), {
            onClose: updateShowRunNowPrompt,
            showFlag: showRunNowPrompt.value,
            title: "Run Task",
            message: "Do you wish to run this task now?",
            confirmYes: runNowYes,
            confirmNo: runNowNo,
            operating: running.value,
            operation: "starting"
          }, null, 40, ["showFlag", "operating"]))
        ])) : createCommentVNode("", true),
        showRemoveTaskPrompt.value ? (openBlock(), createElementBlock("div", _hoisted_30, [
          (openBlock(), createBlock(resolveDynamicComponent(removeTaskDialog.value), {
            onClose: updateShowRemoveTaskPrompt,
            showFlag: showRemoveTaskPrompt.value,
            title: "Remove Task",
            message: "Are you sure you want to remove this task?",
            confirmYes: removeTaskYes,
            confirmNo: removeTaskNo,
            operating: removing.value,
            operation: "removing"
          }, null, 40, ["showFlag", "operating"]))
        ])) : createCommentVNode("", true),
        showLogView.value ? (openBlock(), createElementBlock("div", _hoisted_31, [
          (openBlock(), createBlock(resolveDynamicComponent(logViewComponent.value), {
            onClose: updateShowLogViewComponent,
            task: selectedTask.value
          }, null, 40, ["task"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
class ParameterNode {
  constructor(label, key) {
    __publicField(this, "label");
    __publicField(this, "key");
    __publicField(this, "children");
    __publicField(this, "value");
    this.label = label;
    this.key = key;
    this.children = [];
  }
  addChild(child) {
    this.children.push(child);
    return this;
  }
  asEnvKeyValues() {
    return this.children.map((c) => c.asEnvKeyValues()).flat().map((kv) => `${this.key}_${kv}`);
  }
}
class StringParameter extends ParameterNode {
  constructor(label, key, value = "") {
    super(label, key);
    __publicField(this, "value");
    this.value = value;
  }
  asEnvKeyValues() {
    return [`${this.key}=${this.value}`];
  }
}
class IntParameter extends ParameterNode {
  constructor(label, key, value = 0) {
    super(label, key);
    __publicField(this, "value");
    this.value = value;
  }
  asEnvKeyValues() {
    return [`${this.key}=${this.value.toString()}`];
  }
}
class BoolParameter extends ParameterNode {
  constructor(label, key, value = false) {
    super(label, key);
    __publicField(this, "value");
    this.value = value;
  }
  asEnvKeyValues() {
    return [`${this.key}=${this.value ? "true" : "false"}`];
  }
}
class SelectionOption {
  constructor(value, label) {
    __publicField(this, "value");
    __publicField(this, "label");
    this.value = value;
    this.label = label;
  }
}
class SelectionParameter extends ParameterNode {
  constructor(label, key, value = "", options = []) {
    super(label, key);
    __publicField(this, "value");
    __publicField(this, "options");
    this.value = value;
    this.options = options;
  }
  addOption(option) {
    this.options.push(option);
  }
  asEnvKeyValues() {
    return [`${this.key}=${this.value}`];
  }
}
class ZfsDatasetParameter extends ParameterNode {
  constructor(label, key, host = "", port = 0, user = "", pool = "", dataset = "") {
    super(label, key);
    this.addChild(new StringParameter("Host", "host", host));
    this.addChild(new IntParameter("Port", "port", port));
    this.addChild(new StringParameter("User", "user", user));
    const poolParam = new SelectionParameter("Pool", "pool", pool);
    this.addChild(poolParam);
    const datasetParam = new SelectionParameter("Dataset", "dataset", dataset);
    this.addChild(datasetParam);
  }
  async loadPools() {
    const pools = await getPoolData(this.children["host"], this.children["port"], this.children["user"]);
    const poolParam = this.getChild("pool");
    pools.forEach((pool) => {
      poolParam.addOption(new SelectionOption(pool, pool));
    });
  }
  async loadDatasets(pool) {
    const datasets = await getDatasetData(this.children["host"], this.children["port"], this.children["user"], pool);
    const datasetParam = this.getChild("dataset");
    datasets.forEach((dataset) => {
      datasetParam.addOption(new SelectionOption(dataset, dataset));
    });
  }
  getChild(key) {
    const child = this.children.find((child2) => child2.key === key);
    if (!child) {
      throw new Error(`Child with key ${key} not found`);
    }
    return child;
  }
  static fromLocation(label, key, location) {
    const { host, port, user, root, path } = location;
    return new ZfsDatasetParameter(label, key, host, port, user, root, path);
  }
  toLocation() {
    this.children[0].value;
    this.children[1].value;
    const host = this.children[2].value;
    const port = this.children[3].value;
    const user = this.children[4].value;
    const root = this.children[5].value;
    const path = this.children[6].value;
    return { host, port, user, root, path };
  }
}
class LocationParameter extends ParameterNode {
  constructor(label, key, host = "", port = 0, user = "", root = "", path = "") {
    super(label, key);
    this.addChild(new StringParameter("Host", "host", host));
    this.addChild(new IntParameter("Port", "port", port));
    this.addChild(new StringParameter("User", "user", user));
    this.addChild(new StringParameter("Root", "root", root));
    this.addChild(new StringParameter("Path", "path", path));
  }
  static fromLocation(label, key, location) {
    const { host, port, user, root, path } = location;
    return new LocationParameter(label, key, host, port, user, root, path);
  }
  toLocation() {
    this.children[0].value;
    this.children[1].value;
    const host = this.children[2].value;
    const port = this.children[3].value;
    const user = this.children[4].value;
    const root = this.children[5].value;
    const path = this.children[6].value;
    return { host, port, user, root, path };
  }
}
class TaskInstance {
  constructor(name, template, parameters, schedule) {
    __publicField(this, "name");
    __publicField(this, "template");
    __publicField(this, "parameters");
    __publicField(this, "schedule");
    this.name = name;
    this.template = template;
    this.parameters = parameters;
    this.schedule = schedule;
  }
}
class TaskSchedule {
  constructor(enabled, intervals) {
    __publicField(this, "enabled");
    __publicField(this, "intervals");
    this.enabled = enabled;
    this.intervals = intervals;
  }
}
class TaskScheduleInterval {
  constructor(intervalData) {
    __publicField(this, "dayOfWeek");
    Object.keys(intervalData).forEach((key) => {
      this[key] = intervalData[key];
    });
  }
}
class TaskTemplate {
  constructor(name, parameterSchema) {
    __publicField(this, "name");
    __publicField(this, "parameterSchema");
    this.name = name;
    this.parameterSchema = parameterSchema;
  }
  createTaskInstance(parameters) {
    return TaskInstance;
  }
}
class ZFSReplicationTaskTemplate extends TaskTemplate {
  constructor() {
    const name = "ZFS Replication Task";
    const parameterSchema = new ParameterNode("ZFS Replication Task Config", "zfsRepConfig").addChild(new ZfsDatasetParameter("Source Dataset", "sourceDataset", "", 0, "", "", "")).addChild(new ZfsDatasetParameter("Destination Dataset", "destDataset", "", 22, "", "", "")).addChild(
      new ParameterNode("Send Options", "sendOptions").addChild(new BoolParameter("Compressed", "compressed_flag", false)).addChild(new BoolParameter("Raw", "raw_flag", false)).addChild(new BoolParameter("Recursive", "recursive_flag", false)).addChild(new IntParameter("MBuffer Size", "mbufferSize", 1)).addChild(new StringParameter("MBuffer Unit", "mbufferUnit", "G")).addChild(new BoolParameter("Custom Name Flag", "customName_flag", false)).addChild(new StringParameter("Custom Name", "customName", ""))
    ).addChild(
      new ParameterNode("Snapshot Retention", "snapRetention").addChild(new IntParameter("Source", "source", 5)).addChild(new IntParameter("Destination", "destination", 5))
    );
    super(name, parameterSchema);
  }
  createTaskInstance(parameters, schedule) {
    return TaskInstance;
  }
}
class AutomatedSnapshotTaskTemplate extends TaskTemplate {
  constructor() {
    const name = "Automated Snapshot Task";
    const parameterSchema = new ParameterNode("Automated Snapshot Task Config", "autoSnapConfig").addChild(new ZfsDatasetParameter("Filesystem", "filesystem", "", 0, "", "", "")).addChild(new BoolParameter("Recursive", "recursive_flag", false)).addChild(new BoolParameter("Custom Name Flag", "customName_flag", false)).addChild(new StringParameter("Custom Name", "customName", "")).addChild(
      new IntParameter("Snapshot Retention", "snapRetention", 5)
    );
    super(name, parameterSchema);
  }
  createTaskInstance(parameters, schedule) {
    return TaskInstance;
  }
}
class RsyncTaskTemplate extends TaskTemplate {
  constructor() {
    const name = "Rsync Task";
    const directionSelection = [
      new SelectionOption("push", "Push"),
      new SelectionOption("pull", "Pull")
    ];
    const parameterSchema = new ParameterNode("Rsync Task Config", "rsyncConfig").addChild(new StringParameter("Local Path", "local_path", "")).addChild(new LocationParameter("Target Information", "target_info", "", 22, "", "", "")).addChild(new SelectionParameter("Direction", "direction", "push", directionSelection)).addChild(
      new ParameterNode("Rsync Options", "rsyncOptions").addChild(new BoolParameter("Archive", "archive_flag", true)).addChild(new BoolParameter("Recursive", "recursive_flag", false)).addChild(new BoolParameter("Compressed", "compressed_flag", false)).addChild(new BoolParameter("Delete", "delete_flag", false)).addChild(new BoolParameter("Quiet", "quiet_flag", false)).addChild(new BoolParameter("Preserve Times", "times_flag", false)).addChild(new BoolParameter("Preserve Hard Links", "hardLinks_flag", false)).addChild(new BoolParameter("Preserve Permissions", "permissions_flag", false)).addChild(new BoolParameter("Preserve Extended Attributes", "xattr_flag", false)).addChild(new IntParameter("Limit Bandwidth", "bandwidth_limit_kbps", 0)).addChild(new StringParameter("Include", "include_pattern", "")).addChild(new StringParameter("Exclude", "exclude_pattern", "")).addChild(new StringParameter("Additional Custom Arguments", "custom_args", "")).addChild(new BoolParameter("Parallel Transfer", "parallel_flag", false)).addChild(new IntParameter("Threads", "parallel_threads", 0))
    );
    super(name, parameterSchema);
  }
  createTaskInstance(parameters, schedule) {
    return TaskInstance;
  }
}
class ScrubTaskTemplate extends TaskTemplate {
  constructor() {
    const name = "Scrub Task";
    const parameterSchema = new ParameterNode("Scrub Task Config", "scrubConfig").addChild(new ZfsDatasetParameter("Pool", "pool", "", 0, "", "", ""));
    super(name, parameterSchema);
  }
  createTaskInstance(parameters, schedule) {
    return TaskInstance;
  }
}
class SmartTestTemplate extends TaskTemplate {
  constructor() {
    const name = "SMART Test";
    const parameterSchema = new ParameterNode("SMART Test Config", "smartTestConfig").addChild(new StringParameter("Disks", "disks", "")).addChild(new StringParameter("Test Type", "testType", ""));
    super(name, parameterSchema);
  }
  createTaskInstance(parameters, schedule) {
    return TaskInstance;
  }
}
class TaskExecutionLog {
  constructor(entries) {
    __publicField(this, "entries");
    this.entries = entries;
  }
  async getEntriesFor(taskInstance, untilTime) {
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const taskName = taskInstance.name;
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskName}`;
    try {
      if (!untilTime) {
        console.log("No until time provided");
        const logCommand = ["journalctl", "-r", "-u", fullTaskName, "--no-pager", "--all", "-n", "1"];
        const logState = useSpawn(logCommand, { superuser: "try" });
        const logResult = await logState.promise();
        return logResult.stdout;
      }
      const command = ["journalctl", "-u", fullTaskName, "--until", untilTime, "--no-pager", "--all"];
      const state = useSpawn(command, { superuser: "try" });
      const result = await state.promise();
      const taskLogData = result.stdout.trim();
      return taskLogData;
    } catch (error) {
      console.error(errorString(error));
      return false;
    }
  }
  async getLatestEntryFor(taskInstance) {
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const taskName = taskInstance.name;
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskName}`;
    try {
      const execCommand = ["systemctl", "show", fullTaskName, "-p", "ExecMainStatus,ExecMainStartTimestamp,ExecMainExitTimestamp"];
      const execState = useSpawn(execCommand, { superuser: "try" });
      const execResult = await execState.promise();
      const properties = Object.fromEntries(execResult.stdout.split("\n").filter((line) => line.includes("=")).map((line) => line.split("=")));
      const exitCode = properties["ExecMainStatus"] || "0";
      const startTime = properties["ExecMainStartTimestamp"] || "";
      const finishTime = properties["ExecMainExitTimestamp"] || "";
      let output = "";
      if (startTime) {
        const logCommand = ["journalctl", "-u", fullTaskName, "--since", startTime, "--no-pager", "--all"];
        const logState = useSpawn(logCommand, { superuser: "try" });
        const logResult = await logState.promise();
        output = logResult.stdout;
      } else {
        output = "No executions found.";
      }
      const latestEntry = new TaskExecutionResult(exitCode, output, startTime, finishTime);
      return latestEntry;
    } catch (error) {
      console.error(errorString(error));
      return false;
    }
  }
  async wasTaskRecentlyCompleted(taskInstance) {
    const taskLog = new TaskExecutionLog([]);
    const latestEntry = await taskLog.getLatestEntryFor(taskInstance);
    if (!latestEntry || !latestEntry.finishDate) {
      return false;
    }
    const finishDate = new Date(latestEntry.finishDate).getTime();
    const currentTime = Date.now();
    const threshold = 10 * 60 * 1e3;
    return currentTime - finishDate <= threshold;
  }
}
class TaskExecutionResult {
  constructor(exitCode, output, startDate, finishDate) {
    __publicField(this, "exitCode");
    __publicField(this, "output");
    __publicField(this, "startDate");
    __publicField(this, "finishDate");
    this.exitCode = exitCode;
    this.output = output;
    this.startDate = startDate;
    this.finishDate = finishDate;
  }
}
const get_tasks_script = `import os
import re
import json
import subprocess

currentTaskTemplates = ['ZfsReplicationTask', 'AutomatedSnapshotTask', 'ScrubTask', 'RsyncTask', 'SmartTest']
# , 'CloudSyncTask'


class TaskScheduleInterval:
    def __init__(self, interval_data):
        self.__dict__ = interval_data

class TaskSchedule:
    def __init__(self, enabled, intervals):
        self.enabled = enabled
        self.intervals = [TaskScheduleInterval(interval).__dict__ for interval in intervals]

class TaskInstance:
    def __init__(self, name, template, parameters, schedule):
        self.name = name
        self.template = template
        self.parameters = parameters
        self.schedule = schedule.__dict__
        

def check_task_status(full_unit_name):
    # check the status of the timer
    subprocess.run(['sudo', 'systemctl', 'status', f'{full_unit_name}.timer'], check=True)


def read_env_parameters(env_path):
    parameters = {}
    with open(env_path, 'r') as env_file:
        for line in env_file:
            match = re.match(r'^([^=]+)=(.*)$', line.strip())
            if match:
                key, value = match.groups()
                parameters[key.strip()] = value.strip()
    return parameters

def read_json_schedule(json_path):
    with open(json_path, 'r') as json_file:
        return json.load(json_file)


def find_template_basenames(template_dir):
    base_names = {}
    for file in os.listdir(template_dir):
        if file.endswith('.service'):
            base_name = os.path.splitext(file)[0]
            base_names[base_name] = None  # Using None as a placeholder
            
            # print(f"Loaded template basename: {base_name}")  # Debug: Check loaded template names
            
    return base_names


def find_valid_task_data_files(system_dir, template_basenames):
    valid_files = {}
    # Adjusted regex to match up to the last dot before extension
    file_regex = re.compile(r"^houston_scheduler_([^_]+)_(.*)\\.(env|json)$")

    for file in os.listdir(system_dir):
        match = file_regex.match(file)
        if match:
            template_name, task_name_with_suffix, suffix = match.groups()
            # Extract the task name correctly before appending the file to the list
            if template_name in template_basenames:
                if template_name not in valid_files:
                    valid_files[template_name] = []
                # Include the correct file format with the suffix
                valid_files[template_name].append(file)

    return valid_files

def create_task_instances(system_dir, valid_files):
    task_instances = []

    for template, files in valid_files.items():
        paired_files = {}

        for file in files:
            full_base_name, ext = os.path.splitext(file)
            # Remove the prefix and then split properly
            task_name = full_base_name[len("houston_scheduler_" + template + "_"):]  # This strips the prefix and template

            if task_name not in paired_files:
                paired_files[task_name] = {}
            paired_files[task_name][ext] = file

        for task_name, file_dict in paired_files.items():
            if '.env' in file_dict:
                env_file_name = file_dict['.env']
                parameters = read_env_parameters(os.path.join(system_dir, env_file_name))
                
                if '.json' in file_dict:
                    json_file_name = file_dict['.json']
                    schedule_data = read_json_schedule(os.path.join(system_dir, json_file_name))
                    schedule = TaskSchedule(schedule_data['enabled'], schedule_data['intervals'])
                else:
                    schedule = TaskSchedule(False, [])

                task_instance = TaskInstance(task_name, template, parameters, schedule)
                task_instances.append(task_instance)

    return json.dumps([instance.__dict__ for instance in task_instances], indent=4)

def main():
    system_dir = '/etc/systemd/system/'

    # Check files in the system directory for those containing any of the task template names
    valid_task_data_files = find_valid_task_data_files(system_dir, currentTaskTemplates)
    
    task_instances = create_task_instances(system_dir, valid_task_data_files)
    print(task_instances)   
    
if __name__ == "__main__":
	main()`;
class Scheduler {
  constructor(taskTemplates, taskInstances) {
    __publicField(this, "taskTemplates");
    __publicField(this, "taskInstances");
    this.taskTemplates = taskTemplates;
    this.taskInstances = taskInstances;
  }
  async loadTaskInstances() {
    this.taskInstances.splice(0, this.taskInstances.length);
    try {
      const state = useSpawn(["/usr/bin/env", "python3", "-c", get_tasks_script], { superuser: "try" });
      const tasksOutput = (await state.promise()).stdout;
      const tasksData = JSON.parse(tasksOutput);
      tasksData.forEach((task) => {
        const newTaskTemplate = ref$1();
        if (task.template == "ZfsReplicationTask") {
          newTaskTemplate.value = new ZFSReplicationTaskTemplate();
        } else if (task.template == "AutomatedSnapshotTask") {
          newTaskTemplate.value = new AutomatedSnapshotTaskTemplate();
        } else if (task.template == "RsyncTask") {
          newTaskTemplate.value = new RsyncTaskTemplate();
        } else if (task.template == "ScrubTask") {
          newTaskTemplate.value = new ScrubTaskTemplate();
        } else if (task.template == "SmartTest") {
          newTaskTemplate.value = new SmartTestTemplate();
        }
        const parameters = task.parameters;
        const parameterNodeStructure = this.createParameterNodeFromSchema(newTaskTemplate.value.parameterSchema, parameters);
        const taskIntervals = [];
        task.schedule.intervals.forEach((interval) => {
          const thisInterval = new TaskScheduleInterval(interval);
          taskIntervals.push(thisInterval);
        });
        const newSchedule = new TaskSchedule(task.schedule.enabled, taskIntervals);
        const newTaskInstance = new TaskInstance(task.name, newTaskTemplate.value, parameterNodeStructure, newSchedule);
        this.taskInstances.push(newTaskInstance);
      });
      console.log("this.taskInstances:", this.taskInstances);
    } catch (state) {
      console.error(errorString(state));
      return null;
    }
  }
  createParameterNodeFromSchema(schema, parameters) {
    function cloneSchema(node) {
      let newNode;
      if (node instanceof StringParameter) {
        newNode = new StringParameter(node.label, node.key);
      } else if (node instanceof IntParameter) {
        newNode = new IntParameter(node.label, node.key);
      } else if (node instanceof BoolParameter) {
        newNode = new BoolParameter(node.label, node.key);
      } else if (node instanceof SelectionParameter) {
        newNode = new SelectionParameter(node.label, node.key);
      } else {
        newNode = new ParameterNode(node.label, node.key);
      }
      node.children.forEach((child) => {
        newNode.addChild(cloneSchema(child));
      });
      return newNode;
    }
    const parameterRoot = cloneSchema(schema);
    function assignValues(node, prefix = "") {
      const currentPrefix = prefix ? prefix + "_" : "";
      const fullKey = currentPrefix + node.key;
      if (parameters.hasOwnProperty(fullKey)) {
        let value = parameters[fullKey];
        if (node instanceof StringParameter || node instanceof SelectionParameter) {
          node.value = value;
        } else if (node instanceof IntParameter) {
          node.value = parseInt(value);
        } else if (node instanceof BoolParameter) {
          node.value = value === "true";
        }
      }
      node.children.forEach((child) => assignValues(child, fullKey));
    }
    assignValues(parameterRoot);
    return parameterRoot;
  }
  parseEnvKeyValues(envKeyValues, templateName) {
    let envObject = envKeyValues.reduce((acc, curr) => {
      const [key, value] = curr.split("=");
      acc[key] = value;
      return acc;
    }, {});
    console.log("templateName:", templateName);
    switch (templateName) {
      case "ZfsReplicationTask":
        if (envObject["zfsRepConfig_sendOptions_raw_flag"] === "true") {
          envObject["zfsRepConfig_sendOptions_compressed_flag"] = "";
        } else if (envObject["zfsRepConfig_sendOptions_compressed_flag"] === "true") {
          envObject["zfsRepConfig_sendOptions_raw_flag"] = "";
        }
        break;
      case "RsyncTask":
        if (!envObject["rsyncConfig_target_info_host"]) {
          envObject["rsyncConfig_target_info_host"] = "";
          envObject["rsyncConfig_target_info_port"] = "";
          envObject["rsyncConfig_target_info_user"] = "";
        }
        if (envObject["rsyncConfig_rsyncOptions_bandwidth_limit_kbps"] !== "0" && envObject["rsyncConfig_rsyncOptions_bandwidth_limit_kbps"] !== 0) {
          envObject["rsyncConfig_rsyncOptions_bandwidth_limit_kbps"] = `${envObject["rsyncConfig_rsyncOptions_bandwidth_limit_kbps"]}`;
        } else {
          envObject["rsyncConfig_rsyncOptions_bandwidth_limit_kbps"] = "";
        }
        if (envObject["rsyncConfig_rsyncOptions_include_pattern"] && envObject["rsyncConfig_rsyncOptions_include_pattern"] !== "''") {
          envObject["rsyncConfig_rsyncOptions_include_pattern"] = `${envObject["rsyncConfig_rsyncOptions_include_pattern"]}`;
        } else {
          envObject["rsyncConfig_rsyncOptions_include_pattern"] = "";
        }
        if (envObject["rsyncConfig_rsyncOptions_exclude_pattern"] && envObject["rsyncConfig_rsyncOptions_exclude_pattern"] !== "''") {
          envObject["rsyncConfig_rsyncOptions_exclude_pattern"] = `${envObject["rsyncConfig_rsyncOptions_exclude_pattern"]}`;
        } else {
          envObject["rsyncConfig_rsyncOptions_exclude_pattern"] = "";
        }
        if (envObject["rsyncConfig_rsyncOptions_custom_args"] && envObject["rsyncConfig_rsyncOptions_custom_args"] !== "''") {
          envObject["rsyncConfig_rsyncOptions_custom_args"] = `${envObject["rsyncConfig_rsyncOptions_custom_args"]}`;
        } else {
          envObject["rsyncConfig_rsyncOptions_custom_args"] = "";
        }
        break;
    }
    console.log("envObject After:", envObject);
    return envObject;
  }
  getScriptFromTemplateName(templateName) {
    switch (templateName) {
      case "ZfsReplicationTask":
        return "replication-script";
      case "AutomatedSnapshotTask":
        return "autosnap-script";
      case "RsyncTask":
        return "rsync-script";
      case "SmartTest":
        return "smart-test-script";
      default:
        console.error("no script provided");
        break;
    }
  }
  async registerTaskInstance(taskInstance) {
    const envKeyValues = taskInstance.parameters.asEnvKeyValues();
    console.log("envKeyVals Before Parse:", envKeyValues);
    const templateName = formatTemplateName(taskInstance.template.name);
    const envObject = this.parseEnvKeyValues(envKeyValues, templateName);
    const scriptFileName = this.getScriptFromTemplateName(templateName);
    const scriptPath = `/opt/45drives/houston/scheduler/scripts/${scriptFileName}.py`;
    const filteredEnvObject = Object.fromEntries(Object.entries(envObject).filter(([key, value]) => value !== "" && value !== 0));
    console.log("Filtered envObject:", filteredEnvObject);
    const envKeyValuesString = Object.entries(filteredEnvObject).map(([key, value]) => `${key}=${value}`).join("\n");
    const templateTimerPath = `/opt/45drives/houston/scheduler/templates/Schedule.timer`;
    const houstonSchedulerPrefix = "houston_scheduler_";
    const envFilePath = `/etc/systemd/system/${houstonSchedulerPrefix}${templateName}_${taskInstance.name}.env`;
    console.log("envFilePath:", envFilePath);
    const file = new BetterCockpitFile(envFilePath, {
      superuser: "try"
    });
    file.replace(envKeyValuesString).then(() => {
      console.log("env file created and content written successfully");
      file.close();
    }).catch((error) => {
      console.error("Error writing content to the file:", error);
      file.close();
    });
    const jsonFilePath = `/etc/systemd/system/${houstonSchedulerPrefix}${templateName}_${taskInstance.name}.json`;
    console.log("jsonFilePath:", jsonFilePath);
    if (taskInstance.schedule.intervals.length < 1) {
      console.log("No schedules found, parameter file generated.");
      await createStandaloneTask(templateName, scriptPath, envFilePath);
    } else {
      console.log("schedule:", taskInstance.schedule);
      const file2 = new BetterCockpitFile(jsonFilePath, {
        superuser: "try"
      });
      const jsonString = JSON.stringify(taskInstance.schedule, null, 2);
      file2.replace(jsonString).then(() => {
        console.log("json file created and content written successfully");
        file2.close();
      }).catch((error) => {
        console.error("Error writing content to the file:", error);
        file2.close();
      });
      await createTaskFiles(templateName, scriptPath, envFilePath, templateTimerPath, jsonFilePath);
    }
  }
  async updateTaskInstance(taskInstance) {
    const envKeyValues = taskInstance.parameters.asEnvKeyValues();
    console.log("envKeyVals:", envKeyValues);
    const templateName = formatTemplateName(taskInstance.template.name);
    const envObject = this.parseEnvKeyValues(envKeyValues, templateName);
    const scriptFileName = this.getScriptFromTemplateName(templateName);
    const scriptPath = `/opt/45drives/houston/scheduler/scripts/${scriptFileName}.py`;
    const filteredEnvObject = Object.fromEntries(Object.entries(envObject).filter(([key, value]) => value !== "" && value !== 0));
    console.log("Filtered envObject:", filteredEnvObject);
    const envKeyValuesString = Object.entries(filteredEnvObject).map(([key, value]) => `${key}=${value}`).join("\n");
    const houstonSchedulerPrefix = "houston_scheduler_";
    const envFilePath = `/etc/systemd/system/${houstonSchedulerPrefix}${templateName}_${taskInstance.name}.env`;
    console.log("envFilePath:", envFilePath);
    const file = new BetterCockpitFile(envFilePath, {
      superuser: "try"
    });
    file.replace(envKeyValuesString).then(() => {
      console.log("env file updated successfully");
      file.close();
    }).catch((error) => {
      console.error("Error updating file:", error);
      file.close();
    });
    await createStandaloneTask(templateName, scriptPath, envFilePath);
    let command = ["sudo", "systemctl", "daemon-reload"];
    let state = useSpawn(command, { superuser: "try" });
    await state.promise();
  }
  async unregisterTaskInstance(taskInstance) {
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskInstance.name}`;
    await removeTask(fullTaskName);
    console.log(`${fullTaskName} removed`);
  }
  async runTaskNow(taskInstance) {
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskInstance.name}`;
    console.log(`Running ${fullTaskName}...`);
    await runTask(fullTaskName);
    console.log(`Task ${fullTaskName} completed.`);
  }
  async getTimerStatus(taskInstance) {
    const taskLog = new TaskExecutionLog([]);
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const fullTaskName = houstonSchedulerPrefix + templateName + "_" + taskInstance.name;
    try {
      const command = ["systemctl", "status", `${fullTaskName}.timer`, "--no-pager", "--output=cat"];
      const state = useSpawn(command, { superuser: "try" });
      const result = await state.promise();
      const output = result.stdout;
      return this.parseTaskStatus(output, fullTaskName, taskLog, taskInstance);
    } catch (error) {
      console.error(`Error checking timer status:`, error);
      return "Error checking timer status";
    }
  }
  async getServiceStatus(taskInstance) {
    const taskLog = new TaskExecutionLog([]);
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const fullTaskName = houstonSchedulerPrefix + templateName + "_" + taskInstance.name;
    try {
      const command = ["systemctl", "status", `${fullTaskName}.service`, "--no-pager", "--output=cat"];
      const state = useSpawn(command, { superuser: "try" });
      const result = await state.promise();
      const output = result.stdout;
      return this.parseTaskStatus(output, fullTaskName, taskLog, taskInstance);
    } catch (error) {
      return this.parseTaskStatus(error.stdout || "", fullTaskName, taskLog, taskInstance);
    }
  }
  async parseTaskStatus(output, fullTaskName, taskLog, taskInstance) {
    try {
      let status = "";
      const activeStatusRegex = /^\s*Active:\s*(\w+\s*\([^)]*\))/m;
      const activeStatusMatch = output.match(activeStatusRegex);
      const succeededRegex = new RegExp(`${fullTaskName}.service: Succeeded`, "m");
      if (activeStatusMatch) {
        const systemdState = activeStatusMatch[1].trim();
        switch (systemdState) {
          case "activating (start)":
            status = "Starting...";
            break;
          case "active (waiting)":
            status = "Active (Pending)";
            break;
          case "active (running)":
            status = "Active (Running)";
            break;
          case "inactive (dead)":
            if (succeededRegex.test(output)) {
              status = "Completed";
            } else {
              const recentlyCompleted = await taskLog.wasTaskRecentlyCompleted(taskInstance);
              status = recentlyCompleted ? "Completed" : "Inactive (Disabled)";
            }
            break;
          case "failed (result)":
            status = "Failed";
            break;
          default:
            status = systemdState;
        }
      } else {
        status = "Unit inactive or not found.";
      }
      return status;
    } catch (error) {
      console.error(`Error parsing status for ${fullTaskName}:`, error);
      return false;
    }
  }
  async enableSchedule(taskInstance) {
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskInstance.name}`;
    const timerName = `${fullTaskName}.timer`;
    try {
      let command = ["sudo", "systemctl", "daemon-reload"];
      let state = useSpawn(command, { superuser: "try" });
      await state.promise();
      command = ["sudo", "systemctl", "enable", timerName];
      state = useSpawn(command, { superuser: "try" });
      await state.promise();
      console.log(`${timerName} has been enabled and started`);
      taskInstance.schedule.enabled = true;
      console.log("taskInstance after enable:", taskInstance);
      await this.updateSchedule(taskInstance);
    } catch (error) {
      console.error(errorString(error));
      return false;
    }
  }
  async disableSchedule(taskInstance) {
    const houstonSchedulerPrefix = "houston_scheduler_";
    const templateName = formatTemplateName(taskInstance.template.name);
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskInstance.name}`;
    const timerName = `${fullTaskName}.timer`;
    try {
      let reloadCommand = ["sudo", "systemctl", "daemon-reload"];
      let reloadState = useSpawn(reloadCommand, { superuser: "try" });
      await reloadState.promise();
      let stopCommand = ["sudo", "systemctl", "stop", timerName];
      let stopState = useSpawn(stopCommand, { superuser: "try" });
      await stopState.promise();
      let disableCommand = ["sudo", "systemctl", "disable", timerName];
      let disableState = useSpawn(disableCommand, { superuser: "try" });
      await disableState.promise();
      console.log(`${timerName} has been stopped and disabled`);
      taskInstance.schedule.enabled = false;
      console.log("taskInstance after disable:", taskInstance);
      await this.updateSchedule(taskInstance);
    } catch (error) {
      console.error(errorString(error));
      return false;
    }
  }
  async updateSchedule(taskInstance) {
    const templateName = formatTemplateName(taskInstance.template.name);
    const templateTimerPath = `/opt/45drives/houston/scheduler/templates/Schedule.timer`;
    const houstonSchedulerPrefix = "houston_scheduler_";
    const fullTaskName = `${houstonSchedulerPrefix}${templateName}_${taskInstance.name}`;
    const jsonFilePath = `/etc/systemd/system/${fullTaskName}.json`;
    console.log("jsonFilePath:", jsonFilePath);
    const file = new BetterCockpitFile(jsonFilePath, {
      superuser: "try"
    });
    const jsonString = JSON.stringify(taskInstance.schedule, null, 2);
    file.replace(jsonString).then(() => {
      console.log("json file created and content written successfully");
      file.close();
    }).catch((error) => {
      console.error("Error writing content to the file:", error);
      file.close();
    });
    if (taskInstance.schedule.enabled) {
      await createScheduleForTask(fullTaskName, templateTimerPath, jsonFilePath);
      let command = ["sudo", "systemctl", "daemon-reload"];
      let state = useSpawn(command, { superuser: "try" });
      await state.promise();
      command = ["sudo", "systemctl", "restart", fullTaskName + ".timer"];
      state = useSpawn(command, { superuser: "try" });
      await state.promise();
    }
  }
  parseIntervalIntoString(interval) {
    const elements = [];
    function getMonthName(number) {
      const months = [
        "January",
        "February",
        "March",
        "April",
        "May",
        "June",
        "July",
        "August",
        "September",
        "October",
        "November",
        "December"
      ];
      return months[number - 1] || "undefined";
    }
    function getDaySuffix(day2) {
      if (day2 > 3 && day2 < 21)
        return "th";
      switch (day2 % 10) {
        case 1:
          return "st";
        case 2:
          return "nd";
        case 3:
          return "rd";
        default:
          return "th";
      }
    }
    function formatUnit(value, type2) {
      if (value === "*") {
        return type2 === "minute" ? "every minute" : type2 === "hour" ? "every hour" : `every ${type2}`;
      } else if (value.startsWith("*/")) {
        const interval2 = value.slice(2);
        return `every ${interval2} ${type2}${interval2 > 1 ? "s" : ""}`;
      } else if (value.includes("/")) {
        const [base, step] = value.split("/");
        if (type2 === "day") {
          return `every ${step} days starting on the ${base}${getDaySuffix(parseInt(base))}`;
        }
        return `every ${step} ${type2}${step > 1 ? "s" : ""} starting from ${base}`;
      } else if (value === "0" && type2 === "minute") {
        return "at the start of the hour";
      } else if (value === "0" && type2 === "hour") {
        return "at midnight";
      } else if (type2 === "day") {
        return `on the ${value}${getDaySuffix(parseInt(value))} of the month`;
      } else if (type2 === "month") {
        return `in ${getMonthName(parseInt(value))}`;
      }
      return `at ${value} ${type2}`;
    }
    const formattedMinute = interval.minute ? formatUnit(interval.minute.value.toString(), "minute") : null;
    const formattedHour = interval.hour ? formatUnit(interval.hour.value.toString(), "hour") : null;
    if (formattedMinute === null && formattedHour === "at midnight") {
      elements.push("at midnight");
    } else {
      if (formattedMinute)
        elements.push(formattedMinute);
      if (formattedHour)
        elements.push(formattedHour);
    }
    const day = interval.day ? formatUnit(interval.day.value.toString(), "day") : "every day";
    const month = interval.month ? formatUnit(interval.month.value.toString(), "month") : "every month";
    const year = interval.year ? formatUnit(interval.year.value.toString(), "year") : "every year";
    if (day)
      elements.push(day);
    if (month)
      elements.push(month);
    if (year)
      elements.push(year);
    if (interval.dayOfWeek && interval.dayOfWeek.length > 0) {
      elements.push(`on ${interval.dayOfWeek.join(", ")}`);
    }
    return elements.filter((e) => e).join(", ");
  }
}
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "App",
  setup(__props) {
    function initializeTaskTemplates() {
      const zfsRepTaskTemplate = new ZFSReplicationTaskTemplate();
      const autoSnapTaskTemplate = new AutomatedSnapshotTaskTemplate();
      const rsyncTaskTemplate = new RsyncTaskTemplate();
      const scrubTaskTemplate = new ScrubTaskTemplate();
      const smartTestTemplate = new SmartTestTemplate();
      return [
        zfsRepTaskTemplate,
        autoSnapTaskTemplate,
        rsyncTaskTemplate,
        scrubTaskTemplate,
        smartTestTemplate
      ];
    }
    const taskTemplates = initializeTaskTemplates();
    const taskInstances = ref$1([]);
    const myScheduler = new Scheduler(taskTemplates, taskInstances.value);
    const loading = ref$1(false);
    const truncateText = ref$1("overflow-hidden whitespace-nowrap text-ellipsis");
    const entries = ref$1([]);
    const myTaskLog = new TaskExecutionLog(entries.value);
    onMounted(async () => {
      loading.value = true;
      initializeTaskTemplates();
      await myScheduler.loadTaskInstances();
      loading.value = false;
    });
    provide(loadingInjectionKey, loading);
    provide(schedulerInjectionKey, myScheduler);
    provide(logInjectionKey, myTaskLog);
    provide(taskInstancesInjectionKey, taskInstances);
    provide(taskTemplatesInjectionKey, taskTemplates);
    provide(truncateTextInjectionKey, truncateText);
    return (_ctx, _cache) => {
      return openBlock(), createBlock(unref(HoustonAppContainer), { moduleName: "Task Scheduler" }, {
        default: withCtx(() => [
          createVNode(unref(CenteredCardColumn), null, {
            default: withCtx(() => [
              createVNode(unref(CardContainer), null, {
                default: withCtx(() => [
                  createVNode(_sfc_main$1)
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      });
    };
  }
});
const app = createApp(_sfc_main);
app.mount("#app");
export {
  getPoolData as $,
  AutomatedSnapshotTaskTemplate as A,
  SmartTestTemplate as B,
  TaskInstance as C,
  pushNotification as D,
  watchEffect as E,
  Fragment as F,
  computed as G,
  cloneVNode as H,
  h as I,
  onMounted as J,
  onUnmounted as K,
  watch as L,
  shallowRef as M,
  Notification as N,
  Teleport as O,
  reactive as P,
  getCurrentInstance as Q,
  RsyncTaskTemplate as R,
  ScrubTaskTemplate as S,
  TaskSchedule as T,
  nextTick as U,
  renderSlot as V,
  _sfc_main$i as W,
  vModelCheckbox as X,
  testSSH as Y,
  ZFSReplicationTaskTemplate as Z,
  __vitePreload as _,
  taskTemplatesInjectionKey as a,
  getDatasetData as a0,
  ParameterNode as a1,
  ZfsDatasetParameter as a2,
  BoolParameter as a3,
  IntParameter as a4,
  StringParameter as a5,
  LocationParameter as a6,
  SelectionParameter as a7,
  SelectionOption as a8,
  getDiskIDName as a9,
  truncateName as aa,
  getDisks as ab,
  pushScopeId as ac,
  popScopeId as ad,
  createStaticVNode as ae,
  upperCaseWord as af,
  logInjectionKey as ag,
  inject as b,
  createElementBlock as c,
  defineComponent as d,
  createVNode as e,
  createTextVNode as f,
  createBaseVNode as g,
  createBlock as h,
  injectWithCheck as i,
  createCommentVNode as j,
  withDirectives as k,
  loadingInjectionKey as l,
  renderList as m,
  normalizeClass as n,
  openBlock as o,
  provide as p,
  toDisplayString as q,
  ref$1 as r,
  schedulerInjectionKey as s,
  taskInstancesInjectionKey as t,
  unref as u,
  vModelText as v,
  withCtx as w,
  vModelSelect as x,
  withModifiers as y,
  resolveDynamicComponent as z
};
